set head off;

spool gis_ddl_log.txt;

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Start gis_ddl.sql install script.' from dual;

/* Create sequence for gis_interface_all table */

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Create sequence for gis_interface_all table ...' from dual;

create sequence gis_interface_s start with 1;

select 'Create sequence for gis_interface_all table completed.' from dual;

/* Create gis_interface_all table */

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Create table gis_interface_all ...' from dual;

create table gis_interface_all
(gis_id            number        not null,
 file_id           number        not null,
 gtn_id            number        not null,
 customer_id       number                ,
 customer_name     varchar2(50)  not null,
 customer_number   varchar2(30)          ,
 order_type        varchar2(40)  not null,
 order_number      number                ,
 order_amount      number                ,
 interface_status  number        not null,
 status_date       date          not null,
 last_error_id     number                ,
 last_updated_by   number(15)    not null,
 last_update_date  date          not null,
 created_by        number(15)    not null,
 creation_date     date          not null,
 org_id            number(15)    default to_number(decode(substr(userenv('CLIENT_INFO'),1,1),' ',null,substr(userenv('CLIENT_INFO'),1,10)))
);

select 'Create table gis_interface_all completed.' from dual;

select 'Create indexes on gis_interface_all ...' from dual;

alter table gis_interface_all
add constraint gis_interface_pk primary key (gis_id);

create index gis_interface_n1
on gis_interface_all (file_id);

create index gis_interface_n2
on gis_interface_all (gtn_id);

create index gis_interface_n3
on gis_interface_all (customer_id);

create index gis_interface_n4
on gis_interface_all (customer_number);

create index gis_interface_n5
on gis_interface_all (order_type, order_number, order_amount);

select 'Create indexes on gis_interface_all completed.' from dual;

/* Create gis_interface view */

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Create view gis_interface ...' from dual;

create or replace view gis_interface
as
select *
from   gis_interface_all gia
where  nvl(gia.org_id,nvl(to_number(decode
       (substr(userenv('client_info'),1,1)
       ,'',null,substr(userenv('client_info'),1,10))),-99))
       = nvl(to_number(decode(substr
       (userenv('client_info'),1,1),''
       ,null,substr(userenv('client_info'),1,10))),-99);
commit;

select 'Create view gis_interface completed.' from dual;

/* Create sequence for gis_error_log_all table */

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Create sequence for gis_error_log_all table ...' from dual;

create sequence gis_error_log_s start with 1;

select 'Create sequence for gis_error_log_all table completed.' from dual;

/* Create gis_error_log_all table */

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Create table gis_error_log_all ...' from dual;

create table gis_error_log_all
(error_id          number         not null,
 file_id           number         not null,
 object_name       varchar2(240)          ,
 input_parameters  varchar2(240)          ,
 event             varchar2(240)          ,
 system_error      varchar2(240)          ,
 status_error      varchar2(240)          ,
 last_updated_by   number(15)     not null,
 last_update_date  date           not null,
 last_update_login number(15)             ,
 created_by        number(15)     not null,
 creation_date     date           not null,
 org_id            number(15)         default to_number(decode(substr(userenv('CLIENT_INFO'),1,1),' ',null,substr(userenv('CLIENT_INFO'),1,10)))
);

select 'Create table gis_error_log_all completed.' from dual;

select 'Create indexes on gis_error_log_all ...' from dual;

alter table gis_error_log_all
add constraint gis_error_log_pk primary key (error_id);

create index gis_error_log_n1
on gis_error_log_all (file_id);

select 'Create indexes on gis_error_log_all completed.' from dual;

/* Create gis_error_log view */

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Create view gis_error_log ...' from dual;

create or replace view gis_error_log
as
select *
from   gis_error_log_all gela
where  nvl(gela.org_id,nvl(to_number(decode
       (substr(userenv('client_info'),1,1)
       ,'',null,substr(userenv('client_info'),1,10))),-99))
       = nvl(to_number(decode(substr
       (userenv('client_info'),1,1),''
       ,null,substr(userenv('client_info'),1,10))),-99);
commit;

select 'Create view gis_error_log completed.' from dual;

/* Create sequence for gis_event_log_all table */

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Create sequence for gis_event_log_all table ...' from dual;

create sequence gis_event_log_s start with 1;

select 'Create sequence for gis_event_log_all table completed.' from dual;

/* Create gis_event_log_all table */

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Create table gis_event_log_all ...' from dual;

create table gis_event_log_all
(event_id          number(15)     not null,
 file_id           number(15)     not null,
 event             varchar2(240)          ,
 last_updated_by   number(15)     not null,
 last_update_date  date           not null,
 last_update_login number(15)             ,
 created_by        number(15)     not null,
 creation_date     date           not null,
 org_id            number(15)         default to_number(decode(substr(userenv('CLIENT_INFO'),1,1),' ',null,substr(userenv('CLIENT_INFO'),1,10)))
);

select 'Create table gis_event_log_all completed.' from dual;

select 'Create indexes on gis_event_log_all ...' from dual;

alter table gis_event_log_all
add constraint gis_event_log_pk primary key (event_id);

create index gis_event_log_n1
on gis_event_log_all (file_id);

select 'Create indexes on gis_event_log_all completed.' from dual;

/* Create gis_event_log view */

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Create view gis_event_log ...' from dual;

create or replace view gis_event_log
as
select *
from   gis_event_log_all gela
where  nvl(gela.org_id,nvl(to_number(decode
       (substr(userenv('client_info'),1,1)
       ,'',null,substr(userenv('client_info'),1,10))),-99))
       = nvl(to_number(decode(substr
       (userenv('client_info'),1,1),''
       ,null,substr(userenv('client_info'),1,10))),-99);
commit;

select 'Create view gis_event_log completed.' from dual;

/* Register GIS application */

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

select 'Registering GIS application, install lookup types  ...' from dual;

declare
  n_user_id           number := 0;  -- SYSADMIN
  n_application_id    fnd_application_vl.application_id%type := null;
  d_current_date      date;
begin

  select fnd_application_s.nextval
  into   n_application_id
  from   dual;

  select sysdate
  into   d_current_date
  from   dual;

  /* GIS */

  insert into fnd_application
    (application_id,
     application_short_name,
     last_update_date,
     last_updated_by,
     creation_date,
     created_by,
     last_update_login,
     basepath)
  values
    (n_application_id,             -- Sequence number
     'GIS',                        -- Global Imaging System
     d_current_date,               -- When installed
     n_user_id,                    -- fnd_user.user_id
     d_current_date,               -- When installed
     n_user_id,                    -- fnd_user.user_id
     n_user_id,                    -- fnd_user.user_id
     'GIS_TOP');                   -- Basepath

  insert into fnd_application_tl
    (application_id,
     language,
     application_name,
     created_by,
     creation_date,
     last_updated_by,
     last_update_date,
     last_update_login,
     description,
     source_lang)
  values
    (n_application_id,             -- Sequence number
     userenv('LANG'),              -- Language
     'Oracle Global Imaging',      -- Application name
     n_user_id,                    -- fnd_user.user_id
     d_current_date,               -- When installed
     n_user_id,                    -- fnd_user.user_id
     d_current_date,               -- When installed
     n_user_id,                    -- fnd_user.user_id
     'Oracle Global Imaging',      -- Description
     userenv('LANG'));             -- Source Language

  /* GIS_DEFAULTS */

  insert into fnd_lookup_types
    (application_id,
     lookup_type,
     customization_level,
     created_by,
     creation_date,
     last_updated_by,
     last_update_date,
     last_update_login,
     security_group_id,
     view_application_id)
  values
    (n_application_id,             -- Sequence number
     'GIS_DEFAULTS',               -- LOOKUP TYPE
     'S',                          -- Customization level
     n_user_id,                    -- fnd_user.user_id
     d_current_date,               -- When installed
     n_user_id,                    -- fnd_user.user_id
     d_current_date,               -- When installed
     n_user_id,                    -- fnd_user.user_id
     0,                            -- Security group id
     0);                           -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_DEFAULTS',                      -- LOOKUP TYPE
     userenv('LANG'),                     -- Source Language
     'A',                                 -- LOOKUP CODE
     'ACTIVE CUSTOMER',                   -- Meaning
     'Active customer for creation',      -- Description
     'Y',                                 -- Enabled
     d_current_date,                      -- Start date active
     NULL,                                -- End date active
     n_user_id,                           -- fnd_user.user_id
     d_current_date,                      -- When installed
     n_user_id,                           -- fnd_user.user_id
     n_user_id,                           -- fnd_user.user_id
     d_current_date,                      -- When installed
     userenv('LANG'),                     -- Source Language
     0,                                   -- Security group id
     0);                                  -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_DEFAULTS',                      -- LOOKUP TYPE
     userenv('LANG'),                     -- Source Language
     'I',                                 -- LOOKUP CODE
     'INSERT FLAG',                       -- Meaning
     'Insert flag for customer creation', -- Description
     'Y',                                 -- Enabled
     d_current_date,                      -- Start date active
     NULL,                                -- End date active
     n_user_id,                           -- fnd_user.user_id
     d_current_date,                      -- When installed
     n_user_id,                           -- fnd_user.user_id
     n_user_id,                           -- fnd_user.user_id
     d_current_date,                      -- When installed
     userenv('LANG'),                     -- Source Language
     0,                                   -- Security group id
     0);                                  -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_DEFAULTS',                      -- LOOKUP TYPE
     userenv('LANG'),                     -- Source Language
     'DEFAULT',                           -- LOOKUP CODE
     'CUSTOMER PROFILE',                  -- Meaning
     'Default customer profile',          -- Description
     'Y',                                 -- Enabled
     d_current_date,                      -- Start date active
     NULL,                                -- End date active
     n_user_id,                           -- fnd_user.user_id
     d_current_date,                      -- When installed
     n_user_id,                           -- fnd_user.user_id
     n_user_id,                           -- fnd_user.user_id
     d_current_date,                      -- When installed
     userenv('LANG'),                     -- Source Language
     0,                                   -- Security group id
     0);                                  -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_DEFAULTS',                      -- LOOKUP TYPE
     userenv('LANG'),                     -- Source Language
     'N',                                 -- LOOKUP CODE
     'CREDIT HOLD',                       -- Meaning
     'Default credit hold',               -- Description
     'Y',                                 -- Enabled
     d_current_date,                      -- Start date active
     NULL,                                -- End date active
     n_user_id,                           -- fnd_user.user_id
     d_current_date,                      -- When installed
     n_user_id,                           -- fnd_user.user_id
     n_user_id,                           -- fnd_user.user_id
     d_current_date,                      -- When installed
     userenv('LANG'),                     -- Source Language
     0,                                   -- Security group id
     0);                                  -- View application id

  /* GIS_STATUS_CODE */

  insert into fnd_lookup_types
    (application_id,
     lookup_type,
     customization_level,
     created_by,
     creation_date,
     last_updated_by,
     last_update_date,
     last_update_login,
     security_group_id,
     view_application_id)
  values
    (n_application_id,             -- Sequence number
     'GIS_STATUS_CODE',            -- LOOKUP TYPE
     'S',                          -- Customization level
     n_user_id,                    -- fnd_user.user_id
     d_current_date,               -- When installed
     n_user_id,                    -- fnd_user.user_id
     d_current_date,               -- When installed
     n_user_id,                    -- fnd_user.user_id
     0,                            -- Security group id
     0);                           -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_STATUS_CODE',              -- LOOKUP TYPE
     userenv('LANG'),                -- Source Language
     '10',                           -- LOOKUP CODE
     'UNPROCESSED',                  -- Meaning
     'Unprocessed',                  -- Description
     'Y',                            -- Enabled
     d_current_date,                 -- Start date active
     NULL,                           -- End date active
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     n_user_id,                      -- fnd_user.user_id
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     userenv('LANG'),                -- Source Language
     0,                              -- Security group id
     0);                             -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_STATUS_CODE',              -- LOOKUP TYPE
     userenv('LANG'),                -- Source Language
     '20',                           -- LOOKUP CODE
     'CREATE CUSTOMER',              -- Meaning
     'Create customer',              -- Description
     'Y',                            -- Enabled
     d_current_date,                 -- Start date active
     NULL,                           -- End date active
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     n_user_id,                      -- fnd_user.user_id
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     userenv('LANG'),                -- Source Language
     0,                              -- Security group id
     0);                             -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_STATUS_CODE',              -- LOOKUP TYPE
     userenv('LANG'),                -- Source Language
     '30',                           -- LOOKUP CODE
     'CUSTOMER INTERFACE ELIGIBLE',  -- Meaning
     'Customer interface eligible',  -- Description
     'Y',                            -- Enabled
     d_current_date,                 -- Start date active
     NULL,                           -- End date active
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     n_user_id,                      -- fnd_user.user_id
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     userenv('LANG'),                -- Source Language
     0,                              -- Security group id
     0);                             -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_STATUS_CODE',              -- LOOKUP TYPE
     userenv('LANG'),                -- Source Language
     '35',                           -- LOOKUP CODE
     'CUSTOMER INTERFACE ERROR',     -- Meaning
     'Customer interface error',     -- Description
     'Y',                            -- Enabled
     d_current_date,                 -- Start date active
     NULL,                           -- End date active
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     n_user_id,                      -- fnd_user.user_id
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     userenv('LANG'),                -- Source Language
     0,                              -- Security group id
     0);                             -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_STATUS_CODE',              -- LOOKUP TYPE
     userenv('LANG'),                -- Source Language
     '40',                           -- LOOKUP CODE
     'CUSTOMER INTERFACE COMPLETE',  -- Meaning
     'Customer interface complete',  -- Description
     'Y',                            -- Enabled
     d_current_date,                 -- Start date active
     NULL,                           -- End date active
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     n_user_id,                      -- fnd_user.user_id
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     userenv('LANG'),                -- Source Language
     0,                              -- Security group id
     0);                             -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_STATUS_CODE',              -- LOOKUP TYPE
     userenv('LANG'),                -- Source Language
     '50',                           -- LOOKUP CODE
     'CUSTOMER EXISTS',              -- Meaning
     'Customer exists',              -- Description
     'Y',                            -- Enabled
     d_current_date,                 -- Start date active
     NULL,                           -- End date active
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     n_user_id,                      -- fnd_user.user_id
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     userenv('LANG'),                -- Source Language
     0,                              -- Security group id
     0);                             -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_STATUS_CODE',              -- LOOKUP TYPE
     userenv('LANG'),                -- Source Language
     '60',                           -- LOOKUP CODE
     'ORDER INTERFACE ELIGIBLE',     -- Meaning
     'Order interface eligible',     -- Description
     'Y',                            -- Enabled
     d_current_date,                 -- Start date active
     NULL,                           -- End date active
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     n_user_id,                      -- fnd_user.user_id
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     userenv('LANG'),                -- Source Language
     0,                              -- Security group id
     0);                             -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_STATUS_CODE',              -- LOOKUP TYPE
     userenv('LANG'),                -- Source Language
     '65',                           -- LOOKUP CODE
     'ORDER INTERFACE ERROR',        -- Meaning
     'Order interface error',        -- Description
     'Y',                            -- Enabled
     d_current_date,                 -- Start date active
     NULL,                           -- End date active
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     n_user_id,                      -- fnd_user.user_id
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     userenv('LANG'),                -- Source Language
     0,                              -- Security group id
     0);                             -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_STATUS_CODE',              -- LOOKUP TYPE
     userenv('LANG'),                -- Source Language
     '70',                           -- LOOKUP CODE
     'ORDER INTERFACE COMPLETE',     -- Meaning
     'Order interface complete',     -- Description
     'Y',                            -- Enabled
     d_current_date,                 -- Start date active
     NULL,                           -- End date active
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     n_user_id,                      -- fnd_user.user_id
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     userenv('LANG'),                -- Source Language
     0,                              -- Security group id
     0);                             -- View application id

  insert into fnd_lookup_values
    (lookup_type,
     language,
     lookup_code,
     meaning,
     description,
     enabled_flag,
     start_date_active,
     end_date_active,
     created_by,
     creation_date,
     last_updated_by,
     last_update_login,
     last_update_date,
     source_lang,
     security_group_id,
     view_application_id)
  values
    ('GIS_STATUS_CODE',              -- LOOKUP TYPE
     userenv('LANG'),                -- Source Language
     '80',                           -- LOOKUP CODE
     'COMPLETE',                     -- Meaning
     'Complete',                     -- Description
     'Y',                            -- Enabled
     d_current_date,                 -- Start date active
     NULL,                           -- End date active
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     n_user_id,                      -- fnd_user.user_id
     n_user_id,                      -- fnd_user.user_id
     d_current_date,                 -- When installed
     userenv('LANG'),                -- Source Language
     0,                              -- Security group id
     0);                             -- View application id

end;
/

select 'Registering GIS application, install lookup types completed.' from dual;

select to_char(sysdate,'DD-MON-RRRR HH:MI') from dual;

commit;

spool off;



