DECLARE

n_application_id NUMBER;
n_user_id NUMBER;
v_appExists  VARCHAR2(1)           := 'N' ;
v_userExists VARCHAR2(1)           := 'N' ;

CURSOR appExists IS
SELECT 'Y'
FROM fnd_application
WHERE application_short_name = 'IMAGING';

CURSOR userExists IS
SELECT 'Y'
FROM fnd_oracle_userid
WHERE oracle_username = 'IMAGING';

BEGIN
  /*
   * Check to see if application already exists
   */
	OPEN  userExists ;
	FETCH userExists INTO v_userExists ;
	CLOSE userExists ;

	IF v_userExists <> 'Y'
	THEN
		SELECT fnd_oracle_userid_s.NEXTVAL
		INTO n_user_id
		FROM dual;

		INSERT INTO fnd_oracle_userid
		VALUES( n_user_id
				,'IMAGING'
				,'Oracle Global Imaging v2'
				,SYSDATE
				,1
				,NULL
				,'N'
				,'A'
				,NULL
				,1
				,SYSDATE
				,1
				,1);
	END IF;

	OPEN  appExists ;
	FETCH appExists INTO v_appExists ;
	CLOSE appExists ;

	IF v_appExists <> 'Y'
	THEN
		SELECT fnd_application_s.NEXTVAL
		INTO n_application_id
		FROM dual;


		INSERT INTO fnd_application
		VALUES( n_application_id
				,'IMAGING'
				,'GIS_TOP'
				,SYSDATE
				,1
				,NULL
				,1
				,SYSDATE);

		INSERT INTO fnd_application_tl
		VALUES( n_application_id
				,'US'
				,'Oracle Global Imaging'
				,'Oracle Global Imaging System V2'
				,1
				,SYSDATE
				,1
				,SYSDATE
				,NULL
				,'US');

		COMMIT;
	END IF;
END;
/
