-- ============================================================================
--
--   NAME
--      gisownr.sql
--
--   DESCRIPTION
--      This script is used to create the Global Imaging schema (imaging)
--
--   HISTORY
--      17/10/2000 David Gough Original version
--
-- ============================================================================

set echo off
set verify off
set serverout on
set heading off

prompt
prompt This script will create a schema imaging, for Global Imaging.
prompt 
accept system_pwd prompt 'Enter SYSTEM password           : ' hide
accept img_pwd   prompt 'Enter password for Imaging      : '
--accept eul_role   prompt 'Enter the Role for Imaging      : '
accept dflt_ts    prompt 'Enter the default tablespace    : '
accept idx_ts     prompt 'Enter the index tablespace      : ' 
accept temp_ts    prompt 'Enter the temporary tablespace  : '

PROMPT
PROMPT     Press <return> to continue or <ctrl-c> to exit.;
pause


---------------------------------------------------------------------------
--  Create log file and check passwords                                   -
---------------------------------------------------------------------------
WHENEVER SQLERROR EXIT FAILURE ROLLBACK;

spool gisownr.log

SELECT 'Imaging schema creation log file : '||
          to_char(SYSDATE, 'DD-MON-YYYY HH24:MI.SS')
FROM   sys.dual;

PROMPT
PROMPT
PROMPT  Checking passwords have been entered correctly ...
PROMPT


PROMPT

conn system/&&system_pwd
SELECT  'SYSTEM password correct.'
FROM    dual;

WHENEVER SQLERROR CONTINUE


CREATE USER IMAGING 
identified by &&img_pwd
default tablespace &&dflt_ts
temporary tablespace &&temp_ts
quota unlimited on &&dflt_ts
quota unlimited on &&idx_ts
quota unlimited on &&temp_ts;

alter user IMAGING default role all;

grant create table to imaging;
grant create synonym to imaging;
grant create session to imaging;
grant create public synonym to imaging;
grant drop public synonym to imaging;
grant create view to imaging;
grant create procedure to imaging;
grant create sequence to imaging;

commit;

exit
