-- ============================================================================
--
--   NAME
--      gis_indexes.sql
--
--   DESCRIPTION
--      Script to create indexes required for GIS 
--
--   HISTORY
--      29/09/2000 David Gough Original version
--		08/11/2000 David Gough FND_LOBS_GIS_N1 index
--					altered to use file_name and program tag
--
-- ============================================================================

CONNECT &img_usr/&img_pwd;

DROP INDEX GIS_SCANNERS_U1;
CREATE UNIQUE INDEX GIS_SCANNERS_U1 ON GIS_SCANNERS("SCANNER_ID")
INITRANS 2
MAXTRANS 255
TABLESPACE &table_i
STORAGE (INITIAL 1000K next 500K pctincrease 0 MAXEXTENTS 255)
PCTFREE 5;

DROP INDEX GIS_SCANNERS_N1;
CREATE INDEX GIS_SCANNERS_N1 ON GIS_SCANNERS("ORGANIZATION_ID")
INITRANS 2
MAXTRANS 255
TABLESPACE &table_i
STORAGE (INITIAL 1000K next 500K pctincrease 0 MAXEXTENTS 255)
PCTFREE 5;
 
DROP INDEX GIS_DOC_STATUS_TYPES_U1;
CREATE UNIQUE INDEX GIS_DOC_STATUS_TYPES_U1 ON GIS_DOC_STATUS_TYPES("DOC_STATUS_TYPE_ID")
INITRANS 2
MAXTRANS 255
TABLESPACE &table_i
STORAGE (INITIAL 1000K next 500K pctincrease 0 MAXEXTENTS 255)
PCTFREE 5;   

DROP INDEX GIS_DOC_STATUS_U1;
CREATE UNIQUE INDEX GIS_DOC_STATUS_U1 ON GIS_DOC_STATUS("DOCUMENT_ID","DOC_STATUS_TYPE_ID")
INITRANS 2
MAXTRANS 255
TABLESPACE &table_i
STORAGE (INITIAL 1000K next 500K pctincrease 0 MAXEXTENTS 255)
PCTFREE 5;   

DROP INDEX GIS_SCAN_USERS_U1;
CREATE UNIQUE INDEX GIS_SCAN_USERS_U1 ON GIS_SCAN_USERS("SCANNER_ID","FND_USER_ID")
INITRANS 2
MAXTRANS 255
TABLESPACE &table_i
STORAGE (INITIAL 1000K next 500K pctincrease 0 MAXEXTENTS 255)
PCTFREE 5;

ALTER TABLE imaging.gis_event_log_all DROP CONSTRAINT gis_event_log_pk; 
ALTER TABLE imaging.gis_event_log_all
ADD constraint gis_event_log_pk primary key (event_id) using INDEX tablespace &table_i
STORAGE (INITIAL 1000K next 500K pctincrease 0 MAXEXTENTS 255)
PCTFREE 5;

DROP INDEX gis_event_log_n1;
CREATE INDEX imaging.gis_event_log_n1
ON imaging.gis_event_log_all (file_id) tablespace &table_i
STORAGE (INITIAL 1000K next 500K pctincrease 0 MAXEXTENTS 255)
PCTFREE 5;                               

-- new index required on std fnd tables
CONNECT &applsys_usr/&applsys_pwd;

DROP INDEX  FND_DOCUMENTS_TL_GIS_N1;
CREATE INDEX FND_DOCUMENTS_TL_GIS_N1 ON FND_DOCUMENTS_TL("DOC_ATTRIBUTE_CATEGORY")
INITRANS 2
MAXTRANS 255
TABLESPACE &applsys_table_i
STORAGE (INITIAL 1000K next 500K pctincrease 0 MAXEXTENTS 255)
PCTFREE 5;

DROP INDEX FND_LOBS_GIS_N1;
CREATE INDEX FND_LOBS_GIS_N1 ON FND_LOBS("FILE_NAME","PROGRAM_TAG")
INITRANS 2
MAXTRANS 255
TABLESPACE &applsys_table_i
STORAGE (INITIAL 1000K next 500K pctincrease 0 MAXEXTENTS 255)
PCTFREE 5;     
