CREATE OR REPLACE
PACKAGE BODY apps.gis_admin_screen IS
-- ============================================================================
--
--   NAME
--      gis_admin_screen_pkb.sql
--
--   DESCRIPTION
--      This script is used to create the gis_admin_screen package body
--      It controls the web administration screens of GIS 
--      
--   HISTORY
--      10/08/2000 David Gough In Development
--      12/06/2001 David Gough Secure document field added to update
--                 and create document category screens
--
-- =============================================================================

PROCEDURE adminMenu( p_userId VARCHAR2) IS

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.adminMenu');
	gis_image_util.infoHeader('GIS - Administration');
	htp.p( '<SCRIPT LANGUAGE="javascript">' );
	htp.p( 'parent.ViewingFrame.document.location="gis_image_util.ViewingFrame?p_userType=Administration"' );
	htp.p( '</SCRIPT>');
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('	<TR>');
 	htp.p('    <TD WIDTH="50%" ALIGN="LEFT" VALIGN="MIDDLE"><B>Scanners</B></TD>');
 	htp.p('    <TD WIDTH="50%" ALIGN="LEFT" VALIGN="MIDDLE"><B>User Scanners</B></TD>');
	htp.p('	</TR>');
	htp.p('	<TR>'); 
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_admin_screen.sortByList?p_userId='||p_userId||'&p_listType=Scanner" TARGET="QueryFrame">
 							<FONT COLOR="ORANGE" SIZE="3">List</FONT></A></TD>');
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_admin_screen.sortByList?p_userId='||p_userId||'&p_listType=User" TARGET="QueryFrame">
 							<FONT COLOR="ORANGE" SIZE="3">List</FONT></A></TD>');
	htp.p('	</TR>');
	htp.p('	<TR>'); 
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_admin_screen.addScanner?p_userId='||p_userId||'" TARGET="QueryFrame">
 							<FONT COLOR="ORANGE" SIZE="3">Add</FONT></A></TD>');
 	htp.p('     <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_admin_screen.userScannerLink?p_userId='||p_userId||'" TARGET="QueryFrame">
							 <FONT COLOR="ORANGE" SIZE="3">Add</FONT></A></TD>');
	htp.p('	</TR>');  			 	
--	htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="'||gis_image_util.c_image_url||'empty.gif"></TD>');
    -- Added by PL: 11/12/2000 - option to link to gis_image_util to allow for mass update of storage location
	htp.p('	<TR>');
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><B>Storage Location</B></TD>');
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><B>Document Categories</TD>');
	htp.p('	</TR>');
	htp.p('	<TR>'); 
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_image_util.UpdateLocation?p_user_id='||p_userId||'" TARGET="ViewingFrame">
 							<FONT COLOR="ORANGE" SIZE="3">Update</FONT></A></TD>');
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_admin_screen.viewDocCategoriesBy?p_userId='||p_userId||'" TARGET="QueryFrame">
 							<FONT COLOR="ORANGE" SIZE="3">View</FONT></TD>');
	htp.p('	</TR>'); 
	htp.p('	<TR>'); 
 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE"></TD>');
 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_admin_screen.addDocCategory?p_userId='||p_userId||'" TARGET="QueryFrame">
 							<FONT COLOR="ORANGE" SIZE="3">Add</FONT></TD>');
	htp.p('	</TR>');   			 	
	htp.p('</TABLE>');
	gis_image_util.pageclose;
END adminmenu;

PROCEDURE sortBy(  	p_userId VARCHAR2
					,p_listType VARCHAR2
					,p_sortByList VARCHAR2
					,p_scannerSelection VARCHAR2 DEFAULT NULL
					,p_userSelection VARCHAR2 DEFAULT NULL)
IS

BEGIN
--	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.sortBy');
--	gis_image_util.infoHeader('GIS');
	IF p_listType = 'User'
	THEN
		scanUserList(p_userId, p_sortByList,p_scannerSelection,p_userSelection);		
	ELSIF p_listType = 'Scanner'
	THEN
		scannerList( p_userId, p_sortByList);
	END IF;
--	gis_image_util.pageclose;		
END sortBy;

PROCEDURE sortByList( p_userId VARCHAR2, p_listType VARCHAR2)
IS

CURSOR cur_scannerList IS
SELECT scanner_id
FROM gis_scanners
ORDER BY scanner_id;

CURSOR cur_userList IS
SELECT DISTINCT usr.user_id
,usr.user_name
FROM fnd_user usr
,gis_scan_users susr
WHERE usr.user_id = susr.fnd_user_id
ORDER BY usr.user_name; 

row_scannerList cur_scannerList%ROWTYPE;
row_userList cur_userList%ROWTYPE;

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.adminMenu');
	gis_image_util.infoHeader('Select ' || p_listType || ' Order By');
	htp.formOpen('gis_admin_screen.sortBy', 'POST',cattributes=>'NAME="sortByList" TARGET="ViewingFrame"');
	htp.formHidden('p_userId',p_userId);
	htp.formHidden('p_listType',p_listType);
	htp.br;
		htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
		htp.p('	<TR>');	
		htp.p('		<TD ALIGN="RIGHT"><B>');
		htp.p('			Order By ');
		htp.p('		</B></TD>');
		htp.p('		<TD>');		
		htp.formSelectOpen(cname=>'p_sortByList',nsize=>'3');	
		
	IF p_listType = 'User'
	THEN
		htp.formSelectOption( 'User Name','SELECTED', CATTRIBUTES=>'VALUE="USR.USER_NAME"');
		htp.formSelectOption( 'Organization', CATTRIBUTES=>'VALUE="ORG.NAME"');
		htp.formSelectOption( 'Scanner ID', CATTRIBUTES=>'VALUE="SCN.SCANNER_ID"');
		htp.formSelectClose;
		htp.p('		</TD>');
		htp.p('	</TR>');
		htp.p('	<TR>');
		htp.p('		<TD><B>');
		htp.p('Restrict List To');
		htp.p('		<B></TD>');
		htp.p('	</TR>');
		htp.p(' <TR>');		
		htp.p('		<TD ALIGN="RIGHT"><B>');
		htp.p('			Scanner ');
		htp.p('		</B></TD>');
		htp.p('		<TD ALIGN="LEFT">');		
		IF NOT cur_scannerList%ISOPEN
		THEN
			OPEN cur_scannerList;
		END IF;
		
		FETCH cur_scannerList INTO row_scannerList;
		IF cur_scannerList%NOTFOUND THEN
			-- need some sort of error handler here
			NULL;
		ELSE
			htp.formSelectOpen(cname=>'p_scannerSelection',nsize=>'3');	
			htp.formSelectOption( 'No Restriction','SELECTED', CATTRIBUTES=>'VALUE="ALL"');
			WHILE cur_scannerList%FOUND
			LOOP
				htp.formSelectOption( row_scannerList.scanner_id, CATTRIBUTES=>'value='||	
													row_scannerList.scanner_id);
				FETCH cur_scannerList INTO row_scannerList;		
			END LOOP;
		END IF;
		CLOSE cur_scannerList; 
		htp.formSelectClose;
		htp.p('		</TD>');
		htp.p('	</TR>'); 
		htp.p(' <TR>');		
		htp.p('		<TD ALIGN="RIGHT"><B>');
		htp.p('			User ');
		htp.p('		</B></TD>');
		htp.p('		<TD ALIGN="LEFT">');		
		IF NOT cur_userList%ISOPEN
		THEN
			OPEN cur_userList;
		END IF;
		
		FETCH cur_userList INTO row_userList;
		IF cur_userList%NOTFOUND THEN
			-- need some sort of error handler here
			NULL;
		ELSE
			htp.formSelectOpen(cname=>'p_userSelection',nsize=>'3');	
			htp.formSelectOption( 'No Restriction','SELECTED', CATTRIBUTES=>'VALUE="ALL"');
			WHILE cur_userList%FOUND
			LOOP
				htp.formSelectOption( row_userList.user_name, CATTRIBUTES=>'value='||	
													row_userList.user_id);
				FETCH cur_userList INTO row_userList;		
			END LOOP;
		END IF;
		CLOSE cur_userList; 				 		
	ELSIF p_listType = 'Scanner'
	THEN
		htp.formSelectOption( 'Scanner ID','SELECTED', CATTRIBUTES=>'VALUE="SCN.SCANNER_ID"');
		htp.formSelectOption( 'Organization', CATTRIBUTES=>'VALUE="ORG.NAME"');
	END IF;
	htp.formSelectClose;
	htp.p('		</TD>');
	htp.p('	</TR>'); 
	htp.p('</TABLE>');
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('	<TR>');	
	htp.p('		<TD ALIGN="CENTER"><A href="JavaScript:document.sortByList.submit()"><IMG SRC="'||gis_image_util.c_image_url||'b_report_m.gif" BORDER="0" ALT="Find Records">');
	htp.p('		</TD>');
	htp.p('	</TR>'); 
	htp.p('</TABLE>');	
	htp.formClose;
	gis_image_util.pageclose;
END sortByList;

PROCEDURE scannerList( p_userId VARCHAR2, p_sortByList VARCHAR2) IS

l_rowCount NUMBER;
cid INTEGER;
sqlSource VARCHAR2(2000);
l_scanner_id VARCHAR2(15);
l_org_name VARCHAR2(50);
l_ip_address VARCHAR2(50);
l_desc VARCHAR2(150);
l_host_name VARCHAR2(50);
 
BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.scannerList');
	gis_image_util.infoHeader('Scanner Details');
	htp.formOpen('gis_admin_screen.sortBy', 'POST',cattributes=>'NAME="scannerList" TARGET="ViewingFrame"');	
	sqlSource := 	'SELECT scn.scanner_id '||
					', org.name '||
					', scn.ip_address '||
					', scn.description '||
					', scn.hostname '||
					'FROM gis_scanners scn '||
					', hr_operating_units org '||
					'WHERE scn.organization_id = org.organization_id '||
					'ORDER BY '|| p_sortByList;
					
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('	<TR>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Select</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Scanner Id</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Organization</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>IP Address</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Description</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Hostname</B></FONT></TD>');
	htp.p('	</TR>');

	cid := dbms_sql.open_cursor;
	dbms_sql.parse( cid, sqlSource, dbms_sql.v7);
	dbms_sql.define_column( cid, 1, l_scanner_id,15);
	dbms_sql.define_column( cid, 2, l_org_name, 50);
	dbms_sql.define_column( cid, 3, l_ip_address, 50);
	dbms_sql.define_column( cid, 4, l_desc, 150);
	dbms_sql.define_column( cid, 5, l_host_name, 50);

	l_rowCount := dbms_sql.execute_and_fetch( cid);
	
	WHILE l_rowCount = 1
	LOOP
		dbms_sql.column_value( cid, 1, l_scanner_id);
		dbms_sql.column_value( cid, 2, l_org_name);
		dbms_sql.column_value( cid, 3, l_ip_address);
		dbms_sql.column_value( cid, 4, l_desc);	
		dbms_sql.column_value( cid, 5, l_host_name);

		htp.p('	<TR>');
	 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE"><INPUT TYPE="checkBox" NAME="deleteFlag" VALUE="'||l_scanner_id||'"></TD>');
	 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE">'||l_scanner_id||'</TD>');
	 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE">'||l_org_name||'</TD>');
        -- Modified by PL 02/03/2001
        -- Added hyperlink to IP address for scanner maintenance
        IF gis_image_util.validIP(l_ip_address) THEN
          htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE"><FONT COLOR="WHITE"><A HREF="http://' || l_ip_address || '">'||l_ip_address||'</A></FONT></TD>');
        ELSE
          htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE">'||l_ip_address||'</TD>');
        END IF;
	 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE">'||l_desc||'</TD>');
	 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE">'||l_host_name||'</TD>');
		htp.p('	</TR>'); 			 	
		
		l_rowCount := dbms_sql.fetch_rows( cid);
	END LOOP;
	htp.p('</TABLE>');
	
	htp.p('</TABLE>');
	htp.br;	
	dbms_sql.close_cursor( cid);
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('	<TR>');
	htp.p('		<TD ALIGN="RIGHT"><A href="JavaScript:delModifyScanner('||p_userId||','''||p_sortByList||''',''DELETE'')"><IMG SRC="'||
					gis_image_util.c_image_url||'b_delete_l.gif" BORDER="0" ALT="Delete Selected Records">');
	htp.p('		</TD>');
	htp.p('		<TD ALIGN="LEFT"><A href="JavaScript:delModifyScanner('||p_userId||','''||p_sortByList||''',''MODIFY'')"><IMG SRC="'||
					gis_image_util.c_image_url||'b_reindex_r.gif" BORDER="0" ALT="Modify Selected Records">');
	htp.p('		</TD>');
	htp.p('	</TR>');
	htp.p('</TABLE>');	
	htp.FormClose;	
	gis_image_util.pageclose;
END scannerList;

PROCEDURE addScanner( 	p_userId VARCHAR2
						, p_scannerId VARCHAR2 DEFAULT NULL
						, p_operation VARCHAR2 DEFAULT 'Add'
						,p_sortByList VARCHAR2 DEFAULT NULL) IS

CURSOR cur_operatingUnits IS
SELECT name
, organization_id
FROM hr_operating_units;

row_operatingUnits cur_operatingUnits%ROWTYPE;
l_scannerId VARCHAR2(15);
l_org VARCHAR2(50);
l_ipAddress VARCHAR2(50);
l_hostname VARCHAR2(50);
l_password VARCHAR(25);
l_description VARCHAR2(150);
l_attribute1 VARCHAR2(50);
l_attribute2 VARCHAR2(50);
l_attribute3 VARCHAR2(50);
l_attribute4 VARCHAR2(50);
l_orgId NUMBER(15);

BEGIN
	IF p_scannerId IS NOT NULL
	THEN
		SELECT 	scn.scanner_id
				,org.name
				,scn.ip_address
				,scn.hostname
				,scn.password
				,scn.description
				,attribute1
				,attribute2
				,attribute3
				,attribute4
				,org.organization_id
		INTO	l_scannerId
				,l_org
				,l_ipAddress
				,l_hostname
				,l_password 
				,l_description
				,l_attribute1
				,l_attribute2
				,l_attribute3
				,l_attribute4
				,l_orgId		
		FROM gis_scanners scn
			,hr_operating_units org
		WHERE scanner_id = p_scannerId
		AND scn.organization_id = org.organization_id;
	END IF;
				
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.addScanner');
	gis_image_util.infoHeader( p_operation ||' Scanner');
	htp.formOpen('gis_admin_screen.saveScanner', 'POST',cattributes=>'NAME="addScanner"');
	htp.formHidden('p_operation',p_operation);
	htp.formHidden('p_userId',p_userId);
	htp.formHidden('p_sortByList',p_sortByList);
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Scanner Id : </B></TD>');
	IF p_scannerId IS NOT NULL
	THEN
		htp.p('		<TD>'||l_scannerId||'</TD>');
		htp.formHidden('p_scannerId', l_scannerId);	
	ELSE
		htp.p('		<TD><INPUT NAME="p_scannerId" COLS=15 TYPE=TEXT size="15" maxlength="15"></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Org : </B></TD><TD>');	

	IF p_scannerId IS NOT NULL
	THEN
		htp.p(l_org); 
		htp.formHidden( 'p_orgId', l_orgId);	
	ELSE
		IF NOT cur_operatingUnits%ISOPEN
		THEN
			OPEN cur_operatingUnits;
		END IF;
		
		FETCH cur_operatingUnits INTO row_operatingUnits;
		IF cur_operatingUnits%NOTFOUND THEN
			-- need some sort of error handler here
			NULL;
		ELSE
			htp.formSelectOpen(cname=>'p_orgId',nsize=>'1');
			htp.formSelectOption( substr(row_operatingUnits.name,1,25),'SELECTED', CATTRIBUTES=>'value='||	
									row_operatingUnits.organization_id);	
			FETCH cur_operatingUnits INTO row_operatingUnits;
			WHILE cur_operatingUnits%FOUND
			LOOP
					htp.formSelectOption( substr(row_operatingUnits.name,1,25), CATTRIBUTES=>'value='||	
												row_operatingUnits.organization_id);

				FETCH cur_operatingUnits INTO row_operatingUnits;		
			END LOOP;
			htp.formSelectClose;
		END IF;
		CLOSE cur_operatingUnits; 
	END IF;
	htp.p('	</TD></TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>IP Address : </B></TD>');
	IF p_scannerId IS NOT NULL
	THEN
		htp.p('		<TD><INPUT NAME="p_ipAddress" COLS=15 TYPE=TEXT size="20" maxlength="50" VALUE="'||l_ipAddress||'"></TD>');
	ELSE
		htp.p('		<TD><INPUT NAME="p_ipAddress" COLS=15 TYPE=TEXT size="20" maxlength="50"></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Password : </B></TD>');
	IF p_scannerId IS NOT NULL
	THEN
		htp.p('		<TD><INPUT NAME="p_password" COLS=15 TYPE=TEXT size="20" maxlength="15" VALUE="'||l_password||'"></TD>');	
	ELSE
		htp.p('		<TD><INPUT NAME="p_password" COLS=15 TYPE=TEXT size="20" maxlength="15"></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Hostname : </B></TD>');
	IF p_scannerId IS NOT NULL
	THEN
		htp.p('		<TD><INPUT NAME="p_hostname" COLS=15 TYPE=TEXT size="20" maxlength="25" VALUE="'||l_hostname||'"></TD>');
	ELSE
		htp.p('		<TD><INPUT NAME="p_hostname" COLS=15 TYPE=TEXT size="20" maxlength="25"></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Description : </B></TD>');
	IF p_scannerId IS NOT NULL
	THEN
		htp.p('		<TD><INPUT NAME="p_description" COLS=15 TYPE=TEXT size="20" maxlength="150" VALUE="'||l_description||'"></TD>');	
	ELSE
		htp.p('		<TD><INPUT NAME="p_description" COLS=15 TYPE=TEXT size="20" maxlength="150"></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Email 1 : </B></TD>');
	IF p_scannerId IS NOT NULL
	THEN
		htp.p('		<TD><INPUT NAME="p_attribute1" COLS=15 TYPE=TEXT size="23" maxlength="150" VALUE="'||l_attribute1||'"></TD>');	
	ELSE
		htp.p('		<TD><INPUT NAME="p_attribute1" COLS=15 TYPE=TEXT size="23" maxlength="150"></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Email 2 : </B></TD>');
	IF p_scannerId IS NOT NULL
	THEN
		htp.p('		<TD><INPUT NAME="p_attribute2" COLS=15 TYPE=TEXT size="23" maxlength="150" VALUE="'||l_attribute2||'"></TD>');	
	ELSE
		htp.p('		<TD><INPUT NAME="p_attribute2" COLS=15 TYPE=TEXT size="23" maxlength="150"></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Email 3 : </B></TD>');
	IF p_scannerId IS NOT NULL
	THEN
		htp.p('		<TD><INPUT NAME="p_attribute3" COLS=15 TYPE=TEXT size="23" maxlength="150" VALUE="'||l_attribute3||'"></TD>');	
	ELSE
		htp.p('		<TD><INPUT NAME="p_attribute3" COLS=15 TYPE=TEXT size="23" maxlength="150"></TD>');
	END IF;
	htp.p('	</TR>');
    -- Added PL: 24/05/2001 to enter optional default storage location for preindex screen input fields
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Storage : </B></TD>');
	IF p_scannerId IS NOT NULL
	THEN
		htp.p('		<TD><INPUT NAME="p_attribute4" COLS=15 TYPE=TEXT size="23" maxlength="150" VALUE="'||l_attribute4||'"></TD>');	
	ELSE
		htp.p('		<TD><INPUT NAME="p_attribute4" COLS=15 TYPE=TEXT size="23" maxlength="150"></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p('</TABLE>');
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');	
	htp.p('		<TD ALIGN="CENTER"><A href="JavaScript:document.addScanner.submit();"><IMG SRC="'||gis_image_util.c_image_url||'b_save_m.gif" BORDER="0" ALT="Save Record"></TD>');
	htp.p('	</TR>');
	htp.p('</TABLE>');
	htp.formClose;	
	gis_image_util.pageclose;
END addScanner;

PROCEDURE saveScanner( p_userId VARCHAR2
						,p_scannerId VARCHAR2
						,p_orgId VARCHAR2
						,p_ipAddress VARCHAR2
						,p_password VARCHAR2
						,p_hostname VARCHAR2
						,p_description VARCHAR2
						,p_attribute1 VARCHAR2 DEFAULT NULL
						,p_attribute2 VARCHAR2 DEFAULT NULL
						,p_attribute3 VARCHAR2 DEFAULT NULL
						,p_attribute4 VARCHAR2 DEFAULT NULL
						,p_operation VARCHAR2
						,p_sortByList VARCHAR2 DEFAULT NULL) IS

l_recordCheck NUMBER(1);

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.saveScanner');
	gis_image_util.infoHeader('Add Scanner Status');
	htp.br;
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');
	htp.p('		<TD VALIGN="TOP" ALIGN="RIGHT"><IMG SRC="'||gis_image_util.c_image_url||'i_note.gif" ALT="Note"></TD>');
	IF p_operation = 'Add'
	THEN
		SELECT count(scanner_id)
		INTO l_recordCheck
		FROM gis_scanners
		WHERE scanner_id = p_scannerId;
		
		IF l_recordCheck > 0 OR p_scannerId IS NULL
		THEN
			htp.p('		<TD ALIGN="LEFT"><B>Scanner Id not Unique - Please re-enter</B></TD>');	
		ELSE
			INSERT INTO gis_scanners(scanner_id
									,organization_id
									,ip_address,password
									,hostname
									,description
									,date_created
									,created_by
									,last_update_date
									,last_updated_by
									,attribute1
									,attribute2
									,attribute3
									,attribute4)
			VALUES( p_scannerId
					,p_orgId
					,p_ipAddress
					,p_hostname
					,p_password
					,p_description
					,SYSDATE
					,p_userId
					,SYSDATE
					,p_userId
					,p_attribute1
					,p_attribute2
					,p_attribute3
					,p_attribute4);
			COMMIT;
			htp.p('		<TD ALIGN="LEFT"><B>Scanner Details Saved</B></TD>');		
		END IF;
	ELSE
		UPDATE gis_scanners
		SET organization_id = p_orgId
			,ip_address = p_ipAddress
			,password = p_password
			,hostname = p_hostname
			,description = p_description
			,last_update_date = SYSDATE
			,last_updated_by = p_userId
			,attribute1 = p_attribute1
			,attribute2 = p_attribute2
			,attribute3 = p_attribute3
			,attribute4 = p_attribute4
 		WHERE scanner_id = p_scannerId;
		COMMIT;
		htp.p('		<TD ALIGN="LEFT"><B>Scanner Details Updated</B></TD>');	
		htp.p( '<SCRIPT LANGUAGE="javascript">' );
   			htp.p( 'parent.ViewingFrame.document.location="gis_admin_screen.scannerList?p_userId='||p_userId||'&p_sortByList='||p_sortByList||'"');
		htp.p( '</SCRIPT>'); 	
	END IF;		
	
	htp.p('	</TR>');
	htp.p('</TABLE>');
	gis_image_util.pageclose;
END saveScanner;

PROCEDURE userScanners( p_userId VARCHAR2
						,p_scanUserId VARCHAR2) IS

CURSOR cur_scannerList( f_scanUserId VARCHAR2) IS
SELECT scn.scanner_id
	   ,scn.scanner_id || ' :' || org.name || ' : ' || scn.description details
FROM hr_operating_units org
	,gis_scanners scn
WHERE scn.organization_id = org.organization_id
AND scn.scanner_id  NOT IN ( SELECT  scanner_id
							FROM	gis_scan_users
							WHERE   fnd_user_id = f_scanUserId)
ORDER BY scn.scanner_id;

row_scannerList cur_scannerList%ROWTYPE;

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.userScannerLink');
	gis_image_util.infoHeader('Select Scanner');
	htp.formOpen('gis_admin_screen.saveScanUserLink', 'POST',cattributes=>'NAME="userScannerLink" TARGET="ViewingFrame"');
	htp.formHidden('p_userId',p_userId);
	htp.formHidden('p_scanUserId', p_scanUserId);
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');

	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Scanners :</B></TD><TD>');	
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="LEFT"><B></B></TD><TD>');	
	IF NOT cur_scannerList%ISOPEN
	THEN
		OPEN cur_scannerList( p_scanUserId);
	END IF;
	
	FETCH cur_scannerList INTO row_scannerList;
	IF cur_scannerList%NOTFOUND THEN
		-- need some sort of error handler here
		NULL;
	ELSE
		htp.formSelectOpen(cname=>'p_scannerId',nsize=>'10');	
		htp.formSelectOption( row_scannerList.details,'SELECTED', CATTRIBUTES=>'value='||	
											row_scannerList.scanner_id);
		FETCH cur_scannerList INTO row_scannerList;
		WHILE cur_scannerList%FOUND
		LOOP
			htp.formSelectOption( row_scannerList.details, CATTRIBUTES=>'value='||	
												row_scannerList.scanner_id);
		FETCH cur_scannerList INTO row_scannerList;		
		END LOOP;
		htp.formSelectClose;
		CLOSE cur_scannerList;
	END IF;
	htp.p('		</TD>');
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Default Skip Process Queue?</B></TD>');
	htp.p('		<TD ALIGN="LEFT"><INPUT TYPE="checkbox" name="p_attribute1" VALUE="Y"></TD>');	
	htp.p('	</TR>');
	htp.p('</TABLE>');
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');	
	htp.p('		<TD ALIGN="CENTER"><A href="JavaScript:document.userScannerLink.submit();"><IMG SRC="'||gis_image_util.c_image_url||'b_save_m.gif" BORDER="0" ALT="Next"></TD>');
	htp.p('	</TR>');
	htp.p('</TABLE>');
	gis_image_util.pageclose;	 
END userScanners;

PROCEDURE userScannerLink(p_userId VARCHAR2) IS

CURSOR cur_userList IS
SELECT
	usr.user_name,
	usr.user_id
FROM
	fnd_user usr
	,fnd_user_resp_groups usrep
	,fnd_responsibility resp
	,fnd_menus menu
	,fnd_menu_entries ent
	,fnd_form_functions func
WHERE func.function_name = 'GIS_03_SCANNER_OPERATOR'
AND usrep.responsibility_id = resp.responsibility_id
AND resp.application_id = usrep.responsibility_application_id
AND usr.user_id = usrep.user_id
AND nvl(usrep.end_date,SYSDATE+1) > SYSDATE
AND nvl(usr.end_date,SYSDATE+1) > SYSDATE
AND resp.menu_id = menu.menu_id
AND menu.menu_id = ent.menu_id
AND ent.function_id = func.function_id
ORDER BY usr.user_name;

row_userList cur_userList%ROWTYPE;

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.userScannerLink');
	gis_image_util.infoHeader('Select User');
	htp.formOpen('gis_admin_screen.userScanners', 'POST',cattributes=>'NAME="userScannerLink" TARGET="ViewingFrame"');
	htp.formHidden('p_userId',p_userId);
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>User : </B></TD><TD>');	
	IF NOT cur_userList%ISOPEN
	THEN
		OPEN cur_userList;
	END IF;
	
	FETCH cur_userList INTO row_userList;
	IF cur_userList%NOTFOUND THEN
		-- need some sort of error handler here
		NULL;
	ELSE
		htp.formSelectOpen(cname=>'p_scanUserId',nsize=>'10');
		htp.formSelectOption( row_userList.user_name,'SELECTED', CATTRIBUTES=>'value='||	
											row_userList.user_id);	
		FETCH cur_userList INTO row_userList;
		WHILE cur_userList%FOUND
		LOOP
			htp.formSelectOption( row_userList.user_name, CATTRIBUTES=>'value='||	
												row_userList.user_id);
			FETCH cur_userList INTO row_userList;		
		END LOOP;
		htp.formSelectClose;
	END IF;
		CLOSE cur_userList;
	htp.p('		</TD>');
	htp.p('	</TR>');
	htp.p('</TABLE>');
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');	
	htp.p('		<TD ALIGN="CENTER"><A href="JavaScript:document.userScannerLink.submit();"><IMG SRC="'||gis_image_util.c_image_url||'b_next_m.gif" BORDER="0" ALT="Next"></TD>');
	htp.p('	</TR>');
	htp.p('</TABLE>');
	gis_image_util.pageclose;	 
END userScannerLink;
					
PROCEDURE saveScanUserLink( p_userId VARCHAR2
							,p_scanUserId VARCHAR2
							,p_scannerId VARCHAR2
							,p_attribute1 VARCHAR2 DEFAULT 'N') IS
							
l_recordCheck NUMBER(1);
					
BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.saveScanUserLink');
	gis_image_util.infoHeader('Update Status');
	htp.br;
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');
	htp.p('		<TD VALIGN="TOP" ALIGN="RIGHT"><IMG SRC="'||gis_image_util.c_image_url||'i_note.gif" ALT="Note"></TD>');
	SELECT count(fnd_user_id)
	INTO l_recordCheck
	FROM gis_scan_users
	WHERE scanner_id = p_scannerId
	AND fnd_user_id = p_scanUserId;

	IF l_recordCheck > 0
	THEN
		htp.p('		<TD ALIGN="LEFT"><B>User already has access to selected scanner</B></TD>');	
	ELSE
		INSERT INTO gis_scan_users( scanner_id 
									,fnd_user_id
									,active_start_date
									,active_end_date
									,attribute1
									,date_created
									,created_by
									,last_update_date
									,last_updated_by)
		VALUES(	p_scannerId
				,p_scanUserId
				,SYSDATE
				,NULL
				,p_attribute1
				,SYSDATE
				,p_userId
				,SYSDATE
				,p_userId);
		COMMIT;
		htp.p('		<TD ALIGN="LEFT"><B>Scanner->User link details saved</B></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p('</TABLE>');			
	gis_image_util.pageclose;
END saveScanUserLink; 

PROCEDURE scanUserList(	p_userId VARCHAR2
						,p_sortByList VARCHAR2
						,p_scannerSelection VARCHAR2
						,p_userSelection VARCHAR2 DEFAULT NULL) IS

l_rowCount NUMBER;
cid INTEGER;
sqlSource VARCHAR2(2000);
l_scanner_id VARCHAR2(15);
l_user_name VARCHAR2(50);
l_org_name VARCHAR2(50);
l_desc VARCHAR2(150);
l_userId NUMBER;
l_attribute1 VARCHAR2(4);

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.scanUserList');
	gis_image_util.infoHeader('Scanner->User Details');
	htp.formOpen('gis_admin_screen.sortBy', 'POST',cattributes=>'NAME="scanUserList" TARGET="ViewingFrame"');
--	htp.p(  p_sortByList);
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('	<TR>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Select</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Scanner Id</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>User Name</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Organization</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Description</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Skip Process Queue</B></FONT></TD>');
	htp.p('	</TR>');
		
	sqlSource := 	'SELECT scn.scanner_id '||
				 	',usr.user_name '||
					',org.name '||
					',scn.description '||
					',usr.user_id '||
					',DECODE(susr.attribute1,''Y'',''Yes'',''No'') '||
					'FROM  gis_scan_users susr '||
					', fnd_user usr '||
					',gis_scanners scn '||
					', hr_operating_units org '||
					'WHERE usr.user_id = susr.fnd_user_id '||
					'AND susr.scanner_id = scn.scanner_id '||
					'AND scn.organization_id = org.organization_id ';
					
	IF p_scannerSelection != 'ALL'
	THEN
		sqlSource := sqlSource || ' AND scn.scanner_id = ''' || p_scannerSelection ||'''';
	END IF;

	IF p_userSelection != 'ALL'
	THEN
		sqlSource := sqlSource || ' AND usr.user_id = ' || p_userSelection ;
	END IF;
		 
	sqlSource := sqlSource ||	' ORDER BY ' || p_sortByList;
	
--	htp.p(sqlSource);				
	cid := dbms_sql.open_cursor;
	dbms_sql.parse( cid, sqlSource, dbms_sql.v7);
	dbms_sql.define_column( cid, 1, l_scanner_id,15);
	dbms_sql.define_column( cid, 2, l_user_name, 50);
	dbms_sql.define_column( cid, 3, l_org_name, 50);
	dbms_sql.define_column( cid, 4, l_desc, 150);
	dbms_sql.define_column( cid, 5, l_userId);
	dbms_sql.define_column( cid, 6, l_attribute1,4);	
	l_rowCount := dbms_sql.execute_and_fetch( cid);
	IF l_rowCount = 1
	THEN
		WHILE l_rowCount = 1
		LOOP
			dbms_sql.column_value( cid, 1, l_scanner_id);
			dbms_sql.column_value( cid, 2, l_user_name);
			dbms_sql.column_value( cid, 3, l_org_name);
			dbms_sql.column_value( cid, 4, l_desc);	
			dbms_sql.column_value( cid, 5, l_userId);	
			dbms_sql.column_value( cid, 6, l_attribute1);	
			htp.p('	<TR>');
		 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE"><INPUT TYPE="checkBox" NAME="deleteFlag" VALUE="'||l_scanner_id|| ','||
		 									l_userId||'"></TD>');
		 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE">'||l_scanner_id||'</TD>');
		 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE">'||l_user_name||'</TD>');
		 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE">'||l_org_name||'</TD>');
		 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE">'||l_desc||'</TD>');
		 	htp.p('    <TD WIDTH="1%"  ALIGN="MIDDLE" VALIGN="MIDDLE">'||l_attribute1||'</TD>');
			htp.p('	</TR>'); 			 	
			l_rowCount := dbms_sql.fetch_rows( cid);
		END LOOP;
		htp.p('</TABLE>');
		htp.br;	
		dbms_sql.close_cursor( cid);
		htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
		htp.p('	<TR>');
		htp.p('		<TD ALIGN="CENTER"><A href="JavaScript:deleteScanUserLink('||p_userId||','''||p_sortByList||''','''||
						p_scannerSelection||''','''||p_userSelection||''')"><IMG SRC="'||
						gis_image_util.c_image_url||'b_delete_m.gif" BORDER="0" ALT="Delete Selected Records">');
		htp.p('		</TD>');
		htp.p('	</TR>');
		htp.p('</TABLE>');
	ELSE
		htp.br;	
		htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
		htp.p('	<TR>');
		htp.p('		<TD ALIGN="CENTER"><IMG SRC="'||gis_image_util.c_image_url||'i_stop.gif" BORDER="0" ALT="Information">');
		htp.p('		<FONT SIZE="4"><B>&nbsp;No Records Found</B></FONT>');
		htp.p('		</TD>');
		htp.p('	</TR>');
		htp.p('</TABLE>');	
	END IF;
	
	htp.formClose;
	gis_image_util.pageclose;
END scanUserList;

PROCEDURE deleteScanUserLink( 	p_currentUserId VARCHAR2
								,p_scanUserLinkList VARCHAR2
								,p_sortByList VARCHAR2
								,p_scannerSelection VARCHAR2
								,p_userSelection VARCHAR2 DEFAULT NULL)
IS

l_startPos NUMBER :=1;
l_endPos NUMBER;
l_userScanLinkList VARCHAR2(500) := REPLACE(p_scanUserLinkList,' ','+') || '+';   -- need to put the + sign at the end for instr func
notDone BOOLEAN := TRUE;
l_scanUserId VARCHAR2(25);
l_scannerId VARCHAR2(15);
l_userId NUMBER;

BEGIN
	WHILE (notDone)
	LOOP
		l_endPos := instr( l_userScanLinkList,'+',l_startPos);
	    l_scanUserId := (substr(l_userScanLinkList,l_startPos,(l_endPos-l_startPos)));
	    l_startPos := l_endPos +1; 
   		-- get the scanner id
   		l_scannerId := substr( l_scanUserId, 1, instr( l_scanUserId,',')-1);
   		-- get the user id
   		l_userId := substr( l_scanUserId, instr( l_scanUserId,',')+1);
   		
		DELETE  gis_scan_users
    	WHERE scanner_id = l_scannerId
    	AND fnd_user_id = l_userId;

	--       htp.p(sqlsource);
	   	IF ( instr( l_userScanLinkList,'+',l_startPos) = 0)
	   	THEN
			notDone := FALSE;
	   	END IF;
	END LOOP;	
	COMMIT;
	scanUserList( 	p_currentUserId
					,p_sortByList
					,p_scannerSelection 
					,p_userSelection);
END deleteScanUserLink;

PROCEDURE deleteModifyScanner( 	p_userId VARCHAR2
							,p_scannerList VARCHAR2
							,p_sortByList VARCHAR2
							,p_operation VARCHAR2)
IS 

l_startPos NUMBER :=1;
l_endPos NUMBER;
l_scannerList VARCHAR2(500) := REPLACE(p_scannerList,' ','+') || '+';   -- need to put the + sign at the end for instr func
notDone BOOLEAN := TRUE;
l_scannerId VARCHAR2(15);
l_userId NUMBER;

BEGIN
	WHILE (notDone)
	LOOP
		l_endPos := instr( l_scannerList,'+',l_startPos);
	    l_scannerId := (substr(l_scannerList,l_startPos,(l_endPos-l_startPos)));
	    l_startPos := l_endPos +1; 
    	
    	IF p_operation = 'DELETE'
    	THEN		
			DELETE  gis_scanners
	    	WHERE scanner_id = l_scannerId;
			null;
	    ELSE
	    	addScanner( p_userId, l_scannerId, 'Modify', p_sortByList);
	    END IF;

	--       htp.p(sqlsource);
	   	IF ( instr( l_scannerList,'+',l_startPos) = 0)
	   	THEN
			notDone := FALSE;
	   	END IF;
	END LOOP;	
	COMMIT;
    IF p_operation = 'DELETE'
    THEN
		scannerList( p_userId, p_sortByList);
	END IF;
END deleteModifyScanner;

PROCEDURE viewDocCategoriesBy( p_userId VARCHAR2)
IS

CURSOR cur_docContext IS
SELECT DISTINCT
con.descriptive_flex_context_code 
,con.description
,con.descriptive_flex_context_name
FROM FND_DESCR_FLEX_CONTEXTS_VL con
WHERE con.descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX'
AND  con.descriptive_flex_context_code != 'Global Data Elements'
AND enabled_flag = 'Y'
ORDER BY con.descriptive_flex_context_code;

--CURSOR cur_docContext IS
--SELECT DISTINCT substr(attribute1,1,1) || LOWER(substr(attribute1,2)) AS dispContext
--, attribute1 AS context
--FROM fnd_document_categories_vl
--WHERE attribute_category = 'GIS'
--AND NVL(start_date_active,sysdate - 1) <= sysdate 
--AND NVL(end_date_active,sysdate + 1) >= sysdate
--ORDER BY attribute1;

row_docContext cur_docContext%ROWTYPE;

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.viewDocCategoriesBy');
	gis_image_util.infoHeader('Select Document Context');
	htp.formOpen('gis_admin_screen.viewDocCategories', 'POST',cattributes=>'NAME="docContext" TARGET="ViewingFrame"');
	htp.formHidden('p_userId',p_userId);
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('	<TR>');	
	htp.p('		<TD ALIGN="RIGHT"><B>');
	htp.p('			Document Context ');
	htp.p('		</B></TD>');
	htp.p('		<TD>');		
	IF NOT cur_docContext%ISOPEN
	THEN
		OPEN cur_docContext;
	END IF;
	
	FETCH cur_docContext INTO row_docContext;
	IF cur_docContext%NOTFOUND THEN
		-- need some sort of error handler here
		NULL;
	ELSE
		htp.formSelectOpen(cname=>'p_context',nsize=>'7');	
		htp.formSelectOption( 'All','SELECTED', CATTRIBUTES=>'VALUE="ALL"');
		WHILE cur_docContext%FOUND
		LOOP
			htp.formSelectOption( row_docContext.description, CATTRIBUTES=>'value="'||	
												UPPER(row_docContext.descriptive_flex_context_code)||'"');
			FETCH cur_docContext INTO row_docContext;		
		END LOOP;
	END IF;
	CLOSE cur_docContext; 
	htp.formSelectClose;
	htp.p('		</TD>');
	htp.p('	</TR>'); 
	htp.p('</TABLE>');
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('	<TR>');	
	htp.p('		<TD ALIGN="CENTER"><A href="JavaScript:document.docContext.submit()"><IMG SRC="'||gis_image_util.c_image_url||'b_report_m.gif" BORDER="0" ALT="Find Records">');
	htp.p('		</TD>');
	htp.p('	</TR>'); 
	htp.p('</TABLE>');	
	htp.formClose;
	gis_image_util.pageclose;
END viewDocCategoriesBy; 

PROCEDURE viewDocCategories(p_userId VARCHAR2
							,p_context VARCHAR2) IS

l_rowCount NUMBER;
cid INTEGER;
sqlSource VARCHAR2(2000);
l_documentId NUMBER(15);
l_user_name VARCHAR2(255);
l_name VARCHAR2(30);
l_attribute1 VARCHAR2(50);

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.scanUserList');
	gis_image_util.infoHeader('Document Categories for Context: '|| substr(p_context,1,1) || LOWER(substr(p_context,2)));
	htp.formOpen('gis_admin_screen.sortBy', 'POST',cattributes=>'NAME="categoryList" TARGET="ViewingFrame"');
--	htp.p(  p_sortByList);
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('	<TR>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Select</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Code</B></FONT></TD>');
	htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Description</B></FONT></TD>');
	IF p_context = 'ALL'
	THEN
		htp.p(' 	<TD BGCOLOR="#C9C9C9"><FONT COLOR="BLACK"><B>Context</B></FONT></TD>');
	END IF;
	htp.p('	</TR>');
		
	sqlSource := 	'SELECT cat.category_id, cat.name '||
				 	',cat.user_name '||
					',cat.attribute1 '||
					'FROM  fnd_document_categories_vl cat '||
					'WHERE cat.attribute_category = ''GIS'''||
					' AND NVL(cat.start_date_active,sysdate - 1) <= sysdate ' ||
					' AND NVL(cat.end_date_active,sysdate + 1) >= sysdate '  ;
					
	IF p_context != 'ALL'
	THEN
		sqlSource := sqlSource || ' AND cat.attribute1 = '''|| p_context ||'''';
	END IF;

	sqlSource := sqlSource ||	' ORDER BY  cat.attribute1, cat.name';
	
--	htp.p(sqlSource);				
	cid := dbms_sql.open_cursor;
	dbms_sql.parse( cid, sqlSource, dbms_sql.v7); 
	dbms_sql.define_column( cid, 1, l_documentId);
	dbms_sql.define_column( cid, 2, l_name,15);
	dbms_sql.define_column( cid, 3, l_user_name, 50);
	dbms_sql.define_column( cid, 4, l_attribute1, 50);
	l_rowCount := dbms_sql.execute_and_fetch( cid);
	IF l_rowCount = 1
	THEN
		WHILE l_rowCount = 1
		LOOP
			dbms_sql.column_value( cid, 1, l_documentId);
			dbms_sql.column_value( cid, 2, l_name);
			dbms_sql.column_value( cid, 3, l_user_name);
			dbms_sql.column_value( cid, 4, l_attribute1);	
			htp.p('	<TR>');
		 	htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE"><INPUT TYPE="checkBox" NAME="modifyFlag" VALUE="'||l_documentId||'"></TD>');
		 	htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE">'||l_name||'</TD>');
		 	htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE">'||l_user_name||'</TD>'); 
			IF p_context = 'ALL'
			THEN
		 		htp.p('    <TD WIDTH="1%"  ALIGN="LEFT" VALIGN="MIDDLE">'||l_attribute1||'</TD>');
		 	END IF;
			htp.p('	</TR>'); 			 	
			l_rowCount := dbms_sql.fetch_rows( cid);
		END LOOP;
		htp.p('</TABLE>');
		htp.br;	
		dbms_sql.close_cursor( cid);
		htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
		htp.p('	<TR>');
		htp.p('		<TD ALIGN="CENTER"><A href="JavaScript:modifyDocCategory('||p_userId||')"><IMG SRC="'||
						gis_image_util.c_image_url||'b_reindex_m.gif" BORDER="0" ALT="Modify Selected Records">');
		htp.p('		</TD>');
		htp.p('	</TR>');
		htp.p('</TABLE>');
	ELSE
		htp.br;	
		htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
		htp.p('	<TR>');
		htp.p('		<TD ALIGN="CENTER"><IMG SRC="'||gis_image_util.c_image_url||'i_stop.gif" BORDER="0" ALT="Information">');
		htp.p('		<FONT SIZE="4"><B>&nbsp;No Records Found</B></FONT>');
		htp.p('		</TD>');
		htp.p('	</TR>');
		htp.p('</TABLE>');	
	END IF;  
	htp.formClose;
	gis_image_util.pageclose;
END viewDocCategories;  

PROCEDURE addDocCategory( p_userId VARCHAR2
						, p_categoryId VARCHAR2 DEFAULT NULL
						, p_operation VARCHAR2 DEFAULT 'Add') IS

CURSOR cur_docContext IS
SELECT DISTINCT
con.descriptive_flex_context_code
,con.description
,con.descriptive_flex_context_name
FROM FND_DESCR_FLEX_CONTEXTS_VL con
WHERE con.descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX'
AND  con.descriptive_flex_context_code != 'Global Data Elements'
AND enabled_flag = 'Y'
ORDER BY con.descriptive_flex_context_code;

CURSOR cur_alterDocCategories( f_context VARCHAR2, f_categoryId NUMBER) IS
SELECT user_name
,category_id 
FROM fnd_document_categories_vl
WHERE attribute1 = f_context
AND category_id != f_categoryId
AND NVL(start_date_active,sysdate - 1) <= sysdate
AND NVL(end_date_active,sysdate + 1) >= sysdate;

row_alterDocCategories cur_alterDocCategories%ROWTYPE;
row_docContext cur_docContext%ROWTYPE;
row_categories fnd_document_categories_vl%ROWTYPE; 
row_user fnd_user%ROWTYPE; 
				
BEGIN
	IF p_categoryId IS NOT NULL
	THEN
		SELECT cat.name
				,cat.user_name
				,cat.start_date_active
				,cat.end_date_active
				,cat.last_update_date
				,usr.user_name
				,cat.attribute1
				,cat.attribute2
		INTO	row_categories.name
				,row_categories.user_name
				,row_categories.start_date_active
				,row_categories.end_date_active
				,row_categories.last_update_date
				,row_user.user_name
				,row_categories.attribute1
				,row_categories.attribute2
		FROM fnd_document_categories_vl cat
		, fnd_user usr
		WHERE cat.category_id = p_categoryId
		AND cat.last_updated_by = usr.user_id;
	END IF;
				
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.addDocCategory');
	htp.p( '<SCRIPT LANGUAGE="javascript">
  			function checkEndDate()
  			{
  				if (document.addCategory.p_moveDocs.checked == true)
  				{
  					if (confirm("Are You Happy With the Alternative Document Category Selected...?"))
  					{
  						document.addCategory.submit();
  					}
  				}
  				else
  				{
  					document.addCategory.submit();
  				}  				
   			}  
			</SCRIPT>'); 
	gis_image_util.infoHeader( p_operation ||' Category');
	htp.formOpen('gis_admin_screen.saveCategory', 'POST',cattributes=>'NAME="addCategory"');
	htp.formHidden('p_operation',p_operation);
	htp.formHidden('p_userId',p_userId);
	htp.formHidden('p_categoryId', p_categoryId);
	
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Context : </B></TD><TD>');	

	IF p_categoryId IS NOT NULL
	THEN
		htp.p(row_categories.attribute1); 
		htp.formHidden( 'p_context', row_categories.attribute1);	
	ELSE
		IF NOT cur_docContext%ISOPEN
		THEN
			OPEN cur_docContext;
		END IF;
		
		FETCH cur_docContext INTO row_docContext;
		IF cur_docContext%NOTFOUND THEN
			-- need some sort of error handler here
			NULL;
		ELSE
			htp.formSelectOpen(cname=>'p_context',nsize=>'1');
			htp.formSelectOption( row_docContext.description,'SELECTED', CATTRIBUTES=>'value="'||	
									row_docContext.descriptive_flex_context_code||'"');	
			FETCH cur_docContext INTO row_docContext;
			WHILE cur_docContext%FOUND
			LOOP
					htp.formSelectOption( row_docContext.description, CATTRIBUTES=>'value="'||	
									row_docContext.descriptive_flex_context_code||'"');	

				FETCH cur_docContext INTO row_docContext;		
			END LOOP;
			htp.formSelectClose;
		END IF;
		CLOSE cur_docContext; 
	END IF;
	htp.p('	</TD></TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Code : </B></TD>');
	IF p_categoryId IS NOT NULL
	THEN
		htp.p('		<TD><INPUT NAME="p_code" COLS=15 TYPE=TEXT size="15" maxlength="30" VALUE="'||row_categories.name||'"></TD>');
	ELSE
		htp.p('		<TD><INPUT NAME="p_code" COLS=15 TYPE=TEXT size="15" maxlength="30"></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Description : </B></TD>');
	IF p_categoryId IS NOT NULL
	THEN
		htp.p('		<TD><INPUT NAME="p_desc" COLS=15 TYPE=TEXT size="22" maxlength="255" VALUE="'||row_categories.user_name||'"></TD>');	
	ELSE
		htp.p('		<TD><INPUT NAME="p_desc" COLS=15 TYPE=TEXT size="22" maxlength="255" VALUE="GIS - "></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Start Date : </B></TD>');
	IF p_categoryId IS NOT NULL
	THEN
		htp.p('		<TD ALIGN="LEFT"><INPUT NAME="p_activeStartDate" COLS=15 TYPE=TEXT size="12" maxlength="12" VALUE="'||row_categories.start_Date_Active||'"></TD>');	
	ELSE
		htp.p('		<TD ALIGN="LEFT"><INPUT NAME="p_activeStartDate" COLS=15 TYPE=TEXT size="12" maxlength="12" VALUE="'||TO_CHAR(SYSDATE, 'DD-MON-YYYY')||'"></TD>');
	END IF;
	htp.p('	</TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>End Date : </B></TD>');
	IF p_categoryId IS NOT NULL
	THEN
		htp.p('		<TD ALIGN="LEFT"><INPUT NAME="p_activeEndDate" COLS=15 TYPE=TEXT size="12" maxlength="12" VALUE="'||row_categories.end_Date_Active||'"></TD>');	
	ELSE
		htp.p('		<TD ALIGN="LEFT"><INPUT NAME="p_activeEndDate" COLS=15 TYPE=TEXT size="12" maxlength="12"></TD>');
	END IF;
	htp.p('	</TR>');
	IF p_categoryId IS NOT NULL
	THEN
		htp.p(' <TR>');
		htp.p('		<TD ALIGN="RIGHT"><B>Last Updated By : </B></TD>');
		htp.p('		<TD>'||row_user.user_name||'</TD>');
		htp.p('	</TR>');
	END IF;

	IF p_categoryId IS NOT NULL
	THEN
		htp.p(' <TR>');
		htp.p('		<TD ALIGN="RIGHT"><B>Last Update Date : </B></TD>');
		htp.p('		<TD>'||row_categories.last_Update_Date||'<TD>');	
	END IF;
	htp.p('	</TR>');
	htp.p(' <TR>');
	htp.p('		<TD ALIGN="RIGHT"><B>Secure : </B></TD>');
	htp.p('<TD>');
	htp.formSelectOpen(cname=>'p_attribute2',nsize=>'1');
	IF p_categoryId IS NOT NULL
	THEN
        IF row_categories.attribute2 = 'SECURE'
        THEN 
	         htp.formSelectOption( 'Secure','SELECTED', CATTRIBUTES=>'value="SECURE"');
	         htp.formSelectOption( 'Open', CATTRIBUTES=>'value="OPEN"');		     
		ELSE
		     htp.formSelectOption( 'Open','SELECTED', CATTRIBUTES=>'value="OPEN"');
	         htp.formSelectOption( 'Secure', CATTRIBUTES=>'value="SECURE"');	
        END IF;
	ELSE
		htp.formSelectOption( 'Open','SELECTED', CATTRIBUTES=>'value="OPEN"');
		htp.formSelectOption( 'Secure', CATTRIBUTES=>'value="SECURE"');	
	END IF;
	htp.formSelectClose;
		htp.p('</TD>');
	htp.p('	</TR>');
	htp.p('</TABLE>');
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');	
	IF p_categoryId IS NOT NULL
	THEN
--	htp.p('		<TD ALIGN="CENTER"><A href="JavaScript:document.addCategory.submit();"><IMG SRC="'||gis_image_util.c_image_url||'b_save_m.gif" BORDER="0" ALT="Save Record"></TD>');
		htp.p('		<TD ALIGN="CENTER"><A href="JavaScript:checkEndDate();"><IMG SRC="'||gis_image_util.c_image_url||'b_save_m.gif" BORDER="0" ALT="Save Record"></TD>');
	ELSE
		htp.p('		<TD ALIGN="CENTER"><A href="JavaScript:document.addCategory.submit();"><IMG SRC="'||gis_image_util.c_image_url||'b_save_m.gif" BORDER="0" ALT="Save Record"></TD>');		
	END IF;
	htp.p('	</TR>');
	htp.p('</TABLE>'); 
	IF p_categoryId IS NOT NULL
	THEN	
		htp.line;      
		htp.p('Move document with this category to another document category...?');
		htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
		htp.p(' <TR>');
		htp.p('		<TD>Move Documents: </TD>');
		htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><INPUT TYPE="checkBox" NAME="p_moveDocs" VALUE="Y"></TD>');
		htp.p('		<TD>');
		htp.p(' <TR>');
		htp.p('		<TD>Alternative Category: </TD>');
		htp.p('		<TD>');
		IF NOT cur_alterDocCategories%ISOPEN
		THEN
			OPEN cur_alterDocCategories(row_categories.attribute1, p_categoryId);
		END IF;
		
		FETCH cur_alterDocCategories INTO row_alterDocCategories;
		IF cur_alterDocCategories%NOTFOUND THEN
			-- need some sort of error handler here
			NULL;
		ELSE
			htp.formSelectOpen(cname=>'p_alterCat',nsize=>'10');
			htp.formSelectOption( row_alterDocCategories.user_name,'SELECTED', CATTRIBUTES=>'value="'||	
									row_alterDocCategories.category_id||'"');	
			FETCH cur_alterDocCategories INTO row_alterDocCategories;
			WHILE cur_alterDocCategories%FOUND
			LOOP
					htp.formSelectOption( row_alterDocCategories.user_name, CATTRIBUTES=>'value="'||	
									row_alterDocCategories.category_id||'"');	
	
				FETCH cur_alterDocCategories INTO row_alterDocCategories;		
			END LOOP;
			htp.formSelectClose;
		END IF;
		CLOSE cur_alterDocCategories;
		htp.p('		</TD>');
		htp.p('	</TR>');
		htp.p('</TABLE>'); 	
	END IF;
	htp.formClose;	
	gis_image_util.pageclose;
END addDocCategory;

PROCEDURE saveCategory( p_operation VARCHAR2
						,p_userId VARCHAR2
						,p_categoryId VARCHAR2 DEFAULT NULL
						,p_context VARCHAR2
						,p_code VARCHAR2
						,p_desc VARCHAR2 
						,p_activeStartDate VARCHAR2 DEFAULT SYSDATE
						,p_activeEndDate VARCHAR2 DEFAULT NULL
						,p_attribute2 VARCHAR2 DEFAULT NULL
						,p_alterCat VARCHAR2 DEFAULT NULL
						,p_moveDocs CHAR DEFAULT NULL) IS

l_recordCheck NUMBER(1);
l_category_id NUMBER(15);
l_context VARCHAR2(50) := upper(p_context);
l_attFuncId NUMBER(15);
l_categoryUsageId NUMBER(15);

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_admin_screen.saveScanner');
	gis_image_util.infoHeader('Add Category Status');
	htp.br;
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p(' <TR>');
	htp.p('		<TD VALIGN="TOP" ALIGN="RIGHT"><IMG SRC="'||gis_image_util.c_image_url||'i_note.gif" ALT="Note"></TD>');
	IF p_operation = 'Add'
	THEN
		SELECT FND_DOCUMENT_CATEGORIES_S.nextval
   		INTO l_category_id
		from dual;	

		BEGIN			
			INSERT INTO fnd_document_categories(category_id
												,creation_date
												,created_by
												,last_update_date
												,last_updated_by
												,name
												,start_date_active
												,end_date_active
												,default_datatype_id
												,attribute_category
												,attribute1
												,attribute2)
			VALUES (l_category_id
					,SYSDATE
					,p_userId
					,SYSDATE
					,p_userId
					,upper(p_code)
					,p_activeStartDate
					,p_activeEndDate
					,6
					,'GIS'
					,l_context
					,UPPER(p_attribute2));
	
			INSERT INTO fnd_document_categories_tl( CATEGORY_ID
													,LANGUAGE
													,NAME
													,USER_NAME
													,CREATION_DATE
													,CREATED_BY
												    ,LAST_UPDATE_DATE
												    ,LAST_UPDATED_BY
												    ,SOURCE_LANG)
		    VALUES( l_category_id
				    ,userenv('LANG')
				    ,upper(p_code)
				    ,p_desc
				    ,SYSDATE
				    ,p_userId
				    ,SYSDATE
				    ,p_userId
				    ,userenv('LANG'));
				    
-- ADD new category details to the FND_DOC_CATEGORY_USAGES table so that it is
-- visible within applications
			BEGIN
				IF l_context = 'ORDER MANAGEMENT'
				THEN
					SELECT attachment_function_id 
					INTO l_attFuncId
					FROM fnd_attachment_functions
					WHERE function_name = 'OEXOEORD';
				ELSIF l_context = 'AGREEMENTS' 
				THEN
					SELECT attachment_function_id 
					INTO l_attFuncId
					FROM fnd_attachment_functions
					WHERE function_name = 'QPXSSDAF'; 
				ELSIF l_context = 'CUSTOMER' 
				THEN
					SELECT attachment_function_id 
					INTO l_attFuncId
					FROM fnd_attachment_functions
					WHERE function_name = 'ARXCUDCI';
				ELSIF l_context = 'PAYABLES' 
				THEN
					SELECT attachment_function_id 
					INTO l_attFuncId
					FROM fnd_attachment_functions
					WHERE function_name = 'APXINWKB';-- 'PA_PAXPREPR_REPORT on gsi1av!!!
				ELSIF l_context = 'PROJECTS' 
				THEN
					SELECT attachment_function_id 
					INTO l_attFuncId
					FROM fnd_attachment_functions
					WHERE function_name = 'PAXPREPR';
				ELSIF l_context = 'CONTRACTS' 
				THEN
					SELECT attachment_function_id 
					INTO l_attFuncId
					FROM fnd_attachment_functions
					WHERE function_name = 'OKSAUDET';  
				ELSIF l_context = 'RECEIVABLES' 
				THEN
					SELECT attachment_function_id 
					INTO l_attFuncId
					FROM fnd_attachment_functions
					WHERE function_name = 'ARXTWMAI';
				ELSIF l_context = 'WEB EXPENSES' 
				THEN
					SELECT attachment_function_id 
					INTO l_attFuncId
					FROM fnd_attachment_functions
					WHERE function_name = 'APXXXEER';
				END IF;
	
				SELECT fnd_doc_category_usages_S.nextval
		   		INTO l_categoryUsageId
				from dual;	  
							
				INSERT INTO fnd_doc_category_usages(doc_category_usage_id
													,category_id
													,attachment_function_id
													,enabled_flag
													,creation_date
													,created_by
													,last_update_date
													,last_updated_by)
				VALUES( l_categoryUsageId
						,l_category_id
						,l_attFuncId
						,'Y'
						,SYSDATE
						,p_userId
						,SYSDATE
						,p_userId);
			EXCEPTION
			WHEN OTHERS
			THEN  
				DECLARE
				errorCode NUMBER := SQLCODE;
				errorMsg VARCHAR(300) := SQLERRM;
    			BEGIN
					htp.p( '<SCRIPT LANGUAGE="javascript">' );
					htp.p( 'alert("Unable to create record in fnd_doc_category_usages. Please setup through apps...');
					htp.p( '</SCRIPT>'); 
				END;
			END;
							             
			COMMIT;
			htp.p('		<TD ALIGN="LEFT"><B>Category Details Saved</B></TD>');
		EXCEPTION
			WHEN OTHERS
			THEN  
			DECLARE
			errorCode NUMBER := SQLCODE;
			errorMsg VARCHAR(300) := SQLERRM;
            BEGIN
				htp.p('	<TD><B>Error encountered while saving category details...				
												Make sure code is not duplicated</B></TD>');
				htp.br;
				htp.p(' </TR><TR><TD></TD><TD>'||errorMsg||'</TD>');
				ROLLBACK;
			END;
		END;
		
	ELSE
		UPDATE fnd_document_categories
		SET name = upper(p_code)
			,start_date_active = p_activeStartDate
			,end_date_active = p_activeEndDate
			,last_update_date = SYSDATE
			,last_updated_by = p_userId 
			,attribute2 = p_attribute2
 		WHERE category_id = p_categoryId;
 		
 		UPDATE fnd_document_categories_tl
 		SET  user_name = p_desc
 		,name = upper(p_code)
 		,last_update_date = SYSDATE
		,last_updated_by = p_userId 
 		WHERE category_id = p_categoryId
 		AND LANGUAGE = userenv('LANG');
		
		IF p_moveDocs = 'Y'
		THEN
			UPDATE fnd_documents
			SET category_id = p_alterCat
			WHERE category_id = p_categoryId;
		END IF; 				
		COMMIT;
		htp.p('		<TD ALIGN="LEFT"><B>Category Details Updated</B></TD>');		
	END IF;		
	htp.p('	</TR>');
	htp.p('</TABLE>');
	htp.p( '<SCRIPT LANGUAGE="javascript">' );
	htp.p( 'parent.ViewingFrame.document.location="gis_admin_screen.viewDocCategories?p_userId='||p_userId||'&p_context='||upper(REPLACE(p_context,' ','+'))||'"');
	htp.p( '</SCRIPT>'); 
	gis_image_util.pageclose;
END saveCategory;

END  gis_admin_screen;
/
