CREATE OR REPLACE
PACKAGE apps.gis_apps_search AS
-- ============================================================================
--
--   NAME
--      gis_apps_search_pks.sql
--
--   DESCRIPTION
--      This script is used to create the gis_apps_search package spec 
--
--   HISTORY
--      03/07/2001 David Gough In Development
--
-- ============================================================================
					  			
------------------------------------------------------------------------------------
-- Public Procedures
FUNCTION IndexedSearchAvail( p_context VARCHAR2) 
RETURN BOOLEAN;

--PROCEDURE CustNameLov( 	p_org VARCHAR2
--						,p_custName	VARCHAR2 DEFAULT NULL);
						
PROCEDURE indexedQueryOptions(	p_document VARCHAR2 DEFAULT NULL
								, p_context VARCHAR2 DEFAULT NULL
								,p_userId VARCHAR2 DEFAULT NULL
								,p_userType VARCHAR2 DEFAULT NULL
								,p_respId VARCHAR2);
								
PROCEDURE OrderHeadersQuery( p_userId VARCHAR2 DEFAULT NULL
							 ,p_userType VARCHAR2 DEFAULT NULL
							 ,p_respId VARCHAR2);

PROCEDURE ListDocuments(p_docRef VARCHAR2
						,p_pkValue VARCHAR2
						,p_context VARCHAR2
						,p_userType VARCHAR2
						,p_userId VARCHAR2
						,p_respId VARCHAR2
						,p_org VARCHAR2 DEFAULT NULL 
						,p_attributes VARCHAR2);
							 
PROCEDURE Order_ManagementIQActions(	p_userId VARCHAR2
							 		,p_userType VARCHAR2
							 		,p_respId VARCHAR2
							 		,p_context VARCHAR2
							 		,p_org VARCHAR2
							 		,p_orgCount VARCHAR2
							 		,imageDisplayed VARCHAR2
							 		,p_orderNumber VARCHAR2 DEFAULT NULL
							 		,p_orderDateFrom VARCHAR2 DEFAULT NULL
							 		,p_orderDateTo VARCHAR2 DEFAULT NULL
							 		,p_docRef VARCHAR2 DEFAULT NULL
							 		,p_soldTo VARCHAR2 DEFAULT NULL
							 		,p_customerNumber VARCHAR2 DEFAULT NULL
							 		,p_orgName VARCHAR2 DEFAULT NULL);

PROCEDURE ContractsQuery( p_userId VARCHAR2 DEFAULT NULL
							 ,p_userType VARCHAR2 DEFAULT NULL
							 ,p_respId VARCHAR2);   

PROCEDURE CustomerIQActions(	p_userId VARCHAR2
							 	,p_userType VARCHAR2
							 	,p_respId VARCHAR2
							 	,p_context VARCHAR2
							 	,p_org VARCHAR2
							 	,p_orgCount VARCHAR2
							 	,imageDisplayed VARCHAR2
							 	,p_customerName VARCHAR2 DEFAULT NULL
							 	,p_customerNumber VARCHAR2 DEFAULT NULL
							 	,p_orgName VARCHAR2 DEFAULT NULL);
							 								 
PROCEDURE ContractsIQActions(	p_userId VARCHAR2
							 		,p_userType VARCHAR2
							 		,p_respId VARCHAR2
							 		,p_context VARCHAR2
							 		,p_org VARCHAR2 
							 		,p_orgCount VARCHAR2
							 		,imageDisplayed VARCHAR2
							 		,p_contractNumber VARCHAR2 DEFAULT NULL
							 		,p_contractModifier VARCHAR2 DEFAULT NULL
							 		,p_soldTo VARCHAR2 DEFAULT NULL
							 		,p_customerNumber VARCHAR2 DEFAULT NULL
							 		,p_orgName VARCHAR2 DEFAULT NULL);
							 		
PROCEDURE Old_RenewalsIQActions(	p_userId VARCHAR2
							 		,p_userType VARCHAR2
							 		,p_respId VARCHAR2
							 		,p_context VARCHAR2
							 		,p_org VARCHAR2
							 		,p_orgCount VARCHAR2
							 		,imageDisplayed VARCHAR2
							 		,p_renewalId VARCHAR2 DEFAULT NULL
							 		,p_soldTo VARCHAR2 DEFAULT NULL
							 		,p_customerNumber VARCHAR2 DEFAULT NULL
							 		,p_orgName VARCHAR2 DEFAULT NULL);

PROCEDURE OldRenewalsQuery( p_userId VARCHAR2 DEFAULT NULL
							 ,p_userType VARCHAR2 DEFAULT NULL
							 ,p_respId VARCHAR2);

--FUNCTION Valid_value ( p_value VARCHAR2) RETURN NUMBER;
                                                         
PROCEDURE UpdateField( 	p_field VARCHAR2 DEFAULT NULL
						,p_value VARCHAR2 DEFAULT NULL
						,p_docId VARCHAR2 DEFAULT NULL
						,p_docRef VARCHAR2 DEFAULT NULL
						,p_pkValue VARCHAR2 DEFAULT NULL
						,p_context VARCHAR2 DEFAULT NULL
						,p_userType VARCHAR2 DEFAULT NULL
						,p_userId VARCHAR2 DEFAULT NULL
						,p_respId VARCHAR2 DEFAULT NULL
						,p_attributes VARCHAR2 DEFAULT NULL
						,p_orgId VARCHAR2);
 
--FUNCTION onMouseOver( p_mesg VARCHAR2) RETURN VARCHAR2;

PROCEDURE SaveUpdate( 	p_field VARCHAR2
						,p_newValue VARCHAR2 DEFAULT NULL
						,p_docId VARCHAR2
						,p_docRef VARCHAR2 DEFAULT NULL
						,p_pkValue VARCHAR2 DEFAULT NULL
						,p_context VARCHAR2 DEFAULT NULL
						,p_userType VARCHAR2 DEFAULT NULL
						,p_userId VARCHAR2 DEFAULT NULL
						,p_respId VARCHAR2 DEFAULT NULL
						,p_attributes VARCHAR2 DEFAULT NULL
						,p_orgId VARCHAR2);

						
PROCEDURE raCustomerQuery( p_userId VARCHAR2 DEFAULT NULL
							 ,p_userType VARCHAR2 DEFAULT NULL
							 ,p_respId VARCHAR2);
							 


END gis_apps_search;
/
