CREATE OR REPLACE
PACKAGE BODY apps.gis_attach_util IS

PROCEDURE adminMenu(p_user_id VARCHAR2) IS

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_attach_util.adminMenu');
	gis_image_util.infoHeader('GIS - Document Administration');
	htp.p( '<SCRIPT LANGUAGE="javascript">' );
	htp.p( 'parent.ViewingFrame.document.location="gis_image_util.ViewingFrame?p_userType=Administration"' );
	htp.p( '</SCRIPT>');
	htp.br;
	htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
    -- Option to link to multi-attach/deattach pkgs
	htp.p('	<TR>');
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><B>Multi-Attachments</B></TD>');
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><B></TD>');
	htp.p('	</TR>');
	htp.p('	<TR>'); 
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_attach_util.show_org?p_user_id='||p_user_id||'&p_operation=V" TARGET="QueryFrame">
 							<FONT COLOR="ORANGE" SIZE="3">View</FONT></TD>');
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"></TD>');
	htp.p('	</TR>'); 
	htp.p('	<TR>'); 
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_attach_util.show_org?p_user_id='||p_user_id||'&p_operation=A" TARGET="QueryFrame">
 							<FONT COLOR="ORANGE" SIZE="3">Add</FONT></A></TD>');
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"></TD>');
	htp.p('	</TR>'); 
	htp.p('	<TR>'); 
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_attach_util.show_org?p_user_id='||p_user_id||'&p_operation=R" TARGET="QueryFrame">
 							<FONT COLOR="ORANGE" SIZE="3">Reset</FONT></TD>');
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"></TD>');
	htp.p('	</TR>'); 
	htp.p('	<TR>'); 
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"><A HREF="'||gis_image_util.c_pack_url||'gis_attach_util.show_org?p_user_id='||p_user_id||'&p_operation=D" TARGET="QueryFrame">
 							<FONT COLOR="ORANGE" SIZE="3">Delete</FONT></TD>');
 	htp.p('    <TD WIDTH="50%"  ALIGN="LEFT" VALIGN="MIDDLE"></TD>');
	htp.p('	</TR>'); 
	htp.p('</TABLE>');
	gis_image_util.pageclose;
END adminMenu;

PROCEDURE show_org(p_user_id   NUMBER,
                   p_operation VARCHAR2) IS
  CURSOR cShowOrg IS    
  SELECT DISTINCT org.name, org.organization_id
  FROM   FND_DESCR_FLEX_CONTEXTS_VL con,
         fnd_user_resp_groups usrep,
         fnd_application_tl app,
         fnd_responsibility_tl resp,
         fnd_user usr,
         fnd_profile_option_values optval,
         fnd_profile_options opt,
         hr_operating_units org
  WHERE  usr.user_id = p_user_id
  AND    usr.user_id = usrep.user_id
  AND    nvl(usrep.end_date,sysdate+1) > sysdate
  AND    usrep.responsibility_application_id = app.application_id
  AND    usrep.responsibility_id = resp.responsibility_id
  AND    usrep.responsibility_application_id = resp.application_id
  AND    usr.user_id = usrep.user_id
  AND    con.descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX'
  AND    descriptive_flex_context_code != 'Global Data Elements'
  AND    app.application_name = con.descriptive_flex_context_name
  AND    usrep.responsibility_id = optval.level_value
  AND    optval.profile_option_id = opt.profile_option_id
  AND    optval.application_id =  opt.application_id
  AND    opt.profile_option_name = 'ORG_ID'
  AND    org.organization_id = TO_NUMBER(optval.profile_option_value)
  ORDER BY org.name;
  rShowOrg cShowOrg%ROWTYPE;
  vHdr     VARCHAR2(100) := NULL;
BEGIN
  IF p_operation = 'A' THEN
    vHdr := 'Add';
  ELSIF p_operation = 'D' THEN
    vHdr := 'Delete';
  ELSIF p_operation = 'R' THEN
    vHdr := 'Reset';
  ELSIF p_operation = 'V' THEN
    vHdr := 'View';
  END IF;
  gis_image_util.pageopen(p_heading => 'Select Organization To ' || vHdr || ' Attachment');
  gis_image_util.InfoHeader('Select Organization To ' || vHdr || ' Attachment');
  htp.formOpen('gis_attach_util.show_doc_types', 'POST',cattributes=>'NAME="show_org"');
  htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
  -- Show Org
  htp.p('  <TR>');
  htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Organization</SPAN>	</TD>');
  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE">');
  htp.formSelectOpen(cname=>'p_org_id',nsize=>'1');	
  htp.formSelectOption('Select An Organization', CATTRIBUTES=>'value=""');
  OPEN cShowOrg;
  LOOP
    FETCH cShowOrg INTO rShowOrg;
    EXIT WHEN cShowOrg%NOTFOUND;
    htp.formSelectOption(rShowOrg.name, CATTRIBUTES=>'value="' ||	TO_CHAR(rShowOrg.organization_id) || '"');
  END LOOP;
  CLOSE cShowOrg;
  htp.formSelectClose;
  htp.p('    </TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.br;
  htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="100%" ALIGN="CENTER"><A HREF="Javascript:document.show_org.submit()" onMouseOver="window.status=''Next''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_next_m.gif" BORDER="0" ALT="Next" ALIGN="TOP"></A></TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.formHidden('p_user_id', p_user_id);
  htp.formHidden('p_file_id', NULL);
  htp.formHidden('p_operation', p_operation);
  htp.formclose;
  gis_image_util.pageclose;
END show_org;

PROCEDURE show_doc_types(p_org_id         NUMBER   DEFAULT NULL,
                         p_user_id        NUMBER,
                         p_file_id        NUMBER   DEFAULT NULL,
                         p_operation      VARCHAR2,
                         p_secure_flag    VARCHAR2 DEFAULT NULL,
                         p_secure_context VARCHAR2 DEFAULT NULL) IS
CURSOR cur_docContext IS
  SELECT DISTINCT con.description, con.descriptive_flex_context_code
  FROM   FND_DESCR_FLEX_CONTEXTS_VL con,
         fnd_user_resp_groups usrep,
         fnd_application_tl app,
         fnd_responsibility_tl resp,
         fnd_user usr,
         fnd_profile_option_values optval,
         fnd_profile_options opt,
         hr_operating_units org
  WHERE  usr.user_id = p_user_id
  AND    usr.user_id = usrep.user_id
  AND    nvl(usrep.end_date,sysdate+1) > sysdate
  AND    usrep.responsibility_application_id = app.application_id
  AND    usrep.responsibility_id = resp.responsibility_id
  AND    usrep.responsibility_application_id = resp.application_id
  AND    usr.user_id = usrep.user_id
  AND    con.descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX'
  AND    descriptive_flex_context_code != 'Global Data Elements'
  AND    app.application_name = con.descriptive_flex_context_name
  AND    usrep.responsibility_id = optval.level_value
  AND    optval.profile_option_id = opt.profile_option_id
  AND    optval.application_id =  opt.application_id
  AND    opt.profile_option_name = 'ORG_ID'
  AND    org.organization_id = TO_NUMBER(optval.profile_option_value)
  AND    org.organization_id = p_org_id
  ORDER BY con.description;
  row_docContext cur_docContext%ROWTYPE;
BEGIN
  IF p_file_id IS NOT NULL AND
     p_secure_flag = 'Y' THEN
    gis_attach_util.show_fields(p_org_id, p_user_id, p_secure_context, p_file_id, p_operation, p_secure_flag);
  ELSE
    gis_image_util.pageopen(p_heading => 'Attach Image');
    gis_image_util.InfoHeader( 'Select Document Category');
    IF p_org_id IS NULL THEN
      htp.br;
      htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="100%" ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="largefont">No Organization selected - please select one.</SPAN></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="100%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="100%" ALIGN="CENTER"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
    ELSE
      htp.formOpen('gis_attach_util.show_fields', 'POST',cattributes=>'NAME="show_doc_types"');
      htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE">');
      htp.formSelectOpen(cname=>'p_context',nsize=>'10');	
      IF NOT cur_docContext%ISOPEN THEN
        OPEN cur_docContext;
      END IF;
      FETCH cur_docContext INTO row_docContext;
      IF cur_docContext%NOTFOUND THEN
        htp.formSelectOption('ERROR','SELECTED',cattributes=>'VALUE="0"' );
        -- put some sort of error message in here
      ELSE
        WHILE cur_docContext%FOUND LOOP	
          htp.formSelectOption(row_docContext.description, CATTRIBUTES=>'value="' ||	
                               row_docContext.descriptive_flex_context_code || '"');
          FETCH cur_docContext INTO row_docContext;
        END LOOP;
      END IF;
      CLOSE cur_docContext;
      htp.formSelectClose;
      htp.p('    </TD>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="98%" ALIGN="CENTER"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_l.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A><A HREF="Javascript:document.show_doc_types.submit()" onMouseOver="window.status=''Next''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_next_r.gif" BORDER="0" ALT="Next" ALIGN="TOP"></A></TD>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
      htp.formHidden('p_file_id', p_file_id);    
      htp.formHidden('p_user_id', p_user_id);
      htp.formHidden('p_org_id', p_org_id);
      htp.formHidden('p_operation', p_operation);
      htp.formHidden('p_secure_flag', p_secure_flag);
      htp.formclose;
    END IF;
    gis_image_util.pageclose;
  END IF;
END show_doc_types;

PROCEDURE confirm_oe_fields(p_org_id      NUMBER,
                            p_user_id     NUMBER,
                            p_context     VARCHAR2,
                            p_file_id     NUMBER,
                            p_oe_number   NUMBER,
                            p_po_number   VARCHAR2) IS

  vSQL       VARCHAR2(1000) := NULL;
  TYPE       cv_type IS REF CURSOR;
  cCheckOE   cv_type;

  nResult    NUMBER := 0;
  nOrdNum    oe_order_headers_all.order_number%TYPE;
  vCustName  ra_customers.customer_name%TYPE;
  vCustNum   ra_customers.customer_number%TYPE;
  nHeaderID  oe_order_headers_all.header_id%TYPE;
BEGIN
  vSQL := 'SELECT s.order_number, c.customer_name, c.customer_number, s.header_id ' ||
          'FROM   oe_order_headers_all s, ra_customers c ' ||
          'WHERE  s.sold_to_org_id = c.customer_id ';
  IF RTRIM(LTRIM(p_oe_number)) IS NOT NULL THEN
    vSQL := vSQL ||
            'AND    s.order_number = ' || TO_CHAR(p_oe_number) || ' ';
  END IF;            
  IF RTRIM(LTRIM(p_po_number)) IS NOT NULL THEN
    vSQL := vSQL ||
            'AND    s.cust_po_number = ''' || p_po_number || ''' ';
  END IF;
  vSQL := vSQL ||
          ' AND    s.org_id = ' || p_org_id;
  gis_image_util.pageopen(p_heading => 'GIS - OE Number Search');
  gis_image_util.InfoHeader('Confirm Order Details For Order ' || TO_CHAR(p_oe_number));
  htp.p('<SCRIPT language="Javascript">
function showSelection()
{
  var listLoop
  var listItems = document.confirm_oe_fields.p_pk_value.length
  var theList = ""
  var listURL

  for (listLoop = 0; listLoop < listItems; listLoop++)
  {
    if (document.confirm_oe_fields.p_pk_value[listLoop].selected == true)
    {
      theList = theList + document.confirm_oe_fields.p_pk_value[listLoop].value + ","
    }
  }
  if ((theList == "") || (theList == ","))
  {
    alert("No order(s) selected - please select at least one order to attach image to.")
  }
  else
  {
    listURL = "gis_attach_util.attach_image?p_user_id=' || p_user_id || '&p_file_id=' || p_file_id || '&p_table_name=OE_ORDER_HEADERS&p_pk_value=" + theList
    document.location = listURL
  }
}
</SCRIPT>');
  htp.formOpen('gis_attach_util.attach_image', 'POST',cattributes=>'NAME="confirm_oe_fields"');
  htp.formSelectOpen(cname=>'p_pk_value',nsize=>'10',cattributes=>'MULTIPLE' );	
  htp.formSelectOption('Order# Customer Name (Customer Number)', CATTRIBUTES=>'DISABLED');
  OPEN cCheckOE FOR vSQL;
  LOOP
    FETCH cCheckOE INTO nOrdNum, vCustName, vCustNum, nHeaderID;
    EXIT WHEN cCheckOE%NOTFOUND;
    nResult := nResult + 1;
    /* Show data for search results */
    htp.formSelectOption(TO_CHAR(nOrdNum) || ' ' || vCustName || ' (' || vCustNum || ')', CATTRIBUTES=>'value="' || TO_CHAR(nHeaderID) || '"');
  END LOOP;
  CLOSE cCheckOE;
  htp.formSelectClose;
  htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
  IF nResult = 0 THEN
    /* OE Number not found */
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>');
    htp.p('    <TD ALIGN="RIGHT"><FONT SIZE=2><IMG SRC="' || C_IMG_URL || 'i_stop.gif"></FONT></TD>');
    htp.p('    <TD ALIGN="CENTER"><FONT SIZE=2>Order Number(s)/Purchase Order Does Not Exist</FONT></TD>');
    htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>' );
  END IF;
  htp.p('  <TR>');
  htp.p('    <TD COLSPAN=3 ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('  <TR>');
  IF nResult = 0 THEN
    htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A></TD>');
  ELSE  
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="Javascript:showSelection()" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok_l.gif" BORDER="0" ALT="Correct" ALIGN="TOP"></A><A HREF="Javascript:back()" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_r.gif" BORDER="0" ALT="Incorrect" ALIGN="TOP"></A></TD>');
  END IF;
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.formHidden('p_file_id', p_file_id);
  htp.formHidden('p_table_name', 'OE_ORDER_HEADERS');
  htp.formHidden('p_user_id', p_user_id);
  -- No p_pk_value - string needs to be generated from array
  htp.p('</FORM>');
  gis_image_util.pageclose;  
END confirm_oe_fields;

PROCEDURE show_fields(p_org_id         NUMBER,
                      p_user_id        NUMBER,
                      p_context        VARCHAR2 DEFAULT 'None',
                      p_file_id        NUMBER   DEFAULT NULL,
                      p_operation      VARCHAR2,
                      p_secure_flag    VARCHAR2 DEFAULT NULL) IS
  vLabel    VARCHAR2(200) := NULL;                      
  vSecure   VARCHAR2(100) := 'PUBLIC';
  CURSOR cDocTypes IS
    SELECT tl.category_id, SUBSTR(tl.user_name, instr(tl.user_name, 'GIS - ') + 6) user_name,
           DECODE(cat.attribute2, 'SECURE', 'Y', 'N') secure
    FROM   fnd_document_categories_tl  tl,
           fnd_document_categories cat
    WHERE  tl.category_id = cat.category_id
    AND    cat.attribute_category = 'GIS'
    AND    cat.attribute1 = UPPER(p_context)
    AND    NVL(cat.start_date_active,SYSDATE - 1) <= SYSDATE
    AND    NVL(cat.end_date_active,SYSDATE + 1) >= SYSDATE
    AND    DECODE(cat.attribute2, 'SECURE', 'SECURE', 'PUBLIC') IN (vSecure, 'PUBLIC')
    ORDER BY tl.user_name;
  rDocTypes cDocTypes%ROWTYPE;
  vHdr      VARCHAR2(100) := NULL;
BEGIN
  -- Get set secure details flag for current user and context
  IF gis_search.viewSecureDocument(p_user_id, p_org_id, p_context) THEN
    vSecure := 'SECURE';
  ELSE
    vSecure := 'PUBLIC';
  END IF;
  -- Prepare label for description and Javascript prompt
  IF p_context = 'Order Management' THEN
    vLabel := 'Order Number';
  ELSIF p_context = 'Agreements' THEN
    vLabel := 'Agreement Name';
  ELSIF p_context = 'Customer' THEN
    vLabel := 'Customer Name';
  ELSIF p_context IN ('Payables', 'Receivables') THEN
    vLabel := 'Invoice Number';
  ELSIF p_context = 'Contracts' THEN
    vLabel := 'Contract Number';
  ELSIF p_context = 'Projects' THEN
    vLabel := 'Project Number';
  ELSIF p_context = 'Web Expenses' THEN
    vLabel := 'Expense Report Number';
  ELSIF p_context = 'Education Bookings' THEN
    vLabel := 'Enrollment Number';
  ELSIF p_context = 'Education Events' THEN
    vLabel := 'Event Title';
  ELSIF p_context = 'HR Assignments' THEN
    vLabel := 'Name';
  ELSIF p_context = 'Suppliers' THEN
    vLabel := 'Supplier Name';
  ELSE
    htp.p('Unknown context: ' || p_context);
-- ERROR handler ???
  END IF;
  htp.p('<SCRIPT language="Javascript">
function requestIt()
{
  var nullError = ""
  var returnValue');
  IF p_operation = 'A' AND
     p_file_id IS NOT NULL THEN
    htp.p('  if (document.show_fields.p_key.value == "" &&
      nullError == "")
  {
    alert("' || vLabel || ' is required.")
    nullError = "1"
    document.show_fields.p_file_id.focus()
  }');
  ELSE
    htp.p('  if (document.show_fields.p_file_id.value == "" && 
      document.show_fields.p_key.value == "" &&
      nullError == "")
  {
    alert("Image Number OR ' || vLabel || ' is required.")
    nullError = "1"
    document.show_fields.p_file_id.focus()
  }');
  END IF;
  IF p_operation = 'A' AND
     p_file_id IS NOT NULL THEN
    htp.p('  if (document.show_fields.p_description.value == "" && 
      nullError == "")
  {
    alert("Description is required.")
    nullError = "1"
    document.show_fields.p_description.focus()
  }');
  END IF;
  htp.p('  if (nullError != "")
  {
    nullError = ""
  }
  else
  {
    document.show_fields.submit()
  }
}
</SCRIPT>');
  IF p_context = 'None' THEN
    gis_image_util.pageopen(p_heading => 'No Document Category Selected');
    gis_image_util.InfoHeader('No Document Category Selected');
  ELSE
    gis_image_util.pageopen(p_heading => p_context || ' Search Fields');
    gis_image_util.InfoHeader('Enter Search Details');
  END IF;
  IF (p_operation IN ('D', 'V', 'R')) OR
     (p_operation = 'A' AND p_file_id IS NULL) THEN
      -- Search for image/Add attachment
    htp.formOpen('gis_attach_util.search_image', 'POST',cattributes=>'NAME="show_fields"');
  ELSE
    -- Search for target record
    htp.formOpen('gis_attach_util.search_target', 'POST',cattributes=>'NAME="show_fields"');
  END IF;
  htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
  IF p_context != 'None' THEN
    IF p_secure_flag = 'Y' THEN
      htp.p('  <TR>' );
      htp.p('    <TD COLSPAN=2 ALIGN="CENTER"><FONT SIZE=2 COLOR="#FFCC00">Source image is a SECURE document - you can only multi-attach this image to a SECURE document type for the ' || p_context || ' LOB.</FONT></TD>');      
      htp.p('  </TR>' );
    END IF;
    IF p_file_id IS NULL THEN
      -- Input to query by image number - show only if no image number is passed
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="RIGHT"><FONT SIZE=2 COLOR="#FFCC00">Image Number:</FONT></TD>');      
      htp.p('    <TD ALIGN="LEFT"><FONT SIZE=2><INPUT type="text" name="p_file_id" size="22" maxlength="100"></FONT></TD>');
      htp.p('  </TR>' );
    ELSE
      -- Show doc type for target context
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="RIGHT"><SPAN CLASS="mediumfont"><FONT COLOR="#FFCC00">Doc Type:</FONT></SPAN></TD>');      
      /* Show LOV for document types for category */
      htp.p('    <TD><SPAN CLASS="mediumfont">');
      htp.formSelectOpen(cname=>'p_doc_category_id', nsize=>'1');
      OPEN cDocTypes;
      LOOP        
        FETCH cDocTypes INTO rDocTypes;
        EXIT WHEN cDocTypes%NOTFOUND;
        IF p_file_id IS NOT NULL AND
           NVL(p_secure_flag, 'X') = rDocTypes.secure THEN
           -- Only show document types with same security type as source
          htp.p('      <OPTION value="' || rDocTypes.category_id || '">' || rDocTypes.user_name);
        END IF;
      END LOOP;
      CLOSE cDocTypes;
      htp.formSelectClose;
      htp.p('    </SPAN></TD>');
      htp.p('  <TR>' );
    END IF;
    /* Show input text field */
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="RIGHT"><FONT SIZE=2 COLOR="#FFCC00">' || vLabel || ':</FONT></TD>');      
    htp.p('    <TD ALIGN="LEFT"><FONT SIZE=2>' || '<INPUT type="text" name="p_key" size="22" maxlength="100"></FONT></TD>');
    htp.p('  </TR>' );
    IF p_operation = 'A' AND
       p_file_id IS NOT NULL THEN
      -- Input description
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="RIGHT"><FONT SIZE=2 COLOR="#FFCC00">Description:</FONT></TD>');      
      htp.p('    <TD ALIGN="LEFT"><FONT SIZE=2>' || '<INPUT type="text" name="p_description" size="22" maxlength="100"></FONT></TD>');
      htp.p('  </TR>' );
    END IF;
  ELSE
    htp.p('  <TR>' );
    -- No document type selected
    htp.p('    <TD ALIGN="RIGHT"><FONT SIZE=2><IMG SRC="' || C_IMG_URL || 'i_stop.gif"></FONT></TD>');
    htp.p('    <TD ALIGN="CENTER"><FONT SIZE=2>NO Document Category Selected</FONT></TD>');
    htp.p('  </TR>' );
  END IF;
  htp.p('  <TR>');
  htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  IF p_context != 'None' THEN
    htp.p('    <TD ALIGN="LEFT"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_l.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A><A HREF="Javascript:requestIt()" onMouseOver="window.status=''Next''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_next_r.gif" BORDER="0" ALT="Next" ALIGN="TOP"></A></TD>');
  ELSE
    htp.p('    <TD ALIGN="CENTER"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A></TD>');
  END IF;
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.formHidden('p_context', p_context);
  htp.formHidden('p_user_id', p_user_id);
  htp.formHidden('p_org_id', p_org_id);
  IF (p_operation IN ('D', 'V', 'R')) OR
     (p_operation = 'A' AND p_file_id IS NULL) THEN
      -- Output p_operation flag
    htp.formHidden('p_operation', p_operation);
  END IF;
  IF p_file_id IS NOT NULL THEN
    htp.formHidden('p_file_id', p_file_id);
  END IF;
  htp.p('</FORM>');
  gis_image_util.pageclose;
EXCEPTION
  WHEN OTHERS THEN
    NULL;
END show_fields;

PROCEDURE search_image(p_org_id         NUMBER,
                       p_user_id        NUMBER,
                       p_context        VARCHAR2,
                       p_file_id        NUMBER    DEFAULT NULL,
                       p_key            VARCHAR2  DEFAULT NULL,
                       p_operation      VARCHAR2) IS

  vStatus        fnd_documents_tl_dfv.index_status_id%TYPE;
  vSelect        VARCHAR2(1000) := NULL; 
  vTable         VARCHAR2(1000) := NULL;
  vSQL           VARCHAR2(10000) := NULL;

  TYPE        cv_type IS REF CURSOR;
  cSearch     cv_type;
  nMediaID    NUMBER;
  vAttachDoc  VARCHAR2(240);
  vRef        VARCHAR2(240);
  vSecureFlag VARCHAR2(240);
  nResult     NUMBER := 0;
  vRefHdg     VARCHAR2(240);

  cImageURL   VARCHAR2(1000);
  vMsg        VARCHAR2(1000);
BEGIN
  htp.p('<SCRIPT language="JavaScript">
<!--BEGIN Script
var listURL = ""
function listIt(p_user_id,p_file_id,p_operation)
{
  listURL = "gis_attach_util.list_attached_images?p_user_id=" + p_user_id + "&p_file_id=" + p_file_id + "&p_operation=" + p_operation
  viewimage('''','''',listURL)
}
function searchTarget(p_org_id,p_user_id,p_file_id,p_operation,p_secure_flag)
{
  listURL = "gis_attach_util.show_doc_types?p_org_id=" + p_org_id + "&p_user_id=" + p_user_id + "&p_file_id=" + p_file_id + "&p_operation=" + p_operation + "&p_secure_flag=" + p_secure_flag + "&p_secure_context=' || p_context || '"
  viewimage('''',listURL,'''')
}
//-->
</SCRIPT>');
  -- Show all attachments and for context/ and image number/key search
  IF p_context = 'Order Management' THEN
    -- Get order number and build SQL statement
    vSelect := ', context.order_number || '' '' || context2.customer_name apps_ref ';
    vTable := ', oe_order_headers_all context, ra_customers context2 ';
    vSQL := 'and a.entity_name = ''OE_ORDER_HEADERS'' ' ||
            'and context.sold_to_org_id = context2.customer_id ' ||
            'and context.org_id = ' || TO_CHAR(p_org_id) || ' ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.header_id) ' ||
            'and context.order_number = ''' || p_key || ''' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.header_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Order Number/Customer Name';
  ELSIF p_context = 'Payables' THEN
    vSelect := ', context.invoice_num || '' '' || context2.vendor_name apps_ref ';
    vTable := ', ap_invoices_all context, po_vendors context2 ';
    vSQL := 'and a.entity_name = ''AP_INVOICES'' ' ||
            'and context.org_id = ' || TO_CHAR(p_org_id) || ' ' ||
            'and context.vendor_id = context2.vendor_id ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.invoice_id) ' ||
            'and context.invoice_num = ''' || p_key || ''' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.invoice_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Invoice Number/Vendor';
  ELSIF p_context = 'Agreements' THEN
    vSelect := ', context.name apps_ref ';
    vTable := ', oe_agreements context ';
    vSQL := 'and a.entity_name = ''OE_AGREEMENTS'' ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.agreement_id) ' ||
            'and context.name = ''' || p_key || ''' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.agreement_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Agreement Name';
  ELSIF p_context = 'Customer' THEN
    vSelect := ', context.party_name apps_ref ';
    vTable := ', hz_parties context, hz_cust_accounts context2 ';
    vSQL := 'and a.entity_name = ''AR_CUSTOMERS'' ' ||
            'and context.party_id = context2.party_id ' ||
            'and exists (select 1 from hz_cust_acct_sites_all ' ||
            'where cust_account_id = context2.cust_account_id ' ||
            'and org_id = ' || TO_CHAR(p_org_id) || ') ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context2.cust_account_id) ' ||
            'and upper(context.party_name) like upper(''' || REPLACE(p_key, '''', '''''') || '%'') ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context2.cust_account_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Customer Name';
  ELSIF p_context = 'Projects' THEN
    vSelect := ', context.segment1 apps_ref ';
    vTable := ', pa_projects_all context ';
    vSQL := 'and a.entity_name = ''PA_PROJECTS'' ' ||
            'and context.org_id = ' || TO_CHAR(p_org_id) || ' ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.project_id) ' ||
            'and context.segment1 = ''' || p_key || ''' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.project_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Project Number';
  ELSIF p_context = 'Web Expenses' THEN
    vSelect := ', context.invoice_num apps_ref ';
    vTable := ', ap_expense_report_headers_all context ';
    vSQL := 'and a.entity_name = ''AP_EXPENSE_REPORT_HEADER_S_ALL'' ' ||
            'and context.org_id = ' || TO_CHAR(p_org_id) || ' ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.report_header_id) ' ||
            'and context.invoice_num = ''' || p_key || ''' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.report_header_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Expense Number';
  ELSIF p_context = 'Contracts' THEN
    vSelect := ', context.contract_number || decode(context.contract_number_modifier, NULL, NULL, '' '' || context.contract_number_modifier)  apps_ref ';
    vTable := ', okc_k_headers_b context ';
    vSQL := 'and a.entity_name = ''OKC_K_HEADERS_V'' ' ||
            'and context.authoring_org_id = ' || TO_CHAR(p_org_id) || ' ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.id) ' ||
            'and context.contract_number = ''' || p_key || ''' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Contract Number/Modifier';
  ELSIF p_context = 'Receivables' THEN
    vSelect := ', context.trx_number apps_ref ';
    vTable := ', ra_customer_trx_all context ';
    vSQL := 'and a.entity_name = ''RA_CUSTOMER_TRX'' ' ||
            'and context.org_id = ' || TO_CHAR(p_org_id) || ' ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.customer_trx_id) ' ||
            'and context.trx_number = ''' || p_key || ''' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.customer_trx_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Invoice Number';
  ELSIF p_context = 'Education Bookings' THEN
    vSelect := ', context.booking_id apps_ref ';
    vTable := ', ota_delegate_bookings context ';
    vSQL := 'and a.entity_name = ''OTA_DELEGATE_BOOKINGS'' ' ||
            'and context.business_group_id = ' || TO_CHAR(p_org_id) || ' ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.booking_id) ' ||
            'and context.booking_id = ''' || p_key || ''' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.booking_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Enrollment Number';
  ELSIF p_context = 'Education Events' THEN
    vSelect := ', context.event_id apps_ref ';
    vTable := ', ota_events context ';
    vSQL := 'and a.entity_name = ''OTA_EVENTS'' ' ||
            'and context.business_group_id = ' || TO_CHAR(p_org_id) || ' ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.event_id) ' ||
            'and context.title = ''' || p_key || ''' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.event_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Course Title';
  ELSIF p_context = 'HR Assignments' THEN
    vSelect := ', context2.full_name apps_ref ';
    vTable := ', per_all_assignments_f context, per_all_people_f context2 ';  
    vSQL := 'and a.entity_name = ''PER_ASSIGNMENTS_F'' ' ||
            'and context.business_group_id = ' || TO_CHAR(p_org_id) || ' ' ||
            'and context.business_group_id+0 = context2.business_group_id+0 ' ||
            'and context.person_id = context2.person_id ' ||
            'and context2.effective_start_date <= TRUNC(SYSDATE) ' ||
            'and context2.effective_end_date >= TRUNC(SYSDATE+1) ' ||
            'and context.effective_start_date <= TRUNC(SYSDATE) ' ||
            'and context.effective_end_date >= TRUNC(SYSDATE+1) ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.assignment_id) ' ||
            'and context2.full_name like ''' || p_key || '%'' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.assignment_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Assignment';
  ELSIF p_context = 'Suppliers' THEN
    vSelect := ', context.vendor_name apps_ref ';
    vTable := ', po_vendors context, hr_operating_units context2 ';
    vSQL := 'and a.entity_name = ''PO_VENDORS'' ' ||
            'and context2.organization_id = ' || TO_CHAR(p_org_id) || ' ' ||
            'and context.set_of_books_id = context2.set_of_books_id ';
    IF p_key IS NOT NULL THEN
      vSQL := vSQL || 
            'and a.pk1_value = TO_CHAR(context.vendor_id) ' ||
            'and context.vendor_name like ''' || REPLACE(p_key, '''', '''''') || '%'' ';
    ELSIF p_file_id IS NOT NULL THEN
      vSQL := vSQL || 
            'and TO_NUMBER(a.pk1_value) = context.vendor_id ' ||
            'and t.media_id = ' || p_file_id || ' ';
    END IF;
    vRefHdg := 'Supplier';
  END IF;
  vSQL := 'select t.media_id, SUBSTR(c.user_name, (INSTR(c.user_name, ''-'')+2)) doc_type ' || vSelect || ', decode(cat.attribute2, ''SECURE'', ''Y'', ''N'') secure_flag ' ||
          'from   fnd_documents_tl t, fnd_attached_documents a, fnd_documents d, fnd_document_categories_tl c, fnd_document_categories cat ' || vTable ||
          'where  t.document_id = d.document_id ' ||
          'and    a.document_id = d.document_id ' ||
          'and    d.category_id = c.category_id ' || 
          'and    c.category_id = cat.category_id ' || vSQL ||
          'order by t.media_id ';
  gis_image_util.pageopen('Search Result');
  gis_image_util.InfoHeader('Search Results');
  htp.p('<FORM>');
  htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
  -- Output heading
  htp.p('  <TR>' );
  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Image </SPAN></TD>');
  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Document Type </SPAN></TD>');
  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vRefHdg || ' </SPAN></TD>');
  htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  -- Show images
  OPEN cSearch FOR vSQL;
  LOOP
    FETCH cSearch INTO nMediaID, vAttachDoc, vRef, vSecureFlag;
    EXIT WHEN cSearch%NOTFOUND;
    nResult := nResult + 1;
    -- Build URL link for file download
    cImageURL := fnd_gfm.construct_download_url(C_APP_URL, nMediaID);
    -- Show data for image PK
    htp.p('  <TR>' );
    htp.p('    <TD><A HREF="JavaScript:viewimage('''','''', ''' || cImageURL || ''')"><SPAN CLASS="mediumfont"><FONT COLOR="WHITE">'|| nMediaID ||'</A></FONT></SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vAttachDoc || '</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vRef || '</SPAN></TD>');
    IF p_operation = 'A' THEN
      -- Search for target image
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:searchTarget(' || '''' || p_org_id || ''',' || '''' || p_user_id || ''',' || '''' || nMediaID || ''',''' || p_operation || ''',''' || vSecureFlag || ''')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
    ELSE
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:listIt(''' || p_user_id || ''',''' || nMediaID || ''',''' || p_operation || ''')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
    END IF;
    htp.p('  </TR>');
  END LOOP;
  CLOSE cSearch;
  IF nResult = 0 THEN
    htp.p('  <TR>' );
    htp.p('    <TD COLSPAN=4 ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>No Attachments</FONT></TD>');
    htp.p('  </TR>' );
  END IF;
  htp.p('</TABLE>');
  htp.br;
  -- User can continue or go back
  htp.formOpen('gis_preindex.save_preindex_info', 'POST',cattributes=>'NAME="save_preindex_info"');
  htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
  htp.p('  <TR>');
  htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vMsg || '</SPAN></TD>');
  htp.p('  </TR>');
  htp.p('  <TR>');
  htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.p('</FORM>');
  gis_image_util.pageclose;		
-- exception to catch records that have been processed  DG 18-10-2000
-- problem caused by duplicate fnd_documents_tl records - modified code to process only those WITH a file name
EXCEPTION
  WHEN OTHERS THEN
    gis_image_util.InfoHeader('Error Details');
    htp.br;
    htp.br;
    htp.p('<B>Error: Unable to check details - contact support with the following error message:</B>');
    htp.br;
    htp.p(SQLERRM);
    htp.br;
    htp.p(vSQL);
    htp.br;
    htp.p('<TABLE WIDTH="100%" ALIGN="CENTER" >');
    htp.p('  <TR ><TD ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TR>');
    htp.p('</TABLE>');
    gis_image_util.pageclose;		
END search_image;

PROCEDURE search_target(p_org_id           NUMBER,
                        p_user_id          NUMBER,
                        p_context          VARCHAR2,
                        p_file_id          NUMBER    DEFAULT NULL,
                        p_key              VARCHAR2  DEFAULT NULL,
                        p_doc_category_id  NUMBER,
                        p_description      VARCHAR2  DEFAULT NULL) IS

  vStatus        fnd_documents_tl_dfv.index_status_id%TYPE;
  vSelect        VARCHAR2(1000) := NULL; 
  vTable         VARCHAR2(1000) := NULL;
  vSQL           VARCHAR2(10000) := NULL;

  TYPE       cv_type IS REF CURSOR;
  cSearch    cv_type;
  nMediaID   NUMBER;
  vAttachDoc VARCHAR2(240);
  vRef       VARCHAR2(240);
  vRef2      VARCHAR2(240);
  nKey       NUMBER := 0;
  vEntity    VARCHAR2(240);
  nResult    NUMBER := 0;
  vRefHdg    VARCHAR2(240);
  vRefHdg2   VARCHAR2(240);

  cImageURL  VARCHAR2(1000);
  vMsg       VARCHAR2(1000);
BEGIN
  htp.p('<SCRIPT language="JavaScript">
<!--BEGIN Script
var listURL = ""
function attachIt(p_org_id,p_user_id,p_file_id,p_key_id,p_entity,p_doc_category_id)
{

  listURL = "gis_attach_util.attach_image?p_org_id=" + p_org_id + "&p_user_id=" + p_user_id + "&p_context=' || REPLACE(p_context, ' ', '+') || '"
  listURL = listURL + "&p_file_id=" + p_file_id + "&p_table_name=" + p_entity + "&p_pk_value=" + p_key_id + "&p_doc_category_id=" + p_doc_category_id
  listURL = listURL + "&p_description=' || REPLACE(REPLACE(p_description, '''', '\'''), ' ', '+') || '"
  viewimage('''',listURL,'''')
}
//-->
</SCRIPT>');
  -- Show all attachments and for context/ and image number/key search
  IF p_context = 'Order Management' THEN
    -- Get order number and build SQL statement
    vSQL := 'select context.order_number, context2.customer_name, context.header_id, ''OE_ORDER_HEADERS'' ' ||
            'from   oe_order_headers_all context, ra_customers context2 ' ||
            'where  context.sold_to_org_id = context2.customer_id ' ||
            'and    context.org_id = ' || TO_CHAR(p_org_id) || ' ' ||
            'and    context.order_number = ''' || p_key || ''' ';
    vRefHdg := 'Order Number';
    vRefHdg2 := 'Customer Name';
  ELSIF p_context = 'Payables' THEN
    vSQL := 'select context.invoice_num, context2.vendor_name, context.invoice_id, ''AP_INVOICES'' ' ||
            'from   ap_invoices_all context, po_vendors context2 ' ||
            'where  context.vendor_id = context2.vendor_id ' ||
            'and    context.invoice_num = ''' || p_key || ''' ';
    vRefHdg := 'Invoice Number';
    vRefHdg2 := 'Vendor';
  ELSIF p_context = 'Agreements' THEN
    vSQL := 'select context.name, agreement_type_code, agreement_id, ''OE_AGREEMENTS'' ' ||
            'from   oe_agreements context ' ||
            'where  context.name = ''' || p_key || ''' ';
    vRefHdg := 'Agreement Name';
    vRefHdg2 := 'Agreement Type';
  ELSIF p_context = 'Customer' THEN
    vSQL := 'select context.party_name, context2.account_number, context2.cust_account_id, ''AR_CUSTOMERS'' ' ||
            'from   hz_parties context, hz_cust_accounts context2 ' ||
            'where  context.party_id = context2.party_id ' ||
            'and    exists (select 1 from hz_cust_acct_sites_all where cust_account_id = context2.cust_account_id and org_id = ' || TO_CHAR(p_org_id) || ') ' ||
            'and    upper(context.party_name) like upper(''' || REPLACE(p_key, '''', '''''') || '%'') ' ||
            'order by context.party_name';
    vRefHdg := 'Customer Name';
    vRefHdg2 := 'Customer Number';
  ELSIF p_context = 'Projects' THEN
    vSQL := 'select p.segment1, c.customer_name, p.project_id, ''PA_PROJECTS'' ' ||
            'from   ra_customers c, pa_projects_all p, pa_project_customers pc ' ||
            'where  p.segment1 = ''' || p_key || ''' ' ||
            'and    c.customer_id = pc.customer_id ' ||
            'and    pc.project_id = p.project_id ' ||
            'and    pc.project_relationship_code = ''Primary'' ' ||
            'and    p.org_id = ' || TO_CHAR(p_org_id) || ' ';
    vRefHdg := 'Project Number';
    vRefHdg2 := 'Customer Name';
  ELSIF p_context = 'Web Expenses' THEN
    vSQL := 'select e.invoice_num, p.full_name || '' - '' || e.description, e.report_header_id,''AP_EXPENSE_REPORT_HEADER_S_ALL'' ' ||
            'from   ap_expense_report_headers_all e, per_people_f p ' ||
            'where  e.employee_id = p.person_id ' ||
            'and    p.effective_end_date >= SYSDATE ' ||
            'and    e.invoice_num = ''' || p_key || ''' ' ||
            'and    e.org_id = ' || TO_CHAR(p_org_id) || ' ';
    vRefHdg := 'Expense Number';
    vRefHdg2 := 'Employee/Description';
  ELSIF p_context = 'Contracts' THEN
    vSQL := 'select h.contract_number || '' '' || h.contract_number_modifier, c.customer_name, h.id, ''OKC_K_HEADERS_V'' ' ||
            'from   okc_rules_b b, okc_k_headers_b h, ra_customers c ' ||
            'where  h.contract_number = ''' || p_key || ''' ' ||
            'and    b.jtot_object1_code = ''OKX_CUSTACCT'' ' ||
            'and    c.customer_id = b.object1_id1 ' ||
            'and    b.dnz_chr_id = h.id ' ||
            'and    h.authoring_org_id = ' || TO_CHAR(p_org_id) || ' ' ||
            'order by c.customer_name, h.id ';
    vRefHdg := 'Contract Number/Modifier';
    vRefHdg2 := 'Customer Name';
  ELSIF p_context = 'Receivables' THEN
    vSQL := 'select c.customer_name, t.trx_number, t.customer_trx_id, ''RA_CUSTOMER_TRX'' ' ||
            'from   ra_customers c, ra_customer_trx_all t ' ||
            'where  t.trx_number = ''' || p_key || ''' ' ||
            'and    t.sold_to_customer_id = c.customer_id ' ||
            'and    t.org_id = ' || TO_CHAR(p_org_id) || ' ';
    vRefHdg := 'Invoice Number';
    vRefHdg2 := 'Customer Name';
  ELSIF p_context = 'Education Bookings' THEN
    vSQL := 'select o.booking_id || '' : '' || e.title || '' - '' || v.version_name,
                    DECODE(o.delegate_person_id,
                           NULL, c.last_name || DECODE(c.first_name, NULL, NULL, '', '' || c.first_name),
                           UPPER(p.full_name)), o.booking_id, ''OTA_DELEGATE_BOOKINGS'' ' ||
             'from  ota_delegate_bookings o, ra_contacts c, ota_events e, ota_activity_versions v, per_people_f p ' ||
             'where o.booking_id = ''' || p_key || ''' ' ||
             'and   o.contact_id = c.contact_id(+) ' ||
             'and   o.delegate_person_id = p.person_id(+) ' ||
             'and   NVL(p.effective_start_date, SYSDATE) <= SYSDATE ' ||
             'and   NVL(p.effective_end_date, SYSDATE) >= SYSDATE ' ||
             'and   o.event_id = e.event_id ' ||
             'and   e.activity_version_id = v.activity_version_id ' ||
             'and   NOT (o.contact_id IS NULL AND o.delegate_person_id IS NULL) ' ||
             'and   e.organization_id = ' || TO_CHAR(p_org_id) || ' ';
    vRefHdg := 'Enrollment Number';
    vRefHdg2 := 'Delegate Name';
  ELSIF p_context = 'Education Events' THEN
    vSQL := 'select e.title || '' - '' || v.version_name, TO_CHAR(e.course_start_date, ''DD-MON-YYYY'') || '' - '' || TO_CHAR(e.course_end_date, ''DD-MON-YYYY''), ' ||
            '       e.event_id, ''OTA_EVENTS'' ' ||
            'from   ota_events e, ota_activity_versions v ' ||
            'where  e.activity_version_id = v.activity_version_id ' ||
            'and    e.organization_id = ' || TO_CHAR(p_org_id) || ' ' ||
            'and    e.title = ''' || p_key || ''' ';
    vRefHdg := 'Course Details';
    vRefHdg2 := 'Start/End Date';
  ELSIF p_context = 'HR Assignments' THEN
    vSQL := 'select p.full_name, t.user_person_type || DECODE(av.discretionary_title, NULL, NULL, '' - '' || av.discretionary_title), a.assignment_id, ''PER_ASSIGNMENTS_F'' ' ||
            'from   per_all_people_f p, per_person_types t, per_all_assignments_f a, per_all_assignments_f_dfv av ' ||
            'where  p.full_name like ''' || p_key || '%'' ' ||
            'and    p.effective_start_date <= TRUNC(SYSDATE) ' ||
            'and    p.effective_end_date >= TRUNC(SYSDATE+1) ' ||
            'and    p.person_type_id = t.person_type_id ' ||
            'and    p.person_id = a.person_id ' ||
            'and    a.effective_start_date <= TRUNC(SYSDATE) ' ||
            'and    a.effective_end_date >= TRUNC(SYSDATE+1) ' ||
            'and    a.rowid = av.rowid ' ||
            'and    p.business_group_id+0 = t.business_group_id+0 ' ||
            'and    p.business_group_id+0 = a.business_group_id+0 ' ||
            'and    p.business_group_id = ' || TO_CHAR(p_org_id) || ' ' ||
            'order by p.full_name ';
    vRefHdg := 'Name';
    vRefHdg2 := 'Assignment';
  ELSIF p_context = 'Suppliers' THEN
    vSQL := 'select p.vendor_name, p.segment1 vendor_number, p.vendor_id, ''PO_VENDORS'' ' ||
            'from   po_vendors p, hr_operating_units u ' ||
            'where  p.vendor_name like ''' || REPLACE(p_key, '''', '''''') || '%'' ' ||
            'and    p.set_of_books_id = u.set_of_books_id ' ||
            'and    u.organization_id = ' || TO_CHAR(p_org_id) || ' ' ||
            'order by p.vendor_name ';
    vRefHdg := 'Supplier';
    vRefHdg2 := 'Supplier Number';
  END IF;
         
  gis_image_util.pageopen('Search Result');
  gis_image_util.InfoHeader('Search Results');
  htp.p('<FORM>');
  htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
  -- Output heading
  htp.p('  <TR>' );
  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vRefHdg || ' </SPAN></TD>');
  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vRefHdg2 || ' </SPAN></TD>');
  htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  -- Show records to attach to
  OPEN cSearch FOR vSQL;
  LOOP
    FETCH cSearch INTO vRef, vRef2, nKey, vEntity;
    EXIT WHEN cSearch%NOTFOUND;
    nResult := nResult + 1;
    -- Show data for record
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vRef || '</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vRef2 || '</SPAN></TD>');
    -- Search for target image
    htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:attachIt(''' || p_org_id || ''',''' || p_user_id || ''',''' || p_file_id || ''',''' || TO_CHAR(nKey) || ''',''' || vEntity || ''',''' || p_doc_category_id || ''')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
    htp.p('  </TR>');
  END LOOP;
  CLOSE cSearch;
  htp.p('</TABLE>');
  htp.br;
  -- User can continue or go back
  htp.formOpen('gis_preindex.save_preindex_info', 'POST',cattributes=>'NAME="save_preindex_info"');
  -- Output variables
--  htp.formHidden('p_context', REPLACE(p_context, '%20', ' '));
--  htp.formHidden('p_user_id', TO_CHAR(p_user_id));
--  htp.formHidden('p_org_id', p_org_id);
--  htp.formHidden('p_file_id', TO_CHAR(p_file_id));
--  htp.formHidden('p_key', p_key);
  htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
  htp.p('  <TR>');
  htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vMsg || '</SPAN></TD>');
  htp.p('  </TR>');
  htp.p('  <TR>');
  htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.p('</FORM>');
  gis_image_util.pageclose;		
-- exception to catch records that have been processed  DG 18-10-2000
-- problem caused by duplicate fnd_documents_tl records - modified code to process only those WITH a file name
EXCEPTION
  WHEN OTHERS THEN
    gis_image_util.InfoHeader('Error Details');
    htp.br;
    htp.p(vSQL);
    htp.br;
    htp.p('<B>Error: Unable to check details - contact support with the following error message:</B>');
    htp.br;
    htp.p(SQLERRM);
    htp.br;
    htp.p('<TABLE WIDTH="100%" ALIGN="CENTER" >');
    htp.p('  <TR ><TD ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TR>');
    htp.p('</TABLE>');
    gis_image_util.pageclose;		
END search_target;

PROCEDURE attach_image(p_org_id           NUMBER,
                       p_user_id          NUMBER,
                       p_context          VARCHAR2,
                       p_file_id          NUMBER,
                       p_table_name       VARCHAR2,
                       p_pk_value         VARCHAR2,
                       p_doc_category_id  NUMBER,
                       p_description      VARCHAR2) IS

  nAttach        NUMBER := 0;
  nDocID         NUMBER := NULL;
  nAttachDocID   NUMBER := NULL;
  vList          VARCHAR2(1000) := NULL;
  vVal           VARCHAR2(1000) := NULL;
  nCompleteID    gis_doc_status_types.doc_status_type_id%TYPE;
  CURSOR cAttach IS
    SELECT NVL(MAX(a.seq_num), 0)
    FROM   fnd_attached_documents a
    WHERE  a.entity_name = p_table_name
    AND    a.pk1_value = vVal;
  nPKID     NUMBER;
  nSecID    NUMBER;
  nSecType  NUMBER;
  vPublish  fnd_documents.publish_flag%TYPE;
  vOENum    oe_order_headers_all.order_number%TYPE;
  vGTN      oe_order_headers_all.attribute6%TYPE;
  vCustName ra_customers.customer_name%TYPE;
  vCustNum  ra_customers.customer_number%TYPE;
  vOEType   so_order_types_all.name%TYPE;
  nOrdVal   NUMBER;
  nLicVal   NUMBER;
  CURSOR cOE IS
    SELECT h.header_id, h.org_id, h.order_number, v.global_tracking_number, 
           c.customer_name, c.customer_number, t.name order_type,
           ROUND(NVL(SUM(ol.ordered_quantity * ol.unit_selling_price), 0), 2) ord_val,
           ROUND(NVL(SUM(ll.ordered_quantity * ll.unit_selling_price), 0), 2) lic_val
    FROM   oe_order_headers_all h, oe_order_headers_all_dfv v, ra_customers c, so_order_types_all t,
           oe_order_lines_all ol, oe_order_lines_all ll
    WHERE  h.rowid = v.rowid
    AND    h.sold_to_org_id = c.customer_id
    AND    h.order_type_id = t.order_type_id
    AND    h.header_id = TO_NUMBER(vVal) --4560767
    AND    h.header_id = ol.header_id(+)
    AND    h.header_id = ll.header_id(+)
    AND    ll.item_type_code(+) != 'SERVICE'
    GROUP BY h.header_id, h.org_id, h.order_number, v.global_tracking_number, 
             c.customer_name, c.customer_number, t.name;
  CURSOR cRC IS
    SELECT customer_name, customer_number
    FROM   ra_customers
    WHERE  customer_id = TO_NUMBER(vVal);
  vAgreeName  oe_agreements_tl.name%TYPE;
  vAgreeCode  oe_agreements_b.agreement_type_code%TYPE;
  CURSOR cSA IS
    SELECT t.name, b.agreement_type_code, c.customer_name, c.customer_number
    FROM   ra_customers c, oe_agreements_tl t, oe_agreements_b b
    WHERE  t.agreement_id = TO_NUMBER(vVal)
    AND    c.customer_id = b.sold_to_org_id
    AND    c.customer_id != -1
    AND    b.agreement_id = t.agreement_id;
  vProjNum pa_projects_all.segment1%TYPE;
  vProjVal pa_projects_all.segment1%TYPE;
  CURSOR cPROJ IS
    SELECT p.segment1 project_number, LTRIM(TO_CHAR(SUM(NVL(pf.total_baselined_amount, 0)), '999999999990.00')) project_value, c.customer_name, c.customer_number
    FROM   ra_customers c, pa_projects_all p, pa_project_customers pc, pa_summary_project_fundings pf
    WHERE  p.project_id = TO_NUMBER(vVal)
    AND    c.customer_id = pc.customer_id
    AND    pc.project_id = p.project_id
    AND    pc.project_id = pf.project_id(+)
    GROUP BY p.segment1, c.customer_name, c.customer_number;
  vStorage fnd_documents_tl.doc_attribute10%TYPE;
  vDesc    fnd_documents_tl.description%TYPE;
  CURSOR cSource IS
    SELECT v.storage_location, t.description
    FROM   fnd_documents_tl t, fnd_documents d, fnd_documents_tl_dfv v
    WHERE  t.media_id = p_file_id
    AND    t.document_id = d.document_id
    AND    t.rowid = v.rowid
    AND    v.primary_document_id = 'Y'
    AND    d.datatype_id = 
     (SELECT datatype_id
      FROM   fnd_document_datatypes
      WHERE  name = 'FILE'
      AND    NVL(start_date_active, SYSDATE) <= SYSDATE
      AND    NVL(end_date_active, SYSDATE) >= SYSDATE);
  vInvNum   ra_customer_trx_all.trx_number%TYPE;
  CURSOR cAR IS
    SELECT c.customer_name, t.trx_number
    FROM   ra_customers c, ra_customer_trx_all t
    WHERE  t.customer_trx_id = TO_NUMBER(vVal)
    AND    t.sold_to_customer_id = c.customer_id;
  vSuppName po_vendors.vendor_name%TYPE;
  vSuppNum  po_vendors.segment1%TYPE;
  CURSOR cPOV IS
    SELECT p.vendor_name, p.segment1 vendor_number
    FROM   po_vendors p
    WHERE  p.vendor_id = TO_NUMBER(vVal);
  vName        per_all_people_f.full_name%TYPE;
  vAssign      VARCHAR2(240);
  vSupervisor  per_all_people_f.full_name%TYPE;
  nAssignRef   per_all_assignments_f.assignment_id%TYPE;
  CURSOR cHRA IS
    SELECT p.full_name, t.user_person_type || DECODE(av.discretionary_title, NULL, NULL, ' - ' || av.discretionary_title) assignment,
           s.full_name supervisor, a.assignment_id
    FROM   per_all_people_f p, per_person_types t, per_all_assignments_f a, per_all_assignments_f_dfv av, per_all_people_f s
    WHERE  a.assignment_id = TO_NUMBER(vVal)
    AND    p.effective_start_date <= TRUNC(SYSDATE)
    AND    p.effective_end_date >= TRUNC(SYSDATE+1)
    AND    p.person_type_id = t.person_type_id
    AND    p.person_id = a.person_id
    AND    a.effective_start_date <= TRUNC(SYSDATE)
    AND    a.effective_end_date >= TRUNC(SYSDATE+1)
    AND    a.rowid = av.rowid
    AND    a.supervisor_id = s.person_id
    AND    s.effective_start_date <= TRUNC(SYSDATE)
    AND    s.effective_end_date >= TRUNC(SYSDATE+1);
  CURSOR cAP IS
    SELECT v.vendor_name, a.invoice_num
    FROM   ap_invoices_all a, po_vendors v
    WHERE  a.invoice_id = TO_NUMBER(vVal)
    AND    a.vendor_id = v.vendor_id;    
  vExpNum  ap_expense_report_headers_all.invoice_num%TYPE;
  nEmpNum  per_people_f.person_id%TYPE;
  CURSOR cWE IS
    SELECT e.invoice_num, p.person_id
    FROM   ap_expense_report_headers_all e, per_people_f p
    WHERE  report_header_id = TO_NUMBER(vVal)
    AND    e.employee_id = p.person_id;  
  vContNum   okc_k_headers_b.contract_number%TYPE;
  vContmod   okc_k_headers_b.contract_number_modifier%TYPE;
  vRenewVal  VARCHAR2(240);
  CURSOR cOKS IS
    SELECT c.customer_name, h.contract_number, h.contract_number_modifier, LTRIM(TO_CHAR(h.estimated_amount, '999999999990.00'))
    FROM   okc_rules_b b, okc_k_headers_b h, ra_customers c
    WHERE  h.id = TO_NUMBER(vVal)
    AND    b.jtot_object1_code = 'OKX_CUSTACCT'
    AND    c.customer_id = b.object1_id1
    AND    b.dnz_chr_id = h.id;
  vTitle      ota_events.title%TYPE;
  vCourse     ota_activity_versions.version_name%TYPE;
  vDelegate   VARCHAR2(240);
  nEnrollNum  ota_delegate_bookings.booking_id%TYPE;
  CURSOR cEB IS
    SELECT e.title, v.version_name,
           DECODE(o.delegate_person_id,
                  NULL, c.last_name || DECODE(c.first_name, NULL, NULL, ', ' || c.first_name),
                  UPPER(p.full_name)),
           o.booking_id
    FROM   ota_delegate_bookings o, ra_contacts c,
           ota_events e, ota_activity_versions v, per_people_f p
    WHERE  o.booking_id = TO_NUMBER(vVal)
    AND    o.contact_id = c.contact_id(+)
    AND    o.delegate_person_id = p.person_id(+)
    AND    NVL(p.effective_start_date, SYSDATE) <= SYSDATE
    AND    NVL(p.effective_end_date, SYSDATE) >= SYSDATE
    AND    o.event_id = e.event_id
    AND    e.activity_version_id = v.activity_version_id
    AND    NOT (o.contact_id IS NULL AND o.delegate_person_id IS NULL);    
  vStart  VARCHAR2(240);
  vEnd    VARCHAR2(240);
  CURSOR cEE IS
    SELECT e.title, v.version_name, TO_CHAR(e.course_start_date, 'DD-MON-YYYY'),
           TO_CHAR(e.course_end_date, 'DD-MON-YYYY')
    FROM   ota_events e, ota_activity_versions v
    WHERE  e.event_id = TO_NUMBER(vVal)
    AND    e.activity_version_id = v.activity_version_id;
  nUpd    NUMBER := 0;
  CURSOR cUpd IS
    SELECT 1
    FROM   fnd_documents_tl_dfv
    WHERE  row_id =
      (SELECT rowid
       FROM   fnd_documents_tl
       WHERE  document_id = nDocID)
    FOR UPDATE OF locked_by NOWAIT;

  vSQL  VARCHAR2(10000) := NULL;
  vCol  VARCHAR2(100) := NULL;

nDummy NUMBER;

BEGIN
  gis_image_util.pageopen(p_heading => 'Multi Attachment For File ID ' || p_file_id);
  gis_image_util.InfoHeader('Attached File ID ' || p_file_id || ' Sucessfully');
  -- Get document_id for new record
  SELECT fnd_documents_s.nextval
  INTO   nDocID
  FROM   dual;

  -- Get attachment_document_id for new record
  SELECT fnd_attached_documents_s.nextval
  INTO   nAttachDocID
  FROM   dual;

  vList := p_pk_value;
  -- OM builds a list specified as as string 'n1,n2,n3'
  -- For any other LOB, it is a singular value, so add a ',' at the end to terminate the loop below
  IF INSTR(vList, ',') = 0 THEN
    vList := vList || ',';
  END IF;
  LOOP
    -- Get first value in list
    vVal := SUBSTR(vList, 1, INSTR(vList, ',') - 1);
    -- Reduce list to start from next value after first
    vList := SUBSTR(vList, INSTR(vList, ',') + 1);
    -- Get number of attachments for target
    OPEN cAttach;
    FETCH cAttach INTO nAttach;
    IF cAttach%NOTFOUND THEN
      nAttach := 0;
    END IF;
    CLOSE cAttach;
    -- Increment internal sequence counter
    nAttach := nAttach + 10;
    -- Get source description and location
    vStorage := NULL;
    vDesc := NULL;
    OPEN cSource;
    FETCH cSource INTO vStorage, vDesc;
    CLOSE cSource;
    -- Get doc status type for COMPLETED
    SELECT doc_status_type_id
    INTO   nCompleteID
    FROM   gis_doc_status_types
    WHERE  doc_status_name = 'COMPLETED';
    
    IF p_context = 'Order Management' THEN
      -- Get OE information to complete index information
      OPEN cOE;
      FETCH cOE INTO nPKID, nSecID, vOENum, vGTN, vCustName, vCustNum, vOEType, nOrdVal, nLicVal;
      CLOSE cOE;
      nSecType := 1;
      vPublish := 'N';
    ELSIF p_context = 'Customer' THEN
      OPEN cRC;
      FETCH cRC INTO vCustName, vCustNum;
      CLOSE cRC;
      nSecType := 2;
      vPublish := 'N';
    ELSIF p_context = 'Agreements' THEN
      OPEN cSA;
      FETCH cSA INTO vAgreeName, vAgreeCode, vCustName, vCustNum;
      CLOSE cSA;      
      nSecType := 1;
      vPublish := 'Y';
    ELSIF p_context = 'Projects' THEN
      OPEN cPROJ;
      FETCH cPROJ INTO vProjNum, vProjVal, vCustName, vCustNum;
      CLOSE cPROJ;      
      nSecType := 1;
      vPublish := 'Y';
    ELSIF p_context = 'Receivables' THEN
      OPEN cAR;
      FETCH cAR INTO vCustName, vInvNum;
      CLOSE cAR;
      nSecType := 2;
      vPublish := 'N';
    ELSIF p_context = 'Suppliers' THEN
      OPEN cPOV;
      FETCH cPOV INTO vSuppName, vSuppNum;
      CLOSE cPOV;
      nSecType := 2;
      vPublish := 'N';
    ELSIF p_context = 'HR Assignments' THEN
      OPEN cHRA;
      FETCH cHRA INTO vName, vAssign, vSupervisor, nAssignRef;
      CLOSE cHRA;
      nSecType := 2;
      vPublish := 'N';
    ELSIF p_context = 'Payables' THEN
      OPEN cAP;
      FETCH cAP INTO vSuppName, vInvNum;
      CLOSE cAP;
      nSecType := 2;
      vPublish := 'N';
    ELSIF p_context = 'Web Expenses' THEN
      OPEN cWE;
      FETCH cWE INTO vExpNum, nEmpNum;
      CLOSE cWE;
      nSecType := 1;
      vPublish := 'N';
    ELSIF p_context = 'Contracts' THEN
      OPEN cOKS;
      FETCH cOKS INTO vCustName, vContNum, vContmod, vRenewVal;
      CLOSE cOKS;
      nSecType := 1;
      vPublish := 'N';
    ELSIF p_context = 'Education Bookings' THEN
      OPEN cEB;
      FETCH cEB INTO vTitle, vCourse, vDelegate, nEnrollNum;
      CLOSE cEB;
      nSecType := 3;
      vPublish := 'N';
    ELSIF p_context = 'Education Events' THEN
      OPEN cEE;
      FETCH cEE INTO vTitle, vCourse, vStart, vEnd;
      CLOSE cEE;
      nSecType := 3;
      vPublish := 'N';
    ELSE
-- Raise some dummy error for now
      nAttach := 1/0;
    END IF;

    INSERT INTO fnd_documents_tl
      (document_id,
       creation_date,
       created_by,
       last_update_date,
       last_updated_by,
       language,
       description,
       file_name,
       media_id,
       doc_attribute_category,
       doc_attribute6,
       source_lang)
    VALUES
      (nDocID,
       SYSDATE,
       p_user_id,
       SYSDATE,
       p_user_id,
       userenv('LANG'),
       p_description,
       'INTERNAL',
       p_file_id,
       p_context,
       'COMPLETED',
       userenv('LANG'));

    INSERT INTO fnd_documents
      (document_id,
       creation_date,
       created_by,
       last_update_date,
       last_updated_by,
       datatype_id,
       category_id,
       security_type,
       security_id,
       publish_flag,
       usage_type)
    VALUES
      (nDocID,
       SYSDATE,
       p_user_id,
       SYSDATE,
       p_user_id,
       6,         --FILE
       p_doc_category_id,
       nSecType,
       nSecID,
       vPublish,
       'S');

    INSERT INTO gis_doc_status
      (document_id,
       doc_status_type_id,
       date_created,
       created_by,
       last_update_date,
       last_updated_by)
    VALUES
      (nDocID,
       nCompleteID,
       SYSDATE,
       p_user_id,
       SYSDATE,
       p_user_id);
    
    INSERT INTO fnd_attached_documents
      (attached_document_id,
       document_id,
       creation_date,
       created_by,
       last_update_date,
       last_updated_by,
       seq_num,
       entity_name,
       pk1_value,
       automatically_added_flag)
    VALUES
      (nAttachDocID,
       nDocID,
       SYSDATE,
       p_user_id,
       SYSDATE,
       p_user_id,
       nAttach,
       p_table_name,
       vVal,
       'N');

    -- Update index information flexfields
    vSQL := 'UPDATE fnd_documents_tl SET ';

    IF p_context = 'Order Management' THEN
      vCol := gis_preindex.find_col_name(p_context, 'GTN');
      vSQL := vSQL || vCol || ' = ''' || vGTN || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'OE Number');
      vSQL := vSQL || vCol || ' = ''' || vOENum || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Customer Name');
      vSQL := vSQL || vCol || ' = ''' || REPLACE(vCustName, '''', '''''') || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Customer Number');
      vSQL := vSQL || vCol || ' = ''' || vCustNum || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'License Value');
      vSQL := vSQL || vCol || ' = ''' || TO_CHAR(nLicVal) || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Order Value');
      vSQL := vSQL || vCol || ' = ''' || TO_CHAR(nOrdVal) || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Order Type');
      vSQL := vSQL || vCol || ' = ''' || vOEType || ''',';
    ELSIF p_context = 'Customer' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Customer Name');
      vSQL := vSQL || vCol || ' = ''' || REPLACE(vCustName, '''', '''''') || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Customer Number');
      vSQL := vSQL || vCol || ' = ''' || vCustNum || ''',';
    ELSIF p_context = 'Agreements' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Customer Name');
      vSQL := vSQL || vCol || ' = ''' || REPLACE(vCustName, '''', '''''') || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Customer Number');
      vSQL := vSQL || vCol || ' = ''' || vCustNum || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Agreement Name');
      vSQL := vSQL || vCol || ' = ''' || REPLACE(vAgreeName, '''', '''''') || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Agreement Code');
      vSQL := vSQL || vCol || ' = ''' || vAgreeCode || ''',';
    ELSIF p_context = 'Projects' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Customer Name');
      vSQL := vSQL || vCol || ' = ''' || REPLACE(vCustName, '''', '''''') || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Customer Number');
      vSQL := vSQL || vCol || ' = ''' || vCustNum || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Project Number');
      vSQL := vSQL || vCol || ' = ''' || vProjNum || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Project Value');
      vSQL := vSQL || vCol || ' = ''' || vProjVal || ''',';
    ELSIF p_context = 'Receivables' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Customer Name');
      vSQL := vSQL || vCol || ' = ''' || REPLACE(vCustName, '''', '''''') || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Invoice Number');
      vSQL := vSQL || vCol || ' = ''' || vInvNum || ''',';
    ELSIF p_context = 'Suppliers' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Supplier Name');
      vSQL := vSQL || vCol || ' = ''' || REPLACE(vSuppName, '''', '''''') || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Supplier Number');
      vSQL := vSQL || vCol || ' = ''' || vSuppNum || ''',';
    ELSIF p_context = 'HR Assignments' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Name');
      vSQL := vSQL || vCol || ' = ''' || REPLACE(vName, '''', '''''') || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Assignment');
      vSQL := vSQL || vCol || ' = ''' || vAssign || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Supervisor');
      vSQL := vSQL || vCol || ' = ''' || REPLACE(vSupervisor, '''', '''''') || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Assignment Ref');
      vSQL := vSQL || vCol || ' = ''' || TO_CHAR(nAssignRef) || ''',';
    ELSIF p_context = 'Payables' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Supplier Name');
      vSQL := vSQL || vCol || ' = ''' || REPLACE(vSuppName, '''', '''''') || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Invoice Number');
      vSQL := vSQL || vCol || ' = ''' || vInvNum || ''',';
    ELSIF p_context = 'Web Expenses' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Expense Report Number');
      vSQL := vSQL || vCol || ' = ''' || vExpNum || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Employee ID Number');
      vSQL := vSQL || vCol || ' = ''' || TO_CHAR(nEmpNum) || ''',';
    ELSIF p_context = 'Contracts' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Customer Name');
      vSQL := vSQL || vCol || ' = ''' || vCustName || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Contracts Number');
      vSQL := vSQL || vCol || ' = ''' || vContNum || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Contracts Modifier');
      vSQL := vSQL || vCol || ' = ''' || vContMod || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Renewal Value');
      vSQL := vSQL || vCol || ' = ''' || vRenewVal || ''',';
    ELSIF p_context = 'Education Bookings' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Title');
      vSQL := vSQL || vCol || ' = ''' || vTitle || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Course Name');
      vSQL := vSQL || vCol || ' = ''' || vCourse || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Delegate Name');
      vSQL := vSQL || vCol || ' = ''' || vDelegate || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Enrollment Number');
      vSQL := vSQL || vCol || ' = ''' || TO_CHAR(nEnrollNum) || ''',';
    ELSIF p_context = 'Education Events' THEN
      vCol := gis_preindex.find_col_name(p_context, 'Title');
      vSQL := vSQL || vCol || ' = ''' || vTitle || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Course Name');
      vSQL := vSQL || vCol || ' = ''' || vCourse || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'Start Date');
      vSQL := vSQL || vCol || ' = ''' || vEnd || ''',';
      vCol := gis_preindex.find_col_name(p_context, 'End Date');
      vSQL := vSQL || vCol || ' = ''' || vStart || ''',';
    END IF;

    vCol := gis_preindex.find_col_name('Global Data Elements', 'Storage Location');
    vSQL := vSQL || vCol || ' = ''' || REPLACE(vStorage, '''', '''''') || ''',';
    vCol := gis_preindex.find_col_name('Global Data Elements', 'Index Date');
    vSQL := vSQL || vCol || ' = TO_CHAR(SYSDATE),';
    vCol := gis_preindex.find_col_name('Global Data Elements', 'Indexed By');
    vSQL := vSQL || vCol || ' = ''' || p_user_id || ''',';
    vCol := gis_preindex.find_col_name('Global Data Elements', 'Index Status Id');
    vSQL := vSQL || vCol || ' = ''COMPLETED'',';
    vCol := gis_preindex.find_col_name('Global Data Elements', 'Attached Document Id');
    vSQL := vSQL || vCol || ' = ''' || TO_CHAR(nAttachDocID) || ''' ';
    vSQL := vSQL || 'WHERE document_id = ' || TO_CHAR(nDocID);

    EXECUTE IMMEDIATE vSQL;

--htp.p('Key = ' || vVal);
    -- Done when there is nothing in the list
    EXIT WHEN vList IS NULL;
  END LOOP;
  COMMIT;

  htp.p('<BR>');  
  htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');  
  htp.p('  <TR>');
  htp.p('    <TD COLSPAN=3 ALIGN="CENTER" VALIGN="MIDDLE">Document Attached Successfully</TD>');
  htp.p('  </TR>');
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="98%" ALIGN="CENTER"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_l.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A><A HREF="Javascript:document.null()" onMouseOver="window.status=''OK''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok_r.gif" BORDER="0" ALT="OK" ALIGN="TOP"></A></TD>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  gis_image_util.pageclose;
EXCEPTION WHEN OTHERS THEN
    gis_image_util.InfoHeader('Error Details');
    htp.br;
    htp.p(SQLERRM);
    htp.br;
    htp.p('<TABLE WIDTH="100%" ALIGN="CENTER" >');
    htp.p('  <TR ><TD ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TR>');
    htp.p('</TABLE>');
    gis_image_util.pageclose;		
END attach_image;

PROCEDURE list_attached_images(p_user_id                NUMBER,
                               p_file_id                NUMBER,
                               p_document_id            NUMBER   DEFAULT NULL,
                               p_primary_document_id    VARCHAR2 DEFAULT NULL,
                               p_operation              VARCHAR2,
                               p_process_request        VARCHAR2 DEFAULT 'N') IS
  CURSOR cAttach IS
    -- Need to finalize DFV and use user_column_names
    SELECT t.media_id, t.document_id, a.attached_document_id, a.entity_name, a.pk1_value, v.attached_document_id primary_attached_id,
           NVL(v.primary_document_id, 'N') primary_document_id
    FROM   fnd_documents_tl t, fnd_attached_documents a, fnd_documents d, fnd_documents_tl_dfv v
    WHERE  t.media_id = p_file_id
    AND    t.document_id = a.document_id(+)
    AND    a.attached_document_id IS NOT NULL
    AND    t.document_id = d.document_id
    AND    t.rowid = v.rowid
    AND    v.index_status_id != 'SCANNED'
    AND    d.datatype_id = 
    (SELECT datatype_id
     FROM   fnd_document_datatypes
     WHERE  name = 'FILE'
     AND    NVL(start_date_active, SYSDATE) <= SYSDATE
     AND    NVL(end_date_active, SYSDATE) >= SYSDATE)
    ORDER BY NVL(v.primary_document_id, 'N') DESC, DECODE(NVL(a.attached_document_id, 0) - TO_NUMBER(NVL(t.doc_attribute14, 0)), 0, 1, 2), a.attached_document_id;
  rAttach  cAttach%ROWTYPE;
  v_Context VARCHAR2(100) := NULL;
  v_Value   VARCHAR2(1000) := NULL;
  nRecs     NUMBER := 0;
  bProcess  BOOLEAN := FALSE;
  vHdg      VARCHAR2(100) := NULL;
  PROCEDURE find_context_pk IS
  BEGIN
    IF rAttach.entity_name = 'OE_ORDER_HEADERS' THEN
      SELECT 'Order Management', 'Order #: ' || h.order_number
      INTO   v_Context, v_Value
      FROM   oe_order_headers_all h
      WHERE  h.header_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'OE_AGREEMENTS' THEN
      SELECT 'Agreements', 'Agreement: ' || name
      INTO   v_Context, v_Value
      FROM   so_agreements
      WHERE  agreement_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'AR_CUSTOMERS' THEN
      SELECT 'Customers', 'Customer (Number): ' || customer_name || ' (' || customer_number || ')'
      INTO   v_Context, v_Value
      FROM   ra_customers
      WHERE  customer_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'AP_INVOICES' THEN
      SELECT 'Payables', 'Invoice #: ' || a.invoice_num
      INTO   v_Context, v_Value
      FROM   ap_invoices_all a
      WHERE  a.invoice_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'RA_CUSTOMER_TRX' THEN
      SELECT 'Receivables', 'Invoice #: ' || t.trx_number
      INTO   v_Context, v_Value
      FROM   ra_customer_trx_all t
      WHERE  t.customer_trx_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'OKC_K_HEADERS_V' THEN
      SELECT 'Renewals', 'Contract # (Modifier): ' ||  h.contract_number ||' (' || NVL(h.contract_number_modifier, 'N/A') || ')'
      INTO   v_Context, v_Value   
      FROM   okc_k_headers_b h
      WHERE  h.id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'PA_PROJECTS' THEN
      SELECT 'Projects', 'Project Number: ' ||  p.segment1
      INTO   v_Context, v_Value   
      FROM   pa_projects_all p
      WHERE  p.project_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'AP_EXPENSE_REPORT_HEADER_S_ALL' THEN
      SELECT 'Web Expenses', 'Expense Report Number: ' ||  e.invoice_num
      INTO   v_Context, v_Value   
      FROM   ap_expense_report_headers_all e
      WHERE  e.report_header_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'OTA_DELEGATE_BOOKINGS' THEN
      SELECT 'Education Bookings', 'Enrollment Number: ' ||  b.booking_id
      INTO   v_Context, v_Value   
      FROM   ota_delegate_bookings b
      WHERE  b.booking_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'OTA_EVENTS' THEN
      SELECT 'Education Events', 'Course Name: ' ||  e.title
      INTO   v_Context, v_Value   
      FROM   ota_events e
      WHERE  e.event_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'PER_ASSIGNMENTS_F' THEN
      SELECT 'HR Assignments', 'Assignment Reference: ' ||  a.assignment_id
      INTO   v_Context, v_Value   
      FROM   per_all_assignments_f a
      WHERE  a.assignment_id = TO_NUMBER(rAttach.pk1_value)
      AND    a.effective_start_date <= TRUNC(SYSDATE)
      AND    a.effective_end_date >= TRUNC(SYSDATE+1);
    ELSIF rAttach.entity_name = 'PO_VENDORS' THEN
      SELECT 'Suppliers', 'Supplier Name: ' ||  p.vendor_name
      INTO   v_Context, v_Value   
      FROM   po_vendors p
      WHERE  p.vendor_id = TO_NUMBER(rAttach.pk1_value);
    ELSE
      v_Context := rAttach.entity_name;
      v_Value := 'NOT IMPLEMENTED';
    END IF;
  END find_context_pk;
  
  FUNCTION switch_primary RETURN BOOLEAN IS
  BEGIN
    -- Set current primary to be secondary
    UPDATE fnd_documents_tl_dfv
    SET    primary_document_id = NULL
    WHERE  rowid = 
      (SELECT t.rowid
       FROM   fnd_documents_tl t, fnd_documents d, fnd_documents_tl_dfv dfv, fnd_document_datatypes typ
       WHERE  t.media_id = p_file_id
       AND    t.document_id = d.document_id
       AND    t.rowid = dfv.rowid
       AND    dfv.primary_document_id = 'Y'
       AND    d.datatype_id = typ.datatype_id
       AND    typ.name = 'FILE'
       AND    NVL(typ.start_date_active, SYSDATE) <= SYSDATE
       AND    NVL(typ.end_date_active, SYSDATE) >= SYSDATE);
    -- Set specified secondary to be primary
    UPDATE fnd_documents_tl_dfv
    SET    primary_document_id = 'Y'
    WHERE  rowid = 
      (SELECT t.rowid
       FROM   fnd_documents_tl t, fnd_documents d, fnd_document_datatypes typ
       WHERE  t.document_id = p_document_id
       AND    t.document_id = d.document_id
       AND    d.datatype_id = typ.datatype_id
       AND    typ.name = 'FILE'
       AND    NVL(typ.start_date_active, SYSDATE) <= SYSDATE
       AND    NVL(typ.end_date_active, SYSDATE) >= SYSDATE);
    COMMIT;
    RETURN(TRUE);
  END;
BEGIN
  gis_image_util.pageopen(p_heading => 'Attachments For File ID ' || p_file_id);
  gis_image_util.InfoHeader('Attachments For File ID ' || p_file_id);

  IF p_process_request = 'Y' THEN
    IF p_operation = 'S' THEN
      -- Switch primary document
      bProcess := switch_primary;
    ELSE
      -- Do any deletions/reset first before showing attachments
      bProcess := gis_image_util.delete_image(p_user_id, p_file_id, p_document_id, p_primary_document_id, p_operation);
    END IF;
  END IF;

--  document.location="gis_attach_util.list_attached_images?p_file_id=" + p_file_id + "&p_attached_document_id=" + p_attached_document_id
  htp.p('<SCRIPT language="Javascript">
function requestIt(p_user_id,p_file_id,p_document_id,p_primary_document_id,p_operation)
{
  var listURL = "gis_attach_util.list_attached_images?p_user_id=" + p_user_id + "&p_file_id=" + p_file_id + "&p_document_id=" + p_document_id + "&p_primary_document_id=" + p_primary_document_id + "&p_operation=" + p_operation + "&p_process_request=Y"
  var returnValue

  if (p_operation == "R")
  {
    returnValue = confirm("Are you sure you want to reset this image for re-indexing ?");
    if (returnValue)
    {
      viewimage('''','''',listURL)
    }
  }
  if (p_operation == "S")
  {
    returnValue = confirm("Are you sure you want to switch this document to be the primary document ?");
    if (returnValue)
    {
      viewimage('''','''',listURL)
    }
  }
  if (p_operation != "S" && p_operation != "R")
  {
    if (p_primary_document_id == "Y")
    {
      returnValue = confirm("Are you sure you want to delete the primary and all secondary attachments for this image ?");
      if (returnValue)
      {
        viewimage('''','''',listURL)
      }
    }
    else
    {
      returnValue = confirm("Are you sure you want to delete this secondary attachment for this image ?");
      if (returnValue)
      {
        viewimage('''','''',listURL)
      }
    }
  }
}
</SCRIPT>');
  htp.formOpen('gis_attach_util.list_attached_images', 'POST',cattributes=>'NAME="list_attached_images"');
  -- Show attachments for image
  htp.p('<TABLE WIDTH="98%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
  htp.p('  <TR>' );  
  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>LOB </FONT></TD>');
  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>Reference Value </FONT></TD>');
  IF p_operation = 'D' THEN
    vHdg := 'Delete';  
    htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>' || vHdg || '</FONT></TD>');
  ELSIF p_operation IN ('R', 'S') THEN
    vHdg := 'Reset';
--    htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
--    htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>Toggle Primary Document</FONT></TD>');
    htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>' || vHdg || '</FONT></TD>');
  END IF;
  htp.p('  </TR>' );
  OPEN cAttach;
  LOOP
    FETCH cAttach INTO rAttach;
    EXIT WHEN cAttach%NOTFOUND;
    nRecs := nRecs + 1;
    /* Translate data from PK to user known unique key */
    find_context_pk;
    /* Show data for attachments number */
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || v_Context || '</FONT></TD>');
    -- Highlight primary attachment
    IF rAttach.primary_document_id = 'Y' THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2 COLOR="#FFCC00">' || v_Value || '</FONT></TD>');
    ELSE
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || v_Value || '</FONT></TD>');
    END IF;
    IF p_operation = 'D' THEN
      htp.p('    <TD COLSPAN=2 ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2><A HREF="Javascript:requestIt(''' || p_user_id || ''',''' || rAttach.media_id || ''',''' || rAttach.document_id || ''',''' || rAttach.primary_document_id || ''',''' || p_operation || ''')" onMouseOver="window.status=''Delete''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_delete.gif" BORDER="0" ALT="Delete" ALIGN="TOP"></A></FONT></TD>');
    ELSIF p_operation IN ('R', 'S') THEN
      IF rAttach.primary_document_id = 'Y' THEN
        htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2><A HREF="Javascript:requestIt(''' || p_user_id || ''',''' || rAttach.media_id || ''',''' || rAttach.document_id || ''',''' || rAttach.primary_document_id || ''',''' || p_operation || ''')" onMouseOver="window.status=''Reset For Re-Indexing''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_reset.gif" BORDER="0" ALT="Reset For Re-Indexing" ALIGN="TOP"></A></FONT></TD>');      
      ELSE
        htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2><A HREF="Javascript:requestIt(''' || p_user_id || ''',''' || rAttach.media_id || ''',''' || rAttach.document_id || ''',''' || rAttach.primary_document_id || ''',''S'')" onMouseOver="window.status=''Switch To Primary Document''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_toggle.gif" BORDER="0" ALT="Switch To Primary Document" ALIGN="TOP"></A></FONT></TD>');      
      END IF;
    END IF;
    htp.p('  </TR>' );
  END LOOP;
  CLOSE cAttach;
  IF nRecs = 0 THEN
    htp.p('  <TR>' );
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>No Attachments</FONT></TD>');
    htp.p('  </TR>' );
  END IF;
  htp.p('</TABLE>');
  htp.p('<BR>');
  htp.p('</FORM>');
  htp.br;
  IF p_process_request = 'Y' THEN
    htp.p('<TABLE WIDTH="98%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>');  
    IF p_operation = 'R' THEN
      htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>Image reset for re-indexing.</FONT></TD>');
    ELSIF p_operation = 'D' AND p_primary_document_id = 'Y' THEN
      htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>Primary and secondary attachments deleted.</FONT></TD>');
    ELSIF p_operation = 'D' AND p_primary_document_id = 'N' THEN
      htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>Secondary attachment deleted.</FONT></TD>');
    END IF;
    htp.p('  </TR>');
    htp.p('</TABLE>');
  END IF;
  gis_image_util.pageclose;
EXCEPTION WHEN OTHERS THEN
    gis_image_util.InfoHeader('Error Details');
    htp.br;
    htp.p('Key = ' || rAttach.pk1_value);
    htp.br;
    htp.p(SQLERRM);
    htp.br;
    htp.p('<TABLE WIDTH="100%" ALIGN="CENTER" >');
    htp.p('  <TR ><TD ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TR>');
    htp.p('</TABLE>');
    gis_image_util.pageclose;		
END list_attached_images;

END gis_attach_util;
/
 