CREATE OR REPLACE
PACKAGE apps.gis_attach_util IS

C_DATE_FORMAT_EN constant varchar2(100) := 'DD-MON-YYYY HH24:MI:SS';
C_APP_URL        constant varchar2(100) := rtrim(FND_WEB_CONFIG.WEB_SERVER,'/')||'/'||rtrim(ltrim(icx_plug_utilities.getPLSQLagent,'/'),'/')||'/';
C_IMG_URL        constant varchar2(100) := fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/images/';
C_FLAG_URL       constant varchar2(100) := fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/images/flags/';

PROCEDURE adminMenu(p_user_id VARCHAR2);

PROCEDURE show_org(p_user_id   NUMBER,
                   p_operation VARCHAR2);

PROCEDURE show_doc_types(p_org_id         NUMBER DEFAULT NULL,
                         p_user_id        NUMBER,
                         p_file_id        NUMBER DEFAULT NULL,
                         p_operation      VARCHAR2,
                         p_secure_flag    VARCHAR2 DEFAULT NULL,
                         p_secure_context VARCHAR2 DEFAULT NULL);

PROCEDURE confirm_oe_fields(p_org_id      NUMBER,
                            p_user_id     NUMBER,
                            p_context     VARCHAR2,
                            p_file_id     NUMBER,
                            p_oe_number   NUMBER,
                            p_po_number   VARCHAR2);
                            
PROCEDURE show_fields(p_org_id         NUMBER,
                      p_user_id        NUMBER,
                      p_context        VARCHAR2 DEFAULT 'None',
                      p_file_id        NUMBER   DEFAULT NULL,
                      p_operation      VARCHAR2,
                      p_secure_flag    VARCHAR2 DEFAULT NULL);

PROCEDURE search_image(p_org_id         NUMBER,
                       p_user_id        NUMBER,
                       p_context        VARCHAR2,
                       p_file_id        NUMBER    DEFAULT NULL,
                       p_key            VARCHAR2  DEFAULT NULL,
                       p_operation      VARCHAR2);
                       
PROCEDURE search_target(p_org_id           NUMBER,
                        p_user_id          NUMBER,
                        p_context          VARCHAR2,
                        p_file_id          NUMBER    DEFAULT NULL,
                        p_key              VARCHAR2  DEFAULT NULL,
                        p_doc_category_id  NUMBER,
                        p_description      VARCHAR2  DEFAULT NULL);

PROCEDURE attach_image(p_org_id           NUMBER,
                       p_user_id          NUMBER,
                       p_context          VARCHAR2,
                       p_file_id          NUMBER,
                       p_table_name       VARCHAR2,
                       p_pk_value         VARCHAR2,
                       p_doc_category_id  NUMBER,
                       p_description      VARCHAR2);

PROCEDURE list_attached_images(p_user_id                NUMBER,
                               p_file_id                NUMBER,
                               p_document_id            NUMBER   DEFAULT NULL,
                               p_primary_document_id    VARCHAR2 DEFAULT NULL,
                               p_operation              VARCHAR2,
                               p_process_request        VARCHAR2 DEFAULT 'N');

END gis_attach_util;
/
