--***************************************************
--
--	file name gis_attached_documents_pkb.sql
--
--  Purpose: Inserts a record into the table 
--           fnd_attached_documents.
--
-- History: 16-Jun-00 David Gough - Initial version
--
--***************************************************

CREATE OR REPLACE
PACKAGE BODY gis_attached_documents_pkg AS

PROCEDURE insert_row(X_attached_document_id         NUMBER,
                     X_document_id                  NUMBER,
                     X_creation_date                DATE,
                     X_created_by                   NUMBER,
                     X_last_update_date             DATE,
                     X_last_updated_by              NUMBER,
                     X_last_update_login            NUMBER DEFAULT NULL,
                     X_seq_num                      NUMBER,
                     X_entity_name                  VARCHAR2,
                     X_pk1_value                    VARCHAR2,
                     X_pk2_value                    VARCHAR2,
                     X_pk3_value                    VARCHAR2,
                     X_pk4_value                    VARCHAR2,
                     X_pk5_value                    VARCHAR2,
                  X_automatically_added_flag     VARCHAR2,
                  X_Attribute_Category                  VARCHAR2 DEFAULT NULL,
                  X_Attribute1                          VARCHAR2 DEFAULT NULL,
                  X_Attribute2                          VARCHAR2 DEFAULT NULL,
                  X_Attribute3                          VARCHAR2 DEFAULT NULL,
                  X_Attribute4                          VARCHAR2 DEFAULT NULL,
                  X_Attribute5                          VARCHAR2 DEFAULT NULL,
                  X_Attribute6                          VARCHAR2 DEFAULT NULL,
                  X_Attribute7                          VARCHAR2 DEFAULT NULL,
                  X_Attribute8                          VARCHAR2 DEFAULT NULL,
                  X_Attribute9                          VARCHAR2 DEFAULT NULL,
                  X_Attribute10                         VARCHAR2 DEFAULT NULL,
                  X_Attribute11                         VARCHAR2 DEFAULT NULL,
                  X_Attribute12                         VARCHAR2 DEFAULT NULL,
                  X_Attribute13                         VARCHAR2 DEFAULT NULL,
                  X_Attribute14                         VARCHAR2 DEFAULT NULL,
                  X_Attribute15                         VARCHAR2 DEFAULT NULL) IS
                  
BEGIN
	 INSERT INTO fnd_attached_documents (
     attached_document_id,
     document_id,
     creation_date,
     created_by,
     last_update_date,
     last_updated_by,
     last_update_login,
     seq_num,
     entity_name,
     pk1_value,
     pk2_value,
     pk3_value,
     pk4_value,
     pk5_value,
     automatically_added_flag,
     attribute_category,
     attribute1,
     attribute2,
     attribute3,
     attribute4,
     attribute5,
     attribute6,
     attribute7,
     attribute8,
     attribute9,
     attribute10,
     attribute11,
     attribute12,
     attribute13,
     attribute14,
     attribute15) VALUES (
     X_attached_document_id,
     X_document_id,
     X_creation_date,
     X_created_by,
     X_last_update_date,
     X_last_updated_by,
     X_last_update_login,
     X_seq_num,
     X_entity_name,
     X_pk1_value,
     X_pk2_value,
     X_pk3_value,
     X_pk4_value,
     X_pk5_value,
     X_automatically_added_flag,
     X_attribute_category,
     X_attribute1,
     X_attribute2,
     X_attribute3,
     X_attribute4,
     X_attribute5,
     X_attribute6,
     X_attribute7,
     X_attribute8,
     X_attribute9,
     X_attribute10,
     X_attribute11,
     X_attribute12,
     X_attribute13,
     X_attribute14,
     X_attribute15);

	COMMIT;
EXCEPTION
	WHEN OTHERS THEN
		DECLARE
		errorCode NUMBER := SQLCODE;
		errorMsg VARCHAR(300) := SQLERRM;
		BEGIN
			DBMS_OUTPUT.put_line ( errorMsg ||'  ' || TO_CHAR( errorCode));
		END;			     
END insert_row;

END gis_attached_documents_pkg;
/
