CREATE OR REPLACE
PACKAGE BODY apps.gis_checkout_image 
IS

PROCEDURE refreshList( p_context VARCHAR2 DEFAULT NULL, p_userId VARCHAR2, p_respId VARCHAR2)
IS
BEGIN
	htp.p( '<SCRIPT LANGUAGE="javascript">' );
	htp.p( 'refresh_list('||p_userId||','||p_respId||')');
--   	htp.p( 'parent.SelectFrame.document.location="gis_process_image.processImage?p_document=&p_context='||p_context||'"' );
	htp.p( '</SCRIPT>'); 
END refreshList;

PROCEDURE checkoutImage(p_document_id VARCHAR2
						,p_user_id VARCHAR2
						,p_context VARCHAR2
						,p_respId VARCHAR2 ) IS

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_checkout_image.checkoutImage');
	gis_image_util.infoHeader('Checkout Status');
    -- enter the user id of the user checking out the document
    -- into doc_attribute15
    UPDATE fnd_documents_tl
    SET doc_attribute15 = p_user_id
    WHERE document_id = p_document_id;
    COMMIT;
    -- notify user if succsessful
	htp.br;
	htp.br;
	htp.p('  <TABLE WIDTH="80%" ALIGN="CENTER" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('		<TR>');	
    htp.p('    		<TD VALIGN="TOP" ALIGN="CENTER"><IMG SRC="'||gis_image_util.c_image_url||'i_note.gif" ALT="Note"></TD>' );
	htp.p('			<TD><B> Document is checked out </B></TD>');
	htp.p('		</TR>');
	htp.p('	</TABLE>'); 
--	htp.p( '<SCRIPT LANGUAGE="javascript">' );
--	htp.p( 'parent.SelectFrame.document.location.reload(true)' );
--   	htp.p( 'parent.SelectFrame.document.location="gis_process_image.processImage"' );
--	htp.p( '</SCRIPT>');  
	refreshList( p_context, p_user_id, p_respId);
	htp.p( '<SCRIPT LANGUAGE="javascript">' );
   	htp.p( 'parent.QueryFrame.document.location="gis_checkout_image.checkOutUsers?p_context='||REPLACE(p_context,' ','+')||
   				'&p_orgId=&p_userId='||p_user_id||'&p_respId='||p_respId||'"' );
	htp.p( '</SCRIPT>'); 
	gis_image_util.pageclose;
END checkoutImage;

PROCEDURE checkinImage(p_document_id VARCHAR2
						,p_user_id VARCHAR2
						,p_context VARCHAR2
						,p_respId VARCHAR2) IS

l_recordToUpdate NUMBER;

BEGIN
	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_checkout_image.checkinImage');
	gis_image_util.infoHeader('Checkout Status');
    -- enter the user id of the user checking out the document
    -- into doc_attribute15
    
    SELECT count(document_id)
    INTO l_recordToUpdate
    FROM fnd_documents_tl
    WHERE document_id = p_document_id
    AND doc_attribute15 = p_user_id;

	htp.br;
	htp.br;                                      
	htp.p('  <TABLE WIDTH="80%" ALIGN="CENTER" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('		<TR>');	
    htp.p('    		<TD VALIGN="TOP" ALIGN="CENTER"><IMG SRC="'||gis_image_util.c_image_url||'i_note.gif" ALT="Note"></TD>' ); 
       
    IF l_recordToUpdate > 0
    THEN    
	    UPDATE fnd_documents_tl
	    SET doc_attribute15 = NULL
	    WHERE document_id = p_document_id
	    AND doc_attribute15 = p_user_id;
	    COMMIT;
	    -- notify user if succsessful
		htp.p('			<TD><B> Document is checked in </B></TD>');
		refreshList( p_context, p_user_id, p_respId);
	ELSE
		htp.p('			<TD><B> Document is checked out to another user - Check in canceled</B></TD>');
	END IF;
	htp.p('		</TR>');
	htp.p('	</TABLE>'); 
	htp.p( '<SCRIPT LANGUAGE="javascript">' );
   	htp.p( 'parent.QueryFrame.document.location="gis_checkout_image.checkOutUsers?p_context='||REPLACE(p_context,' ','+')||
   				'&p_orgId=&p_userId='||p_user_id||'&p_respId='||p_respId||'"' );
	htp.p( '</SCRIPT>');  
	gis_image_util.pageclose;
END checkInImage;

FUNCTION GetUserIdList(p_respId NUMBER) RETURN aUserIdArray IS

CURSOR cur_userId(f_responsibilityId NUMBER) IS
SELECT DISTINCT user_id FROM fnd_user_resp_groups
WHERE responsibility_id =  f_responsibilityId;

row_userId cur_userId%ROWTYPE;
l_userIdList  aUserIdArray:= aUserIdArray();
l_count NUMBER := 1;

BEGIN
	IF NOT cur_userId%ISOPEN
	THEN
		OPEN cur_userId( p_respId);
	END IF;
	
	FETCH cur_userId INTO row_userId;
	IF cur_userId%NOTFOUND THEN
		NULL;
		-- put some sort of error message in here
	ELSE
		WHILE cur_userId%FOUND
		LOOP	
			l_userIdList.EXTEND;
			l_userIdList( l_count) := row_userId.user_id;
			l_count := l_count + 1;			
			FETCH cur_userId INTO row_userId;
		END LOOP;
	END IF;
	CLOSE cur_userId;
	RETURN l_userIdList;
END GetUserIdList;

PROCEDURE checkOutUsers( p_context VARCHAR2
						,p_orgId VARCHAR2 DEFAULT NULL
						,p_userId NUMBER
						,p_respId VARCHAR2 DEFAULT NULL)
IS                

row_countryList gis_search.cur_countryList%ROWTYPE;
l_organization_id NUMBER;
l_appId NUMBER(15);
sqlSource VARCHAR2(4000);
l_userIdList  aUserIdArray:= aUserIdArray();
cid INTEGER;
l_orgId NUMBER(32);
l_orgName VARCHAR2(150);
l_userName VARCHAR2(150);
l_userId NUMBER(32);
rowCount INTEGER;

BEGIN              
	BEGIN
		gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_checkout_image.checkOutUsers');
		gis_image_util.infoHeader('Checkout User List');
	
	 	l_appId := gis_image_util.applicationId( p_context);			
								
		IF NOT gis_search.cur_countryList%ISOPEN
		THEN
			OPEN gis_search.cur_countryList( f_userId=>p_userId, f_appId=>l_appId);
		END IF;
		
		FETCH gis_search.cur_countryList INTO row_countryList;
		IF gis_search.cur_countryList%NOTFOUND THEN
			null;
			-- put some sort of error message in here
		ELSE
			htp.br;
			htp.p('  <TABLE WIDTH="80%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
			htp.p('		<TR><TD ALIGN="RIGHT">');	
			htp.formOpen('gis_search.QueryOptions', 'POST',cattributes=>'NAME="CheckUser"');
			htp.formSelectOpen(cname=>'p_org',nsize=>'1',cattributes=>'onChange="setOrgId( this.options[this.selectedIndex].value,'''||REPLACE(p_context,' ','+')||''','||p_userId||','||p_respId||')"'); 
			IF p_orgId IS NULL 
			THEN
			 	htp.formSelectOption( row_countryList.name,'SELECTED',cattributes=>'value='||row_countryList.organization_id );
			 	l_organization_id :=  row_countryList.organization_id;
			 	FETCH gis_search.cur_countryList INTO row_countryList;
				WHILE gis_search.cur_countryList%FOUND	
				LOOP
			 		htp.formSelectOption( row_countryList.name,cattributes=>'value='||row_countryList.organization_id );
		        	FETCH gis_search.cur_countryList INTO row_countryList;
			   	END LOOP;	
		ELSE
				WHILE gis_search.cur_countryList%FOUND	
				LOOP
					IF p_orgId = row_countryList.organization_id
					THEN
						htp.formSelectOption( row_countryList.name,'SELECTED',cattributes=>'value='||row_countryList.organization_id );
		 				l_organization_id :=  row_countryList.organization_id;	                        	 
		 			ELSE
		 				htp.formSelectOption( row_countryList.name,cattributes=>'value='||row_countryList.organization_id );  
		 			END IF;
		        	FETCH gis_search.cur_countryList INTO row_countryList;
			   	END LOOP;							   	
		   END IF;
		   htp.formSelectClose;
		   htp.p('		</TD>'); 
		   htp.p('<TD ALIGN="LEFT"><B>Organization</B></TD>');
		   htp.p('		</TR>');
		END IF;   
		CLOSE gis_search.cur_countryList;
		
		sqlSource := 	' SELECT DISTINCT hr.organization_id, '||
							' hr.name, '||
							' usr.user_name, '||
							' usr.user_id '||
						' FROM hr_operating_units hr, '||
							' fnd_profile_option_values optval, '||
							' fnd_profile_options opt, '||
							' fnd_application_tl app, '||
							' fnd_responsibility_tl resp, '||
							' fnd_user_resp_groups usrep, '||
							' fnd_user usr '||
						' WHERE usr.user_id IN (';
	
		l_userIdList := GetUserIdList( p_respId);
		FOR i IN 1..l_userIdList.last
		LOOP
			IF i != 1
			THEN
				sqlSource := sqlSource ||	',';
			END IF;
			sqlSource := sqlSource || l_userIdList(i);
		END LOOP;
		sqlSource := sqlSource || ') ' ||					
						' AND nvl(usr.end_date,SYSDATE+1) > SYSDATE '||
						' AND nvl(usr.start_date,SYSDATE-1) < SYSDATE '||
						' AND	resp.application_id = '||l_appId ||
						' AND	TO_NUMBER(hr.organization_id) = '||l_organization_id ||
						' AND	usrep.user_id = usr.user_id '||
						' AND	usrep.responsibility_application_id = app.application_id '||
						' AND	nvl(usrep.end_date,SYSDATE+1) > SYSDATE '||
						' AND	usrep.responsibility_id = resp.responsibility_id '||
						' AND	usrep.responsibility_application_id = resp.application_id '||
						' AND	usrep.responsibility_id = optval.level_value '||
						' AND	optval.profile_option_id = opt.profile_option_id '||
						' AND	optval.application_id =  opt.application_id '||
						' AND	opt.profile_option_name = ''ORG_ID'' '||
						' AND 	optval.profile_option_value = to_char(hr.organization_id) '; 												
--		htp.p(sqlSource);
		cid := dbms_sql.open_cursor;
		dbms_sql.parse( cid, sqlSource, dbms_sql.v7);
		dbms_sql.define_column( cid, 1, l_orgId);
		dbms_sql.define_column( cid, 2, l_orgName, 150);
		dbms_sql.define_column( cid, 3, l_userName, 150);
		dbms_sql.define_column( cid, 4, l_userId );
		rowCount := dbms_sql.execute_and_fetch( cid);
		IF rowCount != 1
		THEN
			-- put some sort of error message in here
			htp.p('No process Users Found');
		ELSE
			htp.br;
			htp.p('		<TR><TD ALIGN="RIGHT">');	
			htp.formSelectOpen(cname=>'p_userNames',nsize=>'7');
			WHILE rowCount = 1 
			LOOP
				dbms_sql.column_value( cid, 1, l_orgId); 
				dbms_sql.column_value( cid, 2, l_orgName);
				dbms_sql.column_value( cid, 3, l_userName);
				dbms_sql.column_value( cid, 4, l_userId);		                    	 
			 	htp.formSelectOption( substr(l_userName,1,25),cattributes=>'value='||l_userId );  
				rowCount := dbms_sql.fetch_rows( cid);
			END LOOP;
			dbms_sql.close_cursor( cid);
		   	htp.formSelectClose;
		   	htp.p('		</TD>');  
		   	htp.p('<TD ALIGN="LEFT"><B>Users&nbsp&nbsp</B><A HREF="javascript:checkuser(this,'||p_respId||','||p_userId||','''||REPLACE(p_context,' ','+')||''')"><IMG SRC="'|| gis_image_util.c_image_url||'b_checkout.gif" BORDER="0" ALT="Check out"></A></TD>');
		   	htp.p('		</TR>');
		END IF;
		htp.p(' </TABLE>');
		htp.br;
		htp.p('  <TABLE WIDTH="80%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
		htp.p('		<TR><TD ALIGN="CENTER"><A HREF="javaScript:menu(2,'''||gis_image_util.c_pack_url||'gis_process_image.BlankFrame'','''||gis_image_util.c_pack_url||
							'gis_search.QueryContext?p_document=&p_navTo=gis_process_image.processImage&p_target=SelectFrame&p_userType=Process+User&p_userId='||
							p_userId||'&p_respId='||p_respId||''')" onMouseOver="window.status=''Back to context screen''; return true" onMouseOut="window.status='' ''; return true"><IMG SRC="'|| gis_image_util.c_image_url||'b_back_m.gif" BORDER="0"  ALT="Back to context screen"></A></TD></TR>');
		htp.p(' </TABLE>');						
		
		htp.formClose;
		gis_image_util.pageclose;
	EXCEPTION
	WHEN OTHERS
	THEN
	 	htp.p(gis_search.showErr( sqlSource,'gis_checkout_image.checkOutUsers'));

		NULL;
	END;
END checkOutUsers;

--FUNCTION processRightsOverOrg( p_userId NUMBER, p_orgId NUMBER) IS


PROCEDURE checkOutDocs( p_docIdList VARCHAR2
						,p_userId VARCHAR2
						,p_context VARCHAR2
						,p_respId VARCHAR2
						,p_currUserId VARCHAR2) IS

notDone BOOLEAN := TRUE;
l_startPos NUMBER(15) := 1;
l_endPos NUMBER(15);
l_docId VARCHAR2(15);
l_docIdList VARCHAR2(500) := REPLACE(p_docIdList,' ','+') || '+';   -- need to put the + sign at the end for instr func
--sqlsource VARCHAR2(500);
l_orgList  gis_search.org_array:= gis_search.org_array();
l_docOrgId VARCHAR2(15);
l_processRights BOOLEAN := FALSE;
l_notAssignedList VARCHAR2(250);
l_securityType NUMBER(15);
l_setOfBooks NUMBER(15);
l_businessGroup NUMBER(15);

BEGIN
	-- extract the document_id's from the docIdList string
-- the org_id's that this user has access to
	l_orgList := gis_search.getOrgList( p_userId, p_context);
	WHILE (notDone)
	LOOP
		l_endPos := instr( l_docIdList,'+',l_startPos);
	    l_docId := (substr(l_docIdList,l_startPos,(l_endPos-l_startPos)));
	    l_startPos := l_endPos +1; 
	-- enter the user id of the user checking out the document
    -- into doc_attribute15

	-- get the documents org id
		SELECT security_id, security_type
		INTO l_docOrgId, l_securityType
		FROM fnd_documents
		WHERE document_id = l_docId;	    
    -- need to check if user hase process rights
    -- over this document for this org before updating record 

		IF l_securityType = 1  -- document uses organization id for security 
		THEN
	        FOR i IN 1..l_orgList.count
	        LOOP
	        	IF l_orgList(i) = l_docOrgId    		
	       		THEN
	       			l_processRights := TRUE;
	       			EXIT;
	       		END IF;
	        END LOOP;
	    END IF;
        
       IF l_securityType = 2    -- document uses set of books id for security 
       THEN
	        FOR i IN 1..l_orgList.count
	        LOOP       		
		        SELECT set_of_books_id
	       		INTO l_setOfBooks
	       		FROM hr_operating_units
	       		WHERE organization_id = l_orgList(i);
	        	
	        	IF l_setOfBooks = l_docOrgId    		
	       		THEN
	       			l_processRights := TRUE;
	       			EXIT;
	       		END IF;
	        END LOOP;
	    END IF;	 

       IF l_securityType = 3   -- document uses business group_id for security 
       THEN
	        FOR i IN 1..l_orgList.count
	        LOOP       		
		        SELECT business_group_id
	       		INTO l_businessGroup
	       		FROM hr_operating_units
	       		WHERE organization_id = l_orgList(i);
	        	
	        	IF l_businessGroup = l_docOrgId    		
	       		THEN
	       			l_processRights := TRUE;
	       			EXIT;
	       		END IF;
	        END LOOP;
	    END IF;	       	      		
	
        IF l_processRights
        THEN
			UPDATE fnd_documents_tl
	    	SET doc_attribute15 = p_userId
	        WHERE document_id = l_docId;
	--       htp.p(sqlsource);
		ELSE
			l_notAssignedList := l_notAssignedList || ',' || l_docId;
		END IF;
	   	IF ( instr( l_docIdList,'+',l_startPos) = 0)
	   	THEN
			notDone := FALSE;
	   	END IF;
	END LOOP;
	COMMIT;

	gis_image_util.pageopen(p_heading=>'Global Imaging System v2',p_procedure=>'gis_checkout_image.checkoutDocs');
	gis_image_util.infoHeader('Checkout Status');
	htp.br;
	htp.br; 
	htp.p('  <TABLE WIDTH="80%" ALIGN="CENTER" BORDER="0" CELLSPACING="0" CELLPADDING="2">');
	htp.p('		<TR>');
    htp.p('    		<TD VALIGN="TOP" ALIGN="CENTER"><IMG SRC="'||gis_image_util.c_image_url||'i_note.gif" ALT="Note"></TD>' );	
	IF length(l_notAssignedList) > 1 -- documents could not be checked to selected user
	THEN
		htp.p( '<SCRIPT LANGUAGE="javascript">' );
	   	htp.p( 'alert("The following documents were not assigned due to the selected user not having process rights over them : '||
	   									l_notAssignedList||'")' );
		htp.p( '</SCRIPT>'); 
		htp.p('			<TD><B> Documents checked out with errors</B></TD>');
	ELSE
    -- notify user if succsessful
		htp.p('			<TD><B> Documents checked out </B></TD>');
	END IF;
	htp.p('		</TR>');
	htp.p('	</TABLE>');
	refreshList( p_context, p_currUserId,p_respId);
	htp.p( '<SCRIPT LANGUAGE="javascript">' );
   	htp.p( 'parent.QueryFrame.document.location="gis_checkout_image.checkOutUsers?p_context='||REPLACE(p_context,' ','+')||
   				'&p_orgId=&p_userId='||p_currUserId||'&p_respId='||p_respId||'"' );
	htp.p( '</SCRIPT>'); 
	gis_image_util.pageclose;
END checkOutDocs;
END gis_checkout_image;
/
