CREATE OR REPLACE
PACKAGE BODY apps.gis_custom IS
-- ============================================================================
--
--   NAME
--      gis_custom.sql
--
--   DESCRIPTION
--      This script is used to build the custom display and
--      query options
--      
--   HISTORY
--      10/08/2000 David Gough In Development
--		11/06/2001 David Gough % option added to all
--					customer name queries to improve performance
--
-- =============================================================================
FUNCTION custom_display_option( p_userId IN VARCHAR2,p_selection IN VARCHAR2, p_context IN VARCHAR2, p_app_col_name IN VARCHAR2) 
RETURN BOOLEAN IS

CURSOR cur_doc_types( f_context VARCHAR) IS
SELECT
substr(tl.user_name,7,length(tl.user_name)-6) user_name
,cat.name
,cat.attribute1
,cat.attribute_category
,cat.category_id
FROM
fnd_document_categories_tl  tl
,fnd_document_categories cat
WHERE
tl.category_id = cat.category_id
AND cat.attribute_category = 'GIS'
AND cat.attribute1 = f_context
AND cat.start_date_active <= SYSDATE
AND nvl(cat.end_date_active,sysdate) >= SYSDATE;

row_doc_types cur_doc_types% ROWTYPE;

cid INTEGER;
sqlSource VARCHAR2(2000);
rowCount INTEGER;
l_col_1 VARCHAR2(50);
l_col_2 VARCHAR2(50);
l_col_3 NUMBER;
l_orgList  gis_search.org_array:= gis_search.org_array();

BEGIN
-- display select box for document types
	IF p_selection = 'Doc Type'
	THEN
		htp.p('      <TD WIDTH="60%"  ALIGN="RIGHT"><FONT size=2><DIV CLASS="inputtext" ID = "text"><B>'||p_selection||'</B></FONT></DIV></TD>');	
		htp.p('<TD ALIGN="LEFT"><FONT size=2>');
		htp.formSelectOpen(cname=>'p_'||p_app_col_name,nsize=>'1');
		IF NOT cur_doc_types%ISOPEN
		THEN
			OPEN cur_doc_types(UPPER(p_context));
		END IF;
		FETCH cur_doc_types INTO row_doc_types;
		IF cur_doc_types%NOTFOUND THEN
			htp.formSelectOption('ERROR','SELECTED',cattributes=>'VALUE="0"' );
			-- need some sort of error handler here
		ELSE
			htp.formSelectOption('All','SELECTED',cattributes=>'VALUE=0' );
			WHILE cur_doc_types%FOUND
			LOOP
				htp.formSelectOption( row_doc_types.user_name,CATTRIBUTES=>'value='||	
													row_doc_types.category_id);
				FETCH cur_doc_types INTO row_doc_types;
			END LOOP;
		END IF;
		CLOSE cur_doc_types;
		htp.formSelectClose;
		htp.p('</FONT></TD>');
		RETURN TRUE;
-- lov for order types
	ELSIF p_selection = 'Order Type'
	THEN
		sqlSource := 	'SELECT tl.name '||
						',tl.description '||
						',tl.transaction_type_id '||
						'FROM oe_transaction_types_tl tl '||
						',oe_transaction_types_all ty '||
						'WHERE tl.transaction_type_id = ty.transaction_type_id '||
						'AND ty.TRANSACTION_TYPE_CODE = ''ORDER'' '||
						'AND   start_date_active <= TRUNC(SYSDATE) '||
						'AND NVL(end_date_active,TRUNC(SYSDATE + 1)) >= TRUNC(SYSDATE)';

		l_orgList := gis_search.getOrgList( p_userId, p_context);
		sqlSource := sqlSource || ' AND ty.org_id IN ('; 
		FOR i IN 1..l_orgList.last
		LOOP
			IF i != 1
			THEN
				sqlSource := sqlSource ||	',';
			END IF;
			sqlSource := sqlSource || l_orgList(i);
		END LOOP;
		sqlSource := sqlSource || ')  ORDER BY name';

--		htp.p(sqlSource);		
		cid := dbms_sql.open_cursor;
		dbms_sql.parse( cid, sqlSource, dbms_sql.v7);				
		dbms_sql.define_column( cid, 1, l_col_1 ,50);
		dbms_sql.define_column( cid, 2, l_col_2 ,50);
		dbms_sql.define_column( cid, 3, l_col_3);
		rowCount := dbms_sql.execute_and_fetch( cid);
		htp.p('      <TD WIDTH="60%"  ALIGN="RIGHT"><FONT size=2><DIV CLASS="inputtext" ID = "text"><B>'||p_selection||'</B></FONT></DIV></TD>');	
		htp.p('<TD><FONT size=2>');
		htp.formSelectOpen(cname=>'p_'||p_app_col_name,nsize=>'1');
		htp.formSelectOption('All','SELECTED',cattributes=>'VALUE="0"' );
		WHILE rowCount = 1 
		LOOP	
			dbms_sql.column_value( cid, 1, l_col_1);	
			dbms_sql.column_value( cid, 2, l_col_2);
			dbms_sql.column_value( cid, 3, l_col_3);
			htp.formSelectOption( l_col_1,CATTRIBUTES=>'value='||	
											l_col_3);
			rowCount := dbms_sql.fetch_rows( cid);
		END LOOP;
		dbms_sql.close_cursor( cid);
		htp.formSelectClose;
		htp.p('</FONT></TD>');
		RETURN TRUE;
	ELSIF p_selection = 'License Value'
	THEN
		htp.p('      <TD WIDTH="60%"  ALIGN="RIGHT"><FONT size=2><DIV CLASS="inputtext" ID = "text"><B>'||p_selection||'</B></FONT></DIV></TD>');	
		htp.p('<TD><FONT size=2>');
		htp.formSelectOpen(cname=>'p_'||p_app_col_name||'_OP',nsize=>'1');
		htp.formSelectOption('=','SELECTED',cattributes=>'VALUE="1"' );
		htp.formSelectOption('>=','SELECTED',cattributes=>'VALUE="2"' );
		htp.formSelectOption('<=','SELECTED',cattributes=>'VALUE="3"' );
		htp.formSelectClose;
		htp.p('  <INPUT NAME="p_'||p_app_col_name||'" COLS=15  maxlength="20"><FONT size=2></TD>');				
	 	RETURN TRUE;
	ELSIF p_selection = 'Order Value'
	THEN
		htp.p('      <TD WIDTH="60%"  ALIGN="RIGHT"><FONT size=2><DIV CLASS="inputtext" ID = "text"><B>'||p_selection||'</B></FONT></DIV></TD>');	
		htp.p('<TD><FONT size=2>');
		htp.formSelectOpen(cname=>'p_'||p_app_col_name||'_OP',nsize=>'1');
		htp.formSelectOption('=','SELECTED',cattributes=>'VALUE="1"' );
		htp.formSelectOption('>=','SELECTED',cattributes=>'VALUE="2"' );
		htp.formSelectOption('<=','SELECTED',cattributes=>'VALUE="3"' );
		htp.formSelectClose;
		htp.p('  <INPUT NAME="p_'||p_app_col_name||'" COLS=15  maxlength="20"><FONT size=2></TD>');				
	 	RETURN TRUE;
	ELSIF p_selection = 'Project Value'
	THEN
		htp.p('      <TD WIDTH="60%"  ALIGN="RIGHT"><FONT size=2><DIV CLASS="inputtext" ID = "text"><B>'||p_selection||'</B></FONT></DIV></TD>');	
		htp.p('<TD><FONT size=2>');
		htp.formSelectOpen(cname=>'p_'||p_app_col_name||'_OP',nsize=>'1');  --  should be doc_attribute4
		htp.formSelectOption('=','SELECTED',cattributes=>'VALUE="1"' );
		htp.formSelectOption('>=','SELECTED',cattributes=>'VALUE="2"' );
		htp.formSelectOption('<=','SELECTED',cattributes=>'VALUE="3"' );
		htp.formSelectClose;
		htp.p('  <INPUT NAME="p_'||p_app_col_name||'" COLS=15  maxlength="20"><FONT size=2></TD>');				
	 	RETURN TRUE;
	ELSIF p_selection = 'Renewal Value'
	THEN
		htp.p('      <TD WIDTH="60%"  ALIGN="RIGHT"><FONT size=2><DIV CLASS="inputtext" ID = "text"><B>'||p_selection||'</B></FONT></DIV></TD>');	
		htp.p('<TD><FONT size=2>');
		htp.formSelectOpen(cname=>'p_'||p_app_col_name||'_OP',nsize=>'1');
		htp.formSelectOption('=','SELECTED',cattributes=>'VALUE="1"' );
		htp.formSelectOption('>=','SELECTED',cattributes=>'VALUE="2"' );
		htp.formSelectOption('<=','SELECTED',cattributes=>'VALUE="3"' );
		htp.formSelectClose;
		htp.p('  <INPUT NAME="p_'||p_app_col_name||'" COLS=15  maxlength="20"><FONT size=2></TD>');				
	 	RETURN TRUE;
	END IF;
	RETURN FALSE;
END custom_display_option;


FUNCTION custom_where_clause( 	p_context IN VARCHAR2
								,p_doc_attribute1 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute2 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute3 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute3_op IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute4 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute4_op IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute5 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute6 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute7 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute8 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute9 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute10 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute11 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute12 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute13 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute14 IN VARCHAR2 DEFAULT NULL
								,p_doc_attribute15 IN VARCHAR2 DEFAULT NULL) 
								RETURN VARCHAR2 IS

sqlSourceWhere VARCHAR2(2000);
l_operator CHAR(2);
l_plus     CHAR(1) := '+';
l_doc_status VARCHAR2(25);
l_orderType VARCHAR2(50);
								
BEGIN
	IF p_context = 'Order Management'
	THEN
		IF p_doc_attribute1 IS NOT NULL
		THEN
     	   	IF instr(p_doc_attribute1,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND upper(dfv.customer_name) like ''' || upper(p_doc_attribute1) || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND UPPER(dfv.customer_name) = ''' || UPPER(p_doc_attribute1) || '''';
			END IF;
		END IF;
		IF nvl(p_doc_attribute2,'0') != '0'
		THEN
			SELECT name
			INTO l_orderType
			FROM so_order_types_all
			WHERE order_type_id = TO_NUMBER( p_doc_attribute2);
			sqlSourceWhere := sqlSourceWhere || ' AND order_type = ''' || l_orderType || '''';
		END IF;
	-- total order value	
		IF nvl(p_doc_attribute3,'0') != '0'
		THEN
			IF p_doc_attribute3_OP = 1
			THEN
				l_operator := '=';
			ELSIF p_doc_attribute3_OP = 2
			THEN
			l_operator := '>=';
			ELSIF p_doc_attribute3_OP = 3
			THEN
				l_operator := '<=';		
			END IF;
-- Modified PL 11/05/2001 Convert char to number for amount filter for OM
--                        This caters for filters of different datatypes stored as char in flexfield
            sqlSourceWhere := sqlSourceWhere || ' AND gis_search.valid_value(doc.doc_attribute3) '||l_operator||' '|| p_doc_attribute3;
		END IF;
	-- license value	
		IF nvl(p_doc_attribute4,'0') != '0'
		THEN
			IF p_doc_attribute4_OP = 1
			THEN
				l_operator := '=';
			ELSIF p_doc_attribute4_OP = 2
			THEN
			l_operator := '>=';
			ELSIF p_doc_attribute4_OP = 3
			THEN
				l_operator := '<=';		
			END IF;
-- Modified PL 11/05/2001 Convert char to number for amount filter for OM
--                        This caters for filters of different datatypes stored as char in flexfield
            sqlSourceWhere := sqlSourceWhere || ' AND gis_search.valid_value(doc.doc_attribute4) '||l_operator||' '|| p_doc_attribute4;
		END IF;
	-- Order Management order number,
		IF p_doc_attribute9 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND  doc.doc_attribute9 = '''|| p_doc_attribute9 || '''' ;
		END IF;
	
	-- Order Management gtn number,
		IF p_doc_attribute11 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND  doc.doc_attribute11 = '''|| p_doc_attribute11 || '''' ;
		END IF;
	
	-- Order Management customer number,
		IF p_doc_attribute12 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND  doc.doc_attribute12 = '''|| p_doc_attribute12 || '''' ;
		END IF;
	ELSIF p_context = 'Contracts'
	THEN
	-- contracts customer name
		IF p_doc_attribute1 IS NOT NULL
		THEN 
	    	IF instr(p_doc_attribute1,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND upper(dfv.customer_name) like ''' || UPPER(p_doc_attribute1) || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND UPPER(dfv.customer_name) = ''' || UPPER(p_doc_attribute1) || '''';
			END IF;
		END IF;
	-- contracts number
		IF p_doc_attribute2 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.contracts_number = ''' || p_doc_attribute2 || '''';
		END IF;
	-- contacts modifier
		IF p_doc_attribute3 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.contracts_modifier like ''' || p_doc_attribute3 || '''';
		END IF;	
	-- renewal amount
		IF nvl(p_doc_attribute4,'0') != '0'
		THEN
			IF p_doc_attribute4_OP = 1
			THEN
				l_operator := '=';
			ELSIF p_doc_attribute4_OP = 2
			THEN
			l_operator := '>=';
			ELSIF p_doc_attribute4_OP = 3
			THEN
				l_operator := '<=';		
			END IF;
			sqlSourceWhere := sqlSourceWhere || ' AND gis_search.valid_value(doc.doc_attribute4) '||l_operator||' '|| p_doc_attribute4 ;
		END IF;
	ELSIF p_context = 'Agreements'
	THEN
	-- agreements agreement name
		IF p_doc_attribute1 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND upper(dfv.agreement_name) like ''' || p_doc_attribute1 || '''';
		END IF;	
	-- agreements agreement code
		IF p_doc_attribute2 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.agreement_code like ''' || p_doc_attribute2 || '''';
		END IF;		
	-- agreements customer name
		IF p_doc_attribute3 IS NOT NULL
		THEN
     	   	IF instr(p_doc_attribute3,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND upper(dfv.customer_name) like ''' || UPPER(p_doc_attribute3) || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND UPPER(dfv.customer_name) = ''' || UPPER(p_doc_attribute3) || '''';
			END IF;
		END IF;	
		-- agreements customer number
		IF p_doc_attribute4 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.customer_number = ''' || p_doc_attribute4 || '''';
		END IF;
	ELSIF p_context = 'Customer'
	THEN
	-- customer customer name
		IF p_doc_attribute1 IS NOT NULL
		THEN
     	   	IF instr(p_doc_attribute1,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND upper(dfv.customer_name) like ''' || UPPER(p_doc_attribute1) || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND UPPER(dfv.customer_name) = ''' || UPPER(p_doc_attribute1) || '''';
			END IF;
		END IF;	
		-- customer customer number
		IF p_doc_attribute2 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.customer_number = ''' || p_doc_attribute2 || '''';
		END IF;
	ELSIF p_context = 'Payables'
	THEN
	-- payables supplier name
		IF p_doc_attribute1 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND upper(dfv.supplier_name) like ''' || upper(p_doc_attribute1) || '''';
		END IF;	
		-- payables voucher number
		IF p_doc_attribute2 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.invoice_number = ''' || p_doc_attribute2 || '''';
		END IF;
	ELSIF p_context = 'Projects'
	THEN
	-- projects customer name
		IF p_doc_attribute1 IS NOT NULL
		THEN
     	   	IF instr(p_doc_attribute1,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND upper(dfv.customer_name) like ''' || UPPER(p_doc_attribute1) || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND UPPER(dfv.customer_name) = ''' || UPPER(p_doc_attribute1) || '''';
			END IF;
		END IF;	
	-- projects customer number
		IF p_doc_attribute2 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.customer_number = ''' || p_doc_attribute2 || '''';
		END IF;	
		-- projects project number
		IF p_doc_attribute3 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.project_number = ''' || p_doc_attribute3 || '''';
		END IF;
	-- project amount
		IF nvl(p_doc_attribute4,'0') != '0'
		THEN
			IF p_doc_attribute4_OP = 1
			THEN
				l_operator := '=';
			ELSIF p_doc_attribute4_OP = 2
			THEN
			l_operator := '>=';
			ELSIF p_doc_attribute4_OP = 3
			THEN
				l_operator := '<=';		
			END IF;
			sqlSourceWhere := sqlSourceWhere || ' AND gis_search.valid_value(doc.doc_attribute4) '||l_operator||' '|| p_doc_attribute4 ;
		END IF;
	ELSIF p_context = 'Receivables'
	THEN
	-- receivables customer name
		IF p_doc_attribute1 IS NOT NULL
		THEN
     	   	IF instr(p_doc_attribute1,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND upper(dfv.customer_name) like ''' || UPPER(p_doc_attribute1) || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND UPPER(dfv.customer_name) = ''' || UPPER(p_doc_attribute1) || '''';
			END IF;
		END IF;	
	-- receivables invoice number
		IF p_doc_attribute2 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.invoice_number = ''' || p_doc_attribute2 || '''';
		END IF;										
	ELSIF p_context = 'Web Expenses'
	THEN
	-- Expense Report Number
		IF p_doc_attribute1 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.Expense_Report_Number = ''' || p_doc_attribute1 || '''';
		END IF;	
	-- Employee ID Number
		IF p_doc_attribute2 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.Employee_ID_Number = ''' || p_doc_attribute2 || '''';
		END IF;
	ELSIF p_context = 'Education Events'
	THEN
	-- Event title
		IF p_doc_attribute1 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.Title = ''' || p_doc_attribute1 || '''';
		END IF;	
	-- Course name
		IF p_doc_attribute2 IS NOT NULL
		THEN
     	   	IF instr(p_doc_attribute2,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.course_name like ''' || p_doc_attribute2 || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.course_name = ''' || p_doc_attribute2 || '''';
			END IF;
		END IF;
	-- start date
		IF p_doc_attribute3 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.start_date = ''' || p_doc_attribute3 || '''';
		END IF;
	-- end date
		IF p_doc_attribute4 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.end_date = ''' || p_doc_attribute4 || '''';
		END IF;	
	ELSIF p_context = 'Education Bookings'
	THEN
	-- Event title
		IF p_doc_attribute1 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.Title = ''' || p_doc_attribute1 || '''';
		END IF;	
	-- Course name
		IF p_doc_attribute2 IS NOT NULL
		THEN
     	   	IF instr(p_doc_attribute2,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.course_name like ''' || p_doc_attribute2 || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.course_name = ''' || p_doc_attribute2 || '''';
			END IF;
		END IF;
	-- Delegate Name
		IF p_doc_attribute3 IS NOT NULL
		THEN
		    IF instr(p_doc_attribute3,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.Delegate_Name like ''' || p_doc_attribute3 || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.Delegate_Name = ''' || p_doc_attribute3 || '''';
			END IF;
		END IF;
	-- Enrollment Number
		IF p_doc_attribute4 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.Enrollment_Number = ''' || p_doc_attribute4 || '''';
		END IF;	
	ELSIF p_context = 'HR Assignments'
	THEN
	-- Employee name
		IF p_doc_attribute1 IS NOT NULL
		THEN
     	   	IF instr(p_doc_attribute1,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.name like ''' || p_doc_attribute1 || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.name = ''' || p_doc_attribute1 || '''';
			END IF;
		END IF;
	-- Assignment 
		IF p_doc_attribute2 IS NOT NULL
		THEN
     	   	IF instr(p_doc_attribute2,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.assignment like ''' || p_doc_attribute2 || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.assignment = ''' || p_doc_attribute2 || '''';
			END IF;
		END IF;
	-- Supervisor
		IF p_doc_attribute3 IS NOT NULL
		THEN
		    IF instr(p_doc_attribute3,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.supervisor like ''' || p_doc_attribute3 || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.supervisor = ''' || p_doc_attribute3 || '''';
			END IF;
		END IF;
	-- Assignment Ref
		IF p_doc_attribute4 IS NOT NULL
		THEN
		    IF instr(p_doc_attribute4,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.assignment_ref like ''' || p_doc_attribute4 || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.assignment_ref  = ''' || p_doc_attribute4 || '''';
			END IF;
		END IF;
	ELSIF p_context = 'Suppliers'
	THEN
	-- Supplier name
		IF p_doc_attribute1 IS NOT NULL
		THEN
     	   	IF instr(p_doc_attribute1,'%') <> 0
			THEN
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.supplier_name like ''' || p_doc_attribute1 || '''';
			ELSE
				sqlSourceWhere := sqlSourceWhere || ' AND dfv.supplier_name = ''' || p_doc_attribute1 || '''';
			END IF;
		END IF;
	-- Supplier number 
		IF p_doc_attribute2 IS NOT NULL
		THEN
			sqlSourceWhere := sqlSourceWhere || ' AND dfv.supplier_number = ''' || p_doc_attribute2 || '''';
		END IF;	
	END IF;
	
-- global attributes
-- document category
	IF nvl(p_doc_attribute10,'0') != '0'
	THEN
		sqlSourceWhere := sqlSourceWhere || ' AND docs.category_id = ' || p_doc_attribute10 ;
	END IF;
-- document status
	IF p_doc_attribute6 != 1
	THEN
		SELECT doc_status_name
		INTO l_doc_status
		FROM gis_doc_status_types
		WHERE doc_status_type_id = p_doc_attribute6;
		l_operator := '=';
	ELSE
		l_doc_status := 'SCANNED';
		l_operator := '!=';
	END IF;
	sqlSourceWhere := sqlSourceWhere || ' AND doc.doc_attribute6 ' || l_operator || ' ''' || l_doc_status ||'''' ;
	
	RETURN sqlSourceWhere;
END custom_where_clause;
END gis_custom;
/
