CREATE OR REPLACE
PACKAGE BODY apps.gis_deattach_util IS

PROCEDURE show_doc_types(p_user_id     NUMBER) IS
CURSOR cur_docContext IS
  SELECT DISTINCT con.descriptive_flex_context_code                                                                  
  FROM   FND_DESCR_FLEX_CONTEXTS_VL con,                                                                
         fnd_user_resp_groups usrep,                                                                        
         fnd_application_tl app,                                                                            
         fnd_responsibility_tl resp,                                                                        
         fnd_user usr                                                                                       
  WHERE  usr.user_id = p_user_id
  AND    usr.user_id = usrep.user_id
  AND    nvl(usrep.end_date,sysdate+1) > sysdate
  AND    usrep.responsibility_application_id = app.application_id
  AND    usrep.responsibility_id = resp.responsibility_id
  AND    usrep.responsibility_application_id = resp.application_id
  AND    usr.user_id = usrep.user_id
  AND    con.descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX'
  AND    descriptive_flex_context_code != 'Global Data Elements'
  AND    app.application_name = con.descriptive_flex_context_name
  ORDER BY descriptive_flex_context_code;
  row_docContext cur_docContext%ROWTYPE;

BEGIN
  gis_image_util.pageopen(p_heading => 'Attach Image');
  gis_image_util.InfoHeader('Select Document Category');
  htp.formOpen('gis_deattach_util.show_fields', 'POST',cattributes=>'NAME="show_doc_types"');
  htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE">');
  htp.formSelectOpen(cname=>'p_context',nsize=>'10');	
  IF NOT cur_docContext%ISOPEN THEN
    OPEN cur_docContext;
  END IF;
  FETCH cur_docContext INTO row_docContext;
  IF cur_docContext%NOTFOUND THEN
    htp.formSelectOption('ERROR','SELECTED',cattributes=>'VALUE="0"' );
    -- put some sort of error message in here
  ELSE
    WHILE cur_docContext%FOUND LOOP	
      htp.formSelectOption(row_docContext.descriptive_flex_context_code, CATTRIBUTES=>'value="' ||	
                           row_docContext.descriptive_flex_context_code || '"');
      FETCH cur_docContext INTO row_docContext;
    END LOOP;
  END IF;
  CLOSE cur_docContext;
  htp.formSelectClose;
  htp.p('    </TD>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="98%" ALIGN="CENTER"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_l.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A><A HREF="Javascript:document.show_doc_types.submit()" onMouseOver="window.status=''Next''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_next_r.gif" BORDER="0" ALT="Next" ALIGN="TOP"></A></TD>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.formHidden('p_user_id', p_user_id);
  htp.formclose;
  gis_image_util.pageclose;
END show_doc_types;

PROCEDURE show_fields(p_user_id      NUMBER,
                      p_context      VARCHAR2 DEFAULT 'None') IS
  CURSOR cDocFields IS
    SELECT 'MEDIA_ID' id, 'File ID' meaning, 'N' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT application_column_name id, end_user_column_name meaning, 'N', column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX'
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'N' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
BEGIN
  IF p_context = 'None' THEN
    gis_image_util.pageopen(p_heading => 'No Line Of Business Selected');
    gis_image_util.InfoHeader('No Line Of Business Selected');
  ELSE
    gis_image_util.pageopen(p_heading => p_context || ' Fields');
    gis_image_util.InfoHeader('Search For PreIndexed Image');
  END IF;
  htp.formOpen('gis_deattach_util.show_index_info', 'POST',cattributes=>'NAME="show_fields"');
  htp.formHidden('p_user_id', TO_CHAR(p_user_id));
  htp.formHidden('p_context', REPLACE(p_context, '%20', ' '));
  htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
  IF p_context != 'None' THEN
    FOR s IN cDocFields LOOP
      htp.p('  <TR>' );
      -- Input fields
      htp.p('    <TD ALIGN="RIGHT"><FONT SIZE=2 COLOR="#FFCC00">' || s.meaning || ':</FONT></TD>');      
      htp.p('    <TD ALIGN="LEFT"><FONT SIZE=2><INPUT type="text" name="' || s.id || '" size="22" maxlength="100"></FONT></TD>');
      htp.p('  </TR>' );
    END LOOP;
  ELSE
    htp.p('  <TR>' );
    -- No document type selected
    htp.p('    <TD ALIGN="RIGHT"><FONT SIZE=2><IMG SRC="' || C_IMG_URL || 'i_stop.gif"></FONT></TD>');
    htp.p('    <TD ALIGN="CENTER"><FONT SIZE=2>NO Line Of Business Selected</FONT></TD>');
    htp.p('  </TR>' );
  END IF;
  htp.p('</TABLE>' );
  htp.p('<TABLE WIDTH="98%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
  htp.p('  <TR>');
  htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('  <TR>');
  htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_l.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A>');
  htp.p('    <A HREF="Javascript:document.show_fields.submit()" onMouseOver="window.status=''Next''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_next_r.gif" BORDER="0" ALT="Next" ALIGN="TOP"></A></TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.p('</FORM>');
  gis_image_util.pageclose;
EXCEPTION
  WHEN OTHERS THEN
    NULL;
END show_fields;

PROCEDURE show_index_info(p_user_id      NUMBER,
                          p_context      VARCHAR2,
                          doc_attribute1 VARCHAR2 DEFAULT NULL,
                          doc_attribute2 VARCHAR2 DEFAULT NULL,
                          doc_attribute3 VARCHAR2 DEFAULT NULL,
                          doc_attribute4 VARCHAR2 DEFAULT NULL,
                          doc_attribute5 VARCHAR2 DEFAULT NULL,
                          doc_attribute6 VARCHAR2 DEFAULT NULL,
                          doc_attribute7 VARCHAR2 DEFAULT NULL,
                          doc_attribute8 VARCHAR2 DEFAULT NULL,
                          doc_attribute9 VARCHAR2 DEFAULT NULL,
                          doc_attribute10 VARCHAR2 DEFAULT NULL,
                          doc_attribute11 VARCHAR2 DEFAULT NULL,
                          doc_attribute12 VARCHAR2 DEFAULT NULL,
                          doc_attribute13 VARCHAR2 DEFAULT NULL,
                          doc_attribute14 VARCHAR2 DEFAULT NULL,
                          doc_attribute15 VARCHAR2 DEFAULT NULL,
                          media_id        NUMBER,
                          description     VARCHAR2 DEFAULT NULL) IS
  v_SQL      VARCHAR2(5000) := NULL;
  TYPE       cv_type IS REF CURSOR;
  cSearch    cv_type;
  nDocID     NUMBER := NULL;
  nMediaID   NUMBER := NULL;
  vDesc      fnd_documents_tl.description%TYPE;
  vAttr1     fnd_documents_tl.doc_attribute1%TYPE;
  vAttr2     fnd_documents_tl.doc_attribute2%TYPE;
  vAttr3     fnd_documents_tl.doc_attribute3%TYPE;
  vAttr4     fnd_documents_tl.doc_attribute4%TYPE;
  vAttr5     fnd_documents_tl.doc_attribute5%TYPE;
  vAttr6     fnd_documents_tl.doc_attribute6%TYPE;
  vAttr7     fnd_documents_tl.doc_attribute7%TYPE;
  vAttr8     fnd_documents_tl.doc_attribute8%TYPE;
  vAttr9     fnd_documents_tl.doc_attribute9%TYPE;
  vAttr10    fnd_documents_tl.doc_attribute10%TYPE;
  vAttr11    fnd_documents_tl.doc_attribute11%TYPE;
  vAttr12    fnd_documents_tl.doc_attribute12%TYPE;
  vAttr13    fnd_documents_tl.doc_attribute13%TYPE;
  vAttr14    fnd_documents_tl.doc_attribute14%TYPE;
  vAttr15    fnd_documents_tl.doc_attribute15%TYPE;
  
  nResult    NUMBER := 0;

  vCol1      fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol2      fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol3      fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol4      fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol5      fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol6      fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol7      fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol8      fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol9      fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol10     fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol11     fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol12     fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol13     fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol14     fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  vCol15     fnd_descr_flex_col_usage_vl.descriptive_flexfield_name%TYPE := NULL;
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX'
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY');

  PROCEDURE build_SQL (v_SQL IN OUT VARCHAR2,
                       v_Col IN     VARCHAR2,
                       v_Val IN     VARCHAR2) IS
  BEGIN
    IF v_Col IS NOT NULL AND
       v_Val IS NOT NULL THEN
      v_SQL := v_SQL || ' AND ' || v_Col || ' = ''' || v_Val || '''';
    END IF;
  END;
BEGIN
  gis_image_util.pageopen(p_heading => 'Image Search Results');
  gis_image_util.InfoHeader('Image Search Results');

--  viewimage('''', '''', newURL)

  htp.p('<SCRIPT language="JavaScript">
<!--BEGIN Script
var newURL = ""
function listAttachments(p_file_id)
{
  newURL = "gis_deattach_util.list_attached_images?p_user_id=' || p_user_id || '&p_file_id=" + p_file_id + "&p_context=' || p_context || '"
  document.location = newURL
}
//-->
</SCRIPT>');

  htp.formOpen('gis_deattach_util.list_attached_images', 'POST',cattributes=>'NAME="show_index_info"');
  -- Build SQL statement dynamically for multiple variable input
  v_SQL := 'SELECT t.document_id,t.media_id,t.description,t.doc_attribute1,t.doc_attribute2,t.doc_attribute3,t.doc_attribute4,' ||
           't.doc_attribute5,t.doc_attribute6,t.doc_attribute7,t.doc_attribute8,t.doc_attribute9,t.doc_attribute10,' ||
           't.doc_attribute11,t.doc_attribute12,t.doc_attribute13,t.doc_attribute14,t.doc_attribute15 '||
           'FROM   fnd_documents_tl t, fnd_documents d ' ||
           'WHERE  t.document_id = d.document_id ' ||
           'AND    d.datatype_id = (SELECT datatype_id FROM fnd_document_datatypes WHERE name = ''FILE'' AND NVL(start_date_active, SYSDATE) <= SYSDATE AND NVL(end_date_active, SYSDATE) >= SYSDATE) ' ||
           'AND    doc_attribute_category = ''' || p_context || '''';
  build_SQL(v_SQL, 'MEDIA_ID', media_id);
  build_SQL(v_SQL, 'DESCRIPTION', description);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE1', doc_attribute1);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE2', doc_attribute2);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE3', doc_attribute3);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE4', doc_attribute4);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE5', doc_attribute5);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE6', doc_attribute6);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE7', doc_attribute7);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE8', doc_attribute8);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE9', doc_attribute9);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE10', doc_attribute10);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE11', doc_attribute11);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE12', doc_attribute12);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE13', doc_attribute13);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE14', doc_attribute14);
  build_SQL(v_SQL, 'DOC_ATTRIBUTE15', doc_attribute15);
  htp.p('<TABLE WIDTH="100%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
  
  FOR s IN cDocFields LOOP
    IF s.id = 'DOC_ATTRIBUTE1' THEN
      vCol1 := s.meaning;
    ELSIF s.id = 'DOC_ATTRIBUTE2' THEN
      vCol2 := s.meaning;
    ELSIF s.id = 'DOC_ATTRIBUTE3' THEN
      vCol3 := s.meaning;
    ELSIF s.id = 'DOC_ATTRIBUTE4' THEN
      vCol4 := s.meaning;
    ELSIF s.id = 'DOC_ATTRIBUTE5' THEN
      vCol5 := s.meaning;
    ELSIF s.id = 'DOC_ATTRIBUTE6' THEN
      vCol6 := s.meaning;  
    ELSIF s.id = 'DOC_ATTRIBUTE7' THEN
      vCol7 := s.meaning;
    ELSIF s.id = 'DOC_ATTRIBUTE8' THEN
      vCol8 := s.meaning;  
    ELSIF s.id = 'DOC_ATTRIBUTE9' THEN
      vCol9 := s.meaning;  
    ELSIF s.id = 'DOC_ATTRIBUTE10' THEN
      vCol10 := s.meaning;  
    ELSIF s.id = 'DOC_ATTRIBUTE11' THEN
      vCol11 := s.meaning;  
    ELSIF s.id = 'DOC_ATTRIBUTE12' THEN
      vCol12 := s.meaning;  
    ELSIF s.id = 'DOC_ATTRIBUTE13' THEN
      vCol13 := s.meaning;  
    ELSIF s.id = 'DOC_ATTRIBUTE14' THEN
      vCol14 := s.meaning;  
    ELSIF s.id = 'DOC_ATTRIBUTE15' THEN
      vCol15 := s.meaning;  
    END IF;
  END LOOP;

  htp.p('  <TR>' );
  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>File ID</FONT></TD>');
  IF vCol1 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol1 || '</FONT></TD>');
  END IF;
  IF vCol2 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol2 || '</FONT></TD>');
  END IF;
  IF vCol3 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol3 || '</FONT></TD>');
  END IF;
  IF vCol4 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol4 || '</FONT></TD>');
  END IF;
  IF vCol5 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol5 || '</FONT></TD>');
  END IF;
  IF vCol6 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol6 || '</FONT></TD>');
  END IF;
  IF vCol7 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol7 || '</FONT></TD>');
  END IF;
  IF vCol8 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol8 || '</FONT></TD>');
  END IF;
  IF vCol9 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol9 || '</FONT></TD>');
  END IF;
  IF vCol10 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol10 || '</FONT></TD>');
  END IF;
  IF vCol11 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol11 || '</FONT></TD>');
  END IF;
  IF vCol12 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol12 || '</FONT></TD>');
  END IF;
  IF vCol13 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol13 || '</FONT></TD>');
  END IF;
  IF vCol14 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol14 || '</FONT></TD>');
  END IF;
  IF vCol15 IS NOT NULL THEN
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || vCol15 || '</FONT></TD>');
  END IF;
  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>Attachments</FONT></TD>');
  htp.p('  </TR>' );    
  
  OPEN cSearch FOR v_SQL;
  LOOP
    FETCH cSearch INTO nDocID, nMediaID, vDesc, vAttr1, vAttr2, vAttr3, vAttr4, vAttr5, vAttr6, vAttr7, vAttr8, vAttr9, vAttr10, 
                       vAttr11, vAttr12, vAttr13, vAttr14, vAttr15;
    EXIT WHEN cSearch%NOTFOUND;
    nResult := nResult + 1;
    /* Show document id */
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || TO_CHAR(nMediaID) || '</FONT></TD>');
    IF vCol1 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr1, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol2 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr2, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol3 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr3, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol4 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr4, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol5 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr5, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol6 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr6, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol7 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr7, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol8 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr8, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol9 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr9, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol10 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr10, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol11 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr11, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol12 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr12, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol13 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr13, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol14 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr14, 'NULL') || '</FONT></TD>');
    END IF;
    IF vCol15 IS NOT NULL THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || NVL(vAttr15, 'NULL') || '</FONT></TD>');
    END IF;
    htp.p('    <TD ALIGN="CENTER"><A HREF="Javascript:listAttachments(' || TO_CHAR(nMediaID) || ')" onMouseOver="window.status=''Show''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Show" ALIGN="TOP"></A></TD>');
    htp.p('  </TR>');
  END LOOP;
  CLOSE cSearch;
  IF nResult = 0 THEN
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=15 ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>No Images Found</FONT></TD>');
    htp.p('  </TR>');
  END IF;
  htp.p('</TABLE>');    
  htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="98%" ALIGN="CENTER"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A></TD>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.formHidden('p_user_id', p_user_id);
  htp.formclose;
  gis_image_util.pageclose;
END show_index_info;

PROCEDURE list_attached_images(p_user_id               NUMBER,
                               p_file_id               NUMBER,
                               p_context               VARCHAR2,
                               p_attached_document_id  NUMBER DEFAULT NULL) IS
  CURSOR cAttach IS
    SELECT t.media_id, t.document_id, a.attached_document_id, a.entity_name, a.pk1_value, v.attached_document_id primary_attached_id
    FROM   fnd_documents_tl t, fnd_attached_documents a, fnd_documents d, fnd_documents_tl_dfv v
    WHERE  t.media_id = p_file_id
    AND    t.document_id = a.document_id(+)
    AND    a.attached_document_id IS NOT NULL
    AND    t.document_id = d.document_id
    AND    t.rowid = v.rowid
    AND    d.datatype_id = 
    (SELECT datatype_id
     FROM   fnd_document_datatypes
     WHERE  name = 'FILE'
     AND    NVL(start_date_active, SYSDATE) <= SYSDATE
     AND    NVL(end_date_active, SYSDATE) >= SYSDATE)
    ORDER BY DECODE(NVL(a.attached_document_id, 0) - TO_NUMBER(NVL(t.doc_attribute14, 0)), 0, 1, 2), a.attached_document_id;
  rAttach  cAttach%ROWTYPE;
  v_Context VARCHAR2(100) := NULL;
  v_Value   VARCHAR2(1000) := NULL;
  nResult   NUMBER := 0;
  PROCEDURE find_context_pk IS
  BEGIN
    IF rAttach.entity_name = 'OE_ORDER_HEADERS' THEN
      SELECT 'Order Management', 'Order #: ' || h.order_number
      INTO   v_Context, v_Value
      FROM   oe_order_headers_all h
      WHERE  h.header_id = TO_NUMBER(rAttach.pk1_value)
      AND    h.org_id =
      (SELECT s.organization_id
       FROM   fnd_documents_tl t, fnd_lobs l, gis_scanners s
       WHERE  t.document_id = rAttach.document_id
       AND    t.media_id = l.file_id
       AND    l.program_tag = s.scanner_id);
    ELSIF rAttach.entity_name = 'OE_AGREEMENTS' THEN
      SELECT 'Agreements', 'Agreement: ' || name
      INTO   v_Context, v_Value
      FROM   so_agreements
      WHERE  agreement_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'AR_CUSTOMERS' THEN
      SELECT 'Customers', 'Customer (Number): ' || customer_name || ' (' || customer_number || ')'
      INTO   v_Context, v_Value
      FROM   ra_customers
      WHERE  customer_id = TO_NUMBER(rAttach.pk1_value);
    ELSIF rAttach.entity_name = 'AP_INVOICES' THEN
      SELECT 'Payables', 'Invoice #: ' || a.invoice_num
      INTO   v_Context, v_Value
      FROM   ap_invoices_all a
      WHERE  a.invoice_id = TO_NUMBER(rAttach.pk1_value)
      AND    a.org_id =
      (SELECT s.organization_id
       FROM   fnd_documents_tl t, fnd_lobs l, gis_scanners s
       WHERE  t.document_id = rAttach.document_id
       AND    t.media_id = l.file_id
       AND    l.program_tag = s.scanner_id);
    ELSIF rAttach.entity_name = 'RA_CUSTOMER_TRX' THEN
      SELECT 'Receivables', 'Invoice #: ' || t.trx_number
      INTO   v_Context, v_Value
      FROM   ra_customer_trx_all t
      WHERE  t.customer_trx_id = TO_NUMBER(rAttach.pk1_value)
      AND    t.org_id =
      (SELECT s.organization_id
       FROM   fnd_documents_tl t, fnd_lobs l, gis_scanners s
       WHERE  t.document_id = rAttach.document_id
       AND    t.media_id = l.file_id
       AND    l.program_tag = s.scanner_id);
    ELSIF rAttach.entity_name = 'OKC_K_HEADERS_V' THEN
      SELECT 'Renewals', 'Contract # (Modifier): ' ||  h.contract_number ||' (' || NVL(h.contract_number_modifier, 'N/A') || ')'
      INTO   v_Context, v_Value   
      FROM   okc_k_headers_b h
      WHERE  h.id = TO_NUMBER(rAttach.pk1_value)
      AND    h.authoring_org_id =
      (SELECT s.organization_id
       FROM   fnd_documents_tl t, fnd_lobs l, gis_scanners s
       WHERE  t.document_id = rAttach.document_id
       AND    t.media_id = l.file_id
       AND    l.program_tag = s.scanner_id);
    ELSIF rAttach.entity_name = 'PA_PROJECTS' THEN
      SELECT 'Projects', 'Project Number: ' ||  p.segment1
      INTO   v_Context, v_Value   
      FROM   pa_projects_all p
      WHERE  p.project_id = TO_NUMBER(rAttach.pk1_value)
      AND    p.org_id =
      (SELECT s.organization_id
       FROM   fnd_documents_tl t, fnd_lobs l, gis_scanners s
       WHERE  t.document_id = rAttach.document_id
       AND    t.media_id = l.file_id
       AND    l.program_tag = s.scanner_id);
    ELSIF rAttach.entity_name = 'AP_EXPENSE_REPORT_HEADER_S_ALL' THEN
      SELECT 'Web Expenses', 'Expense Report Number: ' ||  e.invoice_num
      INTO   v_Context, v_Value   
      FROM   ap_expense_report_headers_all e
      WHERE  e.report_header_id = TO_NUMBER(rAttach.pk1_value)
      AND    e.org_id =
      (SELECT s.organization_id
       FROM   fnd_documents_tl t, fnd_lobs l, gis_scanners s
       WHERE  t.document_id = rAttach.document_id
       AND    t.media_id = l.file_id
       AND    l.program_tag = s.scanner_id);
    ELSE
      v_Context := rAttach.entity_name;
      v_Value := 'NOT IMPLEMENTED';
    END IF;
  END find_context_pk;
BEGIN
  gis_image_util.pageopen(p_heading => 'Attachments For File ID ' || p_file_id);
  gis_image_util.InfoHeader('Attachments For File ID ' || p_file_id);
  htp.p('<SCRIPT language="JavaScript">
function deattachImage(p_user_id, p_file_id, p_context, p_attached_document_id)
{
  var newURL
  var returnValue
  
  if (p_attached_document_id == "")
  {
    returnValue = confirm("Are you sure you want to delete the primary and secondary attachment references and reset image for indexing ?");
    if (returnValue)
    {
      document.location="gis_deattach_util.deattach_images?p_user_id=" + p_user_id + "&p_file_id=" + p_file_id + "&p_context=" + p_context
    }
  }
  else
  {
    returnValue = confirm("Are you sure you want to delete the secondary attachment reference ?");
    if (returnValue)
    {
      document.location="gis_deattach_util.list_attached_images?p_user_id=" + p_user_id + "&p_file_id=" + p_file_id + "&p_context=" + p_context + "&p_attached_document_id=" + p_attached_document_id
    }
  }
}
</SCRIPT>');
  -- Delete attachment if specified
  IF p_attached_document_id IS NOT NULL THEN
    DELETE
    FROM   fnd_attached_documents
    WHERE  attached_document_id = p_attached_document_id;
    COMMIT;
  END IF;
  htp.formOpen('gis_deattach_util.deattach_images', 'POST',cattributes=>'NAME="list_attached_images"');
  -- Show attachments for image
  htp.p('<TABLE WIDTH="98%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
--  htp.p('  <TR>' );  
--  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>Context </FONT></TD>');
--  htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>Value </FONT></TD>');
--  htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>Deattach</FONT></TD>');
--  htp.p('  </TR>' );
  OPEN cAttach;
  LOOP
    FETCH cAttach INTO rAttach;
    EXIT WHEN cAttach%NOTFOUND;
    nResult := nResult + 1;
    /* Translate data from PK to user known unique key */
    find_context_pk;
    /* Show data for attachments number */
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || v_Context || '</FONT></TD>');
    IF rAttach.attached_document_id = rAttach.primary_attached_id THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2 COLOR="#FFCC00">' || v_Value || '</FONT></TD>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    ELSE
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><FONT SIZE=2>' || v_Value || '</FONT></TD>');
      htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2><A HREF="Javascript:deattachImage(' || TO_CHAR(p_user_id) || ',' || TO_CHAR(p_file_id) || ',''' || p_context || ''',' || rAttach.attached_document_id || ')" onMouseOver="window.status=''Delete''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_delete_m.gif" BORDER="0" ALT="Delete" ALIGN="TOP"></A></FONT></TD>');
    END IF;
    htp.p('  </TR>' );
  END LOOP;
  CLOSE cAttach;
  IF nResult = 0 THEN
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=15 ALIGN="CENTER" VALIGN="MIDDLE"><FONT SIZE=2>No Attachments Exist</FONT></TD>');
    htp.p('  </TR>');
  END IF;
  htp.p('</TABLE>');
  htp.p('<BR>');
  htp.p('</FORM>');
  htp.p('<TABLE WIDTH="98%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');  
  htp.p('  <TR>');
  htp.p('    <TD ALIGN="CENTER"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_l.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A><A HREF="Javascript:deattachImage(' || TO_CHAR(p_user_id) || ',' || TO_CHAR(p_file_id) || ',''' || p_context || ''','''')" onMouseOver="window.status=''Delete''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_delete_r.gif" BORDER="0" ALT="Delete" ALIGN="TOP"></A></FONT></TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  gis_image_util.pageclose;
END list_attached_images;

PROCEDURE deattach_images(p_user_id     NUMBER,
                          p_file_id     NUMBER,
                          p_context     VARCHAR2) IS
  nOrgID      NUMBER := NULL;
  nDocID      NUMBER := NULL;
  nStatusID   NUMBER := NULL;
  nAttachID   NUMBER := NULL;
  CURSOR cStatus IS
    SELECT rowid
    FROM   gis_doc_status
    WHERE  document_id = nDocID
    AND    doc_status_type_id = nStatusID;
  rStatus     cStatus%ROWTYPE;
BEGIN
  -- Get org_id for image
  SELECT organization_id
  INTO   nOrgID
  FROM   fnd_lobs l, gis_scanners s
  WHERE  l.file_id = p_file_id
  AND    l.program_name = 'GIS'
  AND    l.program_tag = s.scanner_id;
  -- Get document_id for reference
  SELECT t.document_id
  INTO   nDocID
  FROM   fnd_documents_tl t, fnd_documents d
  WHERE  t.media_id = p_file_id
  AND    t.document_id = d.document_id
  AND    d.datatype_id = 
    (SELECT datatype_id
     FROM   fnd_document_datatypes
     WHERE  name = 'FILE'
     AND    NVL(start_date_active, SYSDATE) <= SYSDATE
     AND    NVL(end_date_active, SYSDATE) >= SYSDATE);
  -- Delete all attachments
  DELETE
  FROM   fnd_attached_documents
  WHERE  document_id = nDocID;
  -- Update all attributes to NULL
  UPDATE fnd_documents_tl
  SET    doc_attribute1 = NULL,
         doc_attribute2 = NULL,
         doc_attribute3 = NULL,
         doc_attribute4 = NULL,
         doc_attribute5 = NULL,
         doc_attribute6 = NULL,
         doc_attribute7 = NULL,
         doc_attribute8 = NULL,
         doc_attribute9 = NULL,
         doc_attribute10 = NULL,
         doc_attribute11 = NULL,
         doc_attribute12 = NULL,
         doc_attribute13 = NULL,
         doc_attribute14 = NULL,
         doc_attribute15 = NULL,
         description = NULL,
         doc_attribute_category = NULL
  WHERE  document_id = nDocID;
  -- Reset record status to REPROCESS so that it can be identified and reprocessed
  UPDATE fnd_documents_tl_dfv
  SET    index_status_id = 'REPROCESS'
  WHERE  rowid IN
    (SELECT t.rowid
     FROM   fnd_documents_tl t
     WHERE  t.document_id = nDocID);
  -- Update doc category to MISC, reset security attributes to default
  UPDATE fnd_documents
  SET    security_type = 1,
         security_id = nOrgID,
         category_id = (SELECT category_id
                        FROM   fnd_document_categories
                        WHERE  name = 'MISC'),
         last_update_date = SYSDATE,
         last_updated_by = p_user_id
  WHERE  document_id = nDocID;
  -- Delete all status records except for SCANNED
  DELETE
  FROM   gis_doc_status
  WHERE  document_id = nDocID
  AND    doc_status_type_id NOT IN
    (SELECT doc_status_type_id
     FROM   gis_doc_status_types
     WHERE  doc_status_name IN ('SCANNED', 'REPROCESS'));
  -- Check if audit record exists for REPROCESS state
  SELECT doc_status_type_id
  INTO   nStatusID
  FROM   gis_doc_status_types
  WHERE  doc_status_name = 'REPROCESS';
  OPEN cStatus;
  FETCH cStatus INTO rStatus;
  IF cStatus%NOTFOUND THEN
    -- Log audit record for REPROCESS
    INSERT INTO gis_doc_status
        (document_id,
         doc_status_type_id,
         date_created,
         created_by,
         last_update_date,
         last_updated_by)
      VALUES
        (nDocID,
         nStatusID,
         SYSDATE,
         p_user_id,
         SYSDATE,
         p_user_id);
  ELSE
    UPDATE gis_doc_status
      SET  last_update_date = SYSDATE,
           last_updated_by = p_user_id
      WHERE rowid = rStatus.rowid;
  END IF;
  CLOSE cStatus;
  -- Delete all comments for file generated by GIS
  DELETE
  FROM   fnd_documents_short_text
  WHERE  media_id = p_file_id
  AND    app_source_version = 'GIS';
  COMMIT;
  gis_image_util.pageopen(p_heading => 'Deleted Attachments For File ID ' || p_file_id);
  gis_image_util.InfoHeader('Deleted Attachments For File ID ' || p_file_id);
  htp.br;
  htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');  
  htp.p('  <TR>');
  htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE">Ready For Reprocessing In Scan Operator Queue</TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.p('<BR>');  
  htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');  
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="98%" ALIGN="CENTER"><A HREF="Javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_l.gif" BORDER="0" ALT="Back" ALIGN="TOP"></A><A HREF="Javascript:document.null()" onMouseOver="window.status=''OK''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok_r.gif" BORDER="0" ALT="OK" ALIGN="TOP"></A></TD>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  gis_image_util.pageclose;
END deattach_images;

END gis_deattach_util;
/
