CREATE OR REPLACE
PACKAGE apps.gis_deattach_util AUTHID CURRENT_USER IS

C_DATE_FORMAT_EN constant varchar2(100) := 'DD-MON-YYYY HH24:MI:SS';
C_APP_URL        constant varchar2(100) := rtrim(FND_WEB_CONFIG.WEB_SERVER,'/')||'/'||rtrim(ltrim(icx_plug_utilities.getPLSQLagent,'/'),'/')||'/';
C_IMG_URL        constant varchar2(100) := fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/images/';
C_FLAG_URL       constant varchar2(100) := fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/images/flags/';
  
PROCEDURE show_doc_types(p_user_id     NUMBER);

PROCEDURE show_fields(p_user_id      NUMBER,
                      p_context      VARCHAR2 DEFAULT 'None');

PROCEDURE show_index_info(p_user_id      NUMBER,
                          p_context      VARCHAR2,
                          doc_attribute1 VARCHAR2 DEFAULT NULL,
                          doc_attribute2 VARCHAR2 DEFAULT NULL,
                          doc_attribute3 VARCHAR2 DEFAULT NULL,
                          doc_attribute4 VARCHAR2 DEFAULT NULL,
                          doc_attribute5 VARCHAR2 DEFAULT NULL,
                          doc_attribute6 VARCHAR2 DEFAULT NULL,
                          doc_attribute7 VARCHAR2 DEFAULT NULL,
                          doc_attribute8 VARCHAR2 DEFAULT NULL,
                          doc_attribute9 VARCHAR2 DEFAULT NULL,
                          doc_attribute10 VARCHAR2 DEFAULT NULL,
                          doc_attribute11 VARCHAR2 DEFAULT NULL,
                          doc_attribute12 VARCHAR2 DEFAULT NULL,
                          doc_attribute13 VARCHAR2 DEFAULT NULL,
                          doc_attribute14 VARCHAR2 DEFAULT NULL,
                          doc_attribute15 VARCHAR2 DEFAULT NULL,
                          media_id        NUMBER,
                          description     VARCHAR2 DEFAULT NULL);

PROCEDURE list_attached_images(p_user_id               NUMBER,
                               p_file_id               NUMBER,
                               p_context               VARCHAR2,
                               p_attached_document_id  NUMBER DEFAULT NULL);

PROCEDURE deattach_images(p_user_id     NUMBER,
                          p_file_id     NUMBER,
                          p_context     VARCHAR2);

END gis_deattach_util;
/
