CREATE OR REPLACE
PACKAGE apps.gis_image_util IS

--------------------------------------------------------------------------------------------------------
-- file name: gis_image_util_pks.sql
--
-- Description: Specification for utility functions and procedures used in GIS
--				All functions/procedures accessed from different web forms should be
--				placed in this package for easy reference and maintenance.
--
--	History: 24-04-2001 David Gough OTA application details added 
--
---------------------------------------------------------------------------------------------------------   
c_background_image gis_search.stdVarchar := '1x1white.gif';
c_background_color gis_search.stdVarchar := 'BGCOLOR="#627A95"'; -- 11i blue?
c_font_color gis_search.stdVarchar := 'white'; 
c_text_color gis_search.stdVarchar := 'TEXT="'||c_font_color||'"'; -- uses the value of c_font_color above.
c_link_colors gis_search.stdVarchar := 'LINK="#0000FF" VLINK="#550055" ALINK="#550055"'; -- Blue, dark purple, dark purple
c_table_attributes gis_search.stdVarchar := 'CELLSPACING="0" CELLPADDING="1" WIDTH="100%"';
c_table_header_row_attributes gis_search.stdVarchar := 'BGCOLOR="#99ccff"'; -- pale blue background
c_table_white_row_attributes gis_search.stdVarchar := 'BGCOLOR="#ffffff"'; -- white background
c_table_yellow_row_attributes gis_search.stdVarchar := 'BGCOLOR="#ffffcc"'; -- pale yellow background
-- the next statement is a bit convoluted in order to make sure the url is correctly formed
-- should the return values be different from database to database
c_pack_url gis_search.stdVarchar;-- := 'http://emea06.uk.oracle.com:38004/pls/eesied/';--rtrim(FND_WEB_CONFIG.WEB_SERVER,'/')||'/'||rtrim(ltrim(icx_plug_utilities.getPLSQLagent,'/'),'/')||'/';
c_image_url gis_search.stdVarchar :=  fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/images/';
c_html_url gis_search.stdVarchar :=  fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/html/';
c_jscript_url gis_search.stdVarchar :=  fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/jscript/';
c_flags_url gis_search.stdVarchar :=  fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/images/flags/';
c_ss_url  gis_search.stdVarchar :=  fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/stylesheet/';
c_comments_yes gis_search.minVarchar := 'PINK'; -- link colour for documents with comments
c_comments_no gis_search.minVarchar := 'WHITE'; -- link colour for documents without comments
n_omAppId NUMBER(15) := 660; -- om
n_arAppId NUMBER(15) := 222; -- ar
n_poAppId NUMBER(15) := 201; -- po
n_apAppId NUMBER(15) := 200; -- ap
n_paAppId NUMBER(15) := 275; -- pa
n_coAppId NUMBER(15) := 515; -- oks
n_ssAppId NUMBER(15) := 178; -- self service
n_otaAppId NUMBER(15) := 810;  -- ota
n_hrAppId NUMBER(15) := 800;  -- hr

FUNCTION userAccessRights( p_user_id NUMBER, p_responsibility_id NUMBER) RETURN VARCHAR2;

FUNCTION applicationId( p_context VARCHAR2) RETURN NUMBER;

PROCEDURE whiteFrame;

PROCEDURE imagingStart(p_user_id           VARCHAR2 DEFAULT NULL,
                       p_responsibility_id VARCHAR2 DEFAULT NULL,
                       p_resolution_height VARCHAR2 DEFAULT NULL);

PROCEDURE SaveComments(p_file_id NUMBER,
                       p_comment VARCHAR2,
                       p_input   VARCHAR2,
                       p_user_id NUMBER);

PROCEDURE LogComments(p_file_id NUMBER,
                      p_user_id NUMBER);
                      
PROCEDURE UpdateLocation(p_user_id      NUMBER,
                         p_process      VARCHAR2 DEFAULT NULL,
                         p_old_location VARCHAR2 DEFAULT NULL,
                         p_new_location VARCHAR2 DEFAULT NULL,
                         p_scanner_id   VARCHAR2 DEFAULT NULL,
                         p_search_user  VARCHAR2 DEFAULT NULL);

PROCEDURE ViewingFrame( p_userType VARCHAR2 DEFAULT NULL);

PROCEDURE OptionFrame(p_user_id VARCHAR2 DEFAULT NULL, p_responsibility_id VARCHAR2 DEFAULT NULL);

PROCEDURE BlankFrame;

PROCEDURE InfoHeader(p_heading  VARCHAR2 DEFAULT NULL
					,p_image VARCHAR2 DEFAULT 'searching2.gif'
					,p_attrib VARCHAR2 DEFAULT NULL
					,p_right_image VARCHAR2 DEFAULT 'empty.gif'
					,p_alt_value VARCHAR2 DEFAULT NULL
					,p_right_link VARCHAR2 DEFAULT NULL);

PROCEDURE pageopen(	p_heading IN VARCHAR2
					,p_procedure IN VARCHAR2 DEFAULT NULL
				   	,p_attrib VARCHAR2 DEFAULT NULL);
				   	
PROCEDURE pageheader(p_heading IN VARCHAR2
					,p_procedure IN VARCHAR2 DEFAULT NULL
					,p_refresh IN VARCHAR2 DEFAULT NULL
					,p_refresh_url IN VARCHAR2 DEFAULT NULL);
					
PROCEDURE pageclose;

PROCEDURE  Error_message(p_message  VARCHAR2 DEFAULT NULL);

PROCEDURE dummypage;

FUNCTION test RETURN VARCHAR2;

PROCEDURE UPDATE_URL( errbuf  out  varchar2,retcode out  varchar2,URL IN VARCHAR);

PROCEDURE show_calendar;

FUNCTION validIP(vIP VARCHAR2) RETURN BOOLEAN;

FUNCTION delete_image(p_user_id             NUMBER,
                      p_file_id             NUMBER,
                      p_document_id         NUMBER DEFAULT NULL,
                      p_primary_document_id VARCHAR2,
                      p_operation           VARCHAR2 DEFAULT 'D') RETURN BOOLEAN;

PROCEDURE recon_index_info(errbuf OUT VARCHAR2, retcode OUT VARCHAR2);

FUNCTION get_pack_url RETURN VARCHAR2;

END gis_image_util;
/
