CREATE OR REPLACE
PACKAGE BODY gis_insert AS
-- Target       : This package create form functions, menues, and 
--				responsibilities for Global Imaging System
-- Made by      : Fernando Gonzalez - IT ERP Senior Consultant(Imaging Team)
-- Date         : 13/09/2000.
-- Modified by  : Fernando Gonzalez - IT ERP Senior Consultant(Imaging Team)
-- Date         : 10/10/2000.*/
/*=============================Procedures=======================*/
PROCEDURE form_function(p_function_name VARCHAR2
                      , p_function_description VARCHAR2
                      , p_inserted_by NUMBER
                      , p_type VARCHAR2
                      , p_web_host VARCHAR2
                      , p_package_procedure VARCHAR2) IS
v_sequence NUMBER;
BEGIN
  v_sequence:=0;
  global_sequence:=0;
  SELECT fnd_form_functions_s.NEXTVAL 
  INTO v_sequence
  FROM dual;
  global_sequence:=v_sequence;
  INSERT INTO fnd_form_functions(
  FUNCTION_ID            
  , FUNCTION_NAME          
  , APPLICATION_ID         
  , FORM_ID                
  , PARAMETERS             
  , CREATION_DATE          
  , CREATED_BY
  , LAST_UPDATE_DATE
  , LAST_UPDATED_BY
  , LAST_UPDATE_LOGIN
  , TYPE
  , WEB_HOST_NAME
  , WEB_AGENT_NAME
  , WEB_HTML_CALL
  , WEB_ENCRYPT_PARAMETERS
  , WEB_SECURED
  , WEB_ICON)
  VALUES ( 
  v_sequence
  , p_function_name
  , NULL
  , NULL
  , NULL
  , SYSDATE
  , p_inserted_by
  , SYSDATE
  , p_inserted_by
  , p_inserted_by
  , p_type
  , p_web_host
  , NULL
  , p_package_procedure
  , NULL
  , NULL
  , NULL);
  INSERT INTO fnd_form_functions_tl(
  LANGUAGE
  , FUNCTION_ID
  , USER_FUNCTION_NAME
  , CREATION_DATE
  , CREATED_BY
  , LAST_UPDATE_DATE
  , LAST_UPDATED_BY
  , LAST_UPDATE_LOGIN
  , DESCRIPTION
  , SOURCE_LANG)
  VALUES
  ('US'
  , v_sequence
  , p_function_description
  , SYSDATE
  , p_inserted_by
  , SYSDATE
  , p_inserted_by
  , p_inserted_by
  , p_function_description
  , 'US');
  commit;
  EXCEPTION
  	WHEN OTHERS
  	THEN
  		dbms_output.put_line('Error inserting function ' || p_function_name);
END form_function;
PROCEDURE menu(p_menu_name VARCHAR2
               , p_menu_description VARCHAR2
               , p_prompt VARCHAR2
               , p_inserted_by NUMBER
               , p_function_name VARCHAR2)  IS
               
v_sequence_menu NUMBER;
v_function_id NUMBER;

BEGIN
	SELECT function_id
	INTO v_function_id
	FROM fnd_form_functions
	WHERE function_name = p_function_name;
	
  SELECT fnd_menus_s.NEXTVAL
  INTO v_sequence_menu
  FROM dual;
  INSERT INTO fnd_menus(
    MENU_ID
    , MENU_NAME
    , LAST_UPDATE_DATE
    , LAST_UPDATED_BY
    , LAST_UPDATE_LOGIN
    , CREATION_DATE
    , CREATED_BY)
    VALUES(
    v_sequence_menu
     , p_menu_name
     , SYSDATE
     , p_inserted_by
     , p_inserted_by
     , SYSDATE
     , p_inserted_by);
  INSERT INTO fnd_menus_tl(
    LANGUAGE
    , MENU_ID
    , USER_MENU_NAME
    , LAST_UPDATE_DATE
    , LAST_UPDATED_BY
    , LAST_UPDATE_LOGIN
    , CREATION_DATE
    , CREATED_BY
    , DESCRIPTION
    , SOURCE_LANG)
  VALUES
    ('US'
    , v_sequence_menu
    , p_menu_description
    , SYSDATE
    , p_inserted_by
    , p_inserted_by
    , SYSDATE
    , p_inserted_by
    , p_menu_description
    , 'US');
  INSERT INTO fnd_menu_entries(
    MENU_ID
    , ENTRY_SEQUENCE
    , LAST_UPDATE_DATE
    , LAST_UPDATED_BY
    , LAST_UPDATE_LOGIN
    , CREATION_DATE
    , CREATED_BY
    , SUB_MENU_ID
    , FUNCTION_ID)
  VALUES(
    v_sequence_menu
    , 10
    , SYSDATE
    , p_inserted_by
    , p_inserted_by
    , SYSDATE
    , p_inserted_by
    , NULL
    , v_function_id);    
  INSERT INTO fnd_menu_entries_tl(
    LANGUAGE
    , MENU_ID
    , ENTRY_SEQUENCE
    , LAST_UPDATE_DATE
    , LAST_UPDATED_BY
    , LAST_UPDATE_LOGIN
    , CREATION_DATE
    , CREATED_BY
    , PROMPT
    , DESCRIPTION
    , SOURCE_LANG)
  VALUES(
    'US'
    , v_sequence_menu
    , 10
    , SYSDATE
    , p_inserted_by
    , p_inserted_by
    , SYSDATE
    , p_inserted_by
    , p_prompt
    , p_menu_description 
    , 'US');
    global_sequence:=v_sequence_menu;
    commit;
   EXCEPTION
   WHEN OTHERS
   	THEN
   		dbms_output.put_line('Error inserting ' ||p_menu_name || ' menu');
END menu;
PROCEDURE responsibility(p_responsibility_description VARCHAR2
                         , p_responsibility_key VARCHAR2
                         , p_data_group_application_id NUMBER
                         , p_data_group_id NUMBER
                         , p_start_date VARCHAR2
                         , p_version VARCHAR2
                         , p_inserted_by NUMBER
                         , p_menu_name VARCHAR2) IS
                         
v_sequence_responsibility NUMBER;
v_application_id NUMBER;
v_menu_id NUMBER;

BEGIN
	SELECT menu_id
	INTO v_menu_id
	FROM fnd_menus
	WHERE menu_name = p_menu_name;
	
  SELECT application_id 
  INTO v_application_id
  FROM fnd_application
  WHERE application_short_name='IMAGING';
  SELECT fnd_responsibility_s.NEXTVAL
  INTO v_sequence_responsibility
  FROM dual;  
  INSERT INTO fnd_responsibility(
   APPLICATION_ID
   , RESPONSIBILITY_ID
   , LAST_UPDATE_DATE
   , LAST_UPDATED_BY
   , CREATION_DATE
   , CREATED_BY
   , LAST_UPDATE_LOGIN
   , DATA_GROUP_APPLICATION_ID
   , DATA_GROUP_ID
   , MENU_ID
   , TERM_SECURITY_ENABLED_FLAG
   , START_DATE
   , END_DATE
   , GROUP_APPLICATION_ID
   , REQUEST_GROUP_ID
   , VERSION
   , WEB_HOST_NAME
   , WEB_AGENT_NAME
   , RESPONSIBILITY_KEY)
VALUES(
   v_application_id
   , v_sequence_responsibility
   , SYSDATE
   , p_inserted_by
   , SYSDATE
   , p_inserted_by
   , p_inserted_by
   , p_data_group_application_id
   , p_data_group_id
   , v_menu_id
   , NULL
   , p_start_date
   , NULL
   , NULL
   , NULL
   , p_version
   , NULL
   , NULL
   , p_responsibility_key);
  INSERT INTO fnd_responsibility_tl(
    APPLICATION_ID
    , RESPONSIBILITY_ID
    , LANGUAGE
    , RESPONSIBILITY_NAME
    , DESCRIPTION
    , CREATED_BY
    , CREATION_DATE
    , LAST_UPDATED_BY
    , LAST_UPDATE_DATE
    , LAST_UPDATE_LOGIN
    , SOURCE_LANG)
  VALUES(
    v_application_id 
    , v_sequence_responsibility 
    , 'US'
    , p_responsibility_description
    , p_responsibility_description
    , p_inserted_by
    , SYSDATE
    , p_inserted_by
    , SYSDATE
    , p_inserted_by
    , 'US');
    commit;
END responsibility;
PROCEDURE responsibility_other_apps(p_responsibility_description VARCHAR2
                         , p_responsibility_key VARCHAR2
                         , p_data_group_application_id NUMBER
                         , p_data_group_id NUMBER
                         , p_start_date VARCHAR2
                         , p_version VARCHAR2
                         , p_inserted_by NUMBER
                         , p_application VARCHAR2
                         , p_menu_name VARCHAR2) IS
                         
v_sequence_responsibility NUMBER;
v_application_id NUMBER; 
v_menu_id NUMBER;

BEGIN 
	SELECT menu_id
	INTO v_menu_id
	FROM fnd_menus
	WHERE menu_name = p_menu_name;
	
  SELECT application_id 
  INTO v_application_id
  FROM fnd_application
  WHERE application_short_name=p_application;
  SELECT fnd_responsibility_s.NEXTVAL
  INTO v_sequence_responsibility
  FROM dual; 
   
  INSERT INTO fnd_responsibility(
   APPLICATION_ID
   , RESPONSIBILITY_ID
   , LAST_UPDATE_DATE
   , LAST_UPDATED_BY
   , CREATION_DATE
   , CREATED_BY
   , LAST_UPDATE_LOGIN
   , DATA_GROUP_APPLICATION_ID
   , DATA_GROUP_ID
   , MENU_ID
   , TERM_SECURITY_ENABLED_FLAG
   , START_DATE
   , END_DATE
   , GROUP_APPLICATION_ID
   , REQUEST_GROUP_ID
   , VERSION
   , WEB_HOST_NAME
   , WEB_AGENT_NAME
   , RESPONSIBILITY_KEY)
VALUES(
   v_application_id
   , v_sequence_responsibility
   , SYSDATE
   , p_inserted_by
   , SYSDATE
   , p_inserted_by
   , p_inserted_by
   , v_application_id--p_data_group_application_id
   , p_data_group_id
   , v_menu_id
   , NULL
   , p_start_date
   , NULL
   , NULL
   , NULL
   , p_version
   , NULL
   , NULL
   , p_responsibility_key);
  INSERT INTO fnd_responsibility_tl(
    APPLICATION_ID
    , RESPONSIBILITY_ID
    , LANGUAGE
    , RESPONSIBILITY_NAME
    , DESCRIPTION
    , CREATED_BY
    , CREATION_DATE
    , LAST_UPDATED_BY
    , LAST_UPDATE_DATE
    , LAST_UPDATE_LOGIN
    , SOURCE_LANG)
  VALUES(
    v_application_id 
    , v_sequence_responsibility 
    , 'US'
    , p_responsibility_description
    , p_responsibility_description
    , p_inserted_by
    , SYSDATE
    , p_inserted_by
    , SYSDATE
    , p_inserted_by
    , 'US');
    commit;
     EXCEPTION
   WHEN OTHERS
   	THEN
   		dbms_output.put_line('Error responsibility ' ||p_responsibility_key || ' menu');
END responsibility_other_apps;
END gis_insert;
/
