CREATE OR REPLACE
PROCEDURE apps.gis_NewImageLoad( p_file_name IN VARCHAR2, p_scannerId IN VARCHAR2)
IS
   
-- local variables
l_rowid VARCHAR2(30);
l_attached_document_id NUMBER;
l_document_id		NUMBER;	
l_creation_date	DATE := SYSDATE;
l_created_by		NUMBER:=1;
l_last_update_date	DATE := SYSDATE;
l_last_updated_by	NUMBER:=1;
l_lang			VARCHAR2(40);
l_seq_num NUMBER;		-- sequency number for attached records
l_counter NUMBER;
l_insert_flag BOOLEAN := FALSE;
l_datatype_id NUMBER := 6;  -- 6 = 'file' datatype
l_category_id NUMBER :=1;
l_orgId NUMBER(15);
l_file_name VARCHAR2(256):= p_file_name;
l_file_id NUMBER(15);
l_primary_document_id fnd_documents_tl.doc_attribute13%TYPE := 'Y'; -- The loaded image is the primary attachment

BEGIN
-- get the current user LANG
	SELECT userenv('LANG')
	INTO l_lang
	FROM DUAL;     
	
-- old version which let in too many duplicates
/*	SELECT file_id,organization_id
	INTO l_file_id,l_orgId
	FROM gis_scanners,
		 fnd_lobs
	WHERE file_name = p_file_name
	AND program_tag = scanner_id
	AND program_name = 'GIS';*/ 
	
	SELECT file_id,organization_id
 	INTO l_file_id,l_orgId
	FROM gis_scanners,
		 fnd_lobs
	WHERE file_name = p_file_name
	AND program_tag = p_scannerId
	AND program_name = 'GIS'
	AND program_tag = scanner_id
	AND ROWNUM < 2
	ORDER BY file_id desc;
	
	-- gis_document_pkg inserts the required details into the tables
	-- fnd_documents and fnd_documents_tl. The document_id is returned from
	-- the package for use in fnd__attached_documents 
			gis_documents_pkg.Insert_Row(
		            X_rowid               => l_rowid,
		            X_document_id         => l_document_id,
		            X_creation_date       => l_creation_date,
		            X_created_by          => l_created_by,
		            X_last_update_date    => l_last_update_date,
		            X_last_updated_by     => l_last_updated_by,
		            X_last_update_login   => NULL,
		            X_datatype_id         => l_datatype_id,
		            X_category_id         => l_category_id,
		            X_security_type       => 1,
		            X_security_id         => l_orgId,  -- org id
		           X_publish_flag         => 'N',
		           X_image_type           => NULL,
		           X_storage_type         => NULL,
		           X_usage_type           => 'S',
		           X_start_date_active    =>  null,
		           X_end_date_active      =>  null,
		           X_request_id           => NULL,
		           X_program_application_id => NULL,
		           X_program_id           => NULL,
		           X_program_update_date  => NULL,
		           X_language             => l_lang,
		           X_description          => NULL,
		           X_file_name            => 'INTERNAL',
		           X_media_id             => l_file_id,
			   	   X_attribute_category   => NULL,
			       X_attribute1           => NULL,
			       X_attribute2           => NULL,
			       X_attribute3           => NULL,
			       X_attribute4           => NULL,
			       X_attribute5           => NULL,
			       X_attribute6           => 'SCANNED',
			       X_attribute7           => NULL,
			       X_attribute8           => NULL,
			       X_attribute9           => NULL,
			       X_attribute10          => NULL,
			       X_attribute11          => NULL,
			       X_attribute12          => NULL,
			       X_attribute13          => l_primary_document_id,
			       X_attribute14          => NULL,
			       X_attribute15          => NULL);	
			       
	-- insert a record into gis_doc_status
	INSERT INTO gis_doc_status(	DOCUMENT_ID
								,DOC_STATUS_TYPE_ID
								,DATE_CREATED
								,CREATED_BY
								,LAST_UPDATE_DATE
								,LAST_UPDATED_BY)

	VALUES( l_document_id
			,1   -- scanned
			,sysdate
			,1
			,sysdate
			,1);       
                
			
	COMMIT;
END gis_NewImageLoad;
/
