CREATE OR REPLACE
PACKAGE apps.gis_preindex AUTHID CURRENT_USER IS

C_DATE_FORMAT_EN constant varchar2(100) := 'DD-MON-YYYY HH24:MI:SS';
C_APP_URL        constant varchar2(100) := rtrim(FND_WEB_CONFIG.WEB_SERVER,'/')||'/'||rtrim(ltrim(icx_plug_utilities.getPLSQLagent,'/'),'/')||'/';
C_IMG_URL        constant varchar2(100) := fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/images/';
C_FLAG_URL       constant varchar2(100) := fnd_profile.value('GISMIS_CUSTOM_URL')||'admin/images/flags/';

PROCEDURE delete_image(p_user_id      NUMBER,
                       p_def_context  VARCHAR2,
                       p_context      VARCHAR2,
                       p_refresh_rate NUMBER,
                       p_file_id      NUMBER,
                       p_def_org      NUMBER DEFAULT NULL);

PROCEDURE confirm_gtn(p_gtn      VARCHAR2 DEFAULT '-1',
                      p_file_id  NUMBER,
                      p_context  VARCHAR2);

PROCEDURE confirm_oe(p_oe       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2);

PROCEDURE confirm_we(p_we       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2);

PROCEDURE confirm_ks(p_ks1      VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2);
                     
PROCEDURE confirm_pa(p_pa1      VARCHAR2 DEFAULT '-1',
                     p_pa2      VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2);

PROCEDURE confirm_sa(p_sa1      VARCHAR2 DEFAULT '-1',
                     p_sa2      VARCHAR2 DEFAULT '-1',
                     p_context  VARCHAR2);

PROCEDURE confirm_rc(p_rc       VARCHAR2 DEFAULT '-1',
                     p_context  VARCHAR2);

PROCEDURE confirm_ar(p_ar       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2);

PROCEDURE confirm_ap(p_ap       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2);

PROCEDURE confirm_ee(p_ee       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2);

PROCEDURE confirm_eb(p_eb       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2);

PROCEDURE confirm_hra(p_hra      VARCHAR2 DEFAULT '-1',
                      p_file_id  NUMBER,
                      p_context  VARCHAR2);

PROCEDURE confirm_pov(p_pov      VARCHAR2 DEFAULT '-1',
                      p_file_id  NUMBER,
                      p_context  VARCHAR2);

FUNCTION find_col_name(p_context VARCHAR2,
                       p_meaning VARCHAR2) RETURN VARCHAR2;
                       
PROCEDURE list_doc_types(p_user_id  NUMBER);

PROCEDURE list_unprocessed(p_user_id      NUMBER,
                           p_def_context  VARCHAR2,
                           p_context      VARCHAR2,
                           p_refresh_rate NUMBER,
                           p_def_org      NUMBER DEFAULT NULL);
                           
PROCEDURE show_doc_types(p_user_id      NUMBER,
                         p_def_context  VARCHAR2,
                         p_context      VARCHAR2,
                         p_refresh_rate NUMBER,
                         p_file_id      NUMBER,
                         p_navTo        VARCHAR2 DEFAULT NULL,
                         p_def_org      NUMBER DEFAULT NULL);

PROCEDURE show_fields(p_user_id      NUMBER,
                      p_def_context  VARCHAR2,
                      p_context      VARCHAR2 DEFAULT 'None',
                      p_refresh_rate NUMBER,
                      p_file_id      NUMBER,
                      p_navTo        VARCHAR2 DEFAULT NULL,
                      p_def_org      NUMBER DEFAULT NULL);

PROCEDURE preindex_info(p_user_id      NUMBER,
                        p_def_context  VARCHAR2,
                        p_context      VARCHAR2,
                        p_refresh_rate NUMBER,
                        p_file_id      NUMBER,
                        p_attr1        VARCHAR2 DEFAULT NULL,
                        p_attr2        VARCHAR2 DEFAULT NULL,
                        p_attr3        VARCHAR2 DEFAULT NULL,
                        p_attr4        VARCHAR2 DEFAULT NULL,
                        p_attr5        VARCHAR2 DEFAULT NULL,
                        p_attr6        VARCHAR2 DEFAULT NULL,
                        p_attr7        VARCHAR2 DEFAULT NULL,
                        p_attr8        VARCHAR2 DEFAULT NULL,
                        p_attr9        VARCHAR2 DEFAULT NULL,
                        p_attr10       VARCHAR2 DEFAULT NULL,
                        p_attr11       VARCHAR2 DEFAULT NULL,
                        p_attr12       VARCHAR2 DEFAULT NULL,
                        p_attr13       VARCHAR2 DEFAULT NULL,
                        p_attr14       VARCHAR2 DEFAULT NULL,
                        p_attr15       VARCHAR2 DEFAULT NULL,
                        p_val1         VARCHAR2 DEFAULT NULL,
                        p_val2         VARCHAR2 DEFAULT NULL,
                        p_val3         VARCHAR2 DEFAULT NULL,
                        p_val4         VARCHAR2 DEFAULT NULL,
                        p_val5         VARCHAR2 DEFAULT NULL,
                        p_val6         VARCHAR2 DEFAULT NULL,
                        p_val7         VARCHAR2 DEFAULT NULL,
                        p_val8         VARCHAR2 DEFAULT NULL,
                        p_val9         VARCHAR2 DEFAULT NULL,
                        p_val10        VARCHAR2 DEFAULT NULL,
                        p_val11        VARCHAR2 DEFAULT NULL,
                        p_val12        VARCHAR2 DEFAULT NULL,
                        p_val13        VARCHAR2 DEFAULT NULL,
                        p_val14        VARCHAR2 DEFAULT NULL,
                        p_val15        VARCHAR2 DEFAULT NULL,
                        p_navTo 	   VARCHAR2 DEFAULT NULL,
                        p_def_org      NUMBER   DEFAULT NULL,
                        p_skip         VARCHAR2 DEFAULT 'N');

PROCEDURE save_preindex_info(p_user_id      NUMBER,
                             p_def_context  VARCHAR2,
                             p_context      VARCHAR2,
                             p_refresh_rate NUMBER,
                             p_file_id      NUMBER,
                             p_attr1        VARCHAR2 DEFAULT NULL,
                             p_attr2        VARCHAR2 DEFAULT NULL,
                             p_attr3        VARCHAR2 DEFAULT NULL,
                             p_attr4        VARCHAR2 DEFAULT NULL,
                             p_attr5        VARCHAR2 DEFAULT NULL,
                             p_attr6        VARCHAR2 DEFAULT NULL,
                             p_attr7        VARCHAR2 DEFAULT NULL,
                             p_attr8        VARCHAR2 DEFAULT NULL,
                             p_attr9        VARCHAR2 DEFAULT NULL,
                             p_attr10       VARCHAR2 DEFAULT NULL,
                             p_attr11       VARCHAR2 DEFAULT NULL,
                             p_attr12       VARCHAR2 DEFAULT NULL,
                             p_attr13       VARCHAR2 DEFAULT NULL,
                             p_attr14       VARCHAR2 DEFAULT NULL,
                             p_attr15       VARCHAR2 DEFAULT NULL,
                             p_val1         VARCHAR2 DEFAULT NULL,
                             p_val2         VARCHAR2 DEFAULT NULL,
                             p_val3         VARCHAR2 DEFAULT NULL,
                             p_val4         VARCHAR2 DEFAULT NULL,
                             p_val5         VARCHAR2 DEFAULT NULL,
                             p_val6         VARCHAR2 DEFAULT NULL,
                             p_val7         VARCHAR2 DEFAULT NULL,
                             p_val8         VARCHAR2 DEFAULT NULL,
                             p_val9         VARCHAR2 DEFAULT NULL,
                             p_val10        VARCHAR2 DEFAULT NULL,
                             p_val11        VARCHAR2 DEFAULT NULL,
                             p_val12        VARCHAR2 DEFAULT NULL,
                             p_val13        VARCHAR2 DEFAULT NULL,
                             p_val14        VARCHAR2 DEFAULT NULL,
                             p_val15        VARCHAR2 DEFAULT NULL,
                             p_navTo 	    VARCHAR2 DEFAULT NULL,
                             p_def_org      NUMBER   DEFAULT NULL,
                             p_skip         VARCHAR2 DEFAULT 'N',
                             p_org_id       NUMBER);

END gis_preindex;
/
