-- ============================================================================
--
--   NAME
--      us_accounts.sql
--
--   DESCRIPTION
--      Control  script for  US user account creation
--	(GIS)
--
--   HISTORY
--	06/04/2001 David Gough initial version
--
-- ============================================================================
-- 
-- US user account creation
--
-- 
set echo off
set verify off
set serverout on
set heading off
set linesize 1000

accept apps_usr prompt        'Enter APPS User-name           : ' 
accept apps_pwd prompt        'Enter APPS password            : ' hide

PROMPT     Press <return> to continue or <ctrl-c> to exit.;
pause

---------------------------------------------------------------------------
--  Create log file and check passwords                                   -
---------------------------------------------------------------------------
spool gisinst.log

SELECT 'gisinst log file : '||
          to_char(SYSDATE, 'DD-MON-YY HH24:MI.SS')
FROM   sys.dual;


WHENEVER SQLERROR EXIT FAILURE ROLLBACK;

connect &&apps_usr/&&apps_pwd
SELECT  'APPS password correct.'
FROM    dual;

WHENEVER SQLERROR CONTINUE

connect &&apps_usr/&&apps_pwd

@us_imaging_responsibilities
PROMPT seeding users accounts
@insert_us_ont_accounts
@insert_us_oks_accounts
@insert_us_pa_accounts

COMMIT; 
PROMPT account creation completed

exit

