--***************************************************************************
--
-- File name: gis_eul_us_synonyms.sql
--
-- Purpose: Creates the required synonyms for the Discoverer EUL user.
--
-- History: 28-Mar-01 Patrick Low - Initial version
--          29-Mar-01 Patrick Low - Added gis_scanners, gis_scan_users
--          30-Mar-01 Patrick Low - Added fnd_profile pkg
--          04-Apr-01 Patrick Low - Added hr_operating_units
--          13-Jun-01 Patrick Low - Added fnd tables and per_business_groups
--          20-Jun-01 Patrick Low - Added fnd_documents, fnd_document_datatypes
--
--***************************************************************************

/***************************/
/* Run as eul_imaging user */
/***************************/
connect &&eul_usr/&&eul_pwd

drop synonym GIS_METRICS_REPORT_V;
create synonym GIS_METRICS_REPORT_V for &&apps_usr..GIS_METRICS_REPORT_V;
drop synonym GIS_SCANNERS;
create synonym GIS_SCANNERS for &&apps_usr..GIS_SCANNERS;
drop synonym GIS_SCAN_USERS;
create synonym GIS_SCAN_USERS for &&apps_usr..GIS_SCAN_USERS;
drop synonym FND_PROFILE;
create synonym FND_PROFILE for &&apps_usr..FND_PROFILE;
drop synonym HR_OPERATING_UNITS;
create synonym HR_OPERATING_UNITS for &&apps_usr..HR_OPERATING_UNITS;
drop synonym FND_APPLICATION_TL;
create synonym FND_APPLICATION_TL for &&apps_usr..FND_APPLICATION_TL;
drop synonym FND_DESCR_FLEX_CONTEXTS_TL;
create synonym FND_DESCR_FLEX_CONTEXTS_TL for &&apps_usr..FND_DESCR_FLEX_CONTEXTS_TL;
drop synonym FND_USER_RESP_GROUPS;
create synonym FND_USER_RESP_GROUPS for &&apps_usr..FND_USER_RESP_GROUPS;
drop synonym FND_RESPONSIBILITY_VL;
create synonym FND_RESPONSIBILITY_VL for &&apps_usr..FND_RESPONSIBILITY_VL;
drop synonym FND_USER;
create synonym FND_USER for &&apps_usr..FND_USER;
drop synonym FND_PROFILE_OPTION_VALUES;
create synonym FND_PROFILE_OPTION_VALUES for &&apps_usr..FND_PROFILE_OPTION_VALUES;
drop synonym FND_PROFILE_OPTIONS;
create synonym FND_PROFILE_OPTIONS for &&apps_usr..FND_PROFILE_OPTIONS;
drop synonym FND_RESPONSIBILITY_TL;
create synonym FND_RESPONSIBILITY_TL for &&apps_usr..FND_RESPONSIBILITY_TL;
drop synonym FND_DESCR_FLEX_CONTEXTS_VL;
create synonym FND_DESCR_FLEX_CONTEXTS_VL for &&apps_usr..FND_DESCR_FLEX_CONTEXTS_VL;
drop synonym FND_DOCUMENTS_TL;
create synonym FND_DOCUMENTS_TL for &&apps_usr..FND_DOCUMENTS_TL;
drop synonym FND_DOCUMENTS_TL_DFV;
create synonym FND_DOCUMENTS_TL_DFV for &&apps_usr..FND_DOCUMENTS_TL_DFV;
drop synonym FND_DOCUMENTS_SHORT_TEXT;
create synonym FND_DOCUMENTS_SHORT_TEXT for &&apps_usr..FND_DOCUMENTS_SHORT_TEXT;
drop synonym FND_LOBS;
create synonym FND_LOBS for &&apps_usr..FND_LOBS;
drop synonym PER_BUSINESS_GROUPS;
create synonym PER_BUSINESS_GROUPS for &&apps_usr..PER_BUSINESS_GROUPS;
drop synonym FND_DOCUMENTS;
create synonym FND_DOCUMENTS for &&apps_usr..FND_DOCUMENTS;
drop synonym FND_DOCUMENT_DATATYPES;
create synonym FND_DOCUMENT_DATATYPES for &&apps_usr..FND_DOCUMENT_DATATYPES;
drop synonym GIS_SCANNERS;
create synonym GIS_SCANNERS for &&apps_usr..GIS_SCANNERS;
drop synonym GIS_SCAN_USERS;
create synonym GIS_SCAN_USERS for &&apps_usr..GIS_SCAN_USERS;
/

