-- ============================================================================
--
--   NAME
--      gis_doc_tables_2.sql
--
--   DESCRIPTION
--      Script to add table for auditing deletions
--
--   HISTORY
--      04/07/2001 Patrick Low Original version
--
-- ============================================================================

-- run in imaging schema

CONNECT &img_usr/&img_pwd;

WHENEVER SQLERROR CONTINUE

/* Create gis_error_log_all table */
DROP TABLE imaging.gis_deletion_log;
CREATE TABLE imaging.gis_deletion_log
(file_id                   number         not null,
 creation_date             date           not null,
 created_by                number(15)     not null,
 last_update_date          date           not null,
 last_updated_by           number(15)     not null,
 last_update_login         number(15)             ,
 file_name                 varchar2(256)          ,
 upload_date               date           not null,
 program_name              varchar2(32)           ,
 program_tag               varchar2(32)           ,
 document_id               number         not null,
 primary_document_id       varchar2(150)          ,
 category_id               number         not null,
 doc_attribute_category    varchar2(30)           ,
 description               varchar2(255)          ,
 entity_name               varchar2(40)           ,
 pk1_value                 varchar2(100)
)
TABLESPACE &table_t
STORAGE (initial 500K next 250K pctincrease 0 maxextents 200);

COMMIT;
/
