-- ============================================================================
--
--   NAME
--      gis_views.sql
--
--   DESCRIPTION
--      Script to create views required for GIS 
--
--   HISTORY
--      07/11/2000 David Gough Original version
--
-- ============================================================================

/*****************************/
/* Run as imaging user          */
/*****************************/
connect &&img_usr/&&img_pwd
/* Create gis_interface view */

CREATE OR replace VIEW imaging.gis_interface
AS
SELECT *
FROM   imaging.gis_interface_all gia
WHERE  nvl(gia.org_id,nvl(TO_NUMBER(DECODE
       (substr(userenv('client_info'),1,1)
       ,'',NULL,substr(userenv('client_info'),1,10))),-99))
       = nvl(TO_NUMBER(DECODE(substr
       (userenv('client_info'),1,1),''
       ,NULL,substr(userenv('client_info'),1,10))),-99);

/* Create gis_error_log view */

CREATE OR replace VIEW imaging.gis_error_log
AS
SELECT *
FROM   imaging.gis_error_log_all gela
WHERE  nvl(gela.org_id,nvl(TO_NUMBER(DECODE
       (substr(userenv('client_info'),1,1)
       ,'',NULL,substr(userenv('client_info'),1,10))),-99))
       = nvl(TO_NUMBER(DECODE(substr
       (userenv('client_info'),1,1),''
       ,NULL,substr(userenv('client_info'),1,10))),-99);

/* Create gis_event_log view */

CREATE OR replace VIEW imaging.gis_event_log
AS
SELECT *
FROM   imaging.gis_event_log_all gela
WHERE  nvl(gela.org_id,nvl(TO_NUMBER(DECODE
       (substr(userenv('client_info'),1,1)
       ,'',NULL,substr(userenv('client_info'),1,10))),-99))
       = nvl(TO_NUMBER(DECODE(substr
       (userenv('client_info'),1,1),''
       ,NULL,substr(userenv('client_info'),1,10))),-99);

COMMIT;
/