CREATE OR REPLACE
PACKAGE BODY apps.gis_preindex IS

PROCEDURE delete_image(p_user_id      NUMBER,
                       p_def_context  VARCHAR2,
                       p_context      VARCHAR2,
                       p_refresh_rate NUMBER,
                       p_file_id      NUMBER,
                       p_def_org      NUMBER DEFAULT NULL) IS
BEGIN
  gis_image_util.pageopen(p_heading => 'Delete Image');
  gis_image_util.InfoHeader('Delete Image');
  -- Generate Javascript to refresh the queue when image is deleted
  htp.p('<SCRIPT language="JavaScript">
<!--BEGIN Script
var listURL = ""
function refreshList()
{
  listURL = "gis_preindex.list_unprocessed?p_user_id=' || p_user_id || '&p_def_context=' || p_def_context || '&p_context=' || p_def_context || '&p_refresh_rate=' || p_refresh_rate || '&p_def_org=' || p_def_org || '"
  viewimage(listURL, ''gis_image_util.BlankFrame'', ''gis_image_util.ViewingFrame'')
}
//-->
</SCRIPT>');
  htp.p('<BR>');  
  htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');  
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  IF gis_image_util.delete_image(p_user_id, p_file_id, NULL, 'Y', 'D') THEN
    htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Image Deleted Successfully</SPAN></TD>');
  ELSE
    htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">ERROR - Could Not Delete Image</SPAN></TD>');
  END IF;
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="98%" ALIGN="CENTER"><A HREF="javascript:refreshList()" onMouseOver="window.status=''OK''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok_m.gif" BORDER="0" ALT="OK"></A></TD>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  htp.p('</TABLE>');
  gis_image_util.pageclose;
END;

PROCEDURE preindex_message (v_hdr     VARCHAR2,
                            v_msg     VARCHAR2,
                            v_option  VARCHAR2) IS
BEGIN
  -- Output message
  gis_image_util.pageopen(p_heading => v_hdr);
  gis_image_util.InfoHeader(v_hdr);
  htp.p('<FORM>');
  htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');          
  htp.p('  <TR>' );
  htp.p('    <TD ALIGN="RIGHT"><IMG SRC="' || C_IMG_URL || 'i_stop.gif"></TD>');
  htp.p('    <TD ALIGN="CENTER"><SPAN CLASS="mediumfont">' || v_msg || '</SPAN></TD>');
  htp.p('  </TR>' );
  htp.p('</TABLE>');
  htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
  htp.p('  <TR>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  IF v_option = 'C' THEN
    -- Close window as we are in a seperate window
    htp.p('  <TR>');
    htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('    <TD WIDTH="98%" ALIGN="CENTER"><A HREF="javascript:window.close()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TD>');  
    htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>');
  ELSIF v_option = 'B' THEN
    -- Go back as we are in the same frame
    htp.p('  <TR>');
    htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('    <TD WIDTH="98%" ALIGN="CENTER"><A HREF="javascript:window.back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TD>');  
    htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>');
  END IF;
  htp.p('</TABLE>');
  htp.p('</FORM>');
  gis_image_util.pageclose;
END preindex_message;

PROCEDURE confirm_gtn(p_gtn      VARCHAR2 DEFAULT '-1',
                      p_file_id  NUMBER,
                      p_context  VARCHAR2 DEFAULT 'Order Management') IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_GTN      VARCHAR2(100) := NULL;
  v_OENum    VARCHAR2(100) := NULL;
  v_CustName VARCHAR2(100) := NULL;
  v_CustNum  VARCHAR2(100) := NULL;
  v_LicVal   VARCHAR2(100) := NULL;
  v_OEVal    VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;
  v_OEType   VARCHAR2(100) := NULL;
  nOrdVal    NUMBER := 0;
  nLicVal    NUMBER := 0;
  CURSOR cCheckGTN IS
    SELECT v.global_tracking_number gtn, s.order_number, c.customer_name, c.customer_number,
           t.name, t.order_type_id, s.header_id
    FROM   oe_order_headers_all s, oe_order_headers_all_dfv v, ra_customers c, so_order_types_all t
    WHERE  v.global_tracking_number = p_gtn
    AND    s.rowid = v.rowid
    AND    s.sold_to_org_id = c.customer_id
    AND    s.order_type_id = t.order_type_id
    AND    s.org_id =
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id);
BEGIN
  IF INSTR(p_gtn, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_gtn != '-1' THEN
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'GTN' THEN
        v_GTN := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'OE Number' THEN
        v_OENum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Customer Name' THEN
        v_CustName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Customer Number' THEN
        v_CustNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning LIKE 'Lic%Value' THEN
        v_LicVal := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Order Value' THEN
        v_OEVal := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Order Type' THEN
        v_OEType := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - GTN Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Confirm Order Details For GTN ' || p_gtn);
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_GTN, p_OENum, p_CustName, p_CustNum, p_OrdVal, p_LicVal, p_OrdType)
{
  var n_loop = 1
  var v_OK = "Y"
  
  opener.document.preindex_info.' || v_GTN || '.value = p_GTN;
  opener.document.preindex_info.' || v_OENum || '.value = p_OENum;
  opener.document.preindex_info.' || v_CustName || '.value = p_CustName;
  opener.document.preindex_info.' || v_CustNum || '.value = p_CustNum;
  opener.document.preindex_info.' || v_OEVal || '.value = p_OrdVal;
  opener.document.preindex_info.' || v_LicVal || '.value = p_LicVal;
  if (p_OrdType != "")
  {
    while (v_OK = "Y")
    {
      if (opener.document.preindex_info.' || v_OEType || '.options[n_loop].value == p_OrdType)
      {
        v_OK = "N"
        opener.document.preindex_info.' || v_OEType || '.options[n_loop].selected = true
        break
      }
      n_loop = n_loop + 1
    }
  }
  if (p_OENum !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_OENum || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    FOR s IN cCheckGTN
       LOOP
      -- Get Order value
      SELECT SUM(ordered_quantity * unit_selling_price)
      INTO   nOrdVal
      FROM   oe_order_lines_all
      WHERE  header_id = s.header_id;
      -- Get License value
      SELECT SUM(ordered_quantity * unit_selling_price)
      INTO   nLicVal
      FROM   oe_order_lines_all
      WHERE  header_id = s.header_id
      AND    item_type_code != 'SERVICE';
      /* Show data for GTN */
      htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
      htp.p('  <TR>');
      htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">GTN </SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || s.gtn || '</SPAN></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">OE Number </SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || s.order_number || '</SPAN></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Name </SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || s.customer_name || '</SPAN></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Number </SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || s.customer_number || '</SPAN></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
      htp.p('<BR>');
      htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="50%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="50%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
--      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || s.gtn || ''',' || '''' || s.order_number || ''',' || '''' || s.customer_name || ''',' || '''' || s.customer_number || '''' || ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok_l.gif" BORDER="0" ALT="Correct" ALIGN="TOP"></A></TD>');
--      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || '''' || ')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_r.gif" BORDER="0" ALT="Incorrect" ALIGN="TOP"></A></TD>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || s.gtn || ''',' || '''' || s.order_number || ''',' || '''' || REPLACE(s.customer_name, '''', '\''') || ''',' || '''' || s.customer_number || ''','|| '''' || TO_CHAR(nOrdVal) || ''','|| '''' || TO_CHAR(nLicVal) || ''','|| '''' || s.name || '''' || ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok_l.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || '''' || ')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_r.gif" BORDER="0" ALT="Incorrect"></A></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
    END LOOP;
    htp.p('</FORM>');
	gis_image_util.pageclose;
  ELSE
    /* No GTN specified */
    preindex_message(p_context || ' Search', 'NO GTN ID Specified', 'C');
  END IF;
END confirm_gtn;

PROCEDURE confirm_oe(p_oe       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2 DEFAULT 'Order Management') IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_GTN      VARCHAR2(100) := NULL;
  v_OENum    VARCHAR2(100) := NULL;
  v_CustName VARCHAR2(100) := NULL;
  v_CustNum  VARCHAR2(100) := NULL;
  v_LicVal   VARCHAR2(100) := NULL;
  v_OEVal    VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;
  v_OEType   VARCHAR2(100) := NULL;
  CURSOR cCheckOE IS
    SELECT v.global_tracking_number gtn, s.order_number, c.customer_name, c.customer_number,
           t.name, t.order_type_id, s.header_id
    FROM   oe_order_headers_all s, oe_order_headers_all_dfv v, ra_customers c, so_order_types_all t
    WHERE  s.order_number = TO_NUMBER(p_oe)
    AND    s.rowid = v.rowid
    AND    s.sold_to_org_id = c.customer_id
    AND    s.order_type_id = t.order_type_id
    AND    s.org_id =
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id);
  rCheckOE   cCheckOE%ROWTYPE;
  nOrdVal    NUMBER := 0;
  nLicVal    NUMBER := 0;
BEGIN
  IF INSTR(p_oe, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_oe != '-1' THEN
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'GTN' THEN
        v_GTN := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'OE Number' THEN
        v_OENum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Customer Name' THEN
        v_CustName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Customer Number' THEN
        v_CustNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning LIKE 'Lic%Value' THEN
        v_LicVal := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Order Value' THEN
        v_OEVal := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Order Type' THEN
        v_OEType := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - OE Number Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Confirm Order Details For Order ' || p_oe);
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_GTN, p_OENum, p_CustName, p_CustNum, p_OrdVal, p_LicVal, p_OrdType)
{
  var n_loop = 1
  var v_OK = "Y"
  
  opener.document.preindex_info.' || v_GTN || '.value = p_GTN;
  opener.document.preindex_info.' || v_OENum || '.value = p_OENum;
  opener.document.preindex_info.' || v_CustName || '.value = p_CustName;
  opener.document.preindex_info.' || v_CustNum || '.value = p_CustNum;
  opener.document.preindex_info.' || v_OEVal || '.value = p_OrdVal;
  opener.document.preindex_info.' || v_LicVal || '.value = p_LicVal;
  if (p_OrdType != "")
  {
    while (v_OK = "Y")
    {
      if (opener.document.preindex_info.' || v_OEType || '.options[n_loop].value == p_OrdType)
      {
        v_OK = "N"
        opener.document.preindex_info.' || v_OEType || '.options[n_loop].selected = true
        break
      }
      n_loop = n_loop + 1
    }
  }
  if (p_OENum !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_OENum || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    OPEN cCheckOE;
    FETCH cCheckOE INTO rCheckOE;
    IF cCheckOE%FOUND THEN
      -- Round any totals to 2 decimal places as this will cause the inqury option to fail on a char to number conversion format mask
      -- Get Order value
      SELECT ROUND(NVL(SUM(ordered_quantity * unit_selling_price), 0), 2)
      INTO   nOrdVal
      FROM   oe_order_lines_all
      WHERE  header_id = rCheckOE.header_id;
      -- Get License value
      SELECT ROUND(NVL(SUM(ordered_quantity * unit_selling_price), 0), 2)
      INTO   nLicVal
      FROM   oe_order_lines_all
      WHERE  header_id = rCheckOE.header_id
      AND    item_type_code != 'SERVICE';
      /* Show data for OE number */
      htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Name </SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckOE.customer_name || '</SPAN></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Number </SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckOE.customer_number || '</SPAN></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
      htp.p('<BR>');
      htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="50%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="50%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || rCheckOE.gtn || ''',' || '''' || rCheckOE.order_number || ''',' || '''' || REPLACE(rCheckOE.customer_name, '''', '\''') || ''',' || '''' || rCheckOE.customer_number || ''','|| '''' || TO_CHAR(nOrdVal) || ''','|| '''' || TO_CHAR(nLicVal) || ''','|| '''' || rCheckOE.name || '''' || ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok_l.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || '''' || ')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_r.gif" BORDER="0" ALT="Incorrect"></A></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
    ELSE
      htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');          
      htp.p('  <TR>' );
      -- No order exists
      htp.p('    <TD ALIGN="RIGHT"><IMG SRC="' || C_IMG_URL || 'i_stop.gif"></TD>');
      htp.p('    <TD ALIGN="CENTER"><SPAN CLASS="mediumfont">Order specified does not exist.</SPAN></TD>');
      htp.p('  </TR>' );
      htp.p('</TABLE>');
      htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="98%" ALIGN="CENTER"><A HREF="javascript:window.close()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TD>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
    END IF;
    CLOSE cCheckOE;
    htp.p('</FORM>');
	gis_image_util.pageclose;
  ELSE
    /* No OE Number specified */
    preindex_message(p_context || ' Search', 'NO Order Number Specified', 'C');
  END IF;
END confirm_oe;

PROCEDURE confirm_we(p_we       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2 DEFAULT 'Web Expenses') IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_InvNum   VARCHAR2(100) := NULL;
  v_EmpID    VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;
  CURSOR cCheckWE IS
    SELECT e.invoice_num, e.description, e.total, p.full_name, p.work_telephone, p.person_id
    FROM   ap_expense_report_headers_all e, per_people_f p
    WHERE  e.employee_id = p.person_id
    AND    e.invoice_num = RTRIM(p_we)
    AND    p.effective_end_date >= SYSDATE
    AND    e.org_id =
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id)
    ORDER BY e.report_header_id;
  rCheckWE   cCheckWE%ROWTYPE;
  nResult    NUMBER := 0;
BEGIN
  IF INSTR(p_we, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_we != '-1' THEN
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Expense Report Number' THEN
        v_InvNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Employee ID Number' THEN
        v_EmpID := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - Web Expense Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Confirm Order Details For Expense ' || p_we);
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_InvNum, p_EmpID)
{
  opener.document.preindex_info.' || v_InvNum || '.value = p_InvNum;
  opener.document.preindex_info.' || v_EmpID || '.value = p_EmpID;
  if (p_InvNum !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_InvNum || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    /* Show data for Web Expense */
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Expense Number </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Description </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"></TD>');
    htp.p('  </TR>');
    OPEN cCheckWE;
    LOOP
      FETCH cCheckWE INTO rCheckWE;
      EXIT WHEN cCheckWE%NOTFOUND;
      nResult := nResult + 1;
      htp.p('  <TR>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckWE.invoice_num || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckWE.description || '</SPAN></TD>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || rCheckWE.invoice_num || ''',' || '''' || rCheckWE.person_id || ''''|| ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('  </TR>');
    END LOOP;
    CLOSE cCheckWE;
    IF nResult = 0 THEN
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=3 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No Web Expenses Found</SPAN></TD>');
      htp.p('  </TR>');
    END IF;
    htp.p('</TABLE>');
    htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>');
    htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || NULL || ''',' || '''' || NULL || '''' || ')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.p('</FORM>');
	gis_image_util.pageclose;
  ELSE
    /* No Web Expense specified */
    preindex_message(p_context || ' Search', 'NO Web Expense Number Specified', 'C');
  END IF;
END confirm_we;

PROCEDURE confirm_ks(p_ks1      VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2 DEFAULT 'Contracts') IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_KSNum    VARCHAR2(100) := NULL;
  v_KSMod    VARCHAR2(100) := NULL;
  v_CustName VARCHAR2(100) := NULL;
  v_Desc     VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;
  v_RenewVal VARCHAR2(100) := NULL;
  CURSOR cCheckKS IS
    SELECT h.contract_number, h.contract_number_modifier, c.customer_name, LTRIM(TO_CHAR(h.estimated_amount, '999999999990.00')) estimated_amount
    FROM   okc_rules_b b, okc_k_headers_b h, ra_customers c
    WHERE  h.contract_number = RTRIM(p_ks1)
    AND    b.jtot_object1_code = 'OKX_CUSTACCT'
    AND    c.customer_id = b.object1_id1
    AND    b.dnz_chr_id = h.id
    AND    h.authoring_org_id =
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id)
    ORDER BY  c.customer_name, h.id;
  rCheckKS   cCheckKS%ROWTYPE;
  nResult    NUMBER := 0;
BEGIN
  IF INSTR(p_ks1, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_ks1 != '-1' THEN
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Contracts Number' THEN
        v_KSNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Contracts Modifier' THEN
        v_KSMod := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Customer Name' THEN
        v_CustName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Description' THEN
        v_Desc := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Renewal Value' THEN
        v_RenewVal := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - Contracts Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Confirm Details For Contract Number ' || p_ks1);
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_KSNum, p_KSMod, p_CustName, p_RenewVal)
{
  opener.document.preindex_info.' || v_KSNum || '.value = p_KSNum;
  opener.document.preindex_info.' || v_KSMod || '.value = p_KSMod;
  opener.document.preindex_info.' || v_CustName || '.value = p_CustName;
  opener.document.preindex_info.' || v_RenewVal || '.value = p_RenewVal;
  
  if (p_KSNum !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_CustName || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    -- Output heading
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Contracts Number </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Contracts Modifier </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Name </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Renewal Value </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>');
    OPEN cCheckKS;
    LOOP
      FETCH cCheckKS INTO rCheckKS;
      EXIT WHEN cCheckKS%NOTFOUND;
      nResult := nResult + 1;
      /* Show data for contracts */
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckKS.contract_number || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckKS.contract_number_modifier || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckKS.customer_name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckKS.estimated_amount || '</SPAN></TD>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || rCheckKS.contract_number || ''',' || '''' || rCheckKS.contract_number_modifier || ''',' || '''' || REPLACE(rCheckKS.customer_name, '''', '\''') || ''',' || '''' || rCheckKS.estimated_amount || ''')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('  </TR>');
    END LOOP;
    CLOSE cCheckKS;
    IF nResult = 0 THEN
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=4 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No Contracts Found</SPAN></TD>');
      htp.p('  </TR>');
    END IF;
    htp.p('</TABLE>');
    htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=5 ALIGN="CENTER"><A HREF="javascript:passBack('''','''','''','''')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.p('</FORM>');
    gis_image_util.pageclose;
  ELSE
    /* No contract number specified */
    preindex_message(p_context || ' Search', 'NO Contract Number Specified', 'C');
  END IF;
END confirm_ks;

PROCEDURE confirm_pa(p_pa1      VARCHAR2 DEFAULT '-1',
                     p_pa2      VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2 DEFAULT 'Projects') IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_PAName   VARCHAR2(100) := NULL;
  v_PANum    VARCHAR2(100) := NULL;
  v_CustName VARCHAR2(100) := NULL;
  v_CustNum  VARCHAR2(100) := NULL;
  v_Desc     VARCHAR2(100) := NULL;
  v_ProjVal  VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;
  -- Modified PL  : 17/04/2001
  -- ISIS 1241548 : Modified cursor to have outer join for projects with no funding amounts
  CURSOR cCheckPA IS
    SELECT p.segment1 project_number, p.description, c.customer_name, c.customer_number, pc.project_relationship_code, LTRIM(TO_CHAR(SUM(NVL(pf.total_baselined_amount, 0)), '999999999990.00')) project_value
    FROM   ra_customers c, pa_projects_all p, pa_project_customers pc, pa_summary_project_fundings pf
    WHERE  UPPER(c.customer_name) LIKE UPPER(LTRIM(RTRIM(p_pa2))) || '%'
    AND    c.customer_id = pc.customer_id
    AND    pc.project_id = p.project_id
    AND    pc.project_id = pf.project_id(+)
    AND    p.segment1 = NVL(p_pa1, p.segment1)
    AND    p.org_id =
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id)
    GROUP BY p.segment1, p.description, c.customer_name, c.customer_number, pc.project_relationship_code
    ORDER BY DECODE(pc.project_relationship_code, 'Primary', 1, 'Secondary', 2, 3), c.customer_name;
  rCheckPA   cCheckPA%ROWTYPE;
  nResult    NUMBER := 0;
  bPrimary   BOOLEAN := FALSE;
BEGIN
  IF (INSTR(p_pa1, '%') > 0) OR (INSTR(p_pa2, '%') > 0) THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_pa1 != '-1' OR
        p_pa2 != '-1' THEN
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Project Number' THEN
        v_PANum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Customer Name' THEN
        v_CustName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Customer Number' THEN
        v_CustNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Description' THEN
        v_Desc := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Project Value' THEN
        v_ProjVal := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - Projects Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Confirm Details For Project ' || p_pa1);
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_PANum, p_CustName, p_CustNum, p_ProjVal)
{
  opener.document.preindex_info.' || v_PANum || '.value = p_PANum;
  opener.document.preindex_info.' || v_CustName || '.value = p_CustName;
  opener.document.preindex_info.' || v_CustNum || '.value = p_CustNum;
  opener.document.preindex_info.' || v_ProjVal || '.value = p_ProjVal;
  if (p_PANum !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_CustName || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    -- Modify to optimal SQL cursor and use dbms_sql later
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    -- Output heading
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Project Number </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Description </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Name </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Number </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Relationship </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Project Value </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>');
    OPEN cCheckPA;
    LOOP
      FETCH cCheckPA INTO rCheckPA;
      EXIT WHEN cCheckPA%NOTFOUND;
      -- Set flag if primary customer exists
      IF rCheckPA.project_relationship_code = 'Primary' AND
         NOT bPrimary THEN
        bPrimary := TRUE;
      END IF;
      nResult := nResult + 1;
      /* Show data for project */
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckPA.project_number || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckPA.description || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckPA.customer_name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckPA.customer_number || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckPA.project_relationship_code || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckPA.project_value || '</SPAN></TD>');
      IF (rCheckPA.project_relationship_code = 'Primary') OR
         (rCheckPA.project_relationship_code != 'Primary' AND NOT bPrimary) THEN
        -- Use primary paying customer for preindexing for future searching OR
        -- No primary paying customer - so make all non-primary customers selectable
        htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || rCheckPA.project_number || ''',' || '''' || REPLACE(rCheckPA.customer_name, '''', '\''') || ''',' || '''' || rCheckPA.customer_number || ''',' || '''' || rCheckPA.project_value || ''')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      ELSE
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      END IF;
      htp.p('  </TR>');
    END LOOP;
    CLOSE cCheckPA;
    IF nResult = 0 THEN
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=7 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No Projects Found</SPAN></TD>');
      htp.p('  </TR>');
    END IF;
    htp.p('</TABLE>');
    htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=6 ALIGN="CENTER"><A HREF="javascript:passBack('''','''','''','''')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.p('</FORM>');
    gis_image_util.pageclose;
  ELSE
    /* No project number or customer name specified */
    preindex_message(p_context || ' Search', 'NO Project Number/Customer Name Specified', 'C');
  END IF;
END confirm_pa;

PROCEDURE confirm_sa(p_sa1      VARCHAR2 DEFAULT '-1',
                     p_sa2      VARCHAR2 DEFAULT '-1',
                     p_context  VARCHAR2 DEFAULT 'Agreements') IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = 'Agreements' OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_SAName   VARCHAR2(100) := NULL;
  v_SANum    VARCHAR2(100) := NULL;
  v_CustName VARCHAR2(100) := NULL;
  v_CustNum  VARCHAR2(100) := NULL;
  v_Desc     VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;

  v_SQL      VARCHAR2(5000) := NULL;
  TYPE       cv_type IS REF CURSOR;
  cCheckSA   cv_type;
  c_Name            oe_agreements_tl.name%TYPE;
  c_Agreement_Code  oe_agreements_b.agreement_type_code%TYPE;
  c_Customer_Name   ra_customers.customer_name%TYPE;
  c_Customer_Number ra_customers.customer_number%TYPE;
  c_Agreement_Id    oe_agreements_tl.agreement_id%TYPE;
  
  nResult    NUMBER := 0;
BEGIN
  IF (INSTR(p_sa1, '%') > 0) OR (INSTR(p_sa2, '%') > 0) THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_sa1 != '-1' OR
        p_sa2 != '-1' THEN
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Agreement Name' THEN
        v_SAName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Agreement Code' THEN
        v_SANum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Customer Name' THEN
        v_CustName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Customer Number' THEN
        v_CustNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Description' THEN
        v_Desc := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - Agreement Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Confirm Details For Agreement ' || p_sa1);
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_SAName, p_SANum, p_CustName, p_CustNum)
{
  opener.document.preindex_info.' || v_SAName || '.value = p_SAName;
  opener.document.preindex_info.' || v_SANum || '.value = p_SANum;
  opener.document.preindex_info.' || v_CustName || '.value = p_CustName;
  opener.document.preindex_info.' || v_CustNum || '.value = p_CustNum;
  if (p_SANum !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_SAName || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    -- Output heading
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Agreement Name </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Agreement Code </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Name </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Number </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>');

    -- Build SQL statement dynamically for mulitple variable input
    -- Reduce r-values to actual search values to speed up searching per ISIS 1025123
    -- Ignore customers with customer_id = -1
    v_SQL := 'SELECT t.name, b.agreement_type_code agreement_code, c.customer_name, c.customer_number, t.agreement_id ' ||
             'FROM   ra_customers c, oe_agreements_tl t, oe_agreements_b b ' ||
             'WHERE  c.customer_id = b.sold_to_org_id ' ||
             'AND    c.customer_id != -1 ' ||
             'AND    b.agreement_id = t.agreement_id ';
    IF p_sa2 IS NOT NULL THEN
      v_SQL := v_SQL || 'AND    UPPER(c.customer_name) LIKE ''' || UPPER(LTRIM(RTRIM(p_sa2))) || '%'' ';
    END IF;
    IF p_sa1 IS NOT NULL THEN
      v_SQL := v_SQL || 'AND    t.name LIKE ''' || RTRIM(p_sa1) || '%'' ';
    END IF;

    OPEN cCheckSA FOR v_SQL;
    LOOP
      FETCH cCheckSA INTO c_Name, c_Agreement_Code, c_Customer_Name, c_Customer_Number, c_Agreement_Id;
      EXIT WHEN cCheckSA%NOTFOUND;
      nResult := nResult + 1;
      /* Show data for agreement */
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || c_Name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || c_Agreement_Code || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || c_Customer_Name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || c_Customer_Number || '</SPAN></TD>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || c_Name || ''',' || '''' || c_Agreement_Code || ''',' || '''' || REPLACE(c_Customer_Name, '''', '\''') || ''',' || '''' || c_Customer_Number || ''''|| ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('  </TR>');
    END LOOP;
    CLOSE cCheckSA;
    IF nResult = 0 THEN
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=3 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No Agreements Found</SPAN></TD>');
      htp.p('  </TR>');
    END IF;
    htp.p('</TABLE>');
    htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=5 ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || ''',' || '''' || NULL || '''' || ')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.p('</FORM>');
    gis_image_util.pageclose;
  ELSE
    /* No agreement or customer name specified */
    preindex_message(p_context || ' Search', 'NO Agreement/Customer Name Specified', 'C');
  END IF;
END confirm_sa;

PROCEDURE confirm_rc(p_rc       VARCHAR2 DEFAULT '-1',
                     p_context  VARCHAR2) IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_CustName VARCHAR2(100) := NULL;
  v_CustNum  VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;
-- Modified PL : 17/04/2001
-- Changed query to look at the r11i hz_parties and hz_cust_accounts table for customer names and numbers.
-- Not all customers are assigned in per_business groups - only show flag if present.
  vRCSearch  VARCHAR2(100) := NULL;
-- Amend cursor to get country specific details from site
  CURSOR cCheckRC IS
  SELECT DISTINCT a.account_number customer_number, p.party_name customer_name,
         DECODE(b.organization_id, NULL, b.legislation_code, b.legislation_code || ' - ' || b.short_name) country,
         DECODE(b.organization_id, NULL, NULL, 'f_'|| b.organization_id || '.gif') flag_file         
  FROM   hz_parties p, hz_cust_accounts a, hz_cust_acct_sites_all s, per_business_groups b
  WHERE  UPPER(p.party_name) LIKE UPPER(LTRIM(RTRIM(vRCSearch)))
  AND    p.party_type = 'ORGANIZATION'
  AND    p.party_id = a.party_id
  AND    a.status = 'A'
  AND    a.cust_account_id = s.cust_account_id
  AND    s.org_id = b.organization_id
  AND    s.status = 'A'
  AND    NVL(b.business_group_id, 1) > 0
  ORDER BY p.party_name, a.account_number;
  rCheckRC  cCheckRC%ROWTYPE;
  nResult   NUMBER := 0;
BEGIN
  IF INSTR(p_rc, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_rc != '-1' THEN
    vRCSearch := RTRIM(p_rc) || '%';
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Customer Name' THEN
        v_CustName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Supplier Name' THEN
        v_CustName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Customer Number' THEN
        v_CustNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'License Value' AND
            p_context = 'Order Management' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' AND
            p_context != 'Order Management' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - Customer Name Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Customers Matching ''' || p_rc || '''');
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_CustName, p_CustNum)
{
  opener.document.preindex_info.' || v_CustName || '.value = p_CustName;');
    IF v_CustNum IS NOT NULL THEN
      htp.p('opener.document.preindex_info.' || v_CustNum || '.value = p_CustNum;');
    END IF;
    htp.p('
  if (p_CustName !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_CustName || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Name </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Number</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Country</SPAN></TD>');
    htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"></TD>');
    htp.p('  </TR>');
    OPEN cCheckRC;
    LOOP
      FETCH cCheckRC INTO rCheckRC;
      EXIT WHEN cCheckRC%NOTFOUND;
      nResult := nResult + 1;
      /* Show data for customer name */
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckRC.customer_name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckRC.customer_number || '</SPAN></TD>');
      IF rCheckRC.flag_file IS NOT NULL THEN
        htp.p('    <TD ALIGN="CENTER"><SPAN CLASS="smallfont"><IMG SRC= "' || C_FLAG_URL || rCheckRC.flag_file || '"  ALIGN="CENTRE" ALT="' || rCheckRC.country || '"></A></SPAN></TD>');
      ELSE
        htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckRC.country || '</SPAN></TD>');
      END IF;
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || REPLACE(rCheckRC.customer_name, '''', '\''') || ''',' || '''' || rCheckRC.customer_number || ''''|| ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('  </TR>');
    END LOOP;
    CLOSE cCheckRC;
    IF nResult = 0 THEN
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=4 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No Customers Found</SPAN></TD>');
      htp.p('  </TR>');
    END IF;
    htp.p('</TABLE>');
    htp.p('<BR>');    
    htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=4 ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || NULL || ''',' || '''' || NULL || '''' || ')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.p('</FORM>');
	gis_image_util.pageclose;
  ELSE
    /* No customer name specified */
     preindex_message(p_context || ' Search', 'NO Customer Name Specified', 'C');
  END IF;
END confirm_rc;

PROCEDURE confirm_ar(p_ar       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2) IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_InvNum   VARCHAR2(100) := NULL;
  v_CustName VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;
  vARSearch  VARCHAR2(100) := NULL;
  CURSOR cCheckAR IS
    SELECT c.customer_name customer_name, t.trx_number trx_number
    FROM   ra_customers c, ra_customer_trx_all t
    WHERE  t.trx_number = vARSearch
    AND    t.org_id =
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id)
    AND    t.sold_to_customer_id = c.customer_id
    ORDER BY t.trx_number;
  rCheckAR  cCheckAR%ROWTYPE;
  nResult   NUMBER := 0;
BEGIN
  IF INSTR(p_ar, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_ar != '-1' THEN
    vARSearch := RTRIM(p_ar);
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Customer Name' THEN
        v_CustName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Invoice Number' THEN
        v_InvNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - Receivables Invoice Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Invoice Matching ''' || p_ar || '''');
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_CustName, p_InvNum)
{
  opener.document.preindex_info.' || v_CustName || '.value = p_CustName;
  opener.document.preindex_info.' || v_InvNum || '.value = p_InvNum;');
  htp.p('
  if (p_InvNum !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_InvNum || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Customer Name </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Invoice Number</SPAN></TD>');
    htp.p('  </TR>');
    OPEN cCheckAR;
    LOOP
      FETCH cCheckAR INTO rCheckAR;
      EXIT WHEN cCheckAR%NOTFOUND;
      nResult := nResult + 1;
      /* Show data for customer invoices */
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || REPLACE(rCheckAR.customer_name, '''', '\''') || ''',' || '''' || rCheckAR.trx_number || ''''|| ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckAR.customer_name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckAR.trx_number || '</SPAN></TD>');
      htp.p('  </TR>');
    END LOOP;
    CLOSE cCheckAR;
    IF nResult = 0 THEN
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=3 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No Invoices Found</SPAN></TD>');
      htp.p('  </TR>');
    END IF;
    htp.p('</TABLE>');
    htp.p('<BR>');    
    htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || NULL || ''',' || '''' || NULL || '''' || ')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.p('</FORM>');
	gis_image_util.pageclose;
  ELSE
    /* No invoice number specified */
     preindex_message(p_context || ' Search', 'NO Invoice Number Specified', 'C');
  END IF;
END confirm_ar;

PROCEDURE confirm_ap(p_ap       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2) IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_InvNum   VARCHAR2(100) := NULL;
  v_SuppName VARCHAR2(100) := NULL;
  v_APSearch VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;
  CURSOR cCheckAP IS
    SELECT a.invoice_num, v.vendor_name, a.invoice_amount, a.invoice_date, a.description
    FROM   ap_invoices_all a, po_vendors v
    WHERE  a.invoice_num = v_APSearch
    AND    a.vendor_id = v.vendor_id
    AND    a.org_id =
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id)
    ORDER BY v.vendor_name, a.invoice_num;
  rCheckAP  cCheckAP%ROWTYPE;
  nResult   NUMBER := 0;
BEGIN
  IF INSTR(p_ap, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_ap != '-1' THEN
    v_APSearch := RTRIM(p_ap);
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Invoice Number' THEN
        v_InvNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Supplier Name' THEN
        v_SuppName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - Payables Invoice Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Invoices Matching ''' || p_ap || '''');
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_InvNum, p_SuppName)
{
  opener.document.preindex_info.' || v_InvNum || '.value = p_InvNum;
  opener.document.preindex_info.' || v_SuppName || '.value = p_SuppName;
  if (p_InvNum !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_InvNum || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Invoice Number </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Supplier Name</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Invoice Amount</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Invoice Date</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Description</SPAN></TD>');
    htp.p('  </TR>');
    OPEN cCheckAP;
    LOOP
      FETCH cCheckAP INTO rCheckAP;
      EXIT WHEN cCheckAP%NOTFOUND;
      nResult := nResult + 1;
      /* Show data for invoice number */
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || rCheckAP.invoice_num || ''',' || '''' || REPLACE(rCheckAP.vendor_name, '''', '\''') || ''''|| ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckAP.invoice_num || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckAP.vendor_name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckAP.invoice_amount || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckAP.invoice_date || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckAP.description || '</SPAN></TD>');
      htp.p('  </TR>');
    END LOOP;
    CLOSE cCheckAP;
    IF nResult = 0 THEN
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=6 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No Invoices Found</SPAN></TD>');
      htp.p('  </TR>');
    END IF;
    htp.p('</TABLE>');
    htp.p('<BR>');    
    htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || NULL || ''',' || '''' || NULL || '''' || ')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.p('</FORM>');
	gis_image_util.pageclose;
  ELSE
    /* No invoice number specified */
     preindex_message(p_context || ' Search', 'NO Invoice Number Specified', 'C');
  END IF;
END confirm_ap;

PROCEDURE confirm_ee(p_ee       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2) IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_Title    VARCHAR2(240) := NULL;
  v_Course   VARCHAR2(240) := NULL;
  v_Start    VARCHAR2(240) := NULL;
  v_End      VARCHAR2(240) := NULL;
  v_EESearch VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;
  CURSOR cCheckEE IS
    SELECT e.title, v.version_name, TO_CHAR(e.course_start_date, 'DD-MON-YYYY') course_start_date,
           TO_CHAR(e.course_end_date, 'DD-MON-YYYY') course_end_date, e.centre
    FROM   ota_events e, ota_activity_versions v
    WHERE  e.title = v_EESearch
    AND    e.activity_version_id = v.activity_version_id
    AND    e.organization_id = 
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id);
  rCheckEE  cCheckEE%ROWTYPE;
  nResult   NUMBER := 0;
BEGIN
  IF INSTR(p_ee, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_ee != '-1' THEN
    v_EESearch := LTRIM(RTRIM(p_ee));
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Title' THEN
        v_Title := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Course Name' THEN
        v_Course := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Start Date' THEN
        v_Start := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'End Date' THEN
        v_End := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - Education Event Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Search Results For Course Title ''' || p_ee || '''');
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_Title,p_Course,p_Start,p_End)
{
  opener.document.preindex_info.' || v_Title || '.value = p_Title;
  opener.document.preindex_info.' || v_Course || '.value = p_Course;
  opener.document.preindex_info.' || v_Start || '.value = p_Start;
  opener.document.preindex_info.' || v_End || '.value = p_End;
  if (p_Title !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_Title || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Title</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Course Name</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Start Date</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">End Date</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Location</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont"></SPAN></TD>');
    htp.p('  </TR>');
    htp.p('  <TR>' );
    OPEN cCheckEE;
    FETCH cCheckEE INTO rCheckEe;
    IF cCheckEE%FOUND THEN
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEE.title || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEE.version_name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEE.course_start_date || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEE.course_end_date || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEE.centre || '</SPAN></TD>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || rCheckEE.title || ''',''' || rCheckEE.version_name || ''',''' || rCheckEE.course_start_date || ''',''' || rCheckEE.course_end_date || '''' || ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
    ELSE
      htp.p('    <TD COLSPAN=6 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No Courses Found</SPAN></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
      htp.p('<BR>');    
      htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:passBack('''','''','''','''')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
    END IF;
    htp.p('</FORM>');
	gis_image_util.pageclose;
  ELSE
    /* No course title specified */
     preindex_message(p_context || ' Search', 'NO Course Title Specified', 'C');
  END IF;
END confirm_ee;

PROCEDURE confirm_eb(p_eb       VARCHAR2 DEFAULT '-1',
                     p_file_id  NUMBER,
                     p_context  VARCHAR2) IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count    NUMBER := 0;
  v_Title    VARCHAR2(240) := NULL;
  v_Course   VARCHAR2(240) := NULL;
  v_Delegate VARCHAR2(240) := NULL;  
  v_EnrolNum VARCHAR2(240) := NULL;
  v_EBSearch VARCHAR2(100) := NULL;
  v_Next     VARCHAR2(100) := NULL;
  CURSOR cCheckEB IS
    SELECT e.title, v.version_name, e.course_start_date, e.course_end_date, e.centre,
           DECODE(o.delegate_person_id,
                  NULL, c.last_name || DECODE(c.first_name, NULL, NULL, ', ' || c.first_name),
                  UPPER(p.full_name)) delegate_name,
           o.booking_id
    FROM   ota_delegate_bookings o, ra_contacts c,
           ota_events e, ota_activity_versions v, per_people_f p
    WHERE  e.title = v_EBSearch
    AND    o.contact_id = c.contact_id(+)
    AND    o.delegate_person_id = p.person_id(+)
    AND    NVL(p.effective_start_date, SYSDATE) <= SYSDATE
    AND    NVL(p.effective_end_date, SYSDATE) >= SYSDATE
    AND    o.event_id = e.event_id
    AND    e.activity_version_id = v.activity_version_id
    AND    NOT (o.contact_id IS NULL AND o.delegate_person_id IS NULL)
    AND    e.organization_id = 
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id)
    ORDER BY 6;
  rCheckEB  cCheckEB%ROWTYPE;
  nResult   NUMBER := 0;
BEGIN
  IF INSTR(p_eb, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_eb != '-1' THEN
    v_EBSearch := LTRIM(RTRIM(p_eb));
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Title' THEN
        v_Title := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Course Name' THEN
        v_Course := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Delegate Name' THEN
        v_Delegate := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Enrollment Number' THEN
        v_EnrolNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - Education Booking Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Bookings For Course Title ''' || p_eb || '''');
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_Title,p_Course,p_Delegate,p_EnrolNum)
{
  opener.document.preindex_info.' || v_Title || '.value = p_Title;
  opener.document.preindex_info.' || v_Course || '.value = p_Course;
  opener.document.preindex_info.' || v_Delegate || '.value = p_Delegate;
  opener.document.preindex_info.' || v_EnrolNum || '.value = p_EnrolNum;
  if (p_Title !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_Title || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    OPEN cCheckEB;
    LOOP
      FETCH cCheckEB INTO rCheckEB;
      EXIT WHEN cCheckEB%NOTFOUND;
      nResult := nResult + 1;
      -- Show heading
      IF nResult = 1 THEN
        htp.p('  <TR>' );
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Title</SPAN></TD>');
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Course Name</SPAN></TD>');
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Start Date</SPAN></TD>');
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">End Date</SPAN></TD>');
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Location</SPAN></TD>');
        htp.p('  </TR>');
        htp.p('  <TR>' );
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEB.title || '</SPAN></TD>');
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEB.version_name || '</SPAN></TD>');
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEB.course_start_date || '</SPAN></TD>');
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEB.course_end_date || '</SPAN></TD>');
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEB.centre || '</SPAN></TD>');
        htp.p('  </TR>');
        /* Show delegates for course */
        htp.p('  <TR>' );
        htp.p('    <TD COLSPAN=6 ALIGN="LEFT" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
        htp.p('  </TR>');
        htp.p('  <TR>' );
        htp.p('    <TD COLSPAN=4 ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Delegate Name</SPAN></TD>');
        htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Select</SPAN></TD>');
        htp.p('  </TR>');
      END IF;
      htp.p('  <TR>' );
      htp.p('    <TD COLSPAN=4 ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckEB.delegate_name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || rCheckEB.title || ''',''' || rCheckEB.version_name || ''',''' || REPLACE(rCheckEB.delegate_name, '''', '\''') || ''',''' || rCheckEB.booking_id || '''' || ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('  </TR>');
    END LOOP;
    CLOSE cCheckEB;
    IF nResult = 0 THEN
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=6 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No Delegates Found</SPAN></TD>');
      htp.p('  </TR>');
    END IF;
    htp.p('</TABLE>');
    htp.p('<BR>');    
    htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:passBack('''','''','''','''')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.p('</FORM>');
	gis_image_util.pageclose;
  ELSE
    /* No course title specified */
     preindex_message(p_context || ' Search', 'NO Course Title Specified', 'C');
  END IF;
END confirm_eb;

PROCEDURE confirm_hra(p_hra      VARCHAR2 DEFAULT '-1',
                      p_file_id  NUMBER,
                      p_context  VARCHAR2) IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count     NUMBER := 0;
  v_Name      VARCHAR2(240) := NULL;
  v_Assign    VARCHAR2(240) := NULL;
  v_Super     VARCHAR2(240) := NULL;  
  v_AssignRef VARCHAR2(240) := NULL;
  v_HRASearch VARCHAR2(100) := NULL;
  v_Next      VARCHAR2(100) := NULL;
  CURSOR cCheckHRA IS
    SELECT p.full_name, t.user_person_type || DECODE(av.discretionary_title, NULL, NULL, ' - ' || av.discretionary_title) assignment,
           s.full_name supervisor, a.assignment_id
    FROM   per_all_people_f p, per_person_types t, per_all_assignments_f a, per_all_assignments_f_dfv av, per_all_people_f s
    WHERE  p.full_name LIKE v_HRASearch
    AND    p.effective_start_date <= TRUNC(SYSDATE)
    AND    p.effective_end_date >= TRUNC(SYSDATE+1)
    AND    p.person_type_id = t.person_type_id
    AND    p.person_id = a.person_id
    AND    a.effective_start_date <= TRUNC(SYSDATE)
    AND    a.effective_end_date >= TRUNC(SYSDATE+1)
    AND    a.rowid = av.rowid
    AND    a.supervisor_id = s.person_id
    AND    s.effective_start_date <= TRUNC(SYSDATE)
    AND    s.effective_end_date >= TRUNC(SYSDATE+1)
    AND    p.business_group_id+0 = t.business_group_id+0
    AND    p.business_group_id+0 = a.business_group_id+0
    AND    a.business_group_id+0 = s.business_group_id+0
    AND    p.business_group_id =
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id)
    ORDER BY p.full_name;
  rCheckHRA  cCheckHRA%ROWTYPE;
  nResult   NUMBER := 0;
BEGIN
  IF INSTR(p_hra, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_hra != '-1' THEN
    v_HRASearch := INITCAP(REPLACE(LTRIM(RTRIM(p_hra)), ' ', '%')) || '%';
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Name' THEN
        v_Name := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Assignment' THEN
        v_Assign := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Supervisor' THEN
        v_Super := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Assignment Ref' THEN
        v_AssignRef := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - HR Assignment Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('HR Assignments For ''' || p_hra || '''');
    htp.p('<SCRIPT language="JavaScript">
function passBack(p_Name,p_Assign,p_Super,p_AssignRef)
{
  opener.document.preindex_info.' || v_Name || '.value = p_Name;
  opener.document.preindex_info.' || v_Assign || '.value = p_Assign;
  opener.document.preindex_info.' || v_Super || '.value = p_Super;
  opener.document.preindex_info.' || v_AssignRef || '.value = p_AssignRef;
  if (p_Name !=  "")
  {
    opener.document.preindex_info.' || v_Next || '.focus();
  }
  else
  {
    opener.document.preindex_info.' || v_Name || '.focus();
  }
  close();
}
</SCRIPT>');
    htp.p('<FORM>');
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    -- Show heading
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Name</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Assignment</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Supervisor</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Assignment Ref</SPAN></TD>');
    htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>');
    OPEN cCheckHRA;
    LOOP
      FETCH cCheckHRA INTO rCheckHRA;
      EXIT WHEN cCheckHRA%NOTFOUND;
      nResult := nResult + 1;
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckHRA.full_name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckHRA.assignment || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckHRA.supervisor || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckHRA.assignment_id || '</SPAN></TD>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || REPLACE(rCheckHRA.full_name, '''', '\''') || ''',''' || rCheckHRA.assignment || ''',''' || REPLACE(rCheckHRA.supervisor, '''', '\''') || ''',''' || rCheckHRA.assignment_id || '''' || ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('  </TR>');
    END LOOP;
    CLOSE cCheckHRA;
    IF nResult = 0 THEN
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=5 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No HR Assignments Found</SPAN></TD>');
      htp.p('  </TR>');
    END IF;
    htp.p('</TABLE>');
    htp.p('<BR>');    
    htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:passBack('''','''','''','''')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.p('</FORM>');
	gis_image_util.pageclose;
  ELSE
    /* No surname specified */
     preindex_message(p_context || ' Search', 'NO Surname Specified', 'C');
  END IF;
END confirm_hra;

PROCEDURE confirm_pov(p_pov      VARCHAR2 DEFAULT '-1',
                      p_file_id  NUMBER,
                      p_context  VARCHAR2) IS
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  n_count     NUMBER := 0;
  v_SuppName  VARCHAR2(240) := NULL;
  v_SuppNum   VARCHAR2(240) := NULL;
  v_POVSearch VARCHAR2(240) := NULL;
  v_Next      VARCHAR2(240) := NULL;
  CURSOR cCheckPOV IS
    SELECT p.vendor_name, p.segment1 vendor_number
    FROM   po_vendors p, hr_operating_units u
    WHERE  p.vendor_name LIKE v_POVSearch
    AND    TO_CHAR(p.set_of_books_id) = u.set_of_books_id
    AND    u.organization_id = 
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id)
    ORDER BY p.vendor_name;
  rCheckPOV  cCheckPOV%ROWTYPE;
  nResult    NUMBER := 0;
BEGIN
  IF INSTR(p_pov, '%') > 0 THEN
    -- No wildcard searches allowed
    preindex_message(p_context || ' Search', 'NO Wild Card Searches Allowed', 'C');
  ELSIF p_pov != '-1' THEN
    v_POVSearch := LTRIM(RTRIM(p_pov)) || '%';
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Supplier Name' THEN
        v_SuppName := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Supplier Number' THEN
        v_SuppNum := 'p_val' || TO_CHAR(n_count);
      ELSIF s.meaning = 'Storage Location' THEN
        v_Next := 'p_val' || TO_CHAR(n_count);
      END IF;
    END LOOP;
	gis_image_util.pageopen(p_heading => 'GIS - Supplier Search', p_attrib => 'onLoad="window.focus()" onBlur="window.focus()"');
	gis_image_util.InfoHeader('Suppliers For ''' || p_pov || '''');
	IF p_context = 'Suppliers'
	THEN
    	htp.p('<SCRIPT language="JavaScript">
		function passBack(p_SuppName,p_SuppNum)
		{
		  opener.document.preindex_info.' || v_SuppName || '.value = p_SuppName;
		  opener.document.preindex_info.' || v_SuppNum || '.value = p_SuppNum;
		  if (p_SuppName !=  "")
		  {
		    opener.document.preindex_info.' || v_Next || '.focus();
		  }
		  else
		  {
		    opener.document.preindex_info.' || v_SuppName || '.focus();
		  }
		  close();
		}
		</SCRIPT>');
	ELSE
    	htp.p('<SCRIPT language="JavaScript">
		function passBack(p_SuppName,p_SuppNum)
		{
		  opener.document.preindex_info.' || v_SuppName || '.value = p_SuppName;
		  if (p_SuppName !=  "")
		  {
		    opener.document.preindex_info.' || v_Next || '.focus();
		  }
		  else
		  {
		    opener.document.preindex_info.' || v_SuppName || '.focus();
		  }
		  close();
		}
		</SCRIPT>');
	END IF;	
    htp.p('<FORM>');
    htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
    -- Show heading
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Supplier Name</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Supplier Number</SPAN></TD>');
    htp.p('    <TD ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>');
    OPEN cCheckPOV;
    LOOP
      FETCH cCheckPOV INTO rCheckPOV;
      EXIT WHEN cCheckPOV%NOTFOUND;
      nResult := nResult + 1;
      htp.p('  <TR>' );
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckPOV.vendor_name || '</SPAN></TD>');
      htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || rCheckPOV.vendor_number || '</SPAN></TD>');
      htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:passBack(' || '''' || REPLACE(rCheckPOV.vendor_name, '''', '\''') || ''',''' || rCheckPOV.vendor_number || '''' || ')" onMouseOver="window.status=''Correct''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok.gif" BORDER="0" ALT="Correct"></A></TD>');
      htp.p('  </TR>');
    END LOOP;
    CLOSE cCheckPOV;
    IF nResult = 0 THEN
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=3 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">No Suppliers Found</SPAN></TD>');
      htp.p('  </TR>');
    END IF;
    htp.p('</TABLE>');
    htp.p('<BR>');    
    htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:passBack('''','''')" onMouseOver="window.status=''Incorrect''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Incorrect"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.p('</FORM>');
	gis_image_util.pageclose;
  ELSE
    /* No supplier specified */
     preindex_message(p_context || ' Search', 'NO Supplier Specified', 'C');
  END IF;
EXCEPTION
  WHEN OTHERS THEN
    gis_image_util.InfoHeader('Error Details');
    htp.br;
    htp.p(SQLERRM);
    htp.br;
    gis_image_util.pageclose;		
END confirm_pov;

FUNCTION find_col_name(p_context VARCHAR2,
                       p_meaning VARCHAR2) RETURN VARCHAR2 IS
  CURSOR cDocColName IS
    SELECT application_column_name id
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    descriptive_flex_context_code = p_context
    AND    end_user_column_name = p_meaning;
  vColName VARCHAR2(240);
BEGIN
  FOR s IN cDocColName LOOP
    vColName := s.id;
  END LOOP;
  RETURN (vColName);
END find_col_name;

PROCEDURE list_doc_types(p_user_id  NUMBER) IS
  CURSOR cur_docContext IS
    SELECT 1, 'All' descriptive_flex_context_code, 'All' description
    FROM   dual
    UNION
    SELECT 2, con.descriptive_flex_context_code, description
    FROM   FND_DESCR_FLEX_CONTEXTS_VL con
    WHERE  con.descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX'
    AND    descriptive_flex_context_code != 'Global Data Elements'
    AND    enabled_flag = 'Y'
    ORDER BY 1, description;
  row_docContext cur_docContext%ROWTYPE;
  CURSOR cCountOrg IS
    SELECT COUNT(*) orgs
    FROM   hr_operating_units org
    WHERE  org.organization_id IN
      (SELECT scan.organization_id
       FROM   gis_scanners scan, gis_scan_users su
       WHERE  su.fnd_user_id = p_user_id
       AND    su.scanner_id = scan.scanner_id);
  nOrg   NUMBER := 0;
  CURSOR cShowOrg IS    
  SELECT   DISTINCT org.name, scan.organization_id
    FROM   gis_scanners scan, gis_scan_users su, hr_operating_units org
    WHERE  su.fnd_user_id = p_user_id
    AND    su.scanner_id = scan.scanner_id
    AND    scan.organization_id = org.organization_id;
  rShowOrg cShowOrg%ROWTYPE;
BEGIN
  gis_image_util.pageopen(p_heading => 'Document Search');
  gis_image_util.InfoHeader( 'Select LOB Defaults');
  htp.p('<SCRIPT language="JavaScript">
<!--BEGIN Script
var listURL = ""
function showList(p_def_context, p_refresh_rate, p_def_org)
{
  listURL = "gis_preindex.list_unprocessed?p_user_id=' || p_user_id || '&p_def_context=" + p_def_context.replace(" ","+") + "&p_context=" + p_def_context.replace(" ","+") + "&p_refresh_rate=" + p_refresh_rate + "&p_def_org=" + p_def_org
  viewimage(listURL, '''', '''')
}
//-->
</SCRIPT>');
  htp.formOpen('gis_preindex.list_unprocessed', 'POST',cattributes=>'NAME="list_doc_types"');
  htp.p('<TABLE WIDTH="98%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
  OPEN cCountOrg;
  FETCH cCountOrg INTO nOrg;
  IF cCountOrg%FOUND AND
     nOrg > 1 THEN
    -- User has access to more than one org scanner - show list to default to
    htp.p('  <TR>');
    htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Default Scanner Org</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">');
    -- Show orgs
    htp.formSelectOpen(cname=>'p_def_org',nsize=>'1');	
    -- Put 'All' selection at top of list
    htp.formSelectOption('All', CATTRIBUTES=>'value="0"');
    OPEN cShowOrg;
    LOOP
      FETCH cShowOrg INTO rShowOrg;
      EXIT WHEN cShowOrg%NOTFOUND;
      htp.formSelectOption(rShowOrg.name, CATTRIBUTES=>'value="' ||	rShowOrg.organization_id || '"');
    END LOOP;
    CLOSE cShowOrg;
    htp.formSelectClose;
    htp.p('    </SPAN></TD>');
    htp.p('  </TR>');
-- DG added to catch users not assigned to a scanner
  ELSIF nOrg = 0 THEN
    htp.p('  <TR>');
    htp.p('    <TD ROWSPAN=2 ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">You have not been assigned to a scanner queue. Contact your system admistrator.</SPAN></TD>');
    htp.p('  </TR>');
  ELSE
    -- Assign default org to hidden parameter
    OPEN cShowOrg;
    FETCH cShowOrg INTO rShowOrg;
    htp.formHidden('p_def_org', TO_CHAR(rShowOrg.organization_id));
    CLOSE cShowOrg;
  END IF;
  CLOSE cCountOrg;
  htp.p('  <TR>');
  IF nOrg >= 1 THEN
    htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Line Of Business</SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">');
    -- Show document categories
    htp.formSelectOpen(cname=>'p_context',nsize=>'1');	
    IF NOT cur_docContext%ISOPEN THEN
      OPEN cur_docContext;
    END IF;
    FETCH cur_docContext INTO row_docContext;
    IF cur_docContext%NOTFOUND THEN
      htp.formSelectOption('ERROR','SELECTED',cattributes=>'VALUE="0"' );
      -- put some sort of error message in here
    ELSE
      WHILE cur_docContext%FOUND LOOP	
        htp.formSelectOption(row_docContext.description, CATTRIBUTES=>'value="' ||	
                             row_docContext.descriptive_flex_context_code || '"');
        FETCH cur_docContext INTO row_docContext;
      END LOOP;
    END IF;
    CLOSE cur_docContext;
    htp.formSelectClose;
    htp.p('    </SPAN></TD>');
    htp.p('  </TR>');
    htp.p('  <TR>');
    htp.p('    <TD ALIGN="RIGHT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Refresh Rate </SPAN></TD>');
    htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">');
    -- Show refresh rate option
    htp.formSelectOpen(cname=>'p_refresh_rate',nsize=>'1');	
    -- Javascript: 60000 millisecs = 60 sec
    htp.formSelectOption('Refresh every 5 min', CATTRIBUTES=>'value="300000"');
    htp.formSelectOption('Refresh every 10 min', CATTRIBUTES=>'value="600000"');
    htp.formSelectOption('Refresh every 15 min', CATTRIBUTES=>'value="900000"');
    htp.formSelectOption('Refresh every 20 min', CATTRIBUTES=>'value="1200000"');
    htp.formSelectOption('Refresh every 30 min', CATTRIBUTES=>'value="1800000"');
    htp.formSelectClose;
    htp.p('    </SPAN></TD>');
    htp.p('  </TR>');
  END IF;
  htp.p('</TABLE>');
  htp.p('<BR>');
  htp.p('<TABLE WIDTH="98%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
  htp.p('  <TR>');
  IF nOrg > 1 THEN
    -- User has access to more than org, select from LOV
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="JavaScript:showList(document.list_doc_types.p_context.options[document.list_doc_types.p_context.selectedIndex].value,document.list_doc_types.p_refresh_rate.options[document.list_doc_types.p_refresh_rate.selectedIndex].value,document.list_doc_types.p_def_org.options[document.list_doc_types.p_def_org.selectedIndex].value)" onMouseOver="window.status=''Next''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_next.gif" BORDER="0" ALT="Next"></A></TD>');
  ELSIF nOrg = 1 THEN
    -- User has access to one org ONLY
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="JavaScript:showList(document.list_doc_types.p_context.options[document.list_doc_types.p_context.selectedIndex].value,document.list_doc_types.p_refresh_rate.options[document.list_doc_types.p_refresh_rate.selectedIndex].value,document.list_doc_types.p_def_org.value)" onMouseOver="window.status=''Next''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_next.gif" BORDER="0" ALT="Next"></A></TD>');
  ELSE
    -- User does not have access to any org
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="Javascript:parent.window.close()" onMouseOver="window.status=''Cancel''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_cancel_m.gif" BORDER="0" ALT="Cancel"></A></TD>');
  END IF;
  htp.p('  </TR>');
  htp.p('</TABLE>');
  htp.formclose;
  gis_image_util.pageclose;
END list_doc_types;
  
PROCEDURE list_unprocessed(p_user_id      NUMBER,
                           p_def_context  VARCHAR2,
                           p_context      VARCHAR2,
                           p_refresh_rate NUMBER,
                           p_def_org      NUMBER DEFAULT NULL) IS
  -- Must show SCANNED/REJECTED/REPROCESS records in queue for the user managing the scanner OR
  -- for an administrator, we can show all SCANNED/REJECTED/REPROCESS records in queue
  nSearchOrg  NUMBER := NULL;

  vSQL        VARCHAR2(10000) := NULL;
  TYPE        cv_type IS REF CURSOR;
  cUnprocDocs cv_type;
  c_Name      VARCHAR2(500);
  c_File_Id   fnd_lobs.file_id%TYPE;
  c_Scan_date fnd_lobs.upload_date%TYPE;
  c_Status    fnd_documents_tl.doc_attribute6%TYPE;
  c_Flag_File VARCHAR2(240);
  c_Context   fnd_documents_tl.doc_attribute_category%TYPE;
  cImageURL    VARCHAR2(1000);
BEGIN
  IF p_def_org = 0 THEN
    nSearchOrg := NULL;
  ELSE
    nSearchOrg := p_def_org;
  END IF;
  gis_image_util.pageopen(p_heading => 'PreIndex Document', p_attrib => 'onLoad="reloadFrame(' || TO_CHAR(p_refresh_rate) || ')"');
  htp.p('<FORM NAME="List">');
  gis_image_util.InfoHeader(p_heading => 'Documents To PreIndex On ' || TO_CHAR(SYSDATE, C_DATE_FORMAT_EN));
  htp.p('<SCRIPT language="JavaScript">
<!--BEGIN Script
function confirmDelete(p_user_id, p_def_context, p_def_context, p_refresh_rate, p_file_id, p_def_org)
{
  var newURL
  var returnValue = confirm("Are you sure you want to delete this image ?");

  if (returnValue)
  {
    newURL = "gis_preindex.delete_image?p_user_id=" + p_user_id + "&p_def_context=" + p_def_context.replace(" ","+") + "&p_context=" + p_def_context.replace(" ","+") + "&p_refresh_rate=" + p_refresh_rate + "&p_file_id=" + p_file_id + "&p_def_org=" + p_def_org
    viewimage('''',newURL,'''')    
  }
}
//-->
</SCRIPT>');
  htp.formHidden('p_user_id', TO_CHAR(p_user_id));
  htp.formHidden('p_def_context', p_def_context);
  htp.formHidden('p_context', p_context);
  htp.formHidden('p_refresh_rate', TO_CHAR(p_refresh_rate));
  htp.formHidden('p_def_org', TO_CHAR(p_def_org));
  htp.p('<TABLE WIDTH="100%" BORDER="1" ALIGN="LEFT" CELLSPACING="0" CELLPADDING="1">');
  htp.p('  <TR>');
  htp.p('    <TD ALIGN="LEFT" VALIGN="CENTER"><SPAN CLASS="smallfont"><B>Org</B></SPAN></TD>');
  htp.p('    <TD ALIGN="LEFT" VALIGN="CENTER"><SPAN CLASS="smallfont"><B>Image</B></SPAN></TD>');
  htp.p('    <TD ALIGN="LEFT" VALIGN="CENTER"><SPAN CLASS="smallfont"><B>Status</B></SPAN></TD>');
  htp.p('    <TD ALIGN="LEFT" VALIGN="CENTER"><SPAN CLASS="smallfont"><B>Scan Date</B></SPAN></TD>');
  htp.p('    <TD ALIGN="LEFT" VALIGN="CENTER"><SPAN CLASS="smallfont"><B>Delete</B></SPAN></TD>');
  htp.p('  </TR>');

  -- Setup SQL for base query
  vSQL := 'SELECT org.name || '': '' || scan.description name, lob.file_id, lob.upload_date scan_date, doc.doc_attribute6 status, ' ||
          '''f_''|| scan.organization_id || ''.gif'' flag_file, doc.doc_attribute_category context ' ||
          'FROM   fnd_documents_tl doc, fnd_documents_tl_dfv v, gis_scanners scan, gis_scan_users su, ' ||
          'fnd_lobs lob, fnd_user usr, hr_operating_units org, fnd_documents d ' ||
          'WHERE  su.fnd_user_id = ' || p_user_id || ' ' ||
          'AND    su.scanner_id = scan.scanner_id ' ||
          'AND    scan.organization_id = org.organization_id ' ||
          'AND    lob.file_name LIKE scan.scanner_id || ''%'' ' ||
          'AND    lob.program_tag = scan.scanner_id ' ||
          'AND    lob.program_name = ''GIS'' ' ||
          'AND    lob.file_id = doc.media_id ' ||
          'AND    doc.doc_attribute6 IN (''SCANNED'', ''REJECTED'', ''REPROCESS'') ' ||
          'AND    doc.rowid = v.rowid ' ||
          'AND    v.primary_document_id = ''Y'' ' ||
          'AND    usr.user_id = doc.created_by ';
  IF nSearchOrg IS NOT NULL THEN
    vSQL := vSQL || 'AND    scan.organization_id = ' || nSearchOrg || ' ';
  END IF;
  vSQL := vSQL ||
          'AND    doc.document_id = d.document_id ' ||
          'AND    d.datatype_id = ' ||
          '(SELECT datatype_id ' ||
          'FROM   fnd_document_datatypes ' ||
          'WHERE  name = ''FILE'' ' ||
          'AND    NVL(start_date_active, SYSDATE) <= SYSDATE ' ||
          'AND    NVL(end_date_active, SYSDATE) >= SYSDATE) ' ||
          'ORDER BY DECODE(doc.doc_attribute6, ''REJECTED'', 1, ''REPROCESS'', 2, 3), lob.upload_date ';
    --      htp.p(vSQL);
  OPEN cUnprocDocs FOR vSQL;
  LOOP
    FETCH cUnprocDocs INTO c_Name, c_File_Id, c_Scan_date, c_Status, c_Flag_File, c_Context;
    EXIT WHEN cUnprocDocs%NOTFOUND;
    -- get the access code and url to view the image through fnd_gfm
    cImageURL := fnd_gfm.construct_download_url(C_APP_URL, c_File_Id);
    htp.p('  <TR>');	
    htp.p('    <TD ALIGN="CENTER"><SPAN CLASS="smallfont"><IMG SRC= "' || C_FLAG_URL || c_Flag_File || '"  ALIGN="CENTRE" ALT="' || c_Name || '"></A></SPAN></TD>');
    IF c_Status IN ('REJECTED', 'REPROCESS') THEN
      IF c_Context IS NOT NULL THEN
        /* Been rejected - show fields for same context */
        htp.p('    <TD><A HREF="JavaScript:viewimage('''',''' || C_APP_URL || 'gis_preindex.show_doc_types?p_user_id=' || TO_CHAR(p_user_id) || '&p_def_context=' || REPLACE(p_def_context, ' ', '+') || '&p_context=' || REPLACE(c_Context, ' ' , '+') || '&p_refresh_rate=' || TO_CHAR(p_refresh_rate) || '&p_file_id=' || TO_CHAR(c_File_Id) || '&p_def_org=' || p_def_org || ''', ''' || cImageURL || ''')"><SPAN CLASS="smallfont"><FONT COLOR="#FFCC00">'|| c_File_Id ||'</FONT></SPAN></A></TD>');
      ELSE
        /* New document - must select context if default is not chosen */
        htp.p('    <TD><A HREF="JavaScript:viewimage('''',''' || C_APP_URL || 'gis_preindex.show_doc_types?p_user_id=' || TO_CHAR(p_user_id) || '&p_def_context=' || REPLACE(p_def_context, ' ', '+') || '&p_context=' || REPLACE(p_context, ' ', '+') || '&p_refresh_rate=' || TO_CHAR(p_refresh_rate) || '&p_file_id=' || TO_CHAR(c_File_Id) || '&p_def_org=' || p_def_org || ''', ''' || cImageURL || ''')"><SPAN CLASS="smallfont"><FONT COLOR="#FFCC00">'|| c_File_Id ||'</FONT></SPAN></A></TD>');
      END IF;
      htp.p('    <TD><SPAN CLASS="smallfont"><FONT COLOR="#FFCC00">' || c_Status || '</FONT></SPAN></A></TD>');
    ELSE
      htp.p('    <TD><A HREF="JavaScript:viewimage('''',''' || C_APP_URL || 'gis_preindex.show_doc_types?p_user_id=' || TO_CHAR(p_user_id) || '&p_def_context=' || REPLACE(p_def_context, ' ', '+') || '&p_context=' || REPLACE(p_context, ' ', '+') || '&p_refresh_rate=' || TO_CHAR(p_refresh_rate) || '&p_file_id=' || TO_CHAR(c_File_Id) || '&p_def_org=' || p_def_org || ''', ''' || cImageURL || ''')"><SPAN CLASS="smallfont"><FONT COLOR="WHITE">'|| c_File_Id ||'</FONT></SPAN></A></TD>');
      htp.p('    <TD><SPAN CLASS="smallfont"><FONT COLOR="WHITE">' || c_Status || '</FONT></SPAN></A></TD>');
    END IF;
    htp.p('    <TD><SPAN CLASS="smallfont">' || TO_CHAR(c_Scan_Date, 'DD-MON-YYYY@HH24:MI:SS') || '</A></SPAN></TD>');
    htp.p('    <TD ALIGN="CENTER"><A HREF="javascript:confirmDelete(''' || p_user_id || ''',''' || REPLACE(p_def_context, ' ', '+') || ''',''' || REPLACE(p_def_context, ' ', '+') || ''',''' || p_refresh_rate || ''',''' || c_File_Id || ''',''' || p_def_org || ''')" onMouseOver="window.status=''Delete''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_delete.gif" BORDER="0" ALT="Delete"></A></TD>');
    htp.p('  </TR>');
  END LOOP;
  CLOSE cUnprocDocs;
  htp.p('</TABLE>');
  htp.p('</FORM>');
  gis_image_util.pageclose;
EXCEPTION WHEN OTHERS THEN
  preindex_message('Search Error', SQLERRM || vSQL, 'B');
END list_unprocessed;

PROCEDURE show_doc_types(p_user_id      NUMBER,
                         p_def_context  VARCHAR2,
                         p_context      VARCHAR2,
                         p_refresh_rate NUMBER,
                         p_file_id      NUMBER,
                         p_navTo 		VARCHAR2 DEFAULT NULL,
                         p_def_org      NUMBER DEFAULT NULL) IS
  -- Pragma declarations to check for locking of record for processing
  ROW_LOCKED    EXCEPTION;
  PRAGMA        EXCEPTION_INIT(ROW_LOCKED, -54);
  ROW_PROCESSED EXCEPTION;

  nDocID         NUMBER := NULL;
  vCurrStatus    fnd_documents_tl_dfv.index_status_id%TYPE;
  CURSOR cur_docContext IS
    SELECT rownum+1 row_id,
           con.descriptive_flexfield_name,
           con.descriptive_flex_context_code,
           con.description,
           con.descriptive_flex_context_name
    FROM   FND_DESCR_FLEX_CONTEXTS_VL con
    WHERE  con.descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX'
    AND    descriptive_flex_context_code != 'Global Data Elements'
    AND    enabled_flag = 'Y'   
    ORDER BY con.description;
  row_docContext cur_docContext%ROWTYPE;
BEGIN
  -- Select fnd_documents_tl record for locking
  SELECT t.document_id, v.index_status_id
  -- Get document_id for to do all updates
  INTO   nDocID, vCurrStatus
  FROM   fnd_documents_tl t, fnd_documents d, fnd_documents_tl_dfv v
  WHERE  t.media_id = p_file_id
  AND    t.document_id = d.document_id
  AND    d.datatype_id = 
    (SELECT datatype_id
     FROM   fnd_document_datatypes
     WHERE  name = 'FILE'
     AND    NVL(start_date_active, SYSDATE) <= SYSDATE
     AND    NVL(end_date_active, SYSDATE) >= SYSDATE)
  AND    t.rowid = v.rowid
  AND    v.primary_document_id = 'Y';
-- iAS has strange behaviour
-- It appears each procedure call is a new session, so the lock is not releasable by commiting
--  FOR UPDATE OF t.document_id NOWAIT;
  IF vCurrStatus NOT IN ('REJECTED', 'SCANNED', 'REPROCESS') AND
     -- Cannot be updated within scan operator - must be rejected or update from processor
     p_navTo IS NULL THEN
    -- Preindexed or processed already
    RAISE ROW_PROCESSED;
  END IF;
  IF p_context = 'All' THEN
    gis_image_util.pageopen(p_heading => 'Document Search');
    gis_image_util.InfoHeader( 'Select LOB For ' || p_file_id);
    htp.formOpen('gis_preindex.show_fields', 'POST',cattributes=>'NAME="show_fields"');
    htp.p('<SCRIPT language="JavaScript">
<!--BEGIN Script
function confirmDelete(p_user_id, p_def_context, p_def_context, p_refresh_rate, p_file_id, p_def_org)
{
  var newURL
  var returnValue = confirm("Are you sure you want to delete this image ?");

  if (returnValue)
  {
    newURL = "gis_preindex.delete_image?p_user_id=" + p_user_id + "&p_def_context=" + p_def_context.replace(" ","+") + "&p_context=" + p_def_context.replace(" ","+") + "&p_refresh_rate=" + p_refresh_rate + "&p_file_id=" + p_file_id + "&p_def_org=" + p_def_org
    viewimage('''',newURL,'''')    
  }
}
//-->
</SCRIPT>');
    htp.formHidden('p_user_id', TO_CHAR(p_user_id));
    htp.formHidden('p_def_context', p_def_context);
    htp.formHidden('p_refresh_rate', TO_CHAR(p_refresh_rate));
    htp.formHidden('p_file_id', TO_CHAR(p_file_id));
    htp.formHidden('p_def_org', TO_CHAR(p_def_org));
    htp.p('<TABLE WIDTH="98%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE">');
    htp.p('      <SPAN CLASS="mediumfont">');
    htp.formSelectOpen(cname=>'p_context',nsize=>'15');	
    IF NOT cur_docContext%ISOPEN THEN
      OPEN cur_docContext;
    END IF;
    FETCH cur_docContext INTO row_docContext;
    IF cur_docContext%NOTFOUND THEN
      htp.formSelectOption('ERROR','SELECTED',cattributes=>'VALUE="0"' );
      -- put some sort of error message in here
    ELSE
      WHILE cur_docContext%FOUND LOOP	
        htp.formSelectOption(row_docContext.description, CATTRIBUTES=>'value="' ||	
                             row_docContext.descriptive_flex_context_code || '"');
        FETCH cur_docContext INTO row_docContext;
      END LOOP;
    END IF;
    CLOSE cur_docContext;
    htp.formSelectClose;
    htp.p('      </SPAN>');      
    htp.p('    </TD>');
    htp.p('  </TR>');
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_l.gif" BORDER="0" ALT="Back"></A><A HREF="javascript:document.show_fields.submit()" onMouseOver="window.status=''Next''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_next_r.gif" BORDER="0" ALT="Next"></A></TD>');
    htp.p('  </TR>');
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>');    
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER"><A HREF="javascript:confirmDelete(''' || p_user_id || ''',''' || REPLACE(p_def_context, ' ', '+') || ''',''' || REPLACE(p_def_context, ' ', '+') || ''',''' || p_refresh_rate || ''',''' || p_file_id || ''',''' || p_def_org || ''')" onMouseOver="window.status=''Delete''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_delete_m.gif" BORDER="0" ALT="Delete"></A></TD>');
    htp.p('  </TR>');
    htp.p('</TABLE>');
    htp.formclose;
    gis_image_util.pageclose;
  ELSE
    -- Show fields for default category selection
    gis_preindex.show_fields(p_user_id, p_def_context, p_context, p_refresh_rate, p_file_id, p_navTo, p_def_org);
  END IF;
EXCEPTION
  WHEN ROW_LOCKED THEN
    preindex_message('Image ' || p_file_id || ' Locked For Indexing', 'This image is in the process of being indexed - please select another image.', 'B');
  WHEN ROW_PROCESSED THEN
    ROLLBACK;
    preindex_message('Image ' || p_file_id || ' Already Indexed', 'This image has been indexed - please select another image.', 'B');
  WHEN OTHERS THEN
    gis_image_util.InfoHeader('Error Details');
    htp.br;
    htp.br;
    htp.p('<B>Error: Unable to save details - check document status is not processed</B>');
    htp.br;
    htp.p(SQLERRM);
    htp.br;
    htp.p('<TABLE WIDTH="100%" ALIGN="CENTER" >');
    htp.p('  <TR ><TD ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TR>');
    htp.p('</TABLE>');
    gis_image_util.pageclose;		
END show_doc_types;

PROCEDURE show_fields(p_user_id      NUMBER,
                      p_def_context  VARCHAR2,
                      p_context      VARCHAR2 DEFAULT 'None',
                      p_refresh_rate NUMBER,
                      p_file_id      NUMBER,
                      p_navTo        VARCHAR2 DEFAULT NULL,
                      p_def_org      NUMBER DEFAULT NULL) IS
                      
  vColName  VARCHAR2(240);
  CURSOR cDocFields IS
    SELECT application_column_name id, end_user_column_name meaning, required_flag, column_seq_num
    FROM   apps.fnd_descr_flex_col_usage_vl
    WHERE  descriptive_flexfield_name = 'ATCHMT_DOCUMENT_FLEX' 
    AND    application_id = 0
    AND    enabled_flag = 'Y'
    AND    (descriptive_flex_context_code = p_context OR
            descriptive_flex_context_code = 'Global Data Elements')
    AND    UPPER(SUBSTR(end_user_column_name, (LENGTH(end_user_column_name)-1),2)) != 'ID'
    AND    UPPER(end_user_column_name) NOT IN ('LOCKED BY', 'INDEXED BY')
    UNION
    SELECT 'CATEGORY_ID' id, 'Doc Type' meaning, 'Y' required_flag, 0 column_seq_num
    FROM   dual
    UNION
    SELECT 'DESCRIPTION' id, 'Description' meaning, 'Y' required_flag, 999 column_seq_num
    FROM   dual
    ORDER BY column_seq_num;
  v_params  VARCHAR2(5000) := null;
  n_attrib  NUMBER := 10;
  n_count   NUMBER := 0;
  n_agree   NUMBER := 0;
  n_proj    NUMBER := 0;
  n_contrct NUMBER := 0;
  n_cust    NUMBER := 0;
  n_order   NUMBER := 0;
  n_loop    NUMBER := 0;
  nOrgID    gis_scanners.organization_id%TYPE;
  vSecure   VARCHAR2(100) := 'PUBLIC';
  -- dg added start and end active dates to cursor 04-01-2001
  CURSOR cDocTypes IS
    SELECT tl.category_id, SUBSTR(tl.user_name, instr(tl.user_name, 'GIS - ') + 6) user_name
    FROM   fnd_document_categories_tl  tl,
           fnd_document_categories cat
    WHERE  tl.category_id = cat.category_id
    AND    cat.attribute_category = 'GIS'
    AND    cat.attribute1 = UPPER(p_context)
    AND    NVL(cat.start_date_active,SYSDATE - 1) <= SYSDATE
    AND    NVL(cat.end_date_active,SYSDATE + 1) >= SYSDATE
    AND    DECODE(cat.attribute2, 'SECURE', 'SECURE', 'PUBLIC') IN (vSecure, 'PUBLIC')
    ORDER BY tl.user_name;
  rDocTypes cDocTypes%ROWTYPE;
  CURSOR cOrderTypes IS
    SELECT name, name order_type
    FROM   so_order_types_all
    WHERE  start_date_active <= TRUNC(SYSDATE)
    AND    NVL(end_date_active, TRUNC(SYSDATE + 1)) >= TRUNC(SYSDATE)
    AND    org_id  = 
      (SELECT s.organization_id
       FROM   fnd_lobs l, gis_scanners s
       WHERE  l.file_id = p_file_id
       AND    l.program_tag = s.scanner_id)
    ORDER BY name;
  rOrderTypes cOrderTypes%ROWTYPE;
  CURSOR cSkip IS
    SELECT u.attribute1, s.attribute4
    FROM   fnd_lobs l, gis_scanners s, gis_scan_users u
    WHERE  l.file_id = p_file_id
    AND    l.program_tag = s.scanner_id
    AND    s.scanner_id = u.scanner_id
    AND    u.fnd_user_id = p_user_id;
  v_Skip gis_scan_users.attribute1%TYPE;
  v_Loc  gis_scanners.attribute4%TYPE := NULL;
  -- Variables to store field names on form to return validated values
  v_Confirm  VARCHAR2(100) := NULL;
  v_OENum    VARCHAR2(100) := NULL;
  v_CustNum  VARCHAR2(100) := NULL;
  v_CustName VARCHAR2(100) := NULL;
  v_LicVal   VARCHAR2(100) := NULL;
  v_OEVal    VARCHAR2(100) := NULL;
  CURSOR cAttrib IS
    SELECT 	t.doc_attribute1, t.doc_attribute2, t.doc_attribute3, t.doc_attribute4, t.doc_attribute5,
            t.doc_attribute6, t.doc_attribute7, t.doc_attribute8, t.doc_attribute9, t.doc_attribute10, 
            t.doc_attribute11, t.doc_attribute12, t.doc_attribute13, t.doc_attribute14, t.doc_attribute15,
            t.doc_attribute_category, t.description, d.category_id
    FROM    fnd_documents_tl t, fnd_documents d, fnd_documents_tl_dfv v
    WHERE   t.media_id = p_file_id
    AND     t.document_id = d.document_id
    AND     t.rowid = v.rowid
    AND     v.primary_document_id = 'Y'
    AND     d.datatype_id =
      (SELECT datatype_id
       FROM   fnd_document_datatypes
       WHERE  name = 'FILE'
       AND    NVL(start_date_active, SYSDATE) <= SYSDATE
       AND    NVL(end_date_active, SYSDATE) >= SYSDATE);
  rAttrib   cAttrib%ROWTYPE;
  vValue    VARCHAR2(240);
  bDefault  BOOLEAN := FALSE;
  FUNCTION get_value(rValues cAttrib%ROWTYPE, vColumnName VARCHAR2, nAttach NUMBER) RETURN VARCHAR2 IS
  BEGIN
    IF nAttach = 0 THEN
      RETURN (NULL);
    ELSIF vColumnName = 'DOC_ATTRIBUTE1' THEN
      RETURN (rValues.doc_attribute1);
    ELSIF vColumnName = 'DOC_ATTRIBUTE2' THEN
      RETURN (rValues.doc_attribute2);
    ELSIF vColumnName = 'DOC_ATTRIBUTE3' THEN
      RETURN (rValues.doc_attribute3);
    ELSIF vColumnName = 'DOC_ATTRIBUTE4' THEN
      RETURN (rValues.doc_attribute4);
    ELSIF vColumnName = 'DOC_ATTRIBUTE5' THEN
      RETURN (rValues.doc_attribute5);
    ELSIF vColumnName = 'DOC_ATTRIBUTE6' THEN
      RETURN (rValues.doc_attribute6);
    ELSIF vColumnName = 'DOC_ATTRIBUTE7' THEN
      RETURN (rValues.doc_attribute7);
    ELSIF vColumnName = 'DOC_ATTRIBUTE8' THEN
      RETURN (rValues.doc_attribute8);
    ELSIF vColumnName = 'DOC_ATTRIBUTE9' THEN
      RETURN (rValues.doc_attribute9);
    ELSIF vColumnName = 'DOC_ATTRIBUTE10' THEN
      RETURN (rValues.doc_attribute10);
    ELSIF vColumnName = 'DOC_ATTRIBUTE11' THEN
      RETURN (rValues.doc_attribute11);
    ELSIF vColumnName = 'DOC_ATTRIBUTE12' THEN
      RETURN (rValues.doc_attribute12);
    ELSIF vColumnName = 'DOC_ATTRIBUTE13' THEN
      RETURN (rValues.doc_attribute13);
    ELSIF vColumnName = 'DOC_ATTRIBUTE14' THEN
      RETURN (rValues.doc_attribute14);
    ELSIF vColumnName = 'DOC_ATTRIBUTE15' THEN
      RETURN (rValues.doc_attribute15);
    ELSIF vColumnName = 'DESCRIPTION' THEN
      RETURN (rValues.description);
    ELSIF vColumnName = 'CATEGORY_ID' THEN
      RETURN (TO_CHAR(rValues.category_id));
    ELSE
      RETURN (NULL);
    END IF;
  END;
BEGIN
  -- Get org_id for source of document
  SELECT s.organization_id
  INTO   nOrgID
  FROM   fnd_lobs l, gis_scanners s
  WHERE  l.file_id = p_file_id
  AND    l.program_tag = s.scanner_id;
  -- Get set secure details flag for current user and context
  IF gis_search.viewSecureDocument(p_user_id, nOrgID, p_context) THEN
    vSecure := 'SECURE';
  ELSE
    vSecure := 'PUBLIC';
  END IF;
  IF p_context = 'None' THEN
    gis_image_util.pageopen(p_heading => 'No Line Of Business Selected');
    gis_image_util.InfoHeader('No Line Of Business Selected');
  ELSE
    gis_image_util.pageopen(p_heading => p_context || ' Fields');
    gis_image_util.InfoHeader('PreIndex Image ' || TO_CHAR(p_file_id));
  END IF;
  -- Get default skip flag for Javascript processing
  -- Will also be used to set default value for checkbox in field generation
  OPEN cSkip;
  FETCH cSkip INTO v_Skip, v_Loc;
  IF cSkip%NOTFOUND THEN
    v_Skip := 'Y';
  END IF;
  CLOSE cSkip;
  htp.p('<SCRIPT language="JavaScript">
<!--BEGIN Script
var search_id1 = ""
var search_id2 = ""
var confirmURL = ""
var commentURL = ""
var nullError = ""
function confirmIt(p_confirm_type, p_item_value1, p_item_value2, p_file_id)
{
  search_id1 = p_item_value1
  while (search_id1.search("&") > 0)
  {
    search_id1 = search_id1.replace("&", "%26")
  }
  while (search_id1.search("#") > 0)
  {
    search_id1 = search_id1.replace("#", "%23")
  }
  while (search_id1.search(" ") > 0)
  {
    search_id1 = search_id1.replace(" ", "+")
  }
  search_id2 = p_item_value2
  while (search_id2.search("&") > 0)
  {
    search_id2 = search_id2.replace("&", "%26")
  }
  while (search_id2.search("#") > 0)
  {
    search_id2 = search_id2.replace("#", "%23")
  }
  while (search_id2.search(" ") > 0)
  {
    search_id2 = search_id2.replace(" ", "+")
  }
  switch (p_confirm_type)
  {');
  IF p_context = 'Agreements' THEN
    htp.p('    case "sa" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "1=" + search_id1.replace(" ", "+") + "&p_" + p_confirm_type + "2=" + search_id2.replace(" ", "+") + "&p_context=' ||  REPLACE(p_context, ' ', '+') || '"
      window.open(confirmURL, ''wConfirmSA'', ''width=550,height=275,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')
      break
    }');
  ELSIF p_context = 'Contracts' THEN
    htp.p('    case "ks" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "1=" + search_id1.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' ||  REPLACE(p_context, ' ', '+') || '"  
      window.open(confirmURL, ''wConfirmKS'', ''width=450,height=275,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')
      break
    }');
  ELSIF p_context = 'Projects' THEN
    htp.p('    case "pa" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "1=" + search_id1.replace(" ", "+") + "&p_" + p_confirm_type + "2=" + search_id2.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' ||  REPLACE(p_context, ' ', '+') || '"  
      window.open(confirmURL, ''wConfirmPA'', ''width=500,height=500,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')
      break
    }');
  ELSIF p_context = 'Order Management' THEN
    htp.p('    case "oe" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' ||  REPLACE(p_context, ' ', '+') || '"  
      window.open(confirmURL, ''wConfirmOE'', ''width=350,height=275,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')
      break
    }
    case "gtn" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' ||  REPLACE(p_context, ' ', '+') || '"  
      window.open(confirmURL, ''wConfirmOE'', ''width=350,height=275,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')
      break
    }
    case "rc" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_context=' || REPLACE(p_context, ' ', '+') || '"
      window.open(confirmURL, ''wConfirmRC'', ''width=350,height=275,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')    
      break
    }');
  ELSIF p_context = 'Web Expenses' THEN
    htp.p('    case "we" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' ||  REPLACE(p_context, ' ', '+') || '"  
      window.open(confirmURL, ''wConfirmWE'', ''width=350,height=275,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')
      break
    }');

  ELSIF p_context = 'Payables' THEN
    htp.p('    case "ap" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' ||  REPLACE(p_context, ' ', '+') || '"
      window.open(confirmURL, ''wConfirmAP'', ''width=600,height=275,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')    
      break
    }');
  ELSIF p_context = 'Receivables' THEN
  htp.p('    case "ar" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' || REPLACE(p_context, ' ', '+') || '"
      window.open(confirmURL, ''wConfirmAR'', ''width=350,height=275,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')    
      break
    }');
  ELSIF p_context = 'Customer' THEN
  htp.p('    case "rc" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_context=' || REPLACE(p_context, ' ', '+') || '"
      window.open(confirmURL, ''wConfirmRC'', ''width=350,height=275,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')    
      break
    }');
  ELSIF p_context = 'Education Bookings' THEN
  htp.p('    case "eb" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' ||  REPLACE(p_context, ' ', '+') || '"
      window.open(confirmURL, ''wConfirmEB'', ''width=600,height=500,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')    
      break
    }');
  ELSIF p_context = 'Education Events' THEN
  htp.p('    case "ee" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' ||  REPLACE(p_context, ' ', '+') || '"
      window.open(confirmURL, ''wConfirmEE'', ''width=600,height=250,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')    
      break
    }');
  ELSIF p_context = 'HR Assignments' THEN
  htp.p('    case "hra" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' ||  REPLACE(p_context, ' ', '+') || '"
      window.open(confirmURL, ''wConfirmHRA'', ''width=700,height=300,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')    
      break
    }');
  ELSIF p_context = 'Suppliers' THEN
  htp.p('    case "pov" :
    {
      confirmURL = "' || C_APP_URL || 'gis_preindex.confirm_" + p_confirm_type + "?p_" + p_confirm_type + "=" + search_id1.replace(" ", "+") + "&p_file_id=' ||  p_file_id || '&p_context=' ||  REPLACE(p_context, ' ', '+') || '"
      window.open(confirmURL, ''wConfirmPOV'', ''width=500,height=300,dependent=no,left=5,top=5,screenX=1,screenY=50,resizable=1,status=0,scrollbars=1'')    
      break
    }');
  END IF;
  htp.p('    default :
    {
      break
    }
  }
}
function checkFields()
{
  var returnValue');
  IF p_context IN ('Agreements', 'Projects', 'Contracts', 'Order Management') THEN
   -- Find p_valX for customer name and context search key - needs 2 parameters to search
    n_count := 0;
    FOR s IN cDocFields LOOP
      n_count := n_count + 1;
      IF s.meaning = 'Customer Name' THEN
        n_cust := n_count;
      ELSIF s.meaning = 'Agreement Name' THEN
        n_agree := n_count;
      ELSIF s.meaning = 'Project Number' THEN
        n_proj := n_count;
      ELSIF s.meaning = 'Contracts Number' THEN
        n_contrct := n_count;
      ELSIF s.meaning = 'OE Number' THEN
        n_order := n_count;
      END IF;
    END LOOP;
  END IF;
  n_count := 0;
  FOR s IN cDocFields LOOP
    n_count := n_count + 1;
    IF s.required_flag = 'Y' THEN
      htp.p('  if (document.preindex_info.p_val' || n_count || '.value == "" && nullError == "")');
      htp.p('  {');
      htp.p('    confirm("' || s.meaning || ' is required.")');
      htp.p('    nullError = "1"');
      htp.p('    document.preindex_info.p_val' || n_count || '.focus()');
      htp.p('  }');
    END IF;
  END LOOP;
  htp.p('  if (nullError != "")');
  htp.p('  {');
  htp.p('    nullError = ""');
  htp.p('  }');
  htp.p('  else');
  htp.p('  {');
  -- Order Management must have order number specified in non-required field to skip processing queue
  htp.p('    if (document.preindex_info.p_context.value == "Order Management" && document.preindex_info.p_val' || n_order || '.value == "" &&  document.preindex_info.p_skip.checked == true)');
  htp.p('    {');
  htp.p('      alert("Order number required to skip process queue for Order Management")');
  htp.p('      document.preindex_info.p_val' || n_order || '.focus()');
  htp.p('    }');
  htp.p('    else');
  -- User has does not have default skip queue - confirm skipping of process queue
  htp.p('    {');
  htp.p('      if ((document.preindex_info.p_skip.checked == true) && ("N" == "' || v_Skip || '"))');
  htp.p('      {');
  htp.p('        returnValue = confirm("Are you sure you want this document to bypass the PROCESSING queue ?")');
  htp.p('        if (returnValue)');
  htp.p('        {');
  htp.p('          document.preindex_info.submit()');
  htp.p('        }');
  htp.p('        else');
  htp.p('        {');
  htp.p('          alert("Please set Skip Process Queue to NO and Save again.")');
  htp.p('        }');
  htp.p('      }');
  htp.p('      else');
  -- User has default skip queue - do not confirm
  htp.p('      {');  
  htp.p('        document.preindex_info.submit()');  
  htp.p('      }');
  htp.p('    }');
  htp.p('  }');
  htp.p('
}
function confirmDelete(p_user_id, p_def_context, p_def_context, p_refresh_rate, p_file_id, p_def_org)
{
  var newURL
  var returnValue = confirm("Are you sure you want to delete this image ?");

  if (returnValue)
  {
    newURL = "gis_preindex.delete_image?p_user_id=" + p_user_id + "&p_def_context=" + p_def_context.replace(" ","+") + "&p_context=" + p_def_context.replace(" ","+") + "&p_refresh_rate=" + p_refresh_rate + "&p_file_id=" + p_file_id + "&p_def_org=" + p_def_org
    viewimage('''',newURL,'''')    
  }
}
//-->
</SCRIPT>');
  htp.formOpen('gis_preindex.preindex_info', 'POST',cattributes=>'NAME="preindex_info"');
  htp.formHidden('p_user_id', TO_CHAR(p_user_id));
  htp.formHidden('p_def_context', p_def_context);
  htp.formHidden('p_context', REPLACE(p_context, '%20', ' '));
  htp.formHidden('p_refresh_rate', TO_CHAR(p_refresh_rate));
  htp.formHidden('p_file_id', TO_CHAR(p_file_id));
  htp.formHidden('p_navTo', REPLACE (p_navTo,' ','+'));
  htp.formHidden('p_def_org', TO_CHAR(p_def_org));
  htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
  IF p_context != 'None' THEN
    n_count := 0;
    OPEN cAttrib;
    FETCH cAttrib INTO rAttrib;
    FOR s IN cDocFields LOOP
      htp.p('  <TR>' );
      -- Input fields
      n_count := n_count + 1;
      htp.formHidden('p_attr'|| TO_CHAR(n_count), s.id);
      IF s.required_flag = 'Y' THEN
        htp.p('    <TD ALIGN="RIGHT"><SPAN CLASS="mediumfont"><FONT COLOR="#FFCC00">' || s.meaning || ':</FONT></SPAN></TD>');      
      ELSE
        htp.p('    <TD ALIGN="RIGHT"><SPAN CLASS="mediumfont">' || s.meaning || ':</SPAN></TD>');      
      END IF;
      IF s.meaning = 'Doc Type' THEN
        /* Show LOV for document types for category */
        htp.p('    <TD><SPAN CLASS="mediumfont">');
        htp.formSelectOpen(cname=>'p_val' || TO_CHAR(n_count), nsize=>'1');
        OPEN cDocTypes;
        LOOP        
          FETCH cDocTypes INTO rDocTypes;
          EXIT WHEN cDocTypes%NOTFOUND;
          IF (TO_CHAR(rDocTypes.category_id) = get_value(rAttrib, s.id, 1) OR
             (p_context = 'Order Management' AND
              rDocTypes.user_name = 'Order Package') AND
              get_value(rAttrib, s.id, 1) IS NULL AND
              NOT bDefault) THEN
            -- Display value previuosly indexed OR set default doc type for OM to Order Package where no value is specified
            -- Once a default value is selected, nothing else can be defaulted.
            htp.p('      <OPTION SELECTED value="' || rDocTypes.category_id || '">' || rDocTypes.user_name);
            bDefault := TRUE;
          ELSE
            -- No matching value, not default for OM
            htp.p('      <OPTION value="' || rDocTypes.category_id || '">' || rDocTypes.user_name);
          END IF;
        END LOOP;
        CLOSE cDocTypes;
        htp.formSelectClose;
        htp.p('    </SPAN></TD>');
      ELSIF s.meaning = 'Order Type' THEN
        /* Show LOV for order types */
        htp.p('    <TD><SPAN CLASS="mediumfont">');
        htp.formSelectOpen(cname=>'p_val' || TO_CHAR(n_count),nsize=>'1');
        OPEN cOrderTypes;
        LOOP        
          FETCH cOrderTypes INTO rOrderTypes;
          EXIT WHEN cOrderTypes%NOTFOUND;
          IF rOrderTypes.name = get_value(rAttrib, s.id, 1) THEN
            htp.formSelectOption(rOrderTypes.name,
                                 CSELECTED => get_value(rAttrib, s.id, 1),
                                 CATTRIBUTES=>'value="'||rOrderTypes.order_type||'"');
          ELSE
            htp.formSelectOption(rOrderTypes.name,
                                 CSELECTED => '',
                                 CATTRIBUTES=>'value="'||rOrderTypes.order_type||'"');
          END IF;
        END LOOP;
      CLOSE cOrderTypes;
        htp.formSelectClose;
        htp.p('     </SPAN></TD>');        
      ELSIF s.meaning = 'Index Date' THEN
        /* Display current date */
        htp.p('    <TD ALIGN="LEFT"><SPAN CLASS="mediumfont"><INPUT type="hidden" name="p_val' || TO_CHAR(n_count) || '" value="' || NVL(get_value(rAttrib, s.id, 1), TO_CHAR(SYSDATE, 'DD-MON-YYYY')) || '" size="22" maxlength="100">' || NVL(get_value(rAttrib, s.id, 1), TO_CHAR(SYSDATE, 'DD-MON-YYYY')) || '</SPAN></TD>');
      ELSIF (s.meaning = 'Agreement Name') OR (s.meaning = 'Customer Name' AND p_context = 'Agreements') THEN
        v_Confirm := 'sa';
        /* Show query button for Agreements */
        htp.p('    <TD ALIGN="LEFT"><SPAN CLASS="mediumfont"><INPUT type="text" name="p_val' || TO_CHAR(n_count) || '" size="22" maxlength="100" value="' || get_value(rAttrib, s.id, 1) || '"><A HREF="javascript:confirmIt(''' || v_Confirm || ''',document.preindex_info.p_val' || TO_CHAR(n_agree) || '.value' ||',document.preindex_info.p_val' || TO_CHAR(n_cust) || '.value,'''')" onMouseOver="window.status=''Details''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_query.gif" BORDER="0" ALT="Details"></A></TD>');
      ELSIF (s.meaning = 'Project Number') OR (s.meaning = 'Customer Name' AND p_context = 'Projects') THEN
        v_Confirm := 'pa';
        /* Show query button for Projects */
        htp.p('    <TD ALIGN="LEFT"><SPAN CLASS="mediumfont"><INPUT type="text" name="p_val' || TO_CHAR(n_count) || '" size="22" maxlength="100" value="' || get_value(rAttrib, s.id, 1) || '"><A HREF="javascript:confirmIt(''' || v_Confirm || ''',document.preindex_info.p_val' || TO_CHAR(n_proj) || '.value' ||',document.preindex_info.p_val' || TO_CHAR(n_cust) || '.value,' || p_file_id ||')" onMouseOver="window.status=''Details''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_query.gif" BORDER="0" ALT="Details"></A></TD>');
      ELSIF (s.meaning = 'Contracts Number') THEN
        v_Confirm := 'ks';
        /* Show query button for Contracts */
        htp.p('    <TD ALIGN="LEFT"><SPAN CLASS="mediumfont"><INPUT type="text" name="p_val' || TO_CHAR(n_count) || '" size="22" maxlength="100" value="' || get_value(rAttrib, s.id, 1) || '"><A HREF="javascript:confirmIt(''' || v_Confirm || ''',document.preindex_info.p_val' || TO_CHAR(n_contrct) || '.value' ||','''',' || p_file_id ||')" onMouseOver="window.status=''Details''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_query.gif" BORDER="0" ALT="Details"></A></TD>');
      ELSIF s.meaning IN ('OE Number', 'Expense Report Number') THEN
        -- OE, WE needs file_id to do org context
        IF s.meaning = 'OE Number' THEN
          v_Confirm := 'oe';
        ELSIF s.meaning = 'Expense Report Number' THEN
          v_Confirm := 'we';
        ELSE
          v_Confirm := 'ERROR';
        END IF;
        htp.p('    <TD ALIGN="LEFT"><SPAN CLASS="mediumfont"><INPUT type="text" name="p_val' || TO_CHAR(n_count) || '" size="22" maxlength="100" value="' || get_value(rAttrib, s.id, 1) || '"><A HREF="javascript:confirmIt(''' || v_Confirm || ''',document.preindex_info.p_val' || TO_CHAR(n_count) || '.value' || ','''',' || p_file_id ||')" onMouseOver="window.status=''Details''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_query.gif" BORDER="0" ALT="Details"></A></TD>');
      ELSIF s.meaning IN ('GTN', 'Customer Name', 'Invoice Number', 'Title', 'Name', 'Supplier Name') AND
            p_context != 'Contracts' THEN
        IF s.meaning = 'GTN' THEN
          v_Confirm := 'gtn';
        ELSIF s.meaning = 'Customer Name' THEN
          v_Confirm := 'rc';
        ELSIF s.meaning = 'Invoice Number' THEN
          IF p_context = 'Payables' THEN
            v_Confirm := 'ap';
          ELSIF p_context = 'Receivables' THEN
            v_Confirm := 'ar';
          ELSE
            v_Confirm := 'ERROR';
          END IF;
        ELSIF s.meaning = 'Title' THEN
          IF p_context = 'Education Bookings' THEN
            v_Confirm := 'eb';
          ELSIF p_context = 'Education Events' THEN
            v_Confirm := 'ee';
          ELSE
            v_Confirm := 'ERROR';
          END IF;
        ELSIF s.meaning = 'Name' THEN
          v_Confirm := 'hra';
        ELSIF s.meaning = 'Supplier Name' THEN
          v_Confirm := 'pov';
        ELSE
          v_Confirm := 'ERROR';
        END IF;
        htp.p('    <TD ALIGN="LEFT"><SPAN CLASS="mediumfont"><INPUT type="text" name="p_val' || TO_CHAR(n_count) || '" size="22" maxlength="100" value="' || get_value(rAttrib, s.id, 1) || '">');
-- DG 11/06/01 removed the confirm it button from the supplier name field on
-- the payables screen. The invoice number will be the primary indexing field
        IF s.meaning = 'Customer Name' AND
           p_context IN ('Agreements', 'Receivables') OR  (s.meaning = 'Supplier Name' AND p_context = 'Payables')THEN
          -- Don't show customer search - will be linked with agreement/invoice search
          NULL;
        ELSE
          -- Show query button for meaning
          htp.p('    <A HREF="javascript:confirmIt(''' || v_Confirm || ''',document.preindex_info.p_val' || TO_CHAR(n_count) || '.value' || ','''','''')" onMouseOver="window.status=''Details''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_query.gif" BORDER="0" ALT="Details"></A>');
        END IF;
        htp.p('    </TD>');
      ELSIF s.meaning = 'Description' THEN
        /* Show comment button for Description */
        htp.p('    <TD ALIGN="LEFT"><SPAN CLASS="mediumfont"><INPUT type="text" name="p_val' || TO_CHAR(n_count) || '" size="22" maxlength="100" value="' || get_value(rAttrib, s.id, 1) || '"><A HREF="javascript:logComments(''' || C_APP_URL || ''', ' || TO_CHAR(p_file_id) || ', ' || TO_CHAR(p_user_id) || ')" onMouseOver="window.status=''Comments''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_comment.gif" BORDER="0" ALT="Comments"></A></TD>');
      ELSIF s.meaning = 'Storage Location' THEN
        /* Show default storage location from gis_scanners.attribute4 */
        htp.p('    <TD ALIGN="LEFT"><SPAN CLASS="mediumfont"><INPUT type="text" name="p_val' || TO_CHAR(n_count) || '" size="22" maxlength="100" value="' || NVL(get_value(rAttrib, s.id, 1), v_Loc) || '"></SPAN></TD>');
      ELSE
        /* Show input text field */
        htp.p('    <TD ALIGN="LEFT"><SPAN CLASS="mediumfont"><INPUT type="text" name="p_val' || TO_CHAR(n_count) || '" size="22" maxlength="100" value="' || get_value(rAttrib, s.id, 1) || '"></SPAN></TD>');
      END IF;        
      htp.p('  </TR>' );
    END LOOP;
    CLOSE cAttrib;
    -- Output checkbox to flag skipping of processing stage
    htp.p('  <TR>' );
    htp.p('    <TD ALIGN="RIGHT"><SPAN CLASS="mediumfont">Skip Process Queue:</SPAN></TD>');      
    htp.p('    <TD ALIGN="LEFT">');
-- DG altered skip process. Checkbox only has a value when checked so it should be 'Y' and not 'N'
    IF v_Skip = 'N' THEN
		htp.formCheckBox('p_skip', 'Y', NULL, NULL);
--      htp.formCheckBox('p_skip', v_Skip, NULL, NULL);
    ELSE
    	htp.formCheckBox('p_skip', 'Y', 'CHECKED', NULL);
--      htp.formCheckBox('p_skip', v_Skip, 'CHECKED', NULL);
    END IF;
    htp.p('    </TD>');
    htp.p('  </TR>' );
  ELSE
    htp.p('  <TR>' );
    -- No document type selected
    htp.p('    <TD ALIGN="RIGHT"><IMG SRC="' || C_IMG_URL || 'i_stop.gif"></TD>');
    htp.p('    <TD ALIGN="CENTER"><SPAN CLASS="mediumfont">NO Line Of Business Selected</SPAN></TD>');
    htp.p('  </TR>' );
  END IF;
  htp.p('</TABLE>' );
  htp.p('<TABLE WIDTH="98%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');  
  htp.p('  <TR>');
  htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
  htp.p('  </TR>');
  IF p_context != 'None' THEN
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_l.gif" BORDER="0" ALT="Back"></A>');
    IF p_navTo IS NULL THEN
      -- Show reset only if preindexing
      htp.p('    <A HREF="javascript:document.preindex_info.reset()" onMouseOver="window.status=''Reset''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_reset_m.gif" BORDER="0" ALT="Reset Fields"></A>');
    END IF;
    htp.p('    <A HREF="javascript:checkFields()" onMouseOver="window.status=''Save''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_save_r.gif" BORDER="0" ALT="Save Fields"></A></TD>');
    htp.p('  </TR>');
    -- Must be able to delete for documents that have a default category selected or have been preindexed
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
    htp.p('  </TR>');
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER"><A HREF="javascript:confirmDelete(''' || p_user_id || ''',''' || p_def_context || ''',''' || p_def_context || ''',''' || p_refresh_rate || ''',''' || p_file_id || ''',''' || p_def_org || ''')" onMouseOver="window.status=''Delete''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_delete_m.gif" BORDER="0" ALT="Delete"></A></TD>');
    htp.p('  </TR>');
  ELSE
    htp.p('  <TR>');
    htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TD>');
    htp.p('  </TR>');
  END IF;
  htp.p('</TABLE>');
  htp.p('</FORM>');
  gis_image_util.pageclose;
EXCEPTION
  WHEN OTHERS THEN
    NULL;
END show_fields;

PROCEDURE preindex_info(p_user_id      NUMBER,
                        p_def_context  VARCHAR2,
                        p_context      VARCHAR2,
                        p_refresh_rate NUMBER,
                        p_file_id      NUMBER,
                        p_attr1        VARCHAR2 DEFAULT NULL,
                        p_attr2        VARCHAR2 DEFAULT NULL,
                        p_attr3        VARCHAR2 DEFAULT NULL,
                        p_attr4        VARCHAR2 DEFAULT NULL,
                        p_attr5        VARCHAR2 DEFAULT NULL,
                        p_attr6        VARCHAR2 DEFAULT NULL,
                        p_attr7        VARCHAR2 DEFAULT NULL,
                        p_attr8        VARCHAR2 DEFAULT NULL,
                        p_attr9        VARCHAR2 DEFAULT NULL,
                        p_attr10       VARCHAR2 DEFAULT NULL,
                        p_attr11       VARCHAR2 DEFAULT NULL,
                        p_attr12       VARCHAR2 DEFAULT NULL,
                        p_attr13       VARCHAR2 DEFAULT NULL,
                        p_attr14       VARCHAR2 DEFAULT NULL,
                        p_attr15       VARCHAR2 DEFAULT NULL,
                        p_val1         VARCHAR2 DEFAULT NULL,
                        p_val2         VARCHAR2 DEFAULT NULL,
                        p_val3         VARCHAR2 DEFAULT NULL,
                        p_val4         VARCHAR2 DEFAULT NULL,
                        p_val5         VARCHAR2 DEFAULT NULL,
                        p_val6         VARCHAR2 DEFAULT NULL,
                        p_val7         VARCHAR2 DEFAULT NULL,
                        p_val8         VARCHAR2 DEFAULT NULL,
                        p_val9         VARCHAR2 DEFAULT NULL,
                        p_val10        VARCHAR2 DEFAULT NULL,
                        p_val11        VARCHAR2 DEFAULT NULL,
                        p_val12        VARCHAR2 DEFAULT NULL,
                        p_val13        VARCHAR2 DEFAULT NULL,
                        p_val14        VARCHAR2 DEFAULT NULL,
                        p_val15        VARCHAR2 DEFAULT NULL,
                        p_navTo 	   VARCHAR2 DEFAULT NULL,
                        p_def_org      NUMBER   DEFAULT NULL,
                        p_skip         VARCHAR2 DEFAULT 'N') IS

  vStatus        fnd_documents_tl_dfv.index_status_id%TYPE;
  vDocType       VARCHAR2(1000) := NULL; 
  vVar           VARCHAR2(1000) := NULL; 
  vKey1          VARCHAR2(1000) := NULL;
  vKey2          VARCHAR2(1000) := NULL; 
  vSelect        VARCHAR2(1000) := NULL; 
  vTable         VARCHAR2(1000) := NULL;
  vTablePK       VARCHAR2(1000) := NULL;
  vSQL           VARCHAR2(10000) := NULL;
  nOrgID         NUMBER := NULL;

  TYPE       cv_type IS REF CURSOR;
  cDup       cv_type;
  nMediaID   NUMBER;
  vAttachDoc VARCHAR2(240);
  vRef       VARCHAR2(240);
  nResult    NUMBER := 0;
  vRefHdg    VARCHAR2(240);

  cImageURL  VARCHAR2(1000);
  vMsg       VARCHAR2(1000);

  FUNCTION Get_Param_Val(vIndex VARCHAR2) RETURN VARCHAR2 IS
  BEGIN
    IF p_attr1 = vIndex THEN
      RETURN (p_val1);
    ELSIF p_attr2 = vIndex THEN
      RETURN (p_val2);
    ELSIF p_attr3 = vIndex THEN
      RETURN (p_val3);
    ELSIF p_attr4 = vIndex THEN
      RETURN (p_val4);
    ELSIF p_attr5 = vIndex THEN
      RETURN (p_val5);
    ELSIF p_attr6 = vIndex THEN
      RETURN (p_val6);
    ELSIF p_attr7 = vIndex THEN
      RETURN (p_val7);
    ELSIF p_attr8 = vIndex THEN
      RETURN (p_val8);
    ELSIF p_attr9 = vIndex THEN
      RETURN (p_val9);
    ELSIF p_attr10 = vIndex THEN
      RETURN (p_val10);
    ELSIF p_attr11 = vIndex THEN
      RETURN (p_val11);
    ELSIF p_attr12 = vIndex THEN
      RETURN (p_val12);
    ELSIF p_attr13 = vIndex THEN
      RETURN (p_val13);
    ELSIF p_attr14 = vIndex THEN
      RETURN (p_val14);
    ELSIF p_attr15 = vIndex THEN
      RETURN (p_val15);
    ELSE
      RETURN (NULL);
    END IF;
  END Get_Param_Val;
BEGIN
  -- Get status of document
  SELECT v.index_status_id
  INTO   vStatus
  FROM   fnd_documents_tl t, fnd_documents d, fnd_documents_tl_dfv v
  WHERE  t.media_id = p_file_id
  AND    t.document_id = d.document_id
  AND    d.datatype_id = 
    (SELECT datatype_id
     FROM   fnd_document_datatypes
     WHERE  name = 'FILE'
     AND    NVL(start_date_active, SYSDATE) <= SYSDATE
     AND    NVL(end_date_active, SYSDATE) >= SYSDATE)
  AND    t.rowid = v.rowid
  AND    v.primary_document_id = 'Y';
  -- Get org_id for image
  SELECT organization_id
  INTO   nOrgID
  FROM   fnd_lobs l, gis_scanners s
  WHERE  l.file_id = p_file_id
  AND    l.program_name = 'GIS'
  AND    l.program_tag = s.scanner_id;
  IF vStatus IN ('REJECTED', 'REPROCESS') OR
    -- REJECTED/REPROCESS are not duplicates - can save preindex information
    p_navTo IS NOT NULL THEN
    -- Request is not from preindex pkg - can save preindex information
    gis_preindex.save_preindex_info(p_user_id, p_def_context, p_context, p_refresh_rate, p_file_id,
                                    p_attr1, p_attr2, p_attr3, p_attr4, p_attr5, p_attr6, p_attr7, p_attr8,
                                    p_attr9, p_attr10, p_attr11, p_attr12, p_attr13, p_attr14, p_attr15,
                                    p_val1, p_val2, p_val3, p_val4, p_val5, p_val6, p_val7, p_val8,
                                    p_val9, p_val10, p_val11, p_val12, p_val13, p_val14, p_val15,
                                    p_navTo, p_def_org, p_skip, nOrgID);  
  ELSE
    -- Request from preindex pkg - must check for duplicates
    -- Check if document type exists for PK attachment - if it does show all attachments and highlight attachments with same doc type
    IF p_context = 'Order Management' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get order number and build SQL statement
      vVar := find_col_name(p_context, 'OE Number');
      vKey1 := Get_Param_Val(vVar);
      vSelect := ', context.order_number apps_ref ';
      vTable := ', oe_order_headers_all context ';
      vTablePK := 'context.header_id';
      vSQL := 'and a.entity_name = ''OE_ORDER_HEADERS'' ' ||
              'and a.pk1_value = (select TO_CHAR(header_id) from oe_order_headers_all where order_number = ' || vKey1 || ' and org_id = ' || TO_CHAR(nOrgID) || ') ' ||
              'and context.org_id = ' || TO_CHAR(nOrgID) || ' ';
      vRefHdg := 'Order Number';
    ELSIF p_context = 'Payables' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get invoice number and build SQL statement
      vVar := find_col_name(p_context, 'Invoice Number');
      vKey1 := Get_Param_Val(vVar);
      vVar := find_col_name(p_context, 'Supplier Name');
      vKey2 := Get_Param_Val(vVar);    
      vSelect := ', context.invoice_num apps_ref ';
      vTable := ', ap_invoices_all context ';
      vTablePK := 'context.invoice_id';
      vSQL := 'and a.entity_name = ''AP_INVOICES'' ' ||
              'and a.pk1_value = (select TO_CHAR(a.invoice_id) from ap_invoices_all a, po_vendors v where a.invoice_num = ''' || vKey1 || ''' and org_id = ' || TO_CHAR(nOrgID) || ' and a.vendor_id = v.vendor_id and v.vendor_name = ''' || REPLACE(vKey2, '''', '''''') || ''') ' ||
              'and context.org_id = ' || TO_CHAR(nOrgID) || ' ';
      vRefHdg := 'Invoice Number';
    ELSIF p_context = 'Agreements' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get agreement name and build SQL statement
      vVar := find_col_name(p_context, 'Agreement Name');
      vKey1 := Get_Param_Val(vVar);
      vSelect := ', context.name apps_ref ';
      vTable := ', oe_agreements context ';
      vTablePK := 'context.agreement_id';
      vSQL := 'and a.entity_name = ''OE_AGREEMENTS'' ' ||
              'and a.pk1_value = (select TO_CHAR(agreement_id) from oe_agreements where name = ''' || vKey1 || ''') ';
      vRefHdg := 'Agreement Name';
    ELSIF p_context = 'Customer' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get customer name and build SQL statement
      vVar := find_col_name(p_context, 'Customer Number');
      vKey1 := Get_Param_Val(vVar);
      vSelect := ', context.customer_number apps_ref ';
      vTable := ', ra_customers context ';
      vTablePK := 'context.customer_id';
      vSQL := 'and a.entity_name = ''AR_CUSTOMERS'' ' ||
              'and a.pk1_value = (select TO_CHAR(customer_id) from ra_customers where customer_number = ''' || REPLACE(vKey1, '''', '''''') || ''') ';
      vRefHdg := 'Customer Number';
    ELSIF p_context = 'Projects' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get project name and build SQL statement
      vVar := find_col_name(p_context, 'Project Number');
      vKey1 := Get_Param_Val(vVar);
      vSelect := ', context.segment1 apps_ref ';
      vTable := ', pa_projects_all context ';
      vTablePK := 'context.project_id';
      vSQL := 'and a.entity_name = ''PA_PROJECTS'' ' ||
              'and a.pk1_value = (select TO_CHAR(project_id) from pa_projects_all where segment1 = ''' || vKey1 || ''' and org_id = ' || TO_CHAR(nOrgID) || ') ' ||
              'and context.org_id = ' || TO_CHAR(nOrgID) || ' ';
      vRefHdg := 'Project Number';
    ELSIF p_context = 'Web Expenses' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get expense number and build SQL statement
      vVar := find_col_name(p_context, 'Expense Report Number');
      vKey1 := Get_Param_Val(vVar);
      vSelect := ', context.invoice_num apps_ref ';
      vTable := ', ap_expense_report_headers_all context ';
      vTablePK := 'context.report_header_id';
      vSQL := 'and a.entity_name = ''AP_EXPENSE_REPORT_HEADER_S_ALL'' ' ||
              'and a.pk1_value = (select TO_CHAR(report_header_id) from ap_expense_report_headers_all where invoice_num = ''' || vKey1 || ''' and org_id = ' || TO_CHAR(nOrgID) || ') ' ||
              'and context.org_id = ' || TO_CHAR(nOrgID) || ' ';
      vRefHdg := 'Expense Number';
    ELSIF p_context = 'Contracts' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get contract number/modifier and build SQL statement
      vVar := find_col_name(p_context, 'Contracts Number');
      vKey1 := Get_Param_Val(vVar);    
      vVar := find_col_name(p_context, 'Contracts Modifier');
      vKey2 := Get_Param_Val(vVar);    
      vSelect := ', context.contract_number || decode(context.contract_number_modifier, NULL, NULL, context.contract_number_modifier)  apps_ref ';
      vTable := ', okc_k_headers_b context ';
      vTablePK := 'context.id';
      vSQL := 'and a.entity_name = ''OKC_K_HEADERS_V'' ' ||
              'and a.pk1_value = (select TO_CHAR(id) from okc_k_headers_b where contract_number = ''' || vKey1 || ''' ';
      IF vKey2 IS NOT NULL THEN
        vSQL := vSQL || 'and contract_number_modifier = ''' || vKey2 || ''' ';
      ELSE
        vSQL := vSQL || 'and contract_number_modifier is null ';
      END IF;
      vSQL := vSQL || 'and authoring_org_id = ' || TO_CHAR(nOrgID) || ') and context.authoring_org_id = ' || TO_CHAR(nOrgID) || ' ';
      vRefHdg := 'Contract Number/Modifier';
    ELSIF p_context = 'Receivables' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get invoice number and build SQL statement
      vVar := find_col_name(p_context, 'Invoice Number');
      vKey1 := Get_Param_Val(vVar);
      vSelect := ', context.trx_number apps_ref ';
      vTable := ', ra_customer_trx_all context ';
      vTablePK := 'context.customer_trx_id';
      vSQL := 'and a.entity_name = ''RA_CUSTOMER_TRX'' ' ||
              'and a.pk1_value = (select TO_CHAR(customer_trx_id) from ra_customer_trx_all where trx_number = ''' || vKey1 || ''' and org_id = ' || TO_CHAR(nOrgID) || ') ' ||
              'and context.org_id = ' || TO_CHAR(nOrgID) || ' ';
      vRefHdg := 'Invoice Number';
    ELSIF p_context = 'Education Bookings' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get enrollment number and build SQL statement
      vVar := find_col_name(p_context, 'Enrollment Number');
      vKey1 := Get_Param_Val(vVar);
      vSelect := ', context.booking_id apps_ref ';
      vTable := ', ota_delegate_bookings context ';
      vTablePK := 'context.booking_id';
      vSQL := 'and a.entity_name = ''OTA_DELEGATE_BOOKINGS'' ' ||
              'and a.pk1_value = (select TO_CHAR(booking_id) from ota_delegate_bookings where booking_id = ''' || vKey1 || ''' and business_group_id = ' || TO_CHAR(nOrgID) || ') ' ||
              'and context.business_group_id = ' || TO_CHAR(nOrgID) || ' ';
      vRefHdg := 'Enrollment Number';
    ELSIF p_context = 'Education Events' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get event title and build SQL statement
      vVar := find_col_name(p_context, 'Title');
      vKey1 := Get_Param_Val(vVar);
      vSelect := ', context.event_id apps_ref ';
      vTable := ', ota_events context ';
      vTablePK := 'context.event_id';
      vSQL := 'and a.entity_name = ''OTA_EVENTS'' ' ||
              'and a.pk1_value = (select TO_CHAR(event_id) from ota_events where title = ''' || vKey1 || ''' and business_group_id = ' || TO_CHAR(nOrgID) || ') ' ||
              'and context.business_group_id = ' || TO_CHAR(nOrgID) || ' ';
      vRefHdg := 'Course Title';
    ELSIF p_context = 'HR Assignments' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get assignment_id and build SQL statement
      vVar := find_col_name(p_context, 'Assignment Ref');
      vKey1 := Get_Param_Val(vVar);
      vSelect := ', context.assignment_id apps_ref ';
      vTable := ', per_all_assignments_f context ';
      vTablePK := 'context.assignment_id';
      vSQL := 'and a.entity_name = ''PER_ASSIGNMENTS_F'' ' ||
              'and a.pk1_value = ' || vKey1 || ' ' ||
              'and context.business_group_id = ' || TO_CHAR(nOrgID) || ' ' ||
              'and context.effective_start_date <= TRUNC(SYSDATE) ' ||
              'and context.effective_end_date >= TRUNC(SYSDATE+1) ';
      vRefHdg := 'Assignment';
    ELSIF p_context = 'Suppliers' THEN
      -- Get doc type - ALWAYS p_val1
      vDocType := p_val1;
      -- Get supplier number and build SQL statement
      vVar := find_col_name(p_context, 'Supplier Number');
      vKey1 := Get_Param_Val(vVar);
      vSelect := ', context.vendor_name apps_ref ';
      vTable := ', po_vendors context, hr_operating_units context2 ';
      vTablePK := 'context.vendor_id';
      vSQL := 'and a.entity_name = ''PO_VENDORS'' ' ||
              'and a.pk1_value = (select TO_CHAR(p.vendor_id) from po_vendors p, hr_operating_units u where p.segment1 = ''' || vKey1 || ''' and p.set_of_books_id = u.set_of_books_id and u.organization_id = ' || TO_CHAR(nOrgID) || ') ' ||
              'and context.set_of_books_id = context2.set_of_books_id and context2.organization_id = ' || TO_CHAR(nOrgID) || ' ';
      vRefHdg := 'Supplier';
    END IF;
    vSQL := 'select t.media_id, SUBSTR(c.user_name, (INSTR(c.user_name, ''-'')+2)) doc_type ' || vSelect ||
            'from   fnd_documents_tl t, fnd_documents_tl_dfv v, fnd_attached_documents a, fnd_documents d, fnd_document_categories_tl c ' || vTable ||
            'where  t.document_id = d.document_id ' ||
            'and    t.rowid = v.rowid ' ||
            'and    v.primary_document_id = ''Y'' ' ||
            'and    a.document_id = d.document_id ' ||
            'and    d.category_id = ' || vDocType || ' ' ||
            'and    d.category_id = c.category_id ' || vSQL ||
            'and    ' || vTablePK || ' = TO_NUMBER(a.pk1_value)';
    -- List any duplicate doc type attachments
    -- htp.p(vSQL);
    -- Order Management does not have a key value for new orders
    -- All other LOBs will have a key value to search on
    IF vKey1 IS NOT NULL THEN
      OPEN cDup FOR vSQL;
      LOOP
        FETCH cDup INTO nMediaID, vAttachDoc, vRef;
        EXIT WHEN cDup%NOTFOUND;
        IF nResult = 0 AND
           cDup%FOUND THEN
          gis_image_util.pageopen('Duplicate Doc Type Attachments');
          gis_image_util.InfoHeader('Duplicate Doc Type Attachments');
          htp.p('<FORM>');
          htp.p('<TABLE WIDTH="95%" BORDER="1" CELLSPACING="0" CELLPADDING="1">');
          -- Output heading
          htp.p('  <TR>' );
          htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Image </SPAN></TD>');
          htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">Attached Doc Type </SPAN></TD>');
          htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vRefHdg || ' </SPAN></TD>');
          htp.p('  </TR>');
        END IF;
        nResult := nResult + 1;
        -- Build URL link for file download
        cImageURL := fnd_gfm.construct_download_url(C_APP_URL, nMediaID);
        /* Show data for duplicated doc type for PK */
        htp.p('  <TR>' );
        htp.p('    <TD><A HREF="JavaScript:viewimage('''','''', ''' || cImageURL || ''')"><SPAN CLASS="mediumfont"><FONT COLOR="WHITE">'|| nMediaID||'</A></FONT></SPAN></TD>');
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vAttachDoc || '</SPAN></TD>');
        htp.p('    <TD ALIGN="LEFT" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vRef || '</SPAN></TD>');
        htp.p('  </TR>');
      END LOOP;
      CLOSE cDup;
    END IF;
    IF nResult > 0 THEN
      htp.p('</TABLE>');
      htp.p('</FORM>');
      htp.br;
      -- User can continue or go back
      htp.formOpen('gis_preindex.save_preindex_info', 'POST',cattributes=>'NAME="save_preindex_info"');
      -- Output variables
      htp.formHidden('p_user_id', TO_CHAR(p_user_id));
      htp.formHidden('p_def_context', p_def_context);
      htp.formHidden('p_context', REPLACE(p_context, '%20', ' '));
      htp.formHidden('p_refresh_rate', TO_CHAR(p_refresh_rate));
      htp.formHidden('p_file_id', TO_CHAR(p_file_id));
      htp.formHidden('p_attr1', p_attr1);
      htp.formHidden('p_attr2', p_attr2);
      htp.formHidden('p_attr3', p_attr3);
      htp.formHidden('p_attr4', p_attr4);
      htp.formHidden('p_attr5', p_attr5);
      htp.formHidden('p_attr6', p_attr6);
      htp.formHidden('p_attr7', p_attr7);
      htp.formHidden('p_attr8', p_attr8);
      htp.formHidden('p_attr9', p_attr9);
      htp.formHidden('p_attr10', p_attr10);
      htp.formHidden('p_attr11', p_attr11);
      htp.formHidden('p_attr12', p_attr12);
      htp.formHidden('p_attr13', p_attr13);
      htp.formHidden('p_attr14', p_attr14);
      htp.formHidden('p_attr15', p_attr15);
      htp.formHidden('p_val1', p_val1);
      htp.formHidden('p_val2', p_val2);
      htp.formHidden('p_val3', p_val3);
      htp.formHidden('p_val4', p_val4);
      htp.formHidden('p_val5', p_val5);
      htp.formHidden('p_val6', p_val6);
      htp.formHidden('p_val7', p_val7);
      htp.formHidden('p_val8', p_val8);
      htp.formHidden('p_val9', p_val9);
      htp.formHidden('p_val10', p_val10);
      htp.formHidden('p_val11', p_val11);
      htp.formHidden('p_val12', p_val12);
      htp.formHidden('p_val13', p_val13);
      htp.formHidden('p_val14', p_val14);
      htp.formHidden('p_val15', p_val15);
      htp.formHidden('p_navTo', p_navTo);
      htp.formHidden('p_def_org', TO_CHAR(p_def_org));
      htp.formHidden('p_skip', p_skip);
      htp.formHidden('p_org_id', nOrgID);
      htp.p('<TABLE WIDTH="95%" BORDER="0" CELLSPACING="0" CELLPADDING="1">');
      htp.p('  <TR>');
      vMsg := 'Duplicate document type exists for ' || vRefHdg || ' ' || vKey1;
      IF vKey2 IS NOT NULL THEN
        vMsg := vMsg || '/' || vKey2;
      END IF;
      vMsg := vMsg || '. Do you want to continue saving ?';
      htp.p('    <TD COLSPAN=3 WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><SPAN CLASS="mediumfont">' || vMsg || '</SPAN></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=3  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_l.gif" BORDER="0" ALT="Back"></A>');
      htp.p('    <A HREF="Javascript:document.save_preindex_info.submit()" onMouseOver="window.status=''Save''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_save_r.gif" BORDER="0" ALT="Save"></A></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
      htp.p('</FORM>');
      gis_image_util.pageclose;		
    ELSE
      -- No duplicates - can save preindex information
      gis_preindex.save_preindex_info(p_user_id, p_def_context, p_context, p_refresh_rate, p_file_id,
                                      p_attr1, p_attr2, p_attr3, p_attr4, p_attr5, p_attr6, p_attr7, p_attr8,
                                      p_attr9, p_attr10, p_attr11, p_attr12, p_attr13, p_attr14, p_attr15,
                                      p_val1, p_val2, p_val3, p_val4, p_val5, p_val6, p_val7, p_val8,
                                      p_val9, p_val10, p_val11, p_val12, p_val13, p_val14, p_val15,
                                      p_navTo, p_def_org, p_skip, nOrgID);  
    END IF;
  END IF;
-- exception to catch records that have been processed  DG 18-10-2000
-- problem caused by duplicate fnd_documents_tl records - modified code to process only those WITH a file name
EXCEPTION
  WHEN OTHERS THEN
    gis_image_util.InfoHeader('Error Details');
    htp.br;
    htp.br;
    htp.p('<B>Error: Unable to check details - contact support with the following error message:</B>');
    htp.br;
    htp.p(SQLERRM);
    htp.br;
    htp.p(vSQL);
    htp.br;
    htp.p('<TABLE WIDTH="100%" ALIGN="CENTER" >');
    htp.p('  <TR ><TD ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TR>');
    htp.p('</TABLE>');
    gis_image_util.pageclose;		
END preindex_info;

PROCEDURE save_preindex_info(p_user_id      NUMBER,
                             p_def_context  VARCHAR2,
                             p_context      VARCHAR2,
                             p_refresh_rate NUMBER,
                             p_file_id      NUMBER,
                             p_attr1        VARCHAR2 DEFAULT NULL,
                             p_attr2        VARCHAR2 DEFAULT NULL,
                             p_attr3        VARCHAR2 DEFAULT NULL,
                             p_attr4        VARCHAR2 DEFAULT NULL,
                             p_attr5        VARCHAR2 DEFAULT NULL,
                             p_attr6        VARCHAR2 DEFAULT NULL,
                             p_attr7        VARCHAR2 DEFAULT NULL,
                             p_attr8        VARCHAR2 DEFAULT NULL,
                             p_attr9        VARCHAR2 DEFAULT NULL,
                             p_attr10       VARCHAR2 DEFAULT NULL,
                             p_attr11       VARCHAR2 DEFAULT NULL,
                             p_attr12       VARCHAR2 DEFAULT NULL,
                             p_attr13       VARCHAR2 DEFAULT NULL,
                             p_attr14       VARCHAR2 DEFAULT NULL,
                             p_attr15       VARCHAR2 DEFAULT NULL,
                             p_val1         VARCHAR2 DEFAULT NULL,
                             p_val2         VARCHAR2 DEFAULT NULL,
                             p_val3         VARCHAR2 DEFAULT NULL,
                             p_val4         VARCHAR2 DEFAULT NULL,
                             p_val5         VARCHAR2 DEFAULT NULL,
                             p_val6         VARCHAR2 DEFAULT NULL,
                             p_val7         VARCHAR2 DEFAULT NULL,
                             p_val8         VARCHAR2 DEFAULT NULL,
                             p_val9         VARCHAR2 DEFAULT NULL,
                             p_val10        VARCHAR2 DEFAULT NULL,
                             p_val11        VARCHAR2 DEFAULT NULL,
                             p_val12        VARCHAR2 DEFAULT NULL,
                             p_val13        VARCHAR2 DEFAULT NULL,
                             p_val14        VARCHAR2 DEFAULT NULL,
                             p_val15        VARCHAR2 DEFAULT NULL,
                             p_navTo 	    VARCHAR2 DEFAULT NULL,
                             p_def_org      NUMBER   DEFAULT NULL,
                             p_skip         VARCHAR2 DEFAULT 'N',
                             p_org_id       NUMBER) IS
  -- Pragma declarations to check for locking of record for processing
  ROW_LOCKED    EXCEPTION;
  PRAGMA        EXCEPTION_INIT(ROW_LOCKED, -54);
  ROW_PROCESSED EXCEPTION;
  NO_PK         EXCEPTION;
  NO_ENTITY     EXCEPTION;
  
  nDocID         NUMBER := NULL;
  vCurrStatus    fnd_documents_tl_dfv.index_status_id%TYPE;
-- DG corrected cursor for correct sequence number 11-JAN-2001
  CURSOR cAttach(f_entity VARCHAR2, f_pk VARCHAR2) IS
    SELECT NVL(MAX(seq_num), 0) + 10
	FROM fnd_attached_documents
	WHERE entity_name = f_entity
	AND   pk1_value = f_pk; 
  vSecureFlag    fnd_document_categories_dfv.secure_document%TYPE;
  CURSOR cSecure IS
    SELECT v.secure_document
    FROM   fnd_document_categories d, fnd_document_categories_dfv v
    WHERE  d.category_id = p_val1
    AND    d.rowid = v.rowid;
  CURSOR cInterface IS
    SELECT interface_status
    FROM   gis_interface_all
    WHERE  file_id = p_file_id;
  nAttach        NUMBER := 10;
  nOEStatus      NUMBER := 10;
  cursor_name    INTEGER;
  rows_processed INTEGER;
  vSQL           VARCHAR2(2000) := NULL;
  nStatusID      NUMBER := NULL;
  nGISID         NUMBER := NULL;
  bNewGTN        BOOLEAN := FALSE;
  vGTNColName    VARCHAR2(240);
  nGTNID         NUMBER := NULL;
  vOEColName     VARCHAR2(240);
  vLicValColName VARCHAR2(240);
  vOrdValColName VARCHAR2(240);
  nOrderNumber   NUMBER := NULL;
  vCustColName   VARCHAR2(240);
  vCustName      VARCHAR2(240);
  vEntity        VARCHAR2(240) := NULL;
-- DG modified the document entity names to that setup on gsi1ap 11-JAN-2001
-- this was causing a problem with document attachments
  CURSOR cEntity IS
    SELECT data_object_code
    FROM   fnd_document_entities
    WHERE  data_object_code = DECODE(p_context,
                                     'Order Management', 'OE_ORDER_HEADERS',
                                     'Contracts', 'OKC_K_HEADERS_V',
                                     'Projects', 'PA_PROJECTS',
                                     'Agreements', 'OE_AGREEMENTS',
                                     'Customer', 'AR_CUSTOMERS',
                                     'Payables', 'AP_INVOICES', 
                                     'Receivables', 'RA_CUSTOMER_TRX',
                                     'Web Expenses', 'AP_EXPENSE_REPORT_HEADER_S_ALL',
                                     'Education Bookings', 'OTA_DELEGATE_BOOKINGS',
                                     'Education Events', 'OTA_EVENTS',
                                     'HR Assignments', 'PER_ASSIGNMENTS_F',
                                     'Suppliers', 'PO_VENDORS');
  vOENum         fnd_documents_tl_dfv.oe_number%TYPE;
  CURSOR cOE IS
    SELECT a.header_id, a.org_id, v.oe_number
    FROM   oe_order_headers_all a, fnd_documents_tl t, fnd_documents_tl_dfv v
    WHERE  v.oe_number = a.order_number(+)
    AND    t.document_id = nDocID
    AND    t.rowid = v.rowid
    AND    v.primary_document_id = 'Y'
    AND    a.org_id(+) = p_org_id;
  CURSOR cWE IS
    SELECT report_header_id, org_id
    FROM   ap_expense_report_headers_all
    WHERE  invoice_num =
      (SELECT v.expense_report_number
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid)
    AND    org_id = p_org_id;
  CURSOR cOKS IS
    SELECT id, authoring_org_id
    FROM   okc_k_headers_b
    WHERE  (contract_number, NVL(contract_number_modifier, '-1')) IN
      (SELECT v.contracts_number, NVL(v.contracts_modifier, '-1')
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid)
    AND    authoring_org_id = p_org_id;
  CURSOR cPROJ IS
    SELECT project_id, org_id
    FROM   pa_projects_all
    WHERE  segment1 =
      (SELECT v.project_number
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid)
    AND    org_id = p_org_id;
  CURSOR cSA IS
    SELECT a.agreement_id, p_org_id
    FROM   oe_agreements a
    WHERE  a.name =
      (SELECT v.agreement_name
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid);
  CURSOR cRC IS
    SELECT c.customer_id, u.set_of_books_id
    FROM   ra_customers c, hr_operating_units u
    WHERE  customer_number = 
      (SELECT v.customer_number
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid)
    AND    u.organization_id = p_org_id;
  CURSOR cAP IS
    SELECT a.invoice_id, a.set_of_books_id
    FROM   ap_invoices_all a, po_vendors v
    WHERE  a.invoice_num =
      (SELECT invoice_number
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid)
    AND    a.vendor_id =
      (SELECT p.vendor_id
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v, po_vendors p
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid
       AND    v.supplier_name = vendor_name)
    AND    a.vendor_id = v.vendor_id
    AND    a.org_id = p_org_id;
  CURSOR cAR IS
    SELECT t.customer_trx_id, t.set_of_books_id
    FROM   ra_customer_trx_all t
    WHERE  t.trx_number =
      (SELECT v.invoice_number
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid)
    AND    t.org_id = p_org_id;
  CURSOR cEB IS
    SELECT o.booking_id, o.business_group_id
    FROM   ota_delegate_bookings o
    WHERE  o.booking_id =
      (SELECT TO_NUMBER(v.enrollment_number)
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid)
    AND    o.business_group_id = p_org_id;
  CURSOR cEE IS
    SELECT e.event_id, e.business_group_id
    FROM   ota_events e
    WHERE  e.title =
      (SELECT v.title
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid)
    AND    e.business_group_id = p_org_id;
  CURSOR cHRA IS
    SELECT a.assignment_id, a.business_group_id
    FROM   per_all_assignments_f a
    WHERE  a.assignment_id =
      (SELECT v.assignment_ref
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid)
    AND    a.business_group_id = p_org_id;
  CURSOR cPOV IS
    SELECT p.vendor_id, p.set_of_books_id
    FROM   po_vendors p, hr_operating_units u
    WHERE  p.segment1 =
      (SELECT v.supplier_number
       FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
       WHERE  t.document_id = nDocID
       AND    v.primary_document_id = 'Y'
       AND    t.rowid = v.rowid)
    AND    p.set_of_books_id = u.set_of_books_id
    AND    u.organization_id = p_org_id;
  nPKID          NUMBER := NULL;
  nAttachID      NUMBER := NULL;
  CURSOR cStatus IS
    SELECT rowid
    FROM   gis_doc_status
    WHERE  document_id = nDocID
    AND    doc_status_type_id = nStatusID;
  rStatus        cStatus%ROWTYPE;

  nSearchOrg  NUMBER := NULL;

  vNextSQL    VARCHAR2(10000) := NULL;
  TYPE        cv_type IS REF CURSOR;
  cNext       cv_type;
  c_Name      VARCHAR2(500);
  c_File_Id   fnd_lobs.file_id%TYPE;
  c_Scan_date fnd_lobs.upload_date%TYPE;
  c_Status    fnd_documents_tl.doc_attribute6%TYPE;
  c_Flag_File VARCHAR2(240);
  c_Context   fnd_documents_tl.doc_attribute_category%TYPE;
  cNextImageURL  VARCHAR2(1000);
  vStatus        VARCHAR2(100);
  nSecType       NUMBER := NULL;
  nSecID         NUMBER := NULL;
  vPublish       VARCHAR2(1) := NULL;  

  PROCEDURE build_sql_statement(vSQL   IN OUT VARCHAR2,
                                p_attr IN     VARCHAR2,
                                p_val  IN     VARCHAR2) IS
    p_newval  VARCHAR2(240) := NULL;
  BEGIN
    /* If col name is set and is equal to the attribute, then this parameter is the value */
    IF NVL(vGTNColName, '-1') = p_attr THEN
      -- Store GTN value if specified
      nGTNID := TO_NUMBER(p_val);
      IF p_context = 'Order Management' AND
         nGTNID IS NULL THEN
        -- Need to specify a GTN for order number
        DECLARE
          vCountry   VARCHAR2(100);
          vUserName  VARCHAR2(100);
        BEGIN
          SELECT b.legislation_code country, u.user_name
          INTO   vCountry, vUserName
          FROM   fnd_lobs lob, gis_scanners scan, fnd_user u, per_business_groups b
          WHERE  lob.file_id = p_file_id
          AND    lob.program_name = 'GIS'
          AND    lob.program_tag = scan.scanner_id
          AND    scan.organization_id = b.organization_id
          AND    u.user_id = p_user_id;
          -- GTN is generated without customer name - customer name is updated after main update for fnd_documents_tl
          nGTNID := glob_tracking_number.tracking_number('GIS', vCountry, vUserName, 'N', NULL, 'PRE-INDEXED FND_LOBS.FILE_ID = ' || TO_CHAR(p_file_id));
          bNewGTN := TRUE;
        END;
        p_newval := TO_NUMBER(nGTNID);
      END IF;
    ELSIF NVL(vOEColName, '-1') = p_attr THEN
      -- Store order number if specified
      nOrderNumber := TO_NUMBER(p_val);
      p_newval := TO_NUMBER(p_val);
    ELSIF NVL(vCustColName, '-1') = p_attr THEN
      -- Store customer name if specified
      vCustName := p_val;
      p_newval := p_val;
    ELSIF NVL(vLicValColName, '-1') = p_attr OR
          NVL(vOrdValColName, '-1') = p_attr THEN
      p_newval := REPLACE(p_val, ',');
    ELSE
      p_newval := p_val;
    END IF;
    -- Build update for SQL
    IF p_attr IS NOT NULL AND
       p_newval IS NOT NULL THEN
      IF vSQL IS NOT NULL THEN
        vSQL := vSQL || ', ';
      END IF;
      vSQL := vSQL || p_attr || ' = ''' || p_newval || '''';
    END IF;
  END build_sql_statement;
  
BEGIN
  -- Select fnd_documents_tl record for locking
  SELECT t.document_id, v.index_status_id
  -- Get document_id for to do all updates
  INTO   nDocID, vCurrStatus
  FROM   fnd_documents_tl t, fnd_documents d, fnd_documents_tl_dfv v
  WHERE  t.media_id = p_file_id
  AND    t.document_id = d.document_id
  AND    d.datatype_id = 
    (SELECT datatype_id
     FROM   fnd_document_datatypes
     WHERE  name = 'FILE'
     AND    NVL(start_date_active, SYSDATE) <= SYSDATE
     AND    NVL(end_date_active, SYSDATE) >= SYSDATE)
  AND    t.rowid = v.rowid
  AND    v.primary_document_id = 'Y'
  FOR UPDATE OF t.document_id NOWAIT;
  IF vCurrStatus NOT IN ('REJECTED', 'SCANNED', 'REPROCESS') AND
     -- Cannot be updated within scan operator - must be rejected or update from processor
     p_navTo IS NULL THEN
    -- Preindexed or processed already
    RAISE ROW_PROCESSED;
  END IF;
  -- Set default org if specified
  IF p_def_org = 0 THEN
    nSearchOrg := NULL;
  ELSE
    nSearchOrg := p_def_org;
  END IF;
  -- Deattach image if attachment exists
  DELETE
  FROM   fnd_attached_documents
  WHERE  attached_document_id = (
    SELECT v.attached_document_id
    FROM   fnd_documents_tl t, fnd_documents_tl_dfv v
    WHERE  document_id = nDocID
    AND    v.primary_document_id = 'Y'
    AND    t.rowid = v.rowid);
  -- Get sequence for attachment record  
  SELECT fnd_attached_documents_s.nextval
  INTO   nAttachID
  FROM   dual;
  IF p_context = 'Order Management' THEN
    -- Get status if exists for OE
    -- Commented out by P LOW: 06/04/2001
    -- Can update index information, otherwise if interfaced as new order, this will raise an error as status = 80
    -- INSERT into gis_interface_all further down will only happen if order number is NULL
    --OPEN cInterface;
    --FETCH cInterface INTO nOEStatus;
    --IF cInterface%NOTFOUND THEN
    NULL;
    --END IF;
    --CLOSE cInterface;
  END IF;
  IF NVL(nOEStatus, 10) != 10 THEN
    -- P LOW: 06/04/2001
    -- Redundant as above never changes the parameter value.
    htp.p('Document has been processed - contact Super User.');
  ELSE
    -- If an order, store column name for GTN + OE Number if specified */
    IF p_context = 'Order Management' THEN
      vGTNColName := find_col_name(p_context, 'GTN');
      vOEColName := find_col_name(p_context, 'OE Number');
      vCustColName := find_col_name(p_context, 'Customer Name');
      vLicValColName := find_col_name(p_context, 'License Value');
      vOrdValColName := find_col_name(p_context, 'Order Value');
    END IF;
    -- Build SQL for inputs
    build_sql_statement(vSQL, p_attr2, REPLACE(p_val2, '''', ''''''));
    build_sql_statement(vSQL, p_attr3, REPLACE(p_val3, '''', ''''''));
    build_sql_statement(vSQL, p_attr4, REPLACE(p_val4, '''', ''''''));
    build_sql_statement(vSQL, p_attr5, REPLACE(p_val5, '''', ''''''));
    build_sql_statement(vSQL, p_attr6, REPLACE(p_val6, '''', ''''''));
    build_sql_statement(vSQL, p_attr7, REPLACE(p_val7, '''', ''''''));
    build_sql_statement(vSQL, p_attr8, REPLACE(p_val8, '''', ''''''));
    build_sql_statement(vSQL, p_attr9, REPLACE(p_val9, '''', ''''''));
    build_sql_statement(vSQL, p_attr10, REPLACE(p_val10, '''', ''''''));
    build_sql_statement(vSQL, p_attr11, REPLACE(p_val11, '''', ''''''));
    build_sql_statement(vSQL, p_attr12, REPLACE(p_val12, '''', ''''''));    
    build_sql_statement(vSQL, p_attr13, REPLACE(p_val13, '''', ''''''));    
    build_sql_statement(vSQL, p_attr14, REPLACE(p_val14, '''', ''''''));    
    build_sql_statement(vSQL, p_attr15, REPLACE(p_val15, '''', ''''''));    
    IF p_context != 'Order Management' THEN
      -- Any other context will be PREINDEXED, use nOrderNumber as a flag > -1
      nOrderNumber := 0;
    END IF;
    IF p_skip = 'Y' THEN
      -- Skip processing queue - COMPLETED
      vStatus := 'COMPLETED';
-- also show that the document has been pre-indexed in the doc_status table
-- DG added 11-jan-2001
    -- Check if audit record exists for PREINDEXED state
    SELECT doc_status_type_id
    INTO   nStatusID
    FROM   gis_doc_status_types
    WHERE  doc_status_name = 'PRE-INDEXED';
    
    OPEN cStatus;
    FETCH cStatus INTO rStatus;
    IF cStatus%NOTFOUND THEN
      -- Log audit record for PREINDEXING  
      INSERT INTO gis_doc_status
        (document_id,
         doc_status_type_id,
         date_created,
         created_by,
         last_update_date,
         last_updated_by)
      VALUES
        (nDocID,
         nStatusID,
         SYSDATE,
         p_user_id,
         SYSDATE,
         p_user_id);
    ELSE
      UPDATE gis_doc_status
        SET  last_update_date = SYSDATE,
             last_updated_by = p_user_id
        WHERE rowid = rStatus.rowid;
    END IF;
    CLOSE cStatus;
    ELSIF nOrderNumber IS NULL THEN
      -- No order number - PENDING
      vStatus := 'PENDING';
    ELSE 
      -- Flagged with order or context other than Order Management
      vStatus := 'PRE-INDEXED';
    END IF;
    -- Get ID for status
    SELECT doc_status_type_id
    INTO   nStatusID
    FROM   gis_doc_status_types
    WHERE  doc_status_name = vStatus;
    -- Complete SQL for required values */
    vSQL := vSQL ||
            ', LAST_UPDATE_DATE = SYSDATE' ||
            ', LAST_UPDATED_BY = ' || TO_CHAR(p_user_id) ||
            ', DOC_ATTRIBUTE_CATEGORY = ''' || p_context || '''';
    vSQL := 'UPDATE fnd_documents_tl SET ' || vSQL || ' WHERE document_id = ' || TO_CHAR(nDocID);
    cursor_name := dbms_sql.open_cursor;
    DBMS_SQL.PARSE(cursor_name, vSQL, dbms_sql.native);
    rows_processed := dbms_sql.execute(cursor_name);
    DBMS_SQL.close_cursor(cursor_name);
    -- Use flexfield view to update columns not referenced via flexfield lookups
    UPDATE fnd_documents_tl_dfv
    SET    index_status_id = vStatus,
           attached_document_id = TO_CHAR(nAttachID),
           indexed_by = TO_CHAR(p_user_id),
-- For now - update it - should be set on load time in GIS_NEWIMAGELOAD
           primary_document_id = 'Y'
    WHERE  ROWID =
      (SELECT ROWID
       FROM   fnd_documents_tl
       WHERE  document_id = nDocID);
    IF bNewGTN THEN
      -- Update GTN with customer name
      UPDATE  glob_tracking_numbers
        SET   customer = vCustName
        WHERE tracking_number = nGTNID;
    END IF;
    -- Check if audit record exists for PREINDEXED state
    OPEN cStatus;
    FETCH cStatus INTO rStatus;
    IF cStatus%NOTFOUND THEN
      -- Log audit record for PREINDEXING  
      INSERT INTO gis_doc_status
        (document_id,
         doc_status_type_id,
         date_created,
         created_by,
         last_update_date,
         last_updated_by)
      VALUES
        (nDocID,
         nStatusID,
         SYSDATE,
         p_user_id,
         SYSDATE,
         p_user_id);
    ELSE
      UPDATE gis_doc_status
        SET  last_update_date = SYSDATE,
             last_updated_by = p_user_id
        WHERE rowid = rStatus.rowid;
    END IF;
    CLOSE cStatus;
    -- Get PK for image to attach to ...
    IF p_context = 'Order Management' THEN
      -- If an order, insert into gis_interface table */
      -- Delete from gis_interface if record exists
      DELETE
      FROM   gis_interface_all
      WHERE  file_id = p_file_id;
      INSERT INTO gis_interface_all
        (gis_id,
         file_id,
         gtn_id,
         customer_id,
         customer_name,
         customer_number,
         order_type,
         order_number,
         order_amount,
         interface_status,
         status_date,
         last_error_id,
         last_updated_by,
         last_update_date,
         created_by,
         creation_date,
         org_id)
      SELECT gis_interface_s.nextval,
             t.media_id file_id,
             nGTNID,
             c.customer_id,
             v.customer_name,
             v.customer_number,
             v.order_type,
             NVL(v.oe_number, -1),
             v.order_value,
             10,
             SYSDATE,
             NULL,
             p_user_id,
             SYSDATE,
             p_user_id,
             SYSDATE,
             s.organization_id
      FROM   fnd_documents_tl t, fnd_documents_tl_dfv v, ra_customers c, fnd_lobs l, gis_scanners s
      WHERE  t.document_id = nDocID
      AND    t.rowid = v.rowid
      AND    v.primary_document_id = 'Y'
      AND    t.media_id = l.file_id
      AND    l.program_tag = s.scanner_id
      AND    l.program_name = 'GIS'
      -- Modified: PL 26/01/2001
      -- Must only insert record into gis_interface_all if order number is not specified
      AND    v.oe_number IS NULL
      AND    v.customer_number = c.customer_number(+);
      -- Get PK for OE Number
      OPEN cOE;
      FETCH cOE INTO nPKID, nSecID, vOENum;
      -- OM is the only context where the APPS record will not exist
      -- Need the org_id to complete the security update on fnd_documents
      IF vOENum IS NOT NULL AND nPKID IS NULL THEN
        -- OM check is more complicate with the skip flag - do check here to avoid mulitple logic errors
        -- Didn't find the order
        RAISE NO_PK;
      ELSE
        -- Found the order OR no order specified - will be generated
        SELECT u.organization_id
        INTO   nSecID
        FROM   fnd_lobs l, gis_scanners s, hr_operating_units u
        WHERE  l.file_id = p_file_id
        AND    l.program_name = 'GIS'
        AND    l.program_tag = s.scanner_id
        AND    s.organization_id = u.organization_id;
      END IF;
      CLOSE cOE;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 1;
      vPublish := 'N';
    ELSIF p_context = 'Web Expenses' THEN
      -- Get PK for Web Expense
      OPEN cWE;
      FETCH cWE INTO nPKID, nSecID;
      CLOSE cWE;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 1;
      vPublish := 'N';
    ELSIF p_context = 'Contracts' THEN
      -- Get PK for Contracts
      OPEN cOKS;
      FETCH cOKS INTO nPKID, nSecID;
      CLOSE cOKS;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 1;
      vPublish := 'N';
    ELSIF p_context = 'Projects' THEN
      -- Get PK for Projects
      OPEN cPROJ;
      FETCH cPROJ INTO nPKID, nSecID;
      CLOSE cPROJ;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 1;
      vPublish := 'Y';
    ELSIF p_context = 'Agreements' THEN
      -- Get PK for Agreement
      OPEN cSA;
      FETCH cSA INTO nPKID, nSecID;
      CLOSE cSA;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 1;
      vPublish := 'Y';
    ELSIF p_context = 'Customer' THEN
      -- Get PK for Customers
      OPEN cRC;
      FETCH cRC INTO nPKID, nSecID;
      CLOSE cRC;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 2;
      vPublish := 'N';
    ELSIF p_context = 'Payables' THEN
      -- Get PK for Payables
      OPEN cAP;
      FETCH cAP INTO nPKID, nSecID;
      CLOSE cAP;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 2;
      vPublish := 'N';
    ELSIF p_context = 'Receivables' THEN
      -- Get PK for Receivables
      OPEN cAR;
      FETCH cAR INTO nPKID, nSecID;
      CLOSE cAR;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 2;
      vPublish := 'N';
    ELSIF p_context = 'Education Bookings' THEN
      -- Get PK for Education Bookings
      OPEN cEB;
      FETCH cEB INTO nPKID, nSecID;
      CLOSE cEB;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 3;
      vPublish := 'N';
    ELSIF p_context = 'Education Events' THEN
      -- Get PK for Education Events
      OPEN cEE;
      FETCH cEE INTO nPKID, nSecID;
      CLOSE cEE;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 3;
      vPublish := 'N';
    ELSIF p_context = 'HR Assignments' THEN
      -- Get PK for HR Assignment
      OPEN cHRA;
      FETCH cHRA INTO nPKID, nSecID;
      CLOSE cHRA;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 2;
      vPublish := 'N';
    ELSIF p_context = 'Suppliers' THEN
      -- Get PK for Supplier
      OPEN cPOV;
      FETCH cPOV INTO nPKID, nSecID;
      CLOSE cPOV;
      -- Set flags for visiblity in APPLICATIONS
      nSecType := 2;
      vPublish := 'N';
    ELSE
      -- Will raise an error
      nSecID := NULL;
      nSecType := NULL;
      vPublish := NULL;
    END IF;
    -- Update document category
    UPDATE fnd_documents
      SET category_id = p_val1,
          security_type = nSecType,
          security_id = nSecID,
          publish_flag = vPublish
      WHERE document_id = nDocID;
    IF (nPKID IS NULL AND p_context = 'Order Management' AND p_skip != 'Y') OR
       (nPKID IS NOT NULL) THEN
      -- Do attachment by document entity
      OPEN cEntity;
      FETCH cEntity INTO vEntity;
      IF cEntity%NOTFOUND THEN
        RAISE NO_ENTITY;
      END IF;
      CLOSE cEntity;
      IF vEntity IS NOT NULL THEN
        -- Get internal sequence for attached document
        -- DG altered to correctly allocate sequence numbers 11-JAN-2001
        OPEN cAttach(vEntity,nPKID);
        FETCH cAttach INTO nAttach;
        IF cAttach%NOTFOUND THEN
          nAttach := 10;
        END IF;
        CLOSE cAttach;
        -- Get 'SECURE' attribute value for document_category and specify value for attribute1
        OPEN cSecure;
        FETCH cSecure INTO vSecureFlag;
        CLOSE cSecure;
        -- Just in case something is in there other than 'SECURE' or 'OPEN'
        IF NVL(vSecureFlag, 'NULL') NOT IN ('SECURE', 'OPEN') THEN
          vSecureFlag := NULL;
        END IF;
        INSERT INTO fnd_attached_documents
          (attached_document_id,
           document_id,
           creation_date,
           created_by,
           last_update_date,
           last_updated_by,
           seq_num,
           entity_name,
           pk1_value,
           automatically_added_flag,
           attribute1)
        VALUES
          (nAttachID,
           nDocID,
           SYSDATE,
           p_user_id,
           SYSDATE,
           p_user_id,
           nAttach,
           vEntity,
           TO_CHAR(nPKID),
           'N',
           vSecureFlag);
      END IF;
      COMMIT;
      -- Output confirmation of success
      gis_image_util.pageopen(p_heading => p_context || ' Fields');
      gis_image_util.InfoHeader('Document Pre-Index Successfully');
      htp.p('<SCRIPT language="JavaScript">
<!--BEGIN Script
var listURL = ""
var docURL = ""
function showList(p_next_file_id, imageURL)
{
  if (p_next_file_id == "")
  {
    listURL = "gis_preindex.list_unprocessed?p_user_id=' || p_user_id || '&p_def_context=' || p_def_context || '&p_context=' || p_def_context || '&p_refresh_rate=' || p_refresh_rate || '&p_def_org=' || p_def_org || '"
    viewimage(listURL, ''gis_image_util.BlankFrame'', ''gis_image_util.ViewingFrame'')
  }
  else
  {
    listURL = "gis_preindex.list_unprocessed?p_user_id=' || p_user_id || '&p_def_context=' || p_def_context || '&p_context=' || p_def_context || '&p_refresh_rate=' || p_refresh_rate || '&p_def_org=' || p_def_org || '"
    docURL =  "gis_preindex.show_doc_types?p_user_id=' || p_user_id || '&p_def_context=' || p_def_context || '&p_context=' || p_def_context || '&p_refresh_rate=' || p_refresh_rate || '&p_file_id="  + p_next_file_id + "&p_def_org=' || p_def_org || '"
    viewimage(listURL, docURL, imageURL)
  }
}
//-->
</SCRIPT>');
      htp.p('<BR>');
      htp.p('<BR>');
      htp.p('<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="2">');  
      IF nOrderNumber IS NULL THEN
        htp.p('  <TR>');
        htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><SPAN CLASS="mediumfont">Document Pre-Indexed Successfully - Pending Order Number Creation</SPAN></TD>');
        htp.p('  </TR>');
      ELSE
        htp.p('  <TR>');
        htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><SPAN CLASS="mediumfont">Document Pre-Indexed Successfully</SPAN></TD>');
        htp.p('  </TR>');
      END IF;
      IF nPKID IS NOT NULL THEN
        htp.p('  <TR>');
        htp.p('    <TD COLSPAN=3 ALIGN="CENTER"><SPAN CLASS="mediumfont">Document Attached Successfully</SPAN></TD>');
        htp.p('  </TR>');
      END IF;
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="98%" ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('  <TR>');
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      -- DG - added navTo option to take user back to inquiry screen if that was where
      -- they came from
      IF p_navTo IS NOT NULL THEN
         htp.p('    <TD WIDTH="98%" ALIGN="CENTER"><A HREF="'||REPLACE(REPLACE(p_navTo,'~','&'),' ','+')||'" onMouseOver="window.status=''OK''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok_m.gif" BORDER="0" ALT="OK"></A></TD>');	
      ELSE
        htp.p('    <TD WIDTH="98%" ALIGN="CENTER">');
        -- Check for profile option to refresh queue
        IF NVL(fnd_profile.value_specific('GISMIS_AUTO_REFRESH', p_user_id), 'N') = 'Y' THEN
          -- Get next file to process and refresh queue
          -- Setup SQL for base query
          vNextSQL := 'SELECT org.name, lob.file_id, lob.upload_date scan_date, doc.doc_attribute6 status, ' ||
                      '''f_''|| scan.organization_id || ''.gif'' flag_file, doc.doc_attribute_category context ' ||
                      'FROM   fnd_documents_tl doc, gis_scanners scan, gis_scan_users su, fnd_documents_tl_dfv v, ' ||
                      'fnd_lobs lob, fnd_user usr, hr_operating_units org, fnd_documents d ' ||
                      'WHERE  su.fnd_user_id = ' || p_user_id || ' ' ||
                      'AND    su.scanner_id = scan.scanner_id ' ||
                      'AND    scan.organization_id = org.organization_id ' ||
                      'AND    lob.file_name LIKE scan.scanner_id || ''%'' ' ||
                      'AND    lob.program_tag = scan.scanner_id ' ||
                      'AND    lob.program_name = ''GIS'' ' ||
                      'AND    lob.file_id = doc.media_id ' ||
                      'AND    doc.doc_attribute6 IN (''SCANNED'', ''REJECTED'', ''REPROCESS'') ' ||
                      'AND    doc.rowid = v.rowid ' ||
                      'AND    v.primary_document_id = ''Y'' ' ||
                      'AND    usr.user_id = doc.created_by ' ||
                      'AND    lob.file_id != ' || p_file_id || ' ';
          IF nSearchOrg IS NOT NULL THEN
            vNextSQL := vNextSQL || 'AND    scan.organization_id = ' || nSearchOrg || ' ';
          END IF;
          vNextSQL := vNextSQL ||
                      'AND    doc.document_id = d.document_id ' ||
                      'AND    d.datatype_id = ' ||
                      '(SELECT datatype_id ' ||
                      'FROM   fnd_document_datatypes ' ||
                      'WHERE  name = ''FILE'' ' ||
                      'AND    NVL(start_date_active, SYSDATE) <= SYSDATE ' ||
                      'AND    NVL(end_date_active, SYSDATE) >= SYSDATE) ' ||
                      'ORDER BY DECODE(doc.doc_attribute6, ''REJECTED'', 1, ''REPROCESS'', 2, 3), lob.upload_date ';
          OPEN cNext FOR vNextSQL;
          FETCH cNext INTO c_Name, c_File_Id, c_Scan_date, c_Status, c_Flag_File, c_Context;
          IF cNext%FOUND THEN
            cNextImageURL := fnd_gfm.construct_download_url(C_APP_URL, c_File_Id);
            htp.p('      <A HREF="javascript:showList('''','''')" onMouseOver="window.status=''OK''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok_l.gif" BORDER="0" ALT="OK"></A>');
            htp.p('      <A HREF="javascript:showList(''' || TO_CHAR(c_File_Id) || ''',''' || cNextImageURL || ''')" onMouseOver="window.status=''Next Image''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_next_r.gif" BORDER="0" ALT="Next Image"></A>');
          ELSE
            htp.p('      <A HREF="javascript:showList('''','''')" onMouseOver="window.status=''OK''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_ok_m.gif" BORDER="0" ALT="OK"></A>');
          END IF;
          CLOSE cNext;
        ELSE
          htp.p('<SPAN CLASS="mediumfont">To view the next image, go to the frame above and manually select a document you have not indexed.</SPAN>');
        END IF;
        htp.p('    </TD>');
      END IF;
      htp.p('    <TD WIDTH="1%"  ALIGN="CENTER" VALIGN="MIDDLE"><IMG SRC="' || C_IMG_URL || 'empty.gif"></TD>');
      htp.p('  </TR>');
      htp.p('</TABLE>');
      gis_image_util.pageclose;
    ELSE
      -- PK validation failed
      RAISE NO_PK;
    END IF;
  END IF;
-- exception to catch records that have been processed  DG 18-10-2000
-- problem caused by duplicate fnd_documents_tl records - modified code to process only those WITH a file name
EXCEPTION
  WHEN ROW_LOCKED THEN
    preindex_message('Image ' || p_file_id || ' Locked For Indexing', 'This image is in the process of being indexed - please select another image.', 'B');
  WHEN ROW_PROCESSED THEN
    ROLLBACK;
    preindex_message('Image ' || p_file_id || ' Already Indexed', 'This image has been indexed - please select another image.', 'B');
  WHEN NO_PK THEN
      ROLLBACK;
      
htp.p('nDocID = ' || TO_CHAR(nDocID));
htp.br;
htp.p('p_org_id = ' || TO_CHAR(p_org_id));
      
      preindex_message('Image Attachment Failed', 'Could not find record to attach image to - please revalidate ' || p_context || ' input.', 'B');
  WHEN NO_ENTITY THEN
    ROLLBACK;
    preindex_message('Cannot Attach Image.', 'Attachment entity for ' || p_context|| ' does not exist.', 'B');
  WHEN OTHERS THEN
    gis_image_util.InfoHeader('Error Details');
    htp.br;
    htp.br;
    htp.p('<B>Error: Unable to save details - check document status is not processed</B>');
    htp.br;
    htp.p(SQLERRM);
    htp.br;
    htp.p('<TABLE WIDTH="100%" ALIGN="CENTER" >');
    htp.p('  <TR ><TD ALIGN="CENTER"><A HREF="javascript:back()" onMouseOver="window.status=''Back''; return true" onMouseOut="window.status=''''; return true"><IMG SRC="' || C_IMG_URL || 'b_back_m.gif" BORDER="0" ALT="Back"></A></TR>');
    htp.p('</TABLE>');
    gis_image_util.pageclose;		
END save_preindex_info;

END gis_preindex;
/
